#include <cmath>

#include "tang-toennies.h"
#include "II_Dispersion.h"

#include "orient.h"



namespace x2o {

double C = 0;
double D = 0;

void II_Dispersion::set_params(const double c, const double d) {
  C=c;
  D=d;
}


double II_Dispersion::operator()(const double* ion1, const double* ion2) {
  
  const double C6II = x6(C, D, ion1, ion2);

  return C6II;
}

double II_Dispersion::operator()(const double* ion1, const double* ion2,
           double* g_ion1, double* g_ion2)
{

    const double C6II = x6(C, D, ion1, ion2, g_ion1, g_ion2);

    return C6II;

}

double II_Dispersion::dispersion(const double rII, const double c, const double d) {
    double InvRII;
    double ttII;

    InvRII = 1/rII;

    ttII  = x2o::tang_toennies(6,d*rII);

    double Vdispersion = -1.0*ttII*c*pow(InvRII,6);

    return Vdispersion;
}


} // namespace x2o

