#ifndef COULOMB_H
#define COULOMB_H

namespace ttm {

struct smear {
    virtual ~smear() {};

    virtual double aCC() const = 0;
    virtual double aCD() const = 0;
    virtual double aDD_inter() const = 0;
    virtual double aDD_intra_12() const { return aDD_inter(); }
    virtual double aDD_intra_13() const { return aDD_inter(); }
    virtual double aDD_intra_14() const { return aDD_inter(); }

    virtual void smear01(const double&, const double&, const double&,
                         double&, double&) const = 0;

    virtual void smear2(const double&, const double&, const double&,
                        double&, double&) const = 0;

    virtual void smear3(const double&, const double&, const double&,
                        double&, double&, double&) const = 0;
};

struct smear_ttm4x : public smear {

    smear_ttm4x();

    double aCC() const;
    double aCD() const;
    double aDD_inter() const;
    double aDD_intra_12() const;
    double aDD_intra_13() const;
    double aDD_intra_14() const;

    void smear01(const double&, const double&, const double&,
                 double&, double&) const;

    void smear2(const double&, const double&, const double&,
                double&, double&) const;

    void smear3(const double&, const double&, const double&,
                double&, double&, double&) const;

    double m_aDD_inter;
    double m_aDD_intra_12;
    double m_aDD_intra_13;
    double m_aDD_intra_14;
};

} // namespace ttm

#endif // COULOMB_H
