#include <cmath>

#include "tang-toennies.h"

namespace x2o {

double dispersion(const double rCA, const double deltaCA, const double C6_CA)
{
    double InvRCA;
    double ttCA;

    InvRCA = 1/rCA;

    ttCA = x2o::tang_toennies(6,deltaCA*rCA);

    double Vdispersion = -1.0*ttCA*C6_CA*pow(InvRCA,6) ;

    return Vdispersion;
}

double dispersion(const double rOX, const double rH1X, const double rH2X,
                  const double deltaOX, const double deltaHX)
{
const double C6_OX = 1495.63;
const double C6_HX = 248.59;
    double InvROX, InvRH1X, InvRH2X;
    double ttOX, ttH1X, ttH2X;

    InvROX = 1/rOX;
    InvRH1X = 1/rH1X;
    InvRH2X = 1/rH2X;

    ttOX = x2o::tang_toennies(6,deltaOX*rOX);
    ttH1X = x2o::tang_toennies(6,deltaHX*rH1X);
    ttH2X = x2o::tang_toennies(6,deltaHX*rH2X);

    double Vdispersion = -1.0*ttOX*C6_OX*pow(InvROX,6) -1.0*ttH1X*C6_HX*pow(InvRH1X,6) -1.0*ttH2X*C6_HX*pow(InvRH2X,6);

    return Vdispersion;
    }

double dispersion(const double rOX, const double rH1X, const double rH2X,
                  const double deltaOX, const double deltaHX,
                  const double C6_OX, const double C6_HX) {

  double InvROX, InvRH1X, InvRH2X;
  double ttOX, ttH1X, ttH2X;

  InvROX = 1/rOX;
  InvRH1X = 1/rH1X;
  InvRH2X = 1/rH2X;

  ttOX = x2o::tang_toennies(6,deltaOX*rOX);
  ttH1X = x2o::tang_toennies(6,deltaHX*rH1X);
  ttH2X = x2o::tang_toennies(6,deltaHX*rH2X);

  double Vdispersion = - 1.0 * ttOX * C6_OX * pow(InvROX,6) 
                        -1.0 * ttH1X * C6_HX * pow(InvRH1X,6)
                        -1.0 * ttH2X * C6_HX * pow(InvRH2X,6);

  return Vdispersion;
}

double dispersion(const double rOX, const double rH1X, const double rH2X,
                  const double deltaOX, const double deltaHX,
                  const double C6_OX, const double C6_HX, const double aa) {

  double InvROX, InvRH1X, InvRH2X;
  double ttOX, ttH1X, ttH2X;

  InvROX = 1/rOX;
  InvRH1X = 1/rH1X;
  InvRH2X = 1/rH2X;

  ttOX = x2o::tang_toennies(6,deltaOX*rOX);
  ttH1X = x2o::tang_toennies(6,deltaHX*rH1X);
  ttH2X = x2o::tang_toennies(6,deltaHX*rH2X);

  double Vdispersion = - 1.0 * ttOX * C6_OX * pow(InvROX,6)
                        -1.0 * ttH1X * C6_HX * pow(InvRH1X,6)
                        -1.0 * ttH2X * C6_HX * pow(InvRH2X,6)
                        + aa;

  return Vdispersion;
}

double gen_dispersion(const double r, const double C6, const double d){
  double InvR,tt;
  
  InvR = 1/r;
  
  tt=x2o::tang_toennies(6,d*r);
  
  double Vdisp = -1.0 * tt * C6 * pow(InvR,6);

  return Vdisp;
}


} // namespace x2o
