#ifndef ITTM_NION_WATER_H
#define ITTM_NION_WATER_H

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif // HAVE_CONFIG_H
#include <stdlib.h>
#include <cmath>
#include <cassert>

#include <iomanip>
#include <iostream>
#include <sstream>
#include <fstream>
#include <stdexcept>

#include <algorithm>
#include <memory>
#include <vector>
#include <utility>

#include "ttm4-es.h"
#include "ttm4.h"
#include "read-xyz.h"
#include "orient.h"
#include "molecule.h"
#include "system.h"
#include "electrostatics.h"
#include "watI-dispersion.h"

#include "II_Poly.h"
#include "II_Dispersion.h"

#include "pot-water-ion.h"
#include "params.h"
#include "x2b-h2o-ion-v2x.h"
#include "x3b-h2o-ion-v2x.h"

//#define VERBOSE

namespace nion {

bool orderIons (tools::xyz_frame i,tools::xyz_frame j) ;

double get_E(double * coords, std::vector<std::string> at_names, int n_at); 

double get_E(double * coords, std::vector<std::string> at_names, int n_at, double * grd); 

void calcdip(double * coords, std::vector<std::string> at_names, int n_at, double * dipoles, double * dip);

void calcdip(double * coords, std::vector<std::string> at_names, int n_at, double * dip);

void calcdipgrad(double * coords, std::vector<std::string> at_names, int n_at, double * dipgrad);

void set_2b_water_ions();

void set_3b_water_ions();

void set_2b_ion_ion();

} // namespace




#endif

