#ifndef SYSTEM_H
#define SYSTEM_H

#include <vector>
#include <memory>

#include "molecule.h"

////////////////////////////////////////////////////////////////////////////////

namespace sys {

class system {

//------------------  Pointers to the system information  --------------------//

public : 
    int nsites;
    double* coords;
    double* charges;
    double* atmpolar;
    double* polfac;

    excluded_set_type excluded12;
    excluded_set_type excluded13;
    excluded_set_type excluded14;

    std::vector<int> first_index_of_molec;
    std::vector<std::shared_ptr<molecule>> molec;

//------------------  Constructors / Destructors  ----------------------------//

public :
    system();
    virtual ~system();
    system(const system& o);

//------------------  Tools for maintaining system  --------------------------//

    void add_molecule(std::shared_ptr<molecule> o);
    void set_pol(double*);
    void update_molecules();

protected:
    void allocate(const int n);
    void create_system();

};

}

#endif // SYSTEM_H
