#ifndef TTM4_H
#define TTM4_H
#include "molecule.h"

namespace x2o {

class ttm4 : public molecule {
    
public : 
    ttm4();
    ~ttm4();

    // allocates memory, calculates polfac, charges, coords
    ttm4(double*);

    ttm4(const ttm4& o);

    void allocate(const int);
    void set_coords(double*); 
    void set_charges(double*);

    void set_pol(double*);

    void redistrib_frc_virtual_2_real(double*);
    void charge_derivative_force(double*, double*);

private :
    double* charge_grd;
};

} //namespace x2o
#endif // TTM4_H
