#ifndef WATI_DISPERSION_H
#define WATI_DISPERSION_H

#include <cstddef>
#include "tang-toennies.h"


namespace x2o {

struct watI_dispersion{

    void set_tt_params(const double c_OX, const double d_OX,
                       const double c_HX, const double d_HX);


    double operator()(const double*, const double*);
    double operator()(const double*, const double*, double*, double*);

    //
    //  Vdispersion(x) = AA*exp(-BB*x)
    //
    static double dispersion(const double, const double, const double,
                      const double, const double,
                      const double, const double);

};

double mbnrg_dispersion(const double* w1, const double*  x,
                        const double C6_OX, const double C6_HX,
                        const double deltaOX, const double deltaHX,
                        double* g1, double* g2);

} // namespace x2o

#endif //WATI_DISPERSION 
