#ifndef X2B_H2O_ION_V2X_H
#define X2B_H2O_ION_V2X_H

////////////////////////////////////////////////////////////////////////////////
#include <memory>
#include "params.h"
#include "poly-2b-h2o-ion-v1x.h"

namespace h2o_ion {

//----------------------------------------------------------------------------//

//
//  x2b_h2o_ion_v1<4> with gradients and no fitting interface
//

//----------------------------------------------------------------------------//

struct x2b_h2o_ion_v2x {

//    double eval(const double* w1, const double*  x );

    x2b_h2o_ion_v2x() { twobodyfit = new double[874]; };
    ~x2b_h2o_ion_v2x() { delete[] twobodyfit; };

    double eval(const double* w1, const double*  x ,
                             double* g1,       double* g2);

    double k_HH_intra;
    double k_OH_intra;

    double k_XH_coul;
    double k_XO_coul;

    double k_xlp_main;

    double d_HH_intra;
    double d_OH_intra;

    double d_XH_coul;
    double d_XO_coul;

    double d_xlp_main;

    double in_plane_gamma;
    double out_of_plane_gamma;

    double r2i;
    double r2f;

// ADDED MRR

    double * twobodyfit;
    void set_param(mbnrg_param_X_H2O * param);
    
// END ADDED MRR

    double f_switch(const double&, double&); // O-X separation
};

//----------------------------------------------------------------------------//

} // namespace h2o_ion

////////////////////////////////////////////////////////////////////////////////

#endif // X2B_H2O_ION_V2X_H
