#ifndef X3B_H2O_ION_V2X_H
#define X3B_H2O_ION_V2X_H

////////////////////////////////////////////////////////////////////////////////

#include <memory>
#include "params.h"
#include "poly-3b-h2o-ion-v1x.h"

namespace h2o_ion {

//----------------------------------------------------------------------------//

struct x3b_h2o_ion_v2x {

  x3b_h2o_ion_v2x() { threebodyfit = new double[1831]; };
  ~x3b_h2o_ion_v2x() { delete[] threebodyfit; };

//  double eval(const double* w1,
//              const double* w2,
//              const double* x );

  double eval(const double* w1,
              const double* w2,
              const double* x ,
              double* g1,
              double* g2,
              double* g3);

  double r3i;
  double r3f;

  double kOH_intra;
  double kHH_intra;

  double kOO;
  double kOH;
  double kHH;

  double kXO;
  double kXH;
 
  double dOH_intra;
  double dHH_intra;

  double dOO;
  double dOH;
  double dHH;

  double dXO;
  double dXH;

// ADDED MRR

  double * threebodyfit;
  void set_param(mbnrg_param_X_H2O_H2O * param);

// END ADDED MRR

  double f_switch(const double& r, double& g);
};

//----------------------------------------------------------------------------//

} // namespace h2o_ion

////////////////////////////////////////////////////////////////////////////////

#endif // X3B_H2O_ION_V2X_H
