#include <iostream>
#include <utility>
#include <cstddef>
#include <exception>

#include "params.h"



bool multiion_param::check_ion_water_2b_mbnrg(const std::string ion){

  std::vector<std::string> aval_2b;

  // Put here the availability for the 2b potential for ion-water systems
  aval_2b.push_back("F");  
  aval_2b.push_back("Cl");  
  aval_2b.push_back("Br");  
  aval_2b.push_back("I");  

  if (std::find(aval_2b.begin(), aval_2b.end(), ion) != aval_2b.end()) {
    return true;
  } else {
    return false;
  }
}

bool multiion_param::check_ion_water_3b_mbnrg(const std::string ion){

  std::vector<std::string> aval_3b;

  // Put here the availability for the 2b potential for ion-water systems
  aval_3b.push_back("F");
  aval_3b.push_back("Cl");
  aval_3b.push_back("Br");
  aval_3b.push_back("I");

  if (std::find(aval_3b.begin(), aval_3b.end(), ion) != aval_3b.end()) {
    return true;
  } else {
    return false;
  }
}


void multiion_param::set_parameters(const std::string ion) {
  
  if (ion == "F") { 
    double p[] = {  -1 ,                    // Charge
                     2.4669,                   // Polarizability
                     348.864,                  // C6OX
                     3.58619,                  // DeltaOX
                     35920.3,                  // AOX
                     3.58619,                  // BOX
                     128.678,                  // C6HX
                     2.69768,                  // DeltaHX
                     4992.61,                  // AHX
                     2.69768                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Cl") {
    double p[] = { -1 ,                    // Charge
                     5.3602,                   // Polarizability
                     746.199,                  // C6OX
                     3.27542,                  // DeltaOX
                     50180.4,                  // AOX
                     3.27542,                  // BOX
                     306.891,                  // C6HX
                     2.78226,                  // DeltaHX
                     2594.28,                  // AHX
                     2.78226                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Br") {
    double p[] = { -1 ,                    // Charge
                     7.1668,                   // Polarizability
                     942.650,                  // C6OX
                     3.05825,                  // DeltaOX
                     37682.2,                  // AOX
                     3.05825,                  // BOX
                     394.168,                  // C6HX
                     2.79804,                  // DeltaHX
                     3804.53,                  // AHX
                     2.79804                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "I") {
    double p[] = { -1 ,                     // Charge
                     10.1184,                  // Polarizability
                     1294.66,                  // C6OX
                     2.72314,                  // DeltaOX
                     22210.0,                  // AOX
                     2.72314,                  // BOX
                     568.156,                  // C6HX
                     2.79911,                  // DeltaHX
                     6215.10,                  // AHX
                     2.79911                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Li") {
    double p[] = {  1 ,                     // Charge
                     0.028486,                 // Polarizability
                     43.1470,                  // C6OX
                     4.02327,                  // DeltaOX
                     32318.0,                  // AOX
                     4.02327,                  // BOX
                     18.7122,                  // C6HX
                     4.00672,                  // DeltaHX
                     3245.78,                  // AHX
                     4.00672                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Na") {
    double p[] = {  1 ,                     // Charge
                     0.14759,                  // Polarizability
                     176.255,                  // C6OX
                     3.82261,                  // DeltaOX
                     47827.7,                  // AOX
                     3.82261,                  // BOX
                     85.7869,                  // C6HX
                     3.76951,                  // DeltaHX
                     4992.61,                  // AHX
                     3.76951                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "K") {
    double p[] = {  1 ,                     // Charge
                     0.81840,                  // Polarizability
                     431.432,                  // C6OX
                     3.39759,                  // DeltaOX
                     49780.2,                  // AOX
                     3.39759,                  // BOX
                     218.843,                  // C6HX
                     3.31969,                  // DeltaHX
                     4941.43,                  // AHX
                     3.31969                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Rb") {
    double p[] = {  1 ,                     // Charge
                     1.27576,                  // Polarizability
                     527.192,                  // C6OX
                     3.35667,                  // DeltaOX
                     68268.1,                  // AOX
                     3.35667,                  // BOX
                     271.321,                  // C6HX
                     3.29901,                  // DeltaHX
                     6982.09,                  // AHX
                     3.29901                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Cs") {
    double p[] = {  1 ,                     // Charge
                     2.3377 ,                  // Polarizability
                     700.097,                  // C6OX
                     3.03294,                  // DeltaOX
                     45030.7,                  // AOX
                     3.03294,                  // BOX
                     365.322,                  // C6HX
                     3.26732,                  // DeltaHX
                     9426.17,                  // AHX
                     3.26732                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else {
    std::cerr << "Ion " << ion << " not found." << std::endl;
    throw std::exception();
  }
}

void multiion_param::set_parameters(const std::string ion1, const std::string ion2) {
  if (ion1 == ion2) {
    if (ion1 == "F") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     654.195,                  // C6OX
                     2.04316,                  // DeltaOX
                     1687.14,                  // AOX
                     2.04316,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Cl") {
      double p[] = {  0.0,                     // Charge
                     0.0000,                  // Polarizability
                     3246.54,                  // C6OX
                     1.86699,                  // DeltaOX
                     2569.09,                  // AOX
                     1.86699,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Br") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     4908.53,                  // C6OX
                     1.79922,                  // DeltaOX
                     3674.06,                  // AOX
                     1.79922,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "I") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     9971.11,                  // C6OX
                     1.79453,                  // DeltaOX
                     6672.41,                  // AOX
                     1.79453,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Li") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     11.0285,                  // C6OX
                     6.63418,                  // DeltaOX
                     26110.8,                  // AOX
                     6.63418,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Na") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     252.630,                  // C6OX
                     5.17793,                  // DeltaOX
                    134244.0,                  // AOX
                     5.17793,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else {
      std::cerr << "Ion " << ion1 << " not found." << std::endl;
      throw std::exception();
    }
  } else {
    if ((ion1 == "F" && ion2 == "Na") || (ion1 == "Na" && ion2 == "F")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     306.831,                  // C6OX
                     3.52363,                  // DeltaOX
                     37835.8,                  // AOX
                     3.52363,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "Cl" && ion2 == "Na") || (ion1 == "Na" && ion2 == "Cl")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     785.551,                  // C6OX
                     2.69336,                  // DeltaOX
                     26832.4,                  // AOX
                     2.69336,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      } 
    } else if ((ion1 == "Br" && ion2 == "Na") || (ion1 == "Na" && ion2 == "Br")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     1008.96,                  // C6OX
                     2.52520,                  // DeltaOX
                     26310.6,                  // AOX
                     2.52520,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "I" && ion2 == "Na") || (ion1 == "Na" && ion2 == "I")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     1508.75,                  // C6OX
                     2.44570,                  // DeltaOX
                     31172.4,                  // AOX
                     2.44570,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "F" && ion2 == "Li") || (ion1 == "Li" && ion2 == "F")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     77.2367,                  // C6OX
                     4.43372,                  // DeltaOX
                     31820.3,                  // AOX
                     4.43372,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "Cl" && ion2 == "Li") || (ion1 == "Li" && ion2 == "Cl")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     182.017,                  // C6OX
                     3.80762,                  // DeltaOX
                     39948.7,                  // AOX
                     3.80762,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "Br" && ion2 == "Li") || (ion1 == "Li" && ion2 == "Br")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     231.326,                  // C6OX
                     3.57312,                  // DeltaOX
                     43428.9,                  // AOX
                     3.57312,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "I" && ion2 == "Li") || (ion1 == "Li" && ion2 == "I")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     331.518,                  // C6OX
                     3.62036,                  // DeltaOX
                     72706.2,                  // AOX
                     3.62036,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else {
      std::cerr << "Ion " << ion1 << " or ion " << ion2 << " not found." << std::endl;
      throw std::exception();
    }
  }
}

void multiion_param::set_parameters50(const std::string ion) {
  
  if (ion == "F") { 
    double p[] = {  -1 ,                    // Charge
                     1.23345,                  // Polarizability
                     348.864,                  // C6OX
                     3.62593,                  // DeltaOX
                     38290.0,                  // AOX
                     3.62593,                  // BOX
                     128.678,                  // C6HX
                     2.88984,                  // DeltaHX
                     1231.27,                  // AHX
                     2.88984                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Cl") {
    double p[] = { -1 ,                    // Charge
                     2.6801,                   // Polarizability
                     746.199,                  // C6OX
                     3.27841,                  // DeltaOX
                     49488.0,                  // AOX
                     3.27841,                  // BOX
                     306.891,                  // C6HX
                     2.91544,                  // DeltaHX
                     3422.72,                  // AHX
                     2.91544                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Br") {
    double p[] = { -1 ,                    // Charge
                     3.5834,                   // Polarizability
                     942.650,                  // C6OX
                     3.06223,                  // DeltaOX
                     37542.7,                  // AOX
                     3.06223,                  // BOX
                     394.168,                  // C6HX
                     2.91497,                  // DeltaHX
                     4776.13,                  // AHX
                     2.91497                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "I") {
    double p[] = { -1 ,                     // Charge
                     5.05920,                  // Polarizability
                     1294.66,                  // C6OX
                     2.71168,                  // DeltaOX
                     21343.5,                  // AOX
                     2.71168,                  // BOX
                     568.156,                  // C6HX
                     2.88304,                  // DeltaHX
                     7259.50,                  // AHX
                     2.88304                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Li") {
    double p[] = {  1 ,                     // Charge
                     0.014243,                 // Polarizability
                     43.1470,                  // C6OX
                     4.06168,                  // DeltaOX
                     34093.9,                  // AOX
                     4.06168,                  // BOX
                     18.7122,                  // C6HX
                     4.11558,                  // DeltaHX
                     5246.90,                  // AHX
                     4.11558                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Na") {
    double p[] = {  1 ,                     // Charge
                     0.073795,                 // Polarizability
                     176.255,                  // C6OX
                     3.83356,                  // DeltaOX
                     53268.8,                  // AOX
                     3.83356,                  // BOX
                     85.7869,                  // C6HX
                     3.84424,                  // DeltaHX
                     5246.90,                  // AHX
                     3.84424                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "K") {
    double p[] = {  1 ,                     // Charge
                     0.81840,                  // Polarizability
                     431.432,                  // C6OX
                     3.44174,                  // DeltaOX
                     54664.5,                  // AOX
                     3.44174,                  // BOX
                     218.843,                  // C6HX
                     3.34797,                  // DeltaHX
                     5173.66,                  // AHX
                     3.34797                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Rb") {
    double p[] = {  1 ,                     // Charge
                     1.27576,                  // Polarizability
                     527.192,                  // C6OX
                     3.39156,                  // DeltaOX
                     73753.4,                  // AOX
                     3.39156,                  // BOX
                     271.321,                  // C6HX
                     3.31661,                  // DeltaHX
                     7166.33,                  // AHX
                     3.31661                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Cs") {
    double p[] = {  1 ,                     // Charge
                     2.3377 ,                  // Polarizability
                     700.097,                  // C6OX
                     3.0692 ,                  // DeltaOX
                     49101.6,                  // AOX
                     3.0692 ,                  // BOX
                     365.322,                  // C6HX
                     3.28492,                  // DeltaHX
                     9650.76,                  // AHX
                     3.28492                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else {
    std::cerr << "Ion " << ion << " not found." << std::endl;
    throw std::exception();
  }
}

void multiion_param::set_parameters50(const std::string ion1, const std::string ion2) {
  if (ion1 == ion2) {
    if (ion1 == "F") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     654.195,                  // C6OX
                     3.32578,                  // DeltaOX
                     12784.7,                  // AOX
                     3.32578,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Cl") {
      double p[] = {  0.0,                     // Charge
                     0.0000,                  // Polarizability
                     3246.54,                  // C6OX
                     2.90742,                  // DeltaOX
                     31623.2,                  // AOX
                     2.90742,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Br") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     4908.53,                  // C6OX
                     2.58457,                  // DeltaOX
                     22256.6,                  // AOX
                     2.58457,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "I") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     9971.11,                  // C6OX
                     2.90977,                  // DeltaOX
                     22256.6,                  // AOX
                     2.90977,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Li") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     11.0285,                  // C6OX
                     7.44687,                  // DeltaOX
                     53757.6,                  // AOX
                     7.44687,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Na") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     252.630,                  // C6OX
                     5.29883,                  // DeltaOX
                    148248.0,                  // AOX
                     5.29883,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else {
      std::cerr << "Ion " << ion1 << " not found." << std::endl;
      throw std::exception();
    }
  } else {
    if ((ion1 == "F" && ion2 == "Na") || (ion1 == "Na" && ion2 == "F")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     306.831,                  // C6OX
                     4.07891,                  // DeltaOX
                     71367.6,                  // AOX
                     4.07891,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "Cl" && ion2 == "Na") || (ion1 == "Na" && ion2 == "Cl")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     785.551,                  // C6OX
                     3.02363,                  // DeltaOX
                     40193.9,                  // AOX
                     3.02363,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      } 
    } else if ((ion1 == "Br" && ion2 == "Na") || (ion1 == "Na" && ion2 == "Br")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     1008.96,                  // C6OX
                     2.86367,                  // DeltaOX
                     40711.5,                  // AOX
                     2.86367,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "I" && ion2 == "Na") || (ion1 == "Na" && ion2 == "I")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     1508.75,                  // C6OX
                     2.77949,                  // DeltaOX
                     48844.2,                  // AOX
                     2.77949,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "F" && ion2 == "Li") || (ion1 == "Li" && ion2 == "F")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     77.2367,                  // C6OX
                     3.77161,                  // DeltaOX
                     23994.7,                  // AOX
                     3.77161,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "Cl" && ion2 == "Li") || (ion1 == "Li" && ion2 == "Cl")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     182.017,                  // C6OX
                     3.38928,                  // DeltaOX
                     37001.3,                  // AOX
                     3.38928,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "Br" && ion2 == "Li") || (ion1 == "Li" && ion2 == "Br")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     231.326,                  // C6OX
                     3.08093,                  // DeltaOX
                     33460.7,                  // AOX
                     3.08093,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "I" && ion2 == "Li") || (ion1 == "Li" && ion2 == "I")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     331.518,                  // C6OX
                     3.04602,                  // DeltaOX
                     46676.4,                  // AOX
                     3.04602,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else {
      std::cerr << "Ion " << ion1 << " or ion " << ion2 << " not found." << std::endl;
      throw std::exception();
    }
  }
}

void multiion_param::set_parameters00(const std::string ion) {
  
  if (ion == "F") { 
    double p[] = {  -1 ,                    // Charge
                     0.0000,                   // Polarizability
                     348.864,                  // C6OX
                     3.27206,                  // DeltaOX
                     21430.9,                  // AOX
                     3.27206,                  // BOX
                     128.678,                  // C6HX
                     4.20259,                  // DeltaHX
                     8442.01,                  // AHX
                     4.20259                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Cl") {
    double p[] = { -1 ,                    // Charge
                     0.0000,                   // Polarizability
                     746.199,                  // C6OX
                     3.21229,                  // DeltaOX
                     42350.4,                  // AOX
                     3.21229,                  // BOX
                     306.891,                  // C6HX
                     3.20569,                  // DeltaHX
                     5787.65,                  // AHX
                     3.20569                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Br") {
    double p[] = { -1 ,                    // Charge
                     0.0000,                   // Polarizability
                     942.650,                  // C6OX
                     3.01234,                  // DeltaOX
                     33206.3,                  // AOX
                     3.01234,                  // BOX
                     394.168,                  // C6HX
                     3.14075,                  // DeltaHX
                     7239.36,                  // AHX
                     3.14075                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "I") {
    double p[] = { -1 ,                     // Charge
                     0.00000,                  // Polarizability
                     1294.66,                  // C6OX
                     2.68490,                  // DeltaOX
                     19729.8,                  // AOX
                     2.68490,                  // BOX
                     568.156,                  // C6HX
                     3.03234,                  // DeltaHX
                     9627.79,                  // AHX
                     3.03234                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Li") {
    double p[] = {  1 ,                     // Charge
                     0.000000,                 // Polarizability
                     43.1470,                  // C6OX
                     3.97086,                  // DeltaOX
                     29801.7,                  // AOX
                     3.97086,                  // BOX
                     18.7122,                  // C6HX
                     3.58757,                  // DeltaHX
                     1609.67,                  // AHX
                     3.58757                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Na") {
    double p[] = {  1 ,                     // Charge
                     0.00000,                  // Polarizability
                     176.255,                  // C6OX
                     3.74520,                  // DeltaOX
                     49483.1,                  // AOX
                     3.74520,                  // BOX
                     85.7869,                  // C6HX
                     5.26999,                  // DeltaHX
                     23388.1,                  // AHX
                     5.26999                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "K") {
    double p[] = {  1 ,                     // Charge
                     0.81840,                  // Polarizability
                     431.432,                  // C6OX
                     3.47927,                  // DeltaOX
                     58606.4,                  // AOX
                     3.47927,                  // BOX
                     218.843,                  // C6HX
                     3.37037,                  // DeltaHX
                     5377.85,                  // AHX
                     3.37037                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Rb") {
    double p[] = {  1 ,                     // Charge
                     1.27576,                  // Polarizability
                     527.192,                  // C6OX
                     3.42583,                  // DeltaOX
                     78736.9,                  // AOX
                     3.42583,                  // BOX
                     271.321,                  // C6HX
                     3.31139,                  // DeltaHX
                     7099.95,                  // AHX
                     3.31139                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else if (ion == "Cs") {
    double p[] = {  1 ,                     // Charge
                     2.3377 ,                  // Polarizability
                     700.097,                  // C6OX
                     3.11582,                  // DeltaOX
                     54088.2,                  // AOX
                     3.11582,                  // BOX
                     365.322,                  // C6HX
                     3.26611,                  // DeltaHX
                     9291.44,                  // AHX
                     3.26611                 };// BHX
    for (int i = 0; i< 10; i++) {
      params[i] = p[i];
    }
  } else {
    std::cerr << "Ion " << ion << " not found." << std::endl;
    throw std::exception();
  }
}

void multiion_param::set_parameters00(const std::string ion1, const std::string ion2) {
  if (ion1 == ion2) {
    if (ion1 == "F") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     654.195,                  // C6OX
                     6.04707,                  // DeltaOX
                     466921 ,                  // AOX
                     6.04707,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Cl") {
      double p[] = {  0.0,                     // Charge
                     0.0000,                  // Polarizability
                     3246.54,                  // C6OX
                     4.60508,                  // DeltaOX
                     668862 ,                  // AOX
                     4.60508,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Br") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     4908.53,                  // C6OX
                     3.92598,                  // DeltaOX
                     278475 ,                  // AOX
                     3.92598,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "I") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     9971.11,                  // C6OX
                     4.86953,                  // DeltaOX
                     17189000,                 // AOX
                     4.86953,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Li") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     11.0285,                  // C6OX
                     8.64336,                  // DeltaOX
                     160897 ,                  // AOX
                     8.64336,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if (ion1 == "Na") {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     252.630,                  // C6OX
                     5.44473,                  // DeltaOX
                    168980.0,                  // AOX
                     5.44473,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else {
      std::cerr << "Ion " << ion1 << " not found." << std::endl;
      throw std::exception();
    }
  } else {
    if ((ion1 == "F" && ion2 == "Na") || (ion1 == "Na" && ion2 == "F")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     306.831,                  // C6OX
                     4.61504,                  // DeltaOX
                     112607 ,                  // AOX
                     4.61504,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "Cl" && ion2 == "Na") || (ion1 == "Na" && ion2 == "Cl")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     785.551,                  // C6OX
                     3.28633,                  // DeltaOX
                     47387.1,                  // AOX
                     3.28633,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      } 
    } else if ((ion1 == "Br" && ion2 == "Na") || (ion1 == "Na" && ion2 == "Br")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     1008.96,                  // C6OX
                     3.12441,                  // DeltaOX
                     47841.3,                  // AOX
                     3.12441,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "I" && ion2 == "Na") || (ion1 == "Na" && ion2 == "I")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     1508.75,                  // C6OX
                     3.05742,                  // DeltaOX
                     59391.4,                  // AOX
                     3.05742,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "F" && ion2 == "Li") || (ion1 == "Li" && ion2 == "F")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     77.2367,                  // C6OX
                     3.33069,                  // DeltaOX
                     18959.5,                  // AOX
                     3.33069,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "Cl" && ion2 == "Li") || (ion1 == "Li" && ion2 == "Cl")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     182.017,                  // C6OX
                     2.97021,                  // DeltaOX
                     27202.5,                  // AOX
                     2.97021,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "Br" && ion2 == "Li") || (ion1 == "Li" && ion2 == "Br")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     231.326,                  // C6OX
                     2.76135,                  // DeltaOX
                     27815  ,                  // AOX
                     2.76135,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else if ((ion1 == "I" && ion2 == "Li") || (ion1 == "Li" && ion2 == "I")) {
      double p[] = {  0.0,                     // Charge
                     0.00000,                 // Polarizability
                     331.518,                  // C6OX
                     2.70532,                  // DeltaOX
                     36470.8,                  // AOX
                     2.70532,                  // BOX
                     0.00000,                  // C6HX
                     0.00000,                  // DeltaHX
                     0.00000,                  // AHX
                     0.00000                 };// BHX
      for (int i = 0; i< 10; i++) {
        params[i] = p[i];
      }
    } else {
      std::cerr << "Ion " << ion1 << " or ion " << ion2 << " not found." << std::endl;
      throw std::exception();
    }
  }
}

double multiion_param::set_mass(const std::string atom) {
  // The masses are the ones from the most abundant isotope
  // Taken from NIST on November 7th 2015 by Marc R.
  // http://physics.nist.gov/cgi-bin/Compositions/stand_alone.pl?ele=&all=all&ascii=html
  if (atom ==  "H") {  
    mass = 1.007825032;
  } else if (atom ==  "D") {  
    mass = 2.01410178;
  } else if (atom ==  "O") {  
    mass = 15.994914619;
  } else if (atom ==  "F") {  
    mass = 18.998403162;
  } else if (atom ==  "Cl") {  
    mass = 34.968852682;
  } else if (atom ==  "Br") {  
    mass = 78.9183376;
  } else if (atom ==  "I") {  
    mass = 126.9044719;
  } else if (atom ==  "Li") {  
    mass = 7.0160034366;
  } else if (atom ==  "Na") {  
    mass = 22.989769282;
  } else if (atom ==  "K") {  
    mass = 38.9637064864;
  } else if (atom ==  "Rb") {  
    mass = 83.9114977282;
  } else if (atom ==  "Cs") {  
    mass = 132.905429 ;
  } else {
    std::cerr << "Atom " << atom << " not found." << std::endl;
    throw std::exception();
  }

  return mass;
 
}

void mbnrg_param_X_H2O::set_parameters(const std::string ion){
  if (ion == "F") {
    polarizability = 2.4669; //A^3 CCSD(T)/t-av5z from finite field method 
   
    //from XDM 
    C6XH  = 1.286780000000000e+02; // kcal/mol * A^(-6)
    C6XO  = 3.488640000000000e+02; // kcal/mol * A^(-6)
    
    //fit-h2o_f_dimer_ccsdtf12_cbs_mdp1p2000_grid_clusters_pimdt298_pimdclusterst298_troublingconfigs_nmittm_reactivescan_nm9-14_shortrangeconfigs_holes  fit-03/02/2016 as submitted to JCTC 
    D6XH  = 1.154978653439356e+01; // A^(-1)
    D6XO  = 9.935211881691504e+00; // A^(-1)
    
    K_HH_INTRA =          5.552066367161397e-01; // A^(-1)
    K_OH_INTRA =          1.073839197046798e+00; // A^(-1)
    
    K_XH_COUL =           1.304823221165949e+00; // A^(-1)
    K_XO_COUL =           6.480701066338084e-01; // A^(-1)
    
    K_XLP_MAIN =          3.050297831167134e-01; // A^(-1)
    
    IN_PLANE_GAMMA =      1.277093505798443e+00; 
    OUT_OF_PLANE_GAMMA =  9.603011315630968e-01; 
    
    R2I =  5.000000000000000e+00; // A
    R2F =  6.000000000000000e+00; // A

    double twobodyfit_cp[] = {
    1.893710906741673e+01, // 0
    2.177754008051160e+00, // 1
   -1.463577330360822e+01, // 2
   -1.359745923011655e+01, // 3
   -2.984557146346886e+01, // 4
    8.342046974348191e+00, // 5
    3.868310067062990e+01, // 6
    1.622887474976250e+01, // 7
   -8.485588521376839e+00, // 8
    1.583866804588826e+01, // 9
   -5.907954520140095e+00, // 10
   -3.173716212149127e+01, // 11
    3.459110012792107e+01, // 12
   -4.080503064776838e+01, // 13
   -4.450781570083428e+01, // 14
    2.456553047638316e+01, // 15
   -1.761919347105148e+01, // 16
   -1.486888854797208e+01, // 17
   -5.136303184471009e+01, // 18
    6.290942370568395e+01, // 19
    3.340230288480443e+01, // 20
   -3.476841088594704e+01, // 21
    1.785892141135378e+01, // 22
   -5.136143589236933e+01, // 23
    8.169509698516558e+01, // 24
   -2.920299593248724e+01, // 25
   -4.654801409532230e+01, // 26
    6.501914881546790e+00, // 27
   -3.159957327662986e+00, // 28
   -1.617960346128914e+01, // 29
   -5.831538090665545e+00, // 30
   -8.301576413903124e+00, // 31
   -2.094528883172201e+01, // 32
   -3.755410556238844e+00, // 33
    7.497829757228858e+01, // 34
   -1.966466041744574e+01, // 35
    3.898161508229841e+00, // 36
    1.439071397908689e+01, // 37
   -2.745376155245489e+01, // 38
    6.449297710767805e-01, // 39
    1.938469989260123e+00, // 40
    2.342865199915413e+01, // 41
   -1.645329641403726e+01, // 42
    8.251796312665171e+00, // 43
   -3.449857109658059e-01, // 44
    1.366880424751273e+01, // 45
   -2.000535523621024e+01, // 46
   -3.547682773312677e+00, // 47
    3.970939712883683e+01, // 48
    2.217255837679867e+00, // 49
    2.628700829972439e+01, // 50
    3.262639266136772e+01, // 51
   -3.313331181665248e+01, // 52
   -2.493446830239374e+01, // 53
    4.129493301673004e+01, // 54
    1.252844680647578e+01, // 55
   -6.549352896321230e+01, // 56
    4.732551067318144e+00, // 57
   -1.306326605884234e+01, // 58
    6.654377009971425e+00, // 59
    4.227535948312740e+01, // 60
   -3.170770780128784e+01, // 61
    1.211729646803820e-01, // 62
    7.806866973115561e+00, // 63
    4.588026647546765e+00, // 64
    2.104615904984585e+01, // 65
   -2.357263678542243e+00, // 66
    3.353770229758608e+01, // 67
   -6.463324212211674e+00, // 68
    3.421966816117322e-02, // 69
   -5.058123979773693e+01, // 70
    2.009890788235382e+00, // 71
    7.010886910481011e+01, // 72
    2.737246909404796e+00, // 73
   -5.131505180266296e+01, // 74
   -7.996349847867961e+00, // 75
    2.195045424928216e+00, // 76
    2.196442036283644e+01, // 77
    1.552417115760496e+01, // 78
    6.150036646142588e+00, // 79
    4.216751207541524e+01, // 80
   -2.751345541086317e+01, // 81
    1.901877619399954e-01, // 82
   -1.210840382206338e-01, // 83
   -5.700479055918227e+00, // 84
   -4.162348641355311e-03, // 85
   -2.485480373606859e+01, // 86
    8.965910349957376e+00, // 87
   -2.376495037149303e+01, // 88
    1.033900944414003e+01, // 89
    1.162475354898012e+01, // 90
   -7.469586805702633e+01, // 91
    1.379572432222320e+00, // 92
    1.681898486413600e+01, // 93
   -4.328579269244855e+00, // 94
   -2.610694341348544e+01, // 95
   -1.804111309666443e+00, // 96
    8.384662047741600e+00, // 97
    3.175469519255386e+01, // 98
    1.976870681693395e+01, // 99
   -1.763001004004865e+01, // 100
   -9.214873403927134e-01, // 101
    1.203347160730195e+01, // 102
   -9.152792035094073e-01, // 103
    2.617498352445470e+01, // 104
    1.450912629908492e+01, // 105
    1.896694284176909e+01, // 106
    3.649867151946333e+01, // 107
   -2.669459101128036e+01, // 108
    2.535855507291772e+00, // 109
   -2.312370682399581e+01, // 110
   -3.347802438583098e+01, // 111
    1.668675849371155e+01, // 112
    2.163145738796765e-01, // 113
   -4.887455908398160e-01, // 114
   -5.825407149376534e+01, // 115
    1.762081305422337e+01, // 116
    4.352686970892533e+01, // 117
   -3.232744205014510e+00, // 118
   -4.038825423915491e+01, // 119
   -2.668131719361205e+01, // 120
    2.005102386319080e+00, // 121
    5.010650250285538e+01, // 122
    2.982469209105785e+00, // 123
    6.541460718606883e-01, // 124
   -3.459067399425692e+01, // 125
    1.291332024281779e+00, // 126
   -3.305749133823686e+01, // 127
    5.169183863636049e+01, // 128
    2.316511042623805e+00, // 129
    1.030079152495688e+02, // 130
   -6.590482748493062e+00, // 131
   -1.623948735960304e+01, // 132
   -1.468335998815759e+01, // 133
    1.935867574855938e+01, // 134
   -2.245801143361835e+01, // 135
   -3.404273180220489e+01, // 136
   -4.842164557574938e+00, // 137
   -7.010867588724962e+01, // 138
    7.146679739235105e+00, // 139
   -5.057705599380369e+00, // 140
    4.250720002959756e+00, // 141
    2.947851782270776e+00, // 142
    1.454300445839319e+01, // 143
    1.807511150330109e+01, // 144
    4.426261730995378e+01, // 145
   -1.974225620669880e+01, // 146
    1.138899303921795e+01, // 147
   -3.385329833543027e+01, // 148
    7.784056642618475e-01, // 149
   -5.755964738103111e+01, // 150
   -9.560998929585977e-01, // 151
   -3.358238002912703e-01, // 152
    3.247748656565022e+01, // 153
    8.317191299224923e+00, // 154
    1.306368305850289e+01, // 155
    1.949251616818468e+01, // 156
   -6.294195405317251e+01, // 157
    1.389008988440375e+01, // 158
   -3.626420163645603e+00, // 159
    5.913191821759283e+01, // 160
    4.961796101595156e-02, // 161
   -8.955685754960728e+00, // 162
    8.066623061204002e+00, // 163
   -1.987323709539492e+01, // 164
    1.776862128629736e+00, // 165
    1.320803074890726e+01, // 166
    3.744526236769259e+00, // 167
   -1.888342491089934e+01, // 168
    2.497619333000745e+01, // 169
    1.218304788596449e+02, // 170
   -3.845645139080983e-01, // 171
    3.886644078446506e+01, // 172
    2.956543445113355e+01, // 173
    1.863504323189005e+01, // 174
    1.649369994503807e+01, // 175
    3.482800614380172e+01, // 176
    1.981035951717822e+01, // 177
   -1.325932912106032e+02, // 178
    4.002116257154364e+00, // 179
   -2.254490388840841e+01, // 180
    6.667281652648625e+00, // 181
    1.262112053330083e+01, // 182
   -1.550952321608371e+01, // 183
    1.217265166149424e+01, // 184
    4.401912515870127e-01, // 185
    1.330861679215135e+00, // 186
    2.436868961033448e+00, // 187
   -2.837015575208218e-02, // 188
   -4.286203919342265e+01, // 189
    1.695102602769065e+01, // 190
    2.306540665339943e+01, // 191
    8.807285990809739e+01, // 192
    3.063470764887477e-02, // 193
    7.007837808510422e+01, // 194
   -1.819250067701345e-01, // 195
    4.880878452021918e+01, // 196
    8.671453534017070e+00, // 197
   -2.261465696481203e+01, // 198
   -5.288181018055484e+01, // 199
    1.262000143128415e+00, // 200
   -9.387249829373203e-01, // 201
   -2.934437577342572e+01, // 202
    1.944024773434357e+01, // 203
    1.698400615121204e+00, // 204
    1.428452534662182e+01, // 205
    3.485129817024473e+01, // 206
    1.517085347039823e-01, // 207
   -1.359114918766276e+01, // 208
   -7.716617845967830e+00, // 209
    3.157933555589589e-02, // 210
   -4.516993430789476e+01, // 211
    2.553590113259929e-01, // 212
    8.468872966254637e-02, // 213
    3.658419009481759e+01, // 214
   -2.873874842903628e+01, // 215
   -4.290488145048477e+01, // 216
    1.285571263380593e+01, // 217
    6.646810069827541e+00, // 218
    1.328023998396966e+01, // 219
    4.421375718406769e+00, // 220
   -9.546560121376077e+00, // 221
   -4.924824065377259e+01, // 222
   -8.818523210580938e+01, // 223
   -7.154170256492181e+00, // 224
    4.577185404852668e+01, // 225
   -1.476431211835062e+00, // 226
   -2.035804563351311e-06, // 227
   -1.177082594938950e+01, // 228
   -7.238369064637605e+00, // 229
   -4.622689850168722e+00, // 230
    2.606657080266072e+01, // 231
    1.598823207065008e+00, // 232
    2.607077077149247e-02, // 233
   -2.690522746777471e+01, // 234
    1.533279351734081e+01, // 235
    2.472459769253244e+01, // 236
    5.995042710122885e+01, // 237
    3.929726953347325e+01, // 238
    1.595378705140042e+01, // 239
    2.785138861466872e+01, // 240
   -9.937026798397338e+01, // 241
    9.032918227314038e+00, // 242
   -6.561261925203807e+01, // 243
   -6.389454579195398e-03, // 244
    1.007677666678579e+00, // 245
   -1.936649451357264e+01, // 246
    1.129219140565261e-01, // 247
   -2.764641214960434e-01, // 248
    3.625462900051747e-01, // 249
    2.952802775968896e+00, // 250
    1.554011606407029e+01, // 251
    1.751093764558001e+01, // 252
   -1.654149070078274e+01, // 253
    6.837925240701375e+00, // 254
    9.915108450246780e+00, // 255
    3.254450516034668e-01, // 256
   -1.395219646555971e+01, // 257
   -1.811188801489193e+01, // 258
    3.185820055647507e+00, // 259
   -1.830996758790424e+01, // 260
   -1.187048607244357e+01, // 261
    5.192498285529541e+00, // 262
   -3.181211202755005e+00, // 263
    5.183424266141715e+00, // 264
   -2.042550025528987e+01, // 265
    5.543686118370204e-02, // 266
   -4.044770177177955e+01, // 267
    1.281521622847613e+01, // 268
    7.108417983825556e+00, // 269
   -2.569890487525923e+01, // 270
    1.040755414031129e+01, // 271
    2.930791254893928e+01, // 272
    3.139034618145549e+01, // 273
   -7.740534045899207e+01, // 274
   -2.764333484849834e+01, // 275
    7.450727190417989e+00, // 276
   -2.781839473696800e+00, // 277
    1.587053920723097e+01, // 278
   -1.344799289503636e+01, // 279
    7.676866255744135e-03, // 280
    9.686124851539644e+00, // 281
    1.513606981419168e+01, // 282
    3.734386217456662e+01, // 283
    1.967656895428029e+00, // 284
    6.933734465894652e+00, // 285
   -2.187283359606724e+01, // 286
   -2.203784709139661e+01, // 287
   -1.320516710345563e+01, // 288
    2.494332905087627e-02, // 289
   -1.210342448946964e-01, // 290
    4.863515500532582e+01, // 291
   -7.416904405954948e+00, // 292
    6.000612637532598e+01, // 293
    2.082767846876327e+00, // 294
   -1.364841481515249e+01, // 295
    1.459022539251631e+01, // 296
   -3.382516110089162e+01, // 297
   -2.939660813742079e+01, // 298
    2.071626188800230e+01, // 299
   -3.075765495299716e+01, // 300
    1.093604869051766e+01, // 301
    1.303274505135771e-04, // 302
    9.440755804367601e+00, // 303
   -6.668913795219260e+00, // 304
    1.485501672043814e+01, // 305
   -3.692830321360087e+01, // 306
   -6.132755350474553e-04, // 307
    1.594813492569806e+01, // 308
   -2.199864886240727e-04, // 309
   -4.915620950133975e+01, // 310
   -1.534557523605581e+01, // 311
   -1.969838223681542e+01, // 312
   -1.409872217138116e+01, // 313
   -3.426005883138879e+01, // 314
    3.566759353501044e+00, // 315
   -4.755554006471861e-02, // 316
    4.140933488184478e+00, // 317
   -3.141575871429069e-04, // 318
    3.175461340619692e+00, // 319
   -8.966820958918824e+01, // 320
    1.878566070482767e+01, // 321
    1.343566276338511e+00, // 322
   -2.076129763993277e+00, // 323
    1.485980868977857e+01, // 324
   -9.405727188506477e+00, // 325
    2.371609613630548e+01, // 326
    2.043920154391959e+01, // 327
    9.323426945158253e+00, // 328
   -2.797645296019222e+00, // 329
   -1.077759042716399e+01, // 330
    1.002383325084036e+01, // 331
    4.320145862257373e+00, // 332
   -3.899519342385084e+00, // 333
    8.371884092340764e+00, // 334
    5.753998576829310e-02, // 335
   -5.123036770253192e+00, // 336
   -1.950254248681991e-04, // 337
    9.061236561801863e+01, // 338
   -3.984394613051784e+01, // 339
    6.565594809865058e+01, // 340
   -1.021052269717014e-01, // 341
   -7.537863877836173e+01, // 342
    3.353767017909836e+01, // 343
   -1.298226826052973e+01, // 344
   -1.092445683585039e+01, // 345
    1.886653821944716e+01, // 346
    5.538723840461240e-02, // 347
   -1.570280191301180e+01, // 348
    5.329129430471622e+00, // 349
    2.296206684992202e+01, // 350
    4.338304147623072e+01, // 351
   -1.780912161497950e+01, // 352
    9.317054757370963e+00, // 353
   -1.239562981905250e-02, // 354
   -1.957263753811763e+01, // 355
    3.099000243988993e-01, // 356
   -2.027930286972476e-01, // 357
   -1.599777828410249e+01, // 358
   -5.986659928229930e+00, // 359
    3.206528352852359e+01, // 360
   -4.450159045071516e+01, // 361
   -1.058476566622894e-01, // 362
   -3.188162665126210e+01, // 363
   -1.521036949984548e+01, // 364
    8.746176359911480e+00, // 365
   -8.466021751505939e-01, // 366
   -4.092532615200381e+00, // 367
   -4.078871330420655e+01, // 368
    5.900956711404418e+00, // 369
    1.206286839295945e+00, // 370
    1.915864964602270e+01, // 371
    3.973632346996511e+01, // 372
   -6.176445910885012e-02, // 373
   -3.512467162911730e+01, // 374
   -1.926768834566602e+00, // 375
    7.007559736774830e+00, // 376
    4.860821549048556e-01, // 377
   -6.448061056410626e+00, // 378
    6.670190652144592e+01, // 379
    2.663635348307037e+00, // 380
    4.537019153882631e+01, // 381
    2.116427286157704e-03, // 382
   -2.825112666474909e-01, // 383
   -2.450465879930961e+01, // 384
    7.087569503240183e-01, // 385
   -2.111412358053662e+01, // 386
   -3.509641639284364e+00, // 387
    8.808254210898115e+00, // 388
   -1.123364719813184e+01, // 389
    7.294493807246352e+00, // 390
   -1.177338384585893e+00, // 391
    2.261302368733991e+00, // 392
   -1.928231687106898e+01, // 393
    7.866308518166674e-02, // 394
    5.126572180032136e+00, // 395
   -2.655956069736174e+01, // 396
    1.843979434355467e+01, // 397
    7.712351014235382e+01, // 398
    7.936223903306484e+01, // 399
    7.517947630267655e+01, // 400
    6.786128606942410e-01, // 401
    2.532143644208745e-03, // 402
    8.505430346768428e+00, // 403
   -4.786761514550454e+01, // 404
    6.263236316635163e+00, // 405
   -3.942406187735102e+01, // 406
   -1.334894612312685e+00, // 407
    8.003242563958725e+00, // 408
    4.029415398868009e-01, // 409
   -2.810282889707620e+01, // 410
   -6.627983187448726e+01, // 411
    3.540048203770437e+00, // 412
   -2.962040812212735e+01, // 413
    8.989452019816900e+00, // 414
   -3.931540676053249e+00, // 415
    1.095058298368984e+00, // 416
   -1.593810252932899e+01, // 417
   -4.727721007117762e+00, // 418
    7.751469093913227e+01, // 419
   -8.616611819085913e+00, // 420
    2.008922709583233e+00, // 421
   -2.928954862593088e+00, // 422
    8.968040662202102e-02, // 423
   -7.035432702610974e+00, // 424
   -1.084429084100307e+01, // 425
    4.527774304004882e+01, // 426
   -5.520150117027345e+01, // 427
    4.375380916242774e-01, // 428
   -4.397830326690347e+01, // 429
   -1.540650067572209e+00, // 430
   -1.482815929541793e+00, // 431
   -2.822406466065450e-01, // 432
   -7.129730734499889e-01, // 433
   -1.335383661401020e+01, // 434
    1.897310413552279e+01, // 435
    2.185072615256638e+01, // 436
    9.259363075122673e+00, // 437
    1.117608061048294e+01, // 438
    2.007917866082139e-01, // 439
   -1.187837797971712e+01, // 440
    2.979181603581952e+00, // 441
    1.368278722510071e+01, // 442
   -4.948086194530078e+00, // 443
   -3.269015670770728e-01, // 444
    4.570482502568957e+01, // 445
    1.097066846327418e-01, // 446
   -1.003534203161584e+01, // 447
    8.104481877585973e+00, // 448
   -3.809400859566450e+01, // 449
    8.620485653960465e-01, // 450
    9.289888400933860e+00, // 451
   -2.016464886603468e-02, // 452
    1.443425818956240e+01, // 453
   -1.386081902824584e+00, // 454
   -3.754513759509813e+00, // 455
   -5.136951479373088e-02, // 456
   -2.475717698586266e+01, // 457
    8.322491584697461e-01, // 458
   -3.155852809175010e+01, // 459
    4.500635940482258e-01, // 460
    4.971570215488755e+00, // 461
   -1.435103302334368e+01, // 462
    5.223967252187580e-02, // 463
   -1.546870714222255e+01, // 464
    3.437045456158381e+00, // 465
    3.232473063387919e+01, // 466
   -3.823381568209679e-04, // 467
   -2.974050009588879e+01, // 468
   -5.161963039780930e+00, // 469
   -1.878062437287516e+01, // 470
    2.387218027055281e+00, // 471
    9.596012683590287e-01, // 472
   -8.124834244431427e-05, // 473
    1.226337233132991e+00, // 474
   -1.375243096010569e+00, // 475
    9.938511131486475e+00, // 476
    7.917834676570166e+01, // 477
   -2.760429194954582e-02, // 478
   -3.137566084301268e+00, // 479
    7.409356701928221e+00, // 480
   -8.568711041879769e-01, // 481
    8.286296601609076e+00, // 482
    8.512393338733165e+01, // 483
   -5.436313667951348e+00, // 484
   -5.441195253195845e-04, // 485
    1.867019376575398e+01, // 486
   -6.375444562029277e-01, // 487
   -6.948619182736530e-06, // 488
   -9.365464066639068e-03, // 489
    9.091380160740676e-05, // 490
   -3.964135832528561e+00, // 491
   -2.028002006809518e+01, // 492
    2.984216673312274e+01, // 493
   -2.747754580067270e+01, // 494
    4.342400300337090e-03, // 495
   -1.382443558300765e+01, // 496
   -2.920629555021147e-01, // 497
    1.665999206444422e+01, // 498
   -1.622209339188148e+01, // 499
   -1.304512656767659e+01, // 500
    1.758359345937082e+01, // 501
    2.120192721705169e+01, // 502
   -8.524137632657439e+00, // 503
   -2.519696530160878e+00, // 504
   -3.286125933994330e+00, // 505
   -1.472403031085348e-01, // 506
    8.983667853917962e-02, // 507
   -1.170780231742268e+01, // 508
   -6.680880321637114e+00, // 509
    3.344828118880696e+01, // 510
   -3.096566988364271e+00, // 511
   -9.302152883380364e+00, // 512
    1.226871646284255e+01, // 513
   -1.507745569648670e+01, // 514
    7.466351504946064e-04, // 515
   -1.628204920556710e-02, // 516
    4.192779307460501e-02, // 517
    3.914879320115907e+01, // 518
   -3.323464694104207e+01, // 519
   -1.711048219759276e+00, // 520
   -1.505566641542723e+01, // 521
    2.109317711133738e-02, // 522
    2.707210144547662e-02, // 523
    7.610462614393044e-01, // 524
   -2.213091700406088e+00, // 525
   -6.317276466285395e-01, // 526
   -1.541682397640420e+01, // 527
    2.143706560362836e+01, // 528
   -4.407070548671586e-05, // 529
    1.931071927541588e+01, // 530
    7.821311868997455e+00, // 531
   -4.137651709715819e-01, // 532
    3.309707051121750e+00, // 533
   -8.497976905472154e+00, // 534
   -2.087129389200877e+01, // 535
    4.698877071563806e-01, // 536
   -1.163253641578553e-02, // 537
   -2.777048676597582e-07, // 538
    4.139560577923296e-02, // 539
   -1.405594297774837e+00, // 540
    3.053616643335386e+00, // 541
   -3.016620246344982e-05, // 542
   -1.517195576450045e+01, // 543
    1.307651412000345e-01, // 544
    1.910980657121566e+00, // 545
    1.314237525297477e+01, // 546
    1.782454214857855e+01, // 547
    1.603820085784418e+00, // 548
   -2.903719646164716e-02, // 549
   -3.104557903980790e-03, // 550
   -7.927901160664579e+00, // 551
   -1.560546400699683e+00, // 552
   -2.285506931849752e+00, // 553
    2.999512326891043e+00, // 554
    1.527236322225049e+01, // 555
    4.015348448908957e+00, // 556
    3.787632725072673e+01, // 557
   -2.719392795175812e+00, // 558
   -5.819327919985273e-03, // 559
    1.935349958227006e+00, // 560
    1.394583101371618e+01, // 561
    1.370521506185530e+00, // 562
    2.679740425661984e-02, // 563
   -3.526864893415397e-02, // 564
    3.194166282835790e+00, // 565
    2.572609837007280e+00, // 566
    6.855329921552337e-03, // 567
    2.435472441119420e-01, // 568
    2.427106087003031e+01, // 569
    2.018569174181321e+01, // 570
    2.792216349705798e+01, // 571
    2.229044699690074e+01, // 572
   -7.510090151512861e-03, // 573
   -1.561811512790403e+01, // 574
    1.902021500829768e+01, // 575
   -2.002822961264787e+00, // 576
   -6.861866780332902e-07, // 577
    4.713338706077482e+01, // 578
    2.490872022689296e+00, // 579
   -1.977334311363068e-01, // 580
    1.445051396209513e+01, // 581
    3.917352948397189e+01, // 582
    2.176074396994149e+01, // 583
   -2.590672848217652e-02, // 584
    2.105983937116725e+01, // 585
    9.522081136922360e-01, // 586
    1.317837457391171e+01, // 587
    1.903372684863490e+00, // 588
   -8.318135336339421e-01, // 589
    1.876915135093785e-01, // 590
    5.694365218002303e+01, // 591
    3.447248833256865e+01, // 592
   -2.827343370550864e-06, // 593
    4.371534681744448e+01, // 594
    8.649173190092282e-02, // 595
    1.511544981627994e+00, // 596
   -6.089218934802157e+00, // 597
   -1.106514022878578e-01, // 598
   -6.108073161305611e+00, // 599
   -5.037861551268346e+00, // 600
   -1.395456467770700e-03, // 601
   -3.894934386688036e+01, // 602
   -2.702906761035412e+00, // 603
    1.704248636534708e-02, // 604
   -3.518925222984285e-01, // 605
   -6.419816881322710e-04, // 606
   -2.039096720121963e+01, // 607
   -7.694892310662027e-01, // 608
    4.309514756190524e+00, // 609
    2.350114502849614e-02, // 610
    2.923530971153263e+01, // 611
    1.607440775814320e+01, // 612
   -5.344636968551492e+00, // 613
    5.346057980093502e+00, // 614
    3.794758054279585e+00, // 615
   -5.928109220397335e-02, // 616
   -4.836630335064379e-04, // 617
    9.786199190768239e-01, // 618
   -1.920018923710078e-01, // 619
   -9.435891729371404e+00, // 620
    4.948160475416016e+00, // 621
    1.428502330948733e+00, // 622
   -9.789439270227517e+00, // 623
    8.154960915096693e+00, // 624
   -4.733070487364226e+01, // 625
    3.725730348653652e-02, // 626
   -4.895870281568425e+01, // 627
    4.043731397762618e+01, // 628
    1.870098096422238e-04, // 629
   -2.976782133189458e+00, // 630
    1.912133281884788e-01, // 631
   -3.567950617078522e-01, // 632
    3.257592726704035e+01, // 633
    2.922013032909387e+01, // 634
   -5.297837523907028e+00, // 635
   -4.994324440963635e+01, // 636
   -2.827651235282961e+00, // 637
   -4.735308075088727e+00, // 638
    6.405625637161511e+01, // 639
   -9.429689213526495e-03, // 640
    6.740600987227796e+00, // 641
    1.789308961456184e-01, // 642
    1.090089554301098e-04, // 643
   -6.385960737487546e+01, // 644
    8.647551069850447e-01, // 645
    4.694670753797275e+01, // 646
   -1.343179965339960e+01, // 647
   -2.553156353033278e-04, // 648
    8.365559421231383e+01, // 649
   -3.781266165516551e-05, // 650
   -2.861360436956879e+01, // 651
   -1.127186588514559e+00, // 652
    1.235408751245293e+01, // 653
   -1.382130187533397e+01, // 654
    1.336312405038294e+01, // 655
    2.308198099181601e+00, // 656
    3.320481748620851e+01, // 657
   -4.558505055973104e-01, // 658
   -6.539535999821918e+00, // 659
   -2.670165681912102e+00, // 660
   -2.836136706876813e+00, // 661
    8.772760157671091e-01, // 662
    3.434790717763513e+00, // 663
   -5.552192735159090e+01, // 664
    3.806711053206688e+01, // 665
    1.666269498934202e+00, // 666
   -5.475529425386439e-01, // 667
   -8.009795767306659e-02, // 668
    1.383478256465074e+00, // 669
   -6.837026962891892e+01, // 670
    1.444946697348639e-01, // 671
    5.802553353962558e-02, // 672
    2.733174056809050e-01, // 673
    6.785183811831003e-01, // 674
   -1.897661271889684e+01, // 675
    1.294756888763065e+01, // 676
   -4.327850431929883e+00, // 677
   -3.463062227077590e+01, // 678
   -5.190607705965457e-01, // 679
   -9.097964740252076e+00, // 680
   -1.178109336492034e+00, // 681
    2.059935076174553e+01, // 682
    2.050585615831764e-06, // 683
    1.576283725860971e+01, // 684
   -3.184608208688060e+00, // 685
    2.028441944156851e-07, // 686
    7.913669261839461e-03, // 687
    1.406179004477760e+00, // 688
   -8.960731339335744e+00, // 689
    2.293443248486217e+00, // 690
   -1.626970692211463e+01, // 691
   -9.248104692600474e+00, // 692
   -2.644395750547833e+01, // 693
   -2.030684055828581e+01, // 694
   -1.127883336084294e+01, // 695
   -3.496775069472940e+01, // 696
    9.938868692055429e-02, // 697
    5.123783887908198e+00, // 698
    4.819117717333115e+01, // 699
    1.371057230805950e-04, // 700
   -1.720132877356443e+01, // 701
    2.437978036814413e+00, // 702
    7.433621045265814e-03, // 703
    2.465203390666260e+00, // 704
    7.085762499801547e-01, // 705
   -1.492392479946711e+00, // 706
    3.236774385434771e-04, // 707
   -9.907804351581016e-02, // 708
   -4.252649958149356e+00, // 709
   -9.806753186406544e-02, // 710
    3.462401145423487e-01, // 711
   -1.106382289697745e+02, // 712
   -7.727702674485598e+00, // 713
    4.421496974553166e+00, // 714
    5.490460121948768e-02, // 715
    1.388751967876201e+01, // 716
    7.443677761313680e+00, // 717
    3.362920612810037e+00, // 718
    6.151021952862147e+00, // 719
   -2.798689668873373e-01, // 720
   -4.581686109919719e+01, // 721
   -4.964052645551891e+01, // 722
    1.034449391276677e+01, // 723
    1.140531952106015e+01, // 724
   -2.569732861780438e+00, // 725
   -3.180306006005739e+01, // 726
   -5.542982342319720e+01, // 727
   -4.862933913886235e+00, // 728
   -1.204396448886925e+01, // 729
   -3.281503291166104e-01, // 730
    8.305845092048939e+00, // 731
   -6.989918311055944e+00, // 732
   -8.066442965119535e-03, // 733
    2.236741501211580e+01, // 734
   -4.495921719692228e+00, // 735
    1.681020148341152e+00, // 736
   -2.212081509943499e+01, // 737
    6.778740055589832e-03, // 738
   -3.188426556072059e+01, // 739
   -4.676605201699776e+00, // 740
   -2.666293933591020e+01, // 741
    3.837435723425701e-02, // 742
   -8.161058098810750e-04, // 743
   -1.725855002543183e+01, // 744
    7.667315747173830e-01, // 745
   -1.315729973040647e-01, // 746
   -7.661542777710732e-03, // 747
    6.213281500752545e+00, // 748
   -4.323143117967170e+01, // 749
   -1.260509863435629e-02, // 750
   -4.059704580701569e+00, // 751
   -1.606502327539184e+01, // 752
   -3.068458243044761e+01, // 753
   -8.414357478979821e-01, // 754
    1.566680307052232e+00, // 755
    3.886597220448758e+01, // 756
   -5.212419818825776e+01, // 757
    1.501504910067092e+01, // 758
    8.540335476777274e+00, // 759
   -2.702657128441409e+01, // 760
   -4.730525958081064e+00, // 761
    1.538316606797040e+01, // 762
    1.058737399394217e+00, // 763
    8.910532295994280e+00, // 764
   -3.744682198902930e+01, // 765
   -3.327013938638444e+00, // 766
    3.583583415708189e+00, // 767
   -2.353979477612614e-01, // 768
    3.826853120659890e+01, // 769
   -2.310305645199422e-06, // 770
    9.325028036719014e-01, // 771
   -1.996344230285918e+00, // 772
    7.523501754036763e-03, // 773
    2.412869785732216e+00, // 774
   -1.370993562435708e+01, // 775
    1.272564109332880e+01, // 776
    4.561843317646064e-02, // 777
    1.548873989582633e+01, // 778
    3.565954726878266e+01, // 779
   -5.464461556701470e+00, // 780
   -5.163097700133570e-05, // 781
   -1.289317295237869e+01, // 782
   -6.411213449701734e-05, // 783
   -3.363270279891772e+01, // 784
   -5.053322731601030e+01, // 785
    8.189982536093807e-03, // 786
    4.830662015174836e+01, // 787
    1.397385871761893e+01, // 788
    2.256270360364251e+01, // 789
   -1.002534018171994e-03, // 790
   -5.875682886584772e-01, // 791
    1.217306798541533e+01, // 792
   -4.449537702125696e-03, // 793
    1.238678856124637e+01, // 794
   -1.174293755040925e+00, // 795
   -8.146531218534358e+00, // 796
    1.167456699981420e-04, // 797
    1.324522841187575e-04, // 798
   -6.407983860581856e-02, // 799
    5.441411384279875e+01, // 800
    3.394735360811779e+01, // 801
   -1.679648870641590e-05, // 802
   -6.498530506906930e+01, // 803
    1.573163669117392e+01, // 804
   -1.701618939743600e+00, // 805
   -1.111398324290769e+00, // 806
   -4.424969848782362e+01, // 807
    1.906714058906754e-02, // 808
    1.937946814891821e+01, // 809
    8.182447501920047e+00, // 810
   -9.487720418304425e+00, // 811
   -2.306098936656884e+01, // 812
   -1.391039533519675e+01, // 813
    1.081803059233849e+00, // 814
   -1.188786852794913e-02, // 815
    1.747057932065907e-02, // 816
    2.285096654728180e+00, // 817
    2.884348147086835e-02, // 818
   -5.848225722160554e-01, // 819
   -1.168139522295235e-01, // 820
   -1.602963308427886e+01, // 821
   -4.391417045284138e-03, // 822
   -1.348653612816034e+01, // 823
    5.600640498595282e+00, // 824
   -2.270708728264006e+01, // 825
   -1.136590090773889e+01, // 826
    3.595735759240804e+01, // 827
   -1.519456167611923e-09, // 828
   -1.877247406699646e-02, // 829
    1.868890313057615e+00, // 830
    1.204518566676173e+01, // 831
   -7.585937174753701e-04, // 832
    3.608128997126100e+01, // 833
   -5.887886795026309e+00, // 834
    4.043633343583522e-04, // 835
    1.231604355257272e+01, // 836
   -3.227173115041748e-04, // 837
   -1.557214104213220e+01, // 838
   -1.857228658984993e+01, // 839
    4.535040169467203e-06, // 840
    1.574618237145989e+01, // 841
   -3.485824183720202e+01, // 842
    5.760075554318521e+01, // 843
   -5.952893238796456e+00, // 844
    2.635116834500339e+00, // 845
   -1.335456764750187e-02, // 846
    1.541487909363260e-03, // 847
   -3.394668138901306e+00, // 848
   -6.072847991938705e-03, // 849
    2.011330552302817e+01, // 850
   -8.676310143018936e-01, // 851
   -3.352569493326558e+01, // 852
   -3.130095158638871e-01, // 853
    8.290402079109978e+00, // 854
    1.119188046112520e-03, // 855
    5.327572427681838e+00, // 856
   -1.563488098616717e+01, // 857
   -3.380997865727670e+00, // 858
   -2.307934520754551e-01, // 859
    1.237861888782869e+00, // 860
    6.110652722794469e+00, // 861
   -1.373324747184662e+01, // 862
    1.310465259066971e+01, // 863
   -4.413786178362167e+01, // 864
    3.216737673899623e-03, // 865
    1.653563159665636e-02, // 866
    7.322299871733646e+00, // 867
    1.072593716236536e+01, // 868
    5.126115894326714e-01, // 869
   -3.125125992030537e-04, // 870
    4.037007646944055e+00, // 871
    6.005150291477996e-02, // 872
   -1.617931012208859e-04  // 873    
    };    

    for (int i = 0; i< 874; i++)
      twobodyfit[i] = twobodyfit_cp[i];

  } else if (ion == "Cl") {
    polarizability = 5.3602; //A^3 CCSD(T)/t-av5z from finite field method  

    //from XDM     
    C6XH  = 3.068900000000000e+02; // kcal/mol * A^(-6)
    C6XO  = 7.461990000000000e+02; // kcal/mol * A^(-6)
   
    //fit_ccsdtf12_avtqz_fit_5.5-6.5_5th_iter+nm9-14_xdm_mdp1t298_3.5_5.5_polargrid_configs_upto8A  fit-03/02/2016 as submitted to JCTC 
   
    D6XH  = 1.470292940230175e+01; // A^(-1)
    D6XO  = 1.534567526531904e+01; // A^(-1)
   
    K_HH_INTRA =          9.930156092358260e-01; // A^(-1)
    K_OH_INTRA =          1.999999998641889e+00; // A^(-1)
   
    K_XH_COUL =           8.357582923634128e-01; // A^(-1)
    K_XO_COUL =           3.432825654262129e-01; // A^(-1)
   
    K_XLP_MAIN =          2.178539030276617e-01; // A^(-1)
   
    IN_PLANE_GAMMA =      1.101786589509475e+00;
    OUT_OF_PLANE_GAMMA =  1.237025493507669e+00; 
   
    R2I =  5.500000000000000e+00; // A
    R2F =  6.500000000000000e+00; // A

    double twobodyfit_cp[] = { 
    5.420365436820421e+00, // 0
    8.974533249561450e+00, // 1
   -3.614049489098692e-01, // 2
   -5.114139819837765e+00, // 3
   -1.736249424504656e+01, // 4
    1.240585734865707e+01, // 5
    7.129713092111645e+01, // 6
   -2.151393055975399e+00, // 7
   -6.057275522888518e-01, // 8
   -7.503384862423093e+00, // 9
   -5.147320725055354e+01, // 10
    6.433902251145293e+00, // 11
    4.235420443123877e+01, // 12
   -4.488091902228756e+01, // 13
   -2.288385887187729e+01, // 14
    6.217193035504845e-01, // 15
    8.022879312037176e+00, // 16
   -5.139362969141644e+00, // 17
   -7.437847204937844e+01, // 18
    3.270760194840875e+01, // 19
   -7.046277870809628e+00, // 20
   -6.405560093432028e+00, // 21
    1.237007284237649e+00, // 22
   -3.576434821240395e+01, // 23
    1.082263316180874e+02, // 24
   -2.986558916797822e+01, // 25
   -6.735150702727084e+01, // 26
   -2.553040461080647e+00, // 27
   -8.158391944093070e+00, // 28
    1.048668244666463e+01, // 29
    1.466125571624096e+01, // 30
   -6.717256643791856e+00, // 31
   -1.772470392287356e+00, // 32
    5.372092970298329e-01, // 33
    2.428828182256897e+01, // 34
   -2.178601351285136e+00, // 35
    2.856277355779727e+01, // 36
   -2.660471945430395e+00, // 37
   -3.175690731501570e+00, // 38
    2.210516738360337e+00, // 39
    2.669230381129131e+01, // 40
    1.359076584460235e+01, // 41
   -3.523653061505044e+01, // 42
   -4.016061381412046e+00, // 43
    1.329124435897196e+01, // 44
    2.602585109521953e+01, // 45
   -1.058896035701437e+01, // 46
    8.529556141500677e+00, // 47
    2.844808559387913e+01, // 48
   -1.255647837850381e+01, // 49
    4.445499028338361e+01, // 50
    4.716668118848199e+01, // 51
   -2.287626782957357e+01, // 52
   -3.039805728704003e+01, // 53
   -2.400143305425374e-01, // 54
   -4.402387579425644e+00, // 55
   -3.202152826268057e+01, // 56
    6.629425115748129e+00, // 57
    1.610782770115658e+00, // 58
    5.683191700342465e+00, // 59
    9.064598054276390e+00, // 60
   -5.212148673413519e+00, // 61
   -1.616107404565501e+00, // 62
   -2.150405282647123e+01, // 63
   -3.208613290743097e+01, // 64
   -8.588818016601821e-01, // 65
   -1.012520366781876e+00, // 66
    2.731855605358541e+01, // 67
    1.155097856161180e+01, // 68
    4.136272673339253e+00, // 69
   -6.391092185674798e+00, // 70
   -7.464833791733982e+00, // 71
    2.117574812263059e+01, // 72
    6.623029468377823e+00, // 73
   -8.380384621586010e+00, // 74
   -1.710296936805818e+01, // 75
    2.084229310855273e+01, // 76
    6.254046778845521e+00, // 77
   -3.470005419496023e+00, // 78
    1.941393315061029e+00, // 79
    4.616057260222888e+00, // 80
   -3.598739583255495e+01, // 81
   -2.250350779719159e+01, // 82
    1.437039334586388e+01, // 83
    8.059988059751429e+00, // 84
   -2.327840474887496e+00, // 85
   -1.264242136257234e+00, // 86
    3.362436459913561e+00, // 87
   -4.201856405440544e+00, // 88
    3.632850982913952e+00, // 89
    5.439709906278445e+01, // 90
   -1.467971110007663e+01, // 91
   -9.248956775074586e+00, // 92
    1.767746132203107e+01, // 93
   -2.028556938671525e+01, // 94
   -3.685631805442250e+00, // 95
   -2.073962044958955e+01, // 96
    1.323858825124965e+01, // 97
   -2.399277359218192e+00, // 98
   -2.693953919384127e+01, // 99
   -2.608030443629140e+00, // 100
    3.386619525356380e+00, // 101
    7.403495184179788e+00, // 102
   -1.152362809833209e+01, // 103
    2.545964206969357e+01, // 104
    1.978272104653871e+01, // 105
    3.727140749961853e+00, // 106
    8.108283635415985e+00, // 107
   -1.092078945576509e+01, // 108
   -5.561442216157439e+00, // 109
   -8.904757138538248e+00, // 110
    1.008848966434144e+00, // 111
   -4.047343216515520e+01, // 112
   -1.600487290367565e+01, // 113
   -1.218031972522618e+01, // 114
   -2.773558802468004e+01, // 115
    2.810435037504432e+01, // 116
    2.717094411399312e+01, // 117
   -1.477965612350931e+01, // 118
   -3.551439966623230e+01, // 119
   -3.564228365928561e+01, // 120
   -5.462545133373435e+01, // 121
    1.689052759404912e+01, // 122
    8.759481345148938e+00, // 123
    8.639591457906600e-01, // 124
    5.072637740016675e+00, // 125
   -1.831820191896123e+01, // 126
   -2.540110591449914e+01, // 127
    5.261173648264346e+01, // 128
    7.942493071234575e+00, // 129
    7.696142901991354e+01, // 130
    1.324484141740559e+01, // 131
   -4.257515662598775e+01, // 132
   -4.534225685638182e+00, // 133
    2.855617578350235e+01, // 134
   -6.031567998245599e+00, // 135
    1.856007559617589e+00, // 136
   -2.305906134691170e+00, // 137
   -8.079752139887334e+01, // 138
   -8.553661445162363e-01, // 139
   -1.766679010663627e+01, // 140
    1.858235869643027e+01, // 141
   -7.974595182456417e+00, // 142
   -6.140959286356107e-01, // 143
   -2.682184977387618e+00, // 144
    1.166005884414345e+01, // 145
   -1.788166086115567e+01, // 146
    8.571264300863499e+00, // 147
    1.676932276771504e+01, // 148
   -1.490446674265317e+01, // 149
   -9.330141653197094e+00, // 150
    4.683617602139688e+01, // 151
   -4.565676271231426e+00, // 152
   -3.040114150121487e+01, // 153
    1.435414283394888e+01, // 154
    1.413561052945981e+00, // 155
   -2.258759794406586e+01, // 156
   -4.438725590755470e+01, // 157
   -1.208991086590452e+01, // 158
   -8.083933604264999e+00, // 159
    2.798938996483756e+01, // 160
   -2.580782602028073e+00, // 161
    3.695277358257996e+00, // 162
    5.159978803953694e+00, // 163
   -1.914615377998490e+01, // 164
    8.931707376636009e+00, // 165
    2.040961986620531e+01, // 166
   -2.953453731180267e+01, // 167
    4.775494529490170e+01, // 168
    1.000758383443858e+00, // 169
    7.987465023622634e+01, // 170
    1.141704907743109e+01, // 171
    1.449699328654474e+01, // 172
    1.780199816636397e+01, // 173
    1.952565971104501e+01, // 174
    1.885598960780963e+01, // 175
    2.821710438294024e+01, // 176
    1.592481378074015e+00, // 177
   -8.259557265801284e+01, // 178
   -8.957857443167610e+00, // 179
   -5.487664094043009e+01, // 180
    1.675399157097648e+01, // 181
    1.041978792735623e+01, // 182
    1.908398490010942e+01, // 183
    4.865954587792845e+00, // 184
   -1.599997715619881e+01, // 185
   -6.973943192437688e+00, // 186
    8.959520710826119e+00, // 187
   -3.266054252260696e+00, // 188
   -1.990694590837778e+00, // 189
   -5.032465051906271e-01, // 190
    4.595152852124035e+00, // 191
   -2.558297153125656e+01, // 192
   -2.325747843367716e+01, // 193
   -4.096851704252946e-01, // 194
    1.724614131304738e+01, // 195
   -9.704537433421001e+00, // 196
    3.785720804387888e+00, // 197
    1.360185839367952e+00, // 198
   -2.294233672021199e+01, // 199
   -1.461666679247223e+01, // 200
    2.341439287470232e+01, // 201
    3.063950503010401e+01, // 202
    2.331411936442852e+01, // 203
    3.328572453171299e+00, // 204
   -1.817053157959908e+01, // 205
   -1.436269746308451e+00, // 206
    1.246464635063672e+01, // 207
   -1.315948503726263e-01, // 208
    1.229222563898164e+01, // 209
   -2.085420418007385e+01, // 210
    1.686362299448966e+01, // 211
   -8.134436421046592e+00, // 212
   -2.047136467794468e+01, // 213
    2.723421483324120e+01, // 214
    3.901625655553084e+00, // 215
    2.113212137702375e+01, // 216
    3.619871195027156e+00, // 217
    1.091891346564602e+01, // 218
   -5.109669827689057e-01, // 219
    2.339547958608982e+00, // 220
   -5.590477000206894e+01, // 221
   -6.092255100974819e+01, // 222
   -3.996898767968224e+01, // 223
   -7.411987977304932e+00, // 224
    2.646431772795986e+00, // 225
   -3.577448941386157e+00, // 226
   -1.089801239966987e+00, // 227
   -8.254684399171877e+00, // 228
   -2.768385861458101e+00, // 229
   -5.108382311327975e+00, // 230
    2.744579973016778e+01, // 231
   -1.003586220021728e+00, // 232
   -1.151267487037378e+01, // 233
   -1.705049706570912e+01, // 234
   -1.552344857498131e+01, // 235
    2.114154801660291e+01, // 236
    1.976539821364390e+01, // 237
   -1.701195881263595e+01, // 238
   -2.528441940103455e+00, // 239
   -1.749710381016051e+01, // 240
   -3.510372886455155e+01, // 241
   -1.657712218019932e+01, // 242
   -6.761398465882122e+00, // 243
   -8.849395636058144e+00, // 244
    3.104940006592247e+01, // 245
   -1.803267793368615e+01, // 246
   -5.213195081800209e+00, // 247
   -9.849502150024867e+00, // 248
    2.444053642353061e+01, // 249
    1.316136952866164e+01, // 250
    3.430559132717398e+01, // 251
   -7.723503407655094e+00, // 252
   -9.572432229502187e+00, // 253
    5.722049997806701e+00, // 254
   -3.910557084759743e+01, // 255
   -9.692156753412988e+00, // 256
   -3.157581777542813e+01, // 257
    2.146581029414357e+01, // 258
    5.000053636427106e+00, // 259
   -8.027201323410669e+00, // 260
    2.147454766730157e+00, // 261
   -1.842540076465675e+01, // 262
   -4.030140944427703e+01, // 263
    2.293037685840723e+00, // 264
   -2.441994593532891e+01, // 265
   -2.620214195385057e+00, // 266
    2.163617281819664e+01, // 267
    1.953070548857644e+01, // 268
    3.416056056431416e+01, // 269
    7.358446202588266e+00, // 270
   -1.962183993007260e+01, // 271
    1.635365918921889e+01, // 272
    2.002587000923410e+00, // 273
   -3.211142087014746e+01, // 274
   -2.768264261980832e+00, // 275
   -1.828722422694941e+01, // 276
    1.054141862512178e+01, // 277
   -8.826133844141154e+00, // 278
    9.537973853341965e+00, // 279
   -7.000010583458142e-01, // 280
    1.730332797361568e+01, // 281
    6.495361979967111e+00, // 282
    1.798473207993115e+01, // 283
   -2.371307485335045e+01, // 284
   -5.192837112168805e+01, // 285
   -2.093645954391485e+00, // 286
    1.030546455989328e+01, // 287
   -5.533648179413279e+01, // 288
    5.735893329748073e+00, // 289
    6.951199943098369e+00, // 290
    1.057529925906330e+01, // 291
    2.482017338971862e+01, // 292
    1.467562512043645e+00, // 293
   -2.108691448085636e+01, // 294
    4.750624514358953e+00, // 295
    2.311493042981464e+01, // 296
   -2.764495512081634e+01, // 297
   -1.119328932834088e-01, // 298
    2.121612727307955e+01, // 299
   -1.002386926676850e+01, // 300
    6.437833214748018e+00, // 301
    5.870775766831752e+00, // 302
   -1.006711861477825e+01, // 303
    7.105034816312027e+00, // 304
    2.317113509738873e+00, // 305
   -3.450724781777385e+00, // 306
    4.518579438788305e-01, // 307
    1.029451068796515e+01, // 308
   -1.589865611859607e+00, // 309
    8.498526385910338e+00, // 310
   -1.995537584622140e+01, // 311
    4.092847734064418e+00, // 312
    4.295916434949061e+01, // 313
    5.347175854687765e+01, // 314
   -3.258689690190795e+01, // 315
   -6.015961845112272e+00, // 316
   -6.736694536761545e+00, // 317
    1.859111435206554e+00, // 318
    1.963033364360970e+00, // 319
   -3.117407284551244e+01, // 320
   -1.360760108857131e+01, // 321
    6.192019151434620e+00, // 322
    4.220556430948049e+01, // 323
    1.990864687407807e+01, // 324
    6.819230955183940e+00, // 325
    5.745530479517496e+00, // 326
    6.688021051562302e+00, // 327
    5.361890752631754e+01, // 328
    5.877905442384914e+00, // 329
    1.979522862745969e+01, // 330
   -6.913103172285922e+00, // 331
    2.144368730239180e+01, // 332
    6.629336199066228e+00, // 333
    2.377247352625830e+00, // 334
   -1.100812695899249e+01, // 335
   -3.045960972542021e-01, // 336
   -3.308449808812113e-02, // 337
    6.712412358876283e+01, // 338
   -1.650010333348408e+01, // 339
    1.246815396173519e+01, // 340
   -4.242770165425002e+00, // 341
   -1.550353565876411e+01, // 342
    4.309966770024712e+01, // 343
   -3.105502961754277e+01, // 344
    1.337294513844114e+01, // 345
   -1.076806839246244e+01, // 346
    9.000367966089568e+00, // 347
   -2.922311642157034e+01, // 348
   -1.170015190611258e+01, // 349
    6.388549825586129e+00, // 350
    2.443394677148746e+01, // 351
    1.130759390653177e+01, // 352
   -9.192796046732061e+00, // 353
    2.500589580010024e+00, // 354
   -7.199910077276920e+00, // 355
   -1.821487442787079e+01, // 356
    1.370714071412016e+01, // 357
   -6.464787062358625e+00, // 358
    1.186274018765287e+01, // 359
   -3.804538825210185e+01, // 360
    2.191553662123316e+01, // 361
    1.142540097400486e+01, // 362
   -2.554047351837024e+01, // 363
   -4.008618850877719e+01, // 364
   -7.622586068798835e+00, // 365
   -6.017225989801467e+00, // 366
   -9.921878674767740e+00, // 367
   -3.314764893565928e+00, // 368
   -1.165342574852311e+01, // 369
   -1.028520197147723e+01, // 370
    8.320002977230805e+00, // 371
   -1.022349455342947e+01, // 372
    8.305754934087535e+00, // 373
    6.968914514746291e-01, // 374
   -1.748912898713278e+01, // 375
    1.974626032155386e+01, // 376
    1.157253440269137e+01, // 377
   -1.793311488005838e+01, // 378
    3.711727542361871e+01, // 379
    2.287386985476677e+01, // 380
    4.631456219206719e+01, // 381
    3.844554091616491e+00, // 382
    6.535872635983242e-01, // 383
   -9.390324489696216e+00, // 384
    6.088043022643005e+00, // 385
   -1.224603145508753e+01, // 386
    4.171966520846473e-02, // 387
   -1.892363919850225e+01, // 388
   -1.442829062072873e+00, // 389
   -1.754356811607381e+01, // 390
   -7.001800325296136e+00, // 391
    4.570720227425097e+01, // 392
   -1.992254336621880e+01, // 393
   -5.571139065434885e+00, // 394
    6.932148225468133e+00, // 395
   -6.915543302607740e+00, // 396
    6.234468999153425e+00, // 397
    4.627734699063757e+00, // 398
    2.688864390533626e+01, // 399
    1.953554770143486e+01, // 400
    1.636659087794874e+00, // 401
    2.713402126944774e+00, // 402
   -5.191883563367107e+00, // 403
   -2.412052337397695e+01, // 404
    2.087358992328253e+01, // 405
   -5.757448015277136e+01, // 406
    8.975151867374559e-01, // 407
   -2.882341476100290e+01, // 408
   -2.472817847244015e+00, // 409
   -6.964434311542445e+00, // 410
   -7.611140115610572e+00, // 411
   -3.004788559098811e+01, // 412
    9.162961879003563e+00, // 413
    1.248578105366220e+00, // 414
    1.428862726489200e+01, // 415
    5.344852970468920e+00, // 416
   -2.538838742892403e+00, // 417
   -7.218222496249626e+00, // 418
   -2.495190577850352e+00, // 419
    1.446784083079122e+01, // 420
   -4.310812993409436e+00, // 421
    6.989355935924829e+01, // 422
   -3.670225786180875e+01, // 423
    5.588855888071035e+00, // 424
    5.955113007387789e+00, // 425
    2.249512792297836e+00, // 426
    2.688434660830061e+00, // 427
   -2.474818934053570e+00, // 428
   -1.957941347147619e+01, // 429
   -2.036557348296072e+00, // 430
    1.682346104015804e+00, // 431
    2.425297007474164e+00, // 432
   -9.617042162189868e+00, // 433
    9.251905803198477e+00, // 434
   -1.336510914664056e+01, // 435
   -2.811515126827133e+01, // 436
   -2.019821113921182e+01, // 437
   -2.113046685880719e+01, // 438
    1.070962299281542e+01, // 439
   -4.559156644652746e+00, // 440
    6.583135459478357e+00, // 441
    4.161741292830947e+01, // 442
    7.778156185649166e+00, // 443
   -3.775104425376341e+00, // 444
    2.379912947002796e+01, // 445
    1.747150063904412e+01, // 446
    1.201072229054756e+01, // 447
    3.473247981091463e+00, // 448
    8.534794639260914e+00, // 449
   -1.607615254130017e+00, // 450
    9.273104743606725e+00, // 451
   -1.566778271967669e+01, // 452
   -7.832968387607429e+00, // 453
   -5.377694047155327e+00, // 454
   -1.222488839140405e+00, // 455
    1.060559167510450e+01, // 456
   -4.593701199842479e+01, // 457
   -6.582091019787407e+00, // 458
    2.493468051977924e+00, // 459
   -2.221095634672421e+00, // 460
   -8.957539179924081e-01, // 461
   -1.301939190470669e+01, // 462
    3.301119554416737e+00, // 463
    2.245616487211789e+01, // 464
    2.474537781304007e+01, // 465
   -1.602359069171013e+01, // 466
   -1.889629129190909e+00, // 467
   -1.694929896749414e+01, // 468
    2.031263192065603e+01, // 469
   -4.080613187583613e+00, // 470
   -1.052703501730385e+01, // 471
    6.806964167487195e+00, // 472
    1.562350929311993e+00, // 473
   -5.871301241188131e+00, // 474
   -1.848891828811199e+00, // 475
   -9.540295952938619e+00, // 476
   -1.064902173392137e+01, // 477
   -2.922989971250850e+00, // 478
    1.878278161612402e+01, // 479
   -1.099607351414654e+01, // 480
   -5.287876805500422e+01, // 481
    1.198884772205350e+01, // 482
    4.691119637907941e+01, // 483
   -5.768074670715388e+00, // 484
    8.267324111691709e+00, // 485
    1.749896872251731e+01, // 486
   -4.421605992102895e+00, // 487
    3.195951877741687e-01, // 488
    1.350048671554474e+01, // 489
   -1.719406834746755e+00, // 490
    4.599351177914321e+00, // 491
    9.586965899777281e+00, // 492
    2.802995015142659e+01, // 493
   -9.711597709056058e+00, // 494
   -2.365276350861164e+00, // 495
    1.596978130999806e+01, // 496
    1.134162511692360e+01, // 497
    1.059993928453446e+01, // 498
    6.961120354132132e+00, // 499
    2.396553238375774e+01, // 500
   -1.385101227022916e+00, // 501
    4.214322864103437e-01, // 502
    7.306719542488359e+00, // 503
    1.259894874179317e+01, // 504
    3.269920069325104e+01, // 505
   -9.061452904574906e-01, // 506
    2.421691875510369e+01, // 507
    4.934861664720359e+00, // 508
   -1.867531675109398e+01, // 509
   -3.186788157663160e+01, // 510
   -3.020856699918515e+01, // 511
    2.314466478173349e+01, // 512
    1.011526783546985e+01, // 513
   -8.634459640572057e+00, // 514
    4.143335270550329e+00, // 515
    5.351342721661251e+00, // 516
    1.049150744636058e+01, // 517
    6.527061490962025e+00, // 518
    2.493607512729493e+01, // 519
   -2.950751403073494e+00, // 520
    1.890403888772331e+01, // 521
   -6.536740674798676e+00, // 522
    7.141015680725016e+00, // 523
   -4.223887913770838e-01, // 524
   -4.748815357105055e+01, // 525
    3.634650880396449e+01, // 526
   -8.649455844556929e+00, // 527
    6.617103323124770e+00, // 528
    1.229753213270598e+00, // 529
   -1.781428838091163e+01, // 530
    4.285107633824639e+00, // 531
   -1.044713294121218e+01, // 532
   -2.367603908771813e+01, // 533
   -1.026988558799420e+01, // 534
    1.266374652653253e+01, // 535
    3.248685193962658e+00, // 536
    1.235578962802315e+01, // 537
    4.091294839779294e-02, // 538
    4.842083407086011e+00, // 539
   -1.289935138784456e+01, // 540
    1.380460807065940e+01, // 541
   -6.786754671614319e+00, // 542
   -1.139047446154692e+01, // 543
    1.239859716678244e+01, // 544
   -1.051237650632587e+01, // 545
    1.510417087935120e+01, // 546
    3.875293729859299e+00, // 547
    1.769935353491302e+01, // 548
    1.426537113372251e+00, // 549
   -2.138290092271322e-01, // 550
   -1.407612751826038e+01, // 551
   -1.085673315391452e+01, // 552
   -2.506478492308283e+00, // 553
   -3.465843992945812e+01, // 554
   -1.203087321789578e+01, // 555
    2.120811344574020e+01, // 556
   -9.281613619121778e+00, // 557
    6.737933913390357e+00, // 558
    2.267698746803766e+00, // 559
    7.670855556069439e-01, // 560
   -1.811367286920952e+01, // 561
   -9.864530870837575e+00, // 562
   -3.849814177730995e+00, // 563
   -4.176166169645937e+00, // 564
    2.460360368670688e+00, // 565
    7.462006964697347e+00, // 566
    1.328652795007796e+00, // 567
   -1.961155887224468e+00, // 568
   -1.093796910123872e+01, // 569
    9.416532977423044e+00, // 570
    1.451320598288948e+01, // 571
   -1.299647437833300e+01, // 572
    6.231316251945535e+00, // 573
   -5.760271421111537e+00, // 574
    5.929536987800938e+00, // 575
   -7.986687802266500e+00, // 576
    2.040561289848048e+00, // 577
   -4.229431321961505e+00, // 578
    2.513053231522195e+00, // 579
    1.520411363812566e+01, // 580
   -9.833252052901853e+00, // 581
   -1.056367152194083e+01, // 582
    3.047331897817759e-01, // 583
   -3.147390311326692e+01, // 584
   -1.175566057386694e+01, // 585
   -3.123846359460468e+01, // 586
    1.117123267909166e-01, // 587
    6.810295285298734e+00, // 588
   -5.205891748233281e-01, // 589
   -3.586993165638205e+00, // 590
    7.542605062102349e+00, // 591
    1.080448384483196e+01, // 592
   -3.288220930604502e-02, // 593
   -3.884899451281211e+00, // 594
    1.225770851039505e+00, // 595
   -3.776298831578481e-01, // 596
   -3.282458894559166e+01, // 597
    2.789093405690154e+00, // 598
    6.216520303398866e-01, // 599
    1.761199362653784e+01, // 600
   -8.613938053970536e+00, // 601
   -1.798665958274301e+01, // 602
   -2.713596024506291e+01, // 603
    1.772102001523501e+00, // 604
   -6.892071886910061e+00, // 605
   -4.138629077705509e+00, // 606
    2.234674846929800e+01, // 607
    1.136966313645112e+01, // 608
    9.580021090974187e+00, // 609
    4.170619921184336e+00, // 610
   -1.379683062655376e+01, // 611
    2.188895085096378e+00, // 612
    8.172286127394445e+00, // 613
   -1.088539368281275e+01, // 614
   -4.495442288069940e+01, // 615
   -2.346400671445986e+00, // 616
    2.167730706714709e+00, // 617
   -9.426814841062326e+00, // 618
    2.231000038060806e+01, // 619
    1.857172445135114e+00, // 620
    2.948545413469181e+01, // 621
    2.543720068907881e+01, // 622
   -7.920841580717721e+00, // 623
   -1.384428099898079e+01, // 624
   -1.074120467779319e+01, // 625
    1.895014595654219e+01, // 626
    3.029988798112492e+00, // 627
    1.418706079039845e+01, // 628
    5.047042969638614e-01, // 629
    1.429992998814806e+01, // 630
   -6.306583852163429e+00, // 631
   -2.233408529439043e+01, // 632
    9.113875422049011e+00, // 633
   -6.924361010206887e+00, // 634
    3.243666237481675e+01, // 635
   -2.577192698871183e+01, // 636
    8.775034141227317e-01, // 637
    1.850030404219175e+01, // 638
    3.890835971596060e+01, // 639
   -3.088002606764555e+01, // 640
   -3.336938081662554e+01, // 641
   -6.042631339313158e+00, // 642
   -6.951238894317305e-01, // 643
    4.506617597926243e+00, // 644
    1.911879135827003e+01, // 645
    7.456537328820087e+00, // 646
    1.005485344795779e+01, // 647
    8.237141213349559e-01, // 648
    4.755659502898317e+01, // 649
    3.835307744330697e-01, // 650
   -3.051866317648339e+01, // 651
    8.893803451722359e+00, // 652
    9.583932128211490e+00, // 653
   -8.476815418910215e+00, // 654
   -8.938411574799872e-01, // 655
    1.854086740734769e+01, // 656
   -4.011692955943924e+01, // 657
   -2.081387756867597e+00, // 658
   -1.627463432769864e+01, // 659
   -5.691256411170735e+00, // 660
   -1.207571922480790e+01, // 661
   -2.314546782326506e+01, // 662
   -1.516696813762105e+01, // 663
   -7.004568885774163e+00, // 664
    1.618938895707409e+01, // 665
    5.190731371373857e+00, // 666
   -3.962629713930387e+01, // 667
    6.393899930762706e+00, // 668
   -2.140668733135880e+01, // 669
   -2.024832329436369e+01, // 670
    2.486811703509164e+01, // 671
   -1.579986704050432e+01, // 672
   -8.142427982781623e-01, // 673
   -8.634207937097223e+00, // 674
   -4.952624533746985e+00, // 675
    2.441253478029694e+01, // 676
   -2.147813559860683e+01, // 677
    1.963070590141896e+01, // 678
   -2.038974548580389e+00, // 679
   -1.196934709992354e+01, // 680
   -1.467610435252511e+01, // 681
   -4.204886574956168e-01, // 682
   -2.296877007841335e+00, // 683
   -4.648563992777890e-01, // 684
   -2.602087161589967e+01, // 685
   -1.979728055301408e-02, // 686
   -1.140893656357819e+00, // 687
   -1.250971290478869e+01, // 688
   -2.656699743454282e+01, // 689
    1.198559034914570e-02, // 690
   -3.787260210675834e+00, // 691
    5.873562093645066e+00, // 692
   -9.914416400275542e+00, // 693
   -2.795354895233029e+00, // 694
   -1.682266190039986e+00, // 695
   -2.072093537815218e+01, // 696
   -2.796103021411817e+00, // 697
    1.919640175768869e+01, // 698
    7.971087635298495e+00, // 699
    3.419740280703500e+00, // 700
   -1.273508256586348e+01, // 701
    1.784615469267541e+01, // 702
   -4.493571352777807e+00, // 703
   -1.623772089690949e+00, // 704
    2.763393844702967e+01, // 705
   -6.652184262828033e+00, // 706
   -4.452222513671723e-01, // 707
   -2.498869681859210e+01, // 708
   -5.371945669368124e+00, // 709
   -1.322762404657203e+01, // 710
    3.793071322313902e+00, // 711
    2.020311062795324e+01, // 712
   -5.713632885530546e+01, // 713
    2.180791876301818e+01, // 714
    8.801396357436587e+00, // 715
    2.139371151054867e-01, // 716
   -6.484064345575954e+00, // 717
    2.772360056652509e+01, // 718
    6.818226977434733e+00, // 719
    3.246831510732290e+01, // 720
   -5.119511361307007e+00, // 721
    2.749383994456993e+00, // 722
    4.225488808191388e+01, // 723
    2.459771521607024e+00, // 724
   -9.214958007260567e+00, // 725
   -2.838648104321858e+00, // 726
   -3.059842247524435e+01, // 727
    5.888822609141076e+00, // 728
   -7.430016965402277e+00, // 729
    5.174305967867698e+00, // 730
   -5.514565339840497e+00, // 731
    1.107714067393587e+00, // 732
    1.758090201385586e+01, // 733
   -2.222546708785968e+01, // 734
    5.964142556401155e+00, // 735
    7.682928856041367e+00, // 736
   -9.320932769471531e+00, // 737
   -1.015549579423135e+01, // 738
   -2.375629410503047e+01, // 739
    1.899270240092092e+01, // 740
    2.559673626227332e+01, // 741
    6.218177170979557e+00, // 742
    1.095072787642323e+00, // 743
    5.865731631185390e+01, // 744
    9.278865495136625e+00, // 745
   -2.675364434489829e+01, // 746
    4.781252767429400e+00, // 747
   -2.838338578591493e-01, // 748
   -4.596187636473103e+01, // 749
    2.430050808087842e+01, // 750
    2.788199056383321e+01, // 751
    6.400501227937772e+00, // 752
    1.106025180514680e+01, // 753
   -1.535227700700588e+01, // 754
    1.935686065619951e+01, // 755
   -9.100766824992043e+00, // 756
    4.647266209461067e+00, // 757
   -4.797882302046602e+01, // 758
    2.563383915331916e+00, // 759
   -6.290194838357067e+00, // 760
    4.424227080427156e+01, // 761
    5.082877659884009e+01, // 762
   -3.028757923194566e+00, // 763
    1.518561748143265e+01, // 764
   -1.861101148572998e+01, // 765
   -2.975901185869632e-01, // 766
   -1.913805656829905e+01, // 767
   -7.301625726802324e+00, // 768
   -1.047810052955269e+01, // 769
   -6.490486757137487e-02, // 770
   -6.497564601665792e+00, // 771
   -3.712748477402295e+01, // 772
    2.618900708649972e+01, // 773
   -2.603248643090141e+00, // 774
   -1.724442161243362e+00, // 775
    5.328238832738474e+00, // 776
   -5.859531073744036e+00, // 777
   -9.187494147812977e+00, // 778
   -1.112283355334797e+01, // 779
    2.162354869337838e+00, // 780
    3.982181325961862e-01, // 781
    3.593933064544395e+01, // 782
   -3.681802304739282e+00, // 783
   -2.157742200240495e+01, // 784
    7.917634285020940e+00, // 785
   -1.915004762554803e+01, // 786
   -4.114368556683269e+00, // 787
   -3.625765462319712e+01, // 788
    7.842923467231782e+00, // 789
    9.870295608174523e+00, // 790
    1.356726619209402e+01, // 791
    1.200469010914323e+00, // 792
   -5.936211941240715e-01, // 793
    3.659497140238979e+00, // 794
    1.345914209704538e+01, // 795
    2.292667240728348e+00, // 796
    1.056380022594642e+00, // 797
    1.305546575125331e+01, // 798
   -1.805995506798926e+00, // 799
    7.126766901790905e+00, // 800
   -1.394026476699784e+01, // 801
   -2.990065492575397e+00, // 802
   -1.255283824294388e+01, // 803
    7.033270084455147e+00, // 804
    3.209030908888433e+01, // 805
    4.334714639480739e+00, // 806
   -1.856664210675770e+01, // 807
   -8.636210097099557e+00, // 808
   -5.049471019702628e+00, // 809
   -1.116162824366053e+01, // 810
   -4.426774242461473e+00, // 811
   -2.408091102653038e+01, // 812
   -4.391434684692805e+00, // 813
   -6.187839399439440e+00, // 814
    1.338607210682595e+01, // 815
   -1.804984464233404e+01, // 816
   -1.886692566886758e+00, // 817
   -4.097144399134398e+00, // 818
    1.684446492225594e+01, // 819
   -2.837857100222711e+00, // 820
    2.088390345775401e+01, // 821
   -3.627751781581836e+00, // 822
   -2.115289254452079e+01, // 823
   -6.432813083076347e+00, // 824
    1.000914836864622e+01, // 825
    2.658850604282044e+01, // 826
    2.196629953461910e+01, // 827
   -3.550985256309930e-03, // 828
    7.524323427609690e-01, // 829
   -1.257965441045549e+01, // 830
    4.573695339364689e+00, // 831
   -6.853498022930723e+00, // 832
    1.472807205625536e+01, // 833
   -1.329851423471350e+01, // 834
   -7.031097444309392e+00, // 835
   -6.644096992610582e+00, // 836
    1.928356426666260e+00, // 837
    7.226939877461629e+00, // 838
    6.590412604235160e+00, // 839
   -6.839847460597460e-02, // 840
   -4.825138456942606e-01, // 841
   -1.716223481451646e+01, // 842
   -1.579292431448302e+01, // 843
   -3.404951316513300e+01, // 844
   -1.078631301221177e+01, // 845
    2.002895444903658e+00, // 846
   -1.787192946594760e+01, // 847
    1.086106236205251e+01, // 848
    3.890505761800302e+01, // 849
   -7.467007444974789e+00, // 850
   -4.843179014062174e+00, // 851
   -5.442652284965239e+01, // 852
    3.485643158470473e+01, // 853
    3.644819837093647e+01, // 854
    8.914074486232036e-01, // 855
   -3.998279859536876e+00, // 856
   -9.948221763773606e+00, // 857
    3.653905963683146e+01, // 858
    3.021008266023248e+01, // 859
    3.894065474002711e+00, // 860
    8.963206838248741e+00, // 861
   -1.233623456143186e+00, // 862
    1.681726206841420e+01, // 863
   -2.216452511031777e+01, // 864
   -8.243956466423338e+00, // 865
   -1.888920035387535e+01, // 866
   -1.652168460495288e+01, // 867
   -1.660595355228141e+01, // 868
    1.078530808135876e+01, // 869
   -2.299310054485731e+00, // 870
    8.484763307858914e-01, // 871
   -4.435908587022939e+01, // 872
    1.075650356221445e+00  // 873
    };

    for (int i = 0; i< 874; i++)
      twobodyfit[i] = twobodyfit_cp[i];
  } else if (ion == "Br") {

    polarizability = 7.1668; //A^3 CCSD(T)/t-av5z from finite field method  
   
    C6XH  = 3.941680000000000e+02; // kcal/mol * A^(-6)
    C6XO  = 9.426500000000000e+02; // kcal/mol * A^(-6)
   
    //fit-h2o_br_ccsdtf12cbs_mdp1p2000_pimdt298clusterst298_clusters_grid_nm9-14 fit-03/02/2016 (new polar grid) as submitted to JCTC
   
    D6XH  = 2.476647694002546e+01; // A^(-1)
    D6XO  = 2.245564872419419e+01; // A^(-1)
   
    K_HH_INTRA =          8.797396292513129e-01; // A^(-1)
    K_OH_INTRA =          1.925660682058695e+00; // A^(-1)
   
    K_XH_COUL =           9.364621966681188e-01; // A^(-1)
    K_XO_COUL =           3.033743335204718e-01; // A^(-1)
   
    K_XLP_MAIN =          2.528816706404828e-01; // A^(-1)
   
    IN_PLANE_GAMMA =      6.279168656751469e-01; 
    OUT_OF_PLANE_GAMMA =  1.431100184011946e+00; 
   
    R2I =  5.500000000000000e+00; // A
    R2F =  6.500000000000000e+00; // A

    double twobodyfit_cp[] = {
    6.305316008268814e+00, // 0
    2.529032852581863e+01, // 1
   -5.708982885167476e+00, // 2
   -4.458929607076203e+01, // 3
    2.223898731301376e+01, // 4
    1.960009665736413e+01, // 5
    1.161846031843828e+01, // 6
    1.974910704100657e+01, // 7
    7.823396432379383e+01, // 8
    5.070355722929420e-01, // 9
   -2.886451217508629e+01, // 10
   -3.960016152040906e+00, // 11
    7.886438805460143e+00, // 12
   -5.724098611087700e+01, // 13
    1.677952334588556e+01, // 14
   -1.078791858314420e+00, // 15
   -5.705691474974670e-01, // 16
   -5.494897508467988e+00, // 17
   -1.053903516179809e+02, // 18
    5.231063348033806e+01, // 19
    2.913205768689097e+01, // 20
   -3.548877848702936e+01, // 21
    6.279876533517025e+01, // 22
   -3.643564631909405e+01, // 23
    1.476319736587549e+02, // 24
   -3.076010766823864e+01, // 25
   -1.707032483040588e+01, // 26
    5.966333218575128e+00, // 27
    6.565751018911545e+00, // 28
    3.749074531522831e+00, // 29
    2.281728713878031e-01, // 30
   -9.392752406618872e+00, // 31
   -3.008290572210464e+01, // 32
   -6.512013075450006e+00, // 33
   -4.841901138584601e+00, // 34
   -1.526967416155136e+00, // 35
   -7.156075324612091e+00, // 36
   -3.507297142629923e+01, // 37
   -1.255244896138388e+01, // 38
   -2.254691340826965e+01, // 39
    1.535792042016994e+01, // 40
   -2.628847699233387e+01, // 41
   -2.537069755996036e+01, // 42
    1.881983966732618e+01, // 43
    1.286913875713062e+01, // 44
   -2.121277088075136e+01, // 45
    1.742952412100784e+00, // 46
    6.727389384373157e+01, // 47
    6.271497536035800e+01, // 48
    2.408511545694843e+01, // 49
    1.118288006853341e+01, // 50
    5.928772772514316e+01, // 51
   -1.634357405911541e+00, // 52
    6.005536741446179e-01, // 53
   -4.977270002480824e+00, // 54
    8.753185570951700e+00, // 55
   -7.014075273862231e+01, // 56
    4.846040664703292e+00, // 57
   -6.503696450750037e+01, // 58
    4.223016712491786e+00, // 59
    1.138082195125886e+01, // 60
   -2.875997531977002e+01, // 61
    2.021304623810421e+01, // 62
   -4.418962062064546e+01, // 63
   -3.461622497385025e+01, // 64
   -8.957887688927585e+01, // 65
   -1.641105408285722e+01, // 66
   -1.482018277031263e+01, // 67
   -5.438530316922119e+00, // 68
   -2.195274339971402e+01, // 69
    8.920547100520269e+00, // 70
    1.675585394426671e+01, // 71
    6.544206529369839e+01, // 72
   -9.460272274013466e+00, // 73
    1.713990548468986e+01, // 74
   -1.350053772678573e+01, // 75
    5.232603542189442e+01, // 76
    4.327277549915277e+01, // 77
    3.751497156056490e+01, // 78
    3.985540481756838e+01, // 79
    7.170260422168560e+00, // 80
   -1.535740492076957e+01, // 81
    3.679775584748405e+01, // 82
    3.600636275628795e+01, // 83
   -1.179698174794600e+01, // 84
    2.105205349446062e+00, // 85
   -1.492513093090659e+01, // 86
   -5.344727990086837e+01, // 87
   -8.746250868786344e+00, // 88
    5.487873567288346e+01, // 89
    9.494840766885035e+01, // 90
   -5.516460011754707e+01, // 91
   -8.173633391060392e+00, // 92
    4.752137542986083e+01, // 93
    1.904806368783268e-01, // 94
    3.037978550624514e+01, // 95
    1.255412899786464e+01, // 96
    2.439562591952415e+01, // 97
    7.638426943375159e+00, // 98
    2.128565890159898e+00, // 99
    3.585199948123222e+00, // 100
   -2.315983978587723e+01, // 101
   -2.561256374569518e+01, // 102
   -2.586385554717831e+01, // 103
    3.480567348466459e+01, // 104
   -6.009157185921517e+00, // 105
   -1.502095916393273e+01, // 106
    1.273175262562141e+01, // 107
   -2.183871767998648e+01, // 108
    3.050432930074074e+01, // 109
   -2.771541051775878e+01, // 110
    3.617921557136800e+01, // 111
   -8.804890981965986e-01, // 112
    4.294623290285964e+00, // 113
   -2.354210503349711e+01, // 114
    9.629413546979048e+00, // 115
   -6.100062398744876e+00, // 116
   -1.754012394816777e+00, // 117
    2.341299906445983e+01, // 118
   -5.898792458570178e+01, // 119
   -2.839023356629335e+01, // 120
   -5.864939297747466e+00, // 121
   -3.737904104740701e-01, // 122
   -8.247092976832345e+00, // 123
    2.036945480683983e+00, // 124
    3.227329192011122e+00, // 125
   -5.508897650884948e+01, // 126
   -6.426181110122320e+01, // 127
    4.542324827424268e+01, // 128
   -2.774382888468737e+01, // 129
    1.306998561399943e+02, // 130
   -2.659771484054676e+00, // 131
   -2.066860482827351e+01, // 132
   -7.038950201985539e+01, // 133
    3.673916421672703e+01, // 134
   -1.334732288797892e+01, // 135
   -2.679036896451716e-01, // 136
   -2.713516037660736e+00, // 137
   -1.486458753718174e+02, // 138
    1.509256347197162e+01, // 139
   -2.088835798626342e+01, // 140
    4.177940185616447e+01, // 141
    1.770685353023026e+01, // 142
    1.617399076039698e+01, // 143
    3.992676029653755e+01, // 144
   -2.844991651580462e+01, // 145
    1.062072224724513e+01, // 146
   -1.337285037565751e+00, // 147
    1.641470852054921e+01, // 148
   -3.984048777132147e+01, // 149
   -6.444429128451662e+01, // 150
    3.691471566394538e+01, // 151
    8.440937825568203e-01, // 152
   -3.334426586687837e+01, // 153
    1.322960736712826e+01, // 154
    1.927637732085024e+01, // 155
   -1.789060887376020e+00, // 156
   -5.726527565281600e+01, // 157
   -5.150352724100912e+00, // 158
   -1.422343541299311e+01, // 159
    2.018614261329086e+01, // 160
    2.275826093722895e+01, // 161
   -6.596222711957333e+01, // 162
   -2.221036594326333e+01, // 163
   -4.629547535867592e+01, // 164
    3.575320811315967e+01, // 165
    2.348637108029742e+01, // 166
   -2.509962266289535e+01, // 167
    2.888332941381772e+01, // 168
    3.677658025331543e+01, // 169
    1.468824152858788e+02, // 170
   -3.064866955544792e+01, // 171
    3.668307565105989e+01, // 172
   -7.011787040494298e+00, // 173
    2.994888814359176e+01, // 174
    1.603263214168461e+01, // 175
    2.525219837285125e+01, // 176
   -2.755882033471180e+01, // 177
   -1.314226033137035e+02, // 178
   -9.618975357340929e+00, // 179
   -1.714138815769524e+01, // 180
    3.186255655007483e+00, // 181
    3.286552368647168e+01, // 182
    2.804616611219581e+01, // 183
   -4.790883709061025e+00, // 184
    6.368053962211666e+00, // 185
    2.137672568573271e+01, // 186
    1.631808072028567e+01, // 187
   -1.875341667885129e+01, // 188
   -2.051329710581633e+01, // 189
    1.613168857393480e+00, // 190
    1.415570380089612e+01, // 191
   -7.343657524076644e+01, // 192
    2.058954195948064e+01, // 193
   -1.025256091971184e+02, // 194
    3.565192260827204e+01, // 195
   -6.444401909493566e+00, // 196
    2.965165076118312e+01, // 197
   -3.277808821491241e-01, // 198
   -1.601045005490226e+01, // 199
   -5.524124006809293e+00, // 200
   -1.107542289565612e+01, // 201
    1.481079823159876e+01, // 202
    1.991792906833044e+01, // 203
   -2.252396485186686e+01, // 204
   -1.414583552386513e+01, // 205
    2.430326387935320e+01, // 206
    2.132555054860958e+01, // 207
    2.078276500135452e+01, // 208
   -1.413899880132780e+01, // 209
   -1.477283408364680e+01, // 210
    1.128187359761072e+01, // 211
    3.997742357667095e+01, // 212
   -4.426157287753940e+00, // 213
    3.495703921205947e+01, // 214
   -1.412282641100837e+01, // 215
    4.350259890444816e+01, // 216
   -2.173218749397062e+00, // 217
    2.327854452708720e+01, // 218
    1.813232516364004e+01, // 219
   -1.173337931038080e+01, // 220
   -6.497348860184199e+00, // 221
   -7.190565391443755e+01, // 222
   -4.710848471921149e+01, // 223
   -2.449100361850640e+01, // 224
    3.778666443256328e+01, // 225
   -1.898982692601474e+01, // 226
    2.168888058128852e-01, // 227
   -2.226179397670249e+01, // 228
   -2.650275007038021e+01, // 229
   -3.359050395532753e+01, // 230
    1.610500348085388e+01, // 231
    3.795836940592680e+01, // 232
    1.339453795251447e+01, // 233
   -1.840728777189001e+01, // 234
   -2.719314254515324e+01, // 235
    4.664069636039491e+01, // 236
    1.639570431015667e+01, // 237
   -1.033313181903108e+01, // 238
   -1.014570703018203e+01, // 239
   -2.095364722765930e+01, // 240
   -3.621897182586143e+01, // 241
    2.331513921958615e+01, // 242
    1.886023818946005e+00, // 243
    1.637135746346004e+01, // 244
    4.067587651106777e+01, // 245
    5.839099158454836e+00, // 246
   -9.308295589202032e+00, // 247
    9.502096748361637e-01, // 248
   -1.126910229846909e+01, // 249
    1.193613031008379e+01, // 250
    1.188420207516103e+01, // 251
    6.154498991377195e+00, // 252
   -2.682483460158352e+00, // 253
   -6.654029023704545e+00, // 254
   -7.325382207512457e+01, // 255
   -9.388515320469939e+00, // 256
    2.976740979748314e+01, // 257
    3.576513518465782e+01, // 258
   -1.197839675743593e+01, // 259
   -5.917500933367183e+00, // 260
    1.035599336934459e+01, // 261
   -1.700398804664367e+01, // 262
   -1.732838536014761e+01, // 263
   -3.837369744503119e+01, // 264
   -5.139548002304559e+01, // 265
   -2.933342452450275e+00, // 266
   -6.868509441961453e+01, // 267
    4.131139767324447e+00, // 268
    2.813761307920496e+01, // 269
    7.562070038820340e+00, // 270
   -7.464308005224757e+00, // 271
    2.594076852428617e+00, // 272
    9.001006773697343e+00, // 273
   -1.196721957028472e+01, // 274
    9.643051827001655e-01, // 275
    1.140391018442220e+01, // 276
    1.233000363600180e+01, // 277
   -1.386605477707973e+01, // 278
    5.012259136359616e+01, // 279
   -1.902503900892118e+01, // 280
    3.029683564911219e+01, // 281
    7.969308878868418e+01, // 282
    2.412302140762106e+01, // 283
   -4.177649592379370e+01, // 284
   -2.833007628544861e+00, // 285
   -5.022806140568896e+00, // 286
   -4.031730789046940e+00, // 287
   -3.394122228353130e+01, // 288
    1.581749334463712e+01, // 289
   -3.021459798572442e+01, // 290
    1.962963719643073e+01, // 291
    3.084923162674254e+01, // 292
    1.661476662522263e+01, // 293
    1.182000757469961e+01, // 294
    1.776068424760415e+01, // 295
    2.218045794429101e+01, // 296
   -4.981984588350630e+01, // 297
   -1.847217292327585e+00, // 298
    1.457459766725739e+01, // 299
    5.398407316538578e+00, // 300
    5.183161111459629e+01, // 301
    7.675463938541416e-01, // 302
   -3.874425267016350e+01, // 303
    4.087790432503765e+01, // 304
    6.627980519428247e+01, // 305
   -2.955288571177733e+01, // 306
   -4.290202653101804e+00, // 307
    1.895960220426921e+01, // 308
   -9.755763313970460e-01, // 309
   -3.944173891608590e+01, // 310
    1.112730249732523e+01, // 311
   -3.601793069016761e+01, // 312
    2.195163929400601e-01, // 313
    3.356998799698624e+01, // 314
   -7.306625452234981e+01, // 315
   -1.761569084272922e+01, // 316
   -1.297649146601360e+00, // 317
   -7.814260104888800e+00, // 318
   -1.428937516229610e+01, // 319
   -1.623093586901626e+01, // 320
   -2.699638459885947e+00, // 321
   -2.333147741850333e+01, // 322
    5.450518340832715e+01, // 323
    1.231069182295233e+01, // 324
   -4.058512093439538e+01, // 325
    4.976421373516394e+01, // 326
    2.457026537746560e+01, // 327
    2.742844759342199e+01, // 328
    5.275247313676727e+01, // 329
    2.789136987428064e+01, // 330
    1.010889451537506e+02, // 331
    3.028559718817567e+01, // 332
   -9.908453147615699e+00, // 333
   -1.881017394905975e+01, // 334
    6.851108522836210e+00, // 335
    4.259536303725580e+01, // 336
    1.157354473790894e+00, // 337
    1.402593181480517e+01, // 338
   -5.324232915425487e+01, // 339
   -6.098716022533694e+00, // 340
    3.652986873953115e+01, // 341
    3.844390117489044e+00, // 342
    6.083712739849192e+01, // 343
   -2.922340335439765e+01, // 344
    1.653838528874938e+01, // 345
   -1.934100972159893e+01, // 346
   -1.981879790188941e+01, // 347
   -1.379400614605783e+01, // 348
   -3.684516066041364e+01, // 349
   -1.631111556253102e+00, // 350
    2.156993120050644e+01, // 351
    1.979195898086252e+01, // 352
    3.539613359908238e+00, // 353
   -1.407061855228977e+01, // 354
   -1.784429750155981e+01, // 355
   -8.751831597166214e+00, // 356
    8.907405698689365e+00, // 357
    1.203441311796072e-01, // 358
   -3.377581803009760e+01, // 359
   -4.423981320299049e+01, // 360
    1.876550023229082e+01, // 361
    2.981012322573002e+00, // 362
    2.131341907954780e+01, // 363
   -1.415227454731596e+01, // 364
   -2.046829102613805e+01, // 365
   -2.865817942270218e+00, // 366
   -2.350398975131235e+01, // 367
    2.852735848050634e+01, // 368
   -4.096510289350216e+00, // 369
   -3.170237177445757e+00, // 370
    4.507299390705939e-01, // 371
   -2.322772969252511e+01, // 372
   -1.407104726627066e+01, // 373
    3.262640192160884e+01, // 374
   -6.828196143067399e-01, // 375
    5.299595856021867e+01, // 376
    4.802118170271866e+00, // 377
   -3.787011935400897e+01, // 378
   -2.697575586209767e+01, // 379
    8.703251529525371e+00, // 380
    7.575473964256176e+01, // 381
    4.795578889113641e+00, // 382
    2.625265370728123e-03, // 383
   -2.830102140272291e+01, // 384
   -2.348770966413887e+01, // 385
   -1.213729373279611e+01, // 386
   -1.964058142270138e+01, // 387
    1.335597483327408e+01, // 388
   -8.516403397297618e+01, // 389
    1.695154846263703e+01, // 390
    3.993638236558107e+01, // 391
    3.044703805039330e+01, // 392
   -2.094172544829032e+01, // 393
    2.000358164379893e+01, // 394
    2.628858564904295e+01, // 395
   -1.664832809410995e+01, // 396
    1.322294238599853e+01, // 397
    5.283387293953774e+01, // 398
    5.458561147851957e+01, // 399
    1.815348404669183e+01, // 400
   -5.303639151056023e+00, // 401
   -1.492248463335604e+00, // 402
    2.183319064692252e+01, // 403
   -5.139089317004149e+01, // 404
    3.094746224734731e+01, // 405
   -1.738360393147790e+01, // 406
    1.976596075050212e+01, // 407
   -5.347573129165879e+00, // 408
   -2.443472020379810e+01, // 409
    4.128476962038048e+00, // 410
   -3.602029705459495e+01, // 411
   -1.859235093437094e+01, // 412
    2.685548643397876e+01, // 413
   -1.499879795134182e+01, // 414
   -8.857539684142776e-01, // 415
   -3.092269343905198e+01, // 416
   -1.087504389599285e+01, // 417
    1.001940041201706e+02, // 418
    4.515798788985459e+00, // 419
    5.068919485169447e+01, // 420
    1.282774547832956e+01, // 421
    3.918934355488144e+01, // 422
   -1.401003443723162e+01, // 423
    1.429844080086610e+01, // 424
    7.956372190350188e-01, // 425
    2.028774148092532e+01, // 426
   -8.819509487070000e-01, // 427
    4.086560844142444e+01, // 428
   -1.961812771785905e+01, // 429
   -1.438520421988581e+01, // 430
    2.401830507472117e+00, // 431
   -2.343352128197159e+01, // 432
   -4.614975590538100e+00, // 433
    1.376500080941239e+01, // 434
    1.237356102872490e+00, // 435
    2.181173952944267e+01, // 436
   -3.596094121991281e+01, // 437
   -2.544281311039898e+01, // 438
    1.356725353619392e+00, // 439
   -2.576703516247770e+01, // 440
    6.661884119999251e+00, // 441
    1.683146657818760e+01, // 442
    2.134703708419873e+00, // 443
    2.377953086244943e+01, // 444
   -2.517522096098226e+00, // 445
    9.937925869134164e+00, // 446
    1.502289184242722e+01, // 447
   -5.297237324571812e+00, // 448
    2.399400621429714e+01, // 449
    1.027120286846666e+01, // 450
   -1.847324083059388e+01, // 451
   -3.747753530146774e+00, // 452
    3.901934722019059e+01, // 453
    1.294156120788924e+01, // 454
   -3.265181473509088e+00, // 455
    5.865563759789829e+00, // 456
   -4.091623180783970e+01, // 457
   -2.681316224416874e+01, // 458
   -1.063666996023373e+01, // 459
    1.033683280083706e+00, // 460
    2.436834473088737e+00, // 461
   -4.526375415358374e+00, // 462
   -2.921143629036363e-01, // 463
   -4.890791600361363e+00, // 464
    4.544203601232211e+01, // 465
    2.238526045389501e+00, // 466
   -1.606416878844805e+00, // 467
    1.133064432839785e-01, // 468
    9.428566385203224e-01, // 469
    1.604467684142748e+00, // 470
    4.792538918395142e+00, // 471
    6.899877293850720e+00, // 472
    1.469674836323715e+00, // 473
   -1.418368187807415e+00, // 474
   -9.568069922056242e+00, // 475
    5.607122781583534e+00, // 476
    1.725412217466413e-01, // 477
   -8.027353489281946e+00, // 478
    4.020170997628845e+01, // 479
   -2.359986171867190e+01, // 480
   -4.647977537919835e+01, // 481
    1.004799657967359e+01, // 482
    2.566479120784264e+01, // 483
    2.122864447046758e+00, // 484
    4.679444812097026e+00, // 485
   -3.331147742845226e+00, // 486
   -1.452739193440918e+01, // 487
   -1.682351058133117e-01, // 488
    1.618335485104247e+01, // 489
   -1.765265337027547e+00, // 490
   -4.793463935657369e+00, // 491
   -5.868931764551036e+01, // 492
    2.897110541467428e+01, // 493
    7.006003567779175e+00, // 494
    7.247428583232121e+00, // 495
    2.093978740310615e+01, // 496
   -5.567837612374348e-01, // 497
   -2.819781222947942e+01, // 498
    1.984718162167525e+01, // 499
    7.725910024455629e+00, // 500
   -3.964675851567629e+00, // 501
   -3.571009950361671e+00, // 502
    5.124879732038631e+00, // 503
    1.034500367327229e+01, // 504
    1.658975485643410e+01, // 505
   -7.282713538643113e+00, // 506
    1.849846166409521e+01, // 507
   -2.843941762517248e+01, // 508
   -1.917810771456112e+01, // 509
    1.515348531891445e+01, // 510
    1.275612096282004e+01, // 511
   -6.932873387691456e+00, // 512
    1.021668421584843e+01, // 513
    5.502042284934988e+00, // 514
   -1.409245409656003e+00, // 515
   -4.434601138253115e-01, // 516
    7.042988486772247e+00, // 517
    3.076896288700759e+01, // 518
    4.752834530830499e+01, // 519
   -2.037586121781064e+01, // 520
    2.430069763958284e+01, // 521
   -2.225955828027635e+01, // 522
   -4.110463803794247e+00, // 523
    1.835420660975131e+00, // 524
   -4.919566018090231e+01, // 525
    2.245763893311342e+01, // 526
   -1.336325050862831e+01, // 527
    1.622236334687960e+01, // 528
    1.462720384362315e+00, // 529
   -1.774466560464633e+01, // 530
    7.198231344770496e+00, // 531
   -7.786491363847946e+00, // 532
    6.619574964738652e+00, // 533
    6.812073729344280e+00, // 534
    1.358840290168013e+01, // 535
    1.866907575547749e+00, // 536
   -2.327643327834759e+00, // 537
    8.826256561336543e-02, // 538
   -2.933394646897254e+00, // 539
   -1.365201060638315e+01, // 540
    2.084235767376565e+01, // 541
    5.720722225458713e-01, // 542
   -2.503897991228618e+01, // 543
    2.973912102697901e+01, // 544
    2.243873781599092e+01, // 545
   -5.703438621318589e-01, // 546
   -1.073142867186344e+01, // 547
    1.399301774386780e+01, // 548
   -1.382164684082608e+01, // 549
   -2.664677597637500e+00, // 550
   -9.116472117223922e-01, // 551
   -4.524485515480810e+01, // 552
   -4.421832428939343e+00, // 553
   -1.952882730929389e+01, // 554
   -1.198440763819419e+01, // 555
    2.081905551159648e+01, // 556
   -5.249647536215925e+00, // 557
    3.905768275371488e+00, // 558
    1.863416481018196e+00, // 559
   -4.720512390171920e+00, // 560
    9.833437161859799e-01, // 561
   -1.410397258328585e+01, // 562
   -2.496548137664589e+01, // 563
   -1.208598736584475e+01, // 564
   -3.352220142985975e+01, // 565
   -1.496482612792209e+01, // 566
   -1.302999050487835e+00, // 567
    1.038617865388481e+01, // 568
    4.235971234242361e+00, // 569
    2.794124043154266e+01, // 570
    1.178582183508725e+01, // 571
   -1.065244350580921e+01, // 572
    3.096548235641750e+00, // 573
    8.074595106668349e+00, // 574
   -3.200527125815660e+01, // 575
    1.939471160436295e+01, // 576
   -3.831625502148846e-01, // 577
    2.691286112373054e-01, // 578
   -1.791717980467742e+01, // 579
    3.640002548299714e+01, // 580
   -7.023939976361564e+00, // 581
   -3.530578617488001e+00, // 582
    6.966612638009541e+00, // 583
   -3.069670778870633e+01, // 584
    1.677996469719574e+00, // 585
   -1.841796331498145e+01, // 586
    1.105196360914969e+01, // 587
    1.202283073700917e+01, // 588
    6.029326969831006e-01, // 589
    2.717179803659332e+00, // 590
    3.529163785508159e-01, // 591
    2.287075940849166e+01, // 592
   -9.828065045561146e-02, // 593
   -1.118097591143684e+01, // 594
    5.068767129273730e-01, // 595
   -2.475006180627440e+01, // 596
   -2.598369574143796e+01, // 597
    1.024415741967192e+01, // 598
   -1.875178666676248e+01, // 599
    5.764532277446025e+00, // 600
   -3.534201741789166e-01, // 601
   -6.201876826840996e+00, // 602
   -2.653756896294109e+01, // 603
   -1.091828098730427e-01, // 604
    4.648337909117815e+00, // 605
   -1.539394922980777e-01, // 606
    4.005650328511312e+01, // 607
   -1.946260458715524e+01, // 608
    9.742685041745378e-01, // 609
    4.058478905069782e+00, // 610
   -5.039338852689189e+01, // 611
   -1.688690190483243e+01, // 612
    1.319542810119585e+01, // 613
    1.371453631133495e+01, // 614
   -5.965108651092284e+01, // 615
   -7.607095163583994e+00, // 616
    2.246366368706051e+00, // 617
   -1.724177470764179e+01, // 618
    3.320090359419019e+01, // 619
    1.819179635035256e+00, // 620
    9.979017666199169e+01, // 621
   -2.321136462926509e+00, // 622
   -1.297214484619462e+01, // 623
   -4.344588757723498e+00, // 624
    4.275608783235306e+01, // 625
    7.146518641186572e+00, // 626
    2.174900462870771e+00, // 627
    3.970756091003078e+01, // 628
    7.867891961980967e-01, // 629
    1.412981654292713e+01, // 630
   -3.591852078059857e+00, // 631
    2.826155294517574e+01, // 632
   -5.691003777762612e+00, // 633
    2.342599558161619e+01, // 634
    6.951227645228984e+01, // 635
   -3.137875227445019e+01, // 636
   -9.425002625037674e+00, // 637
    9.171645963470556e+00, // 638
    1.824363144241816e+01, // 639
   -8.924155178830002e+00, // 640
   -3.007948223553166e+01, // 641
   -1.234179934347869e+01, // 642
   -2.564986638863552e-01, // 643
    6.843631063382236e+00, // 644
    1.676948633146195e+01, // 645
   -1.272166169847014e+01, // 646
    3.373895601561131e+01, // 647
    3.636095752282292e-01, // 648
    3.103002177223786e+01, // 649
    6.399716187122595e-01, // 650
   -9.579516346556785e+00, // 651
   -3.114033423872843e+01, // 652
    1.351562089308830e+01, // 653
    7.657696570602464e+00, // 654
   -1.371796515754788e+00, // 655
    4.904459069325905e+01, // 656
   -4.722541741022484e+01, // 657
   -3.020145578400165e+01, // 658
   -5.788290396921144e+01, // 659
   -5.229471273230949e+00, // 660
   -2.037836355100759e+01, // 661
   -1.535826272266162e+01, // 662
   -1.639187906585634e-01, // 663
   -4.058769683690811e+01, // 664
    1.104497099581017e+01, // 665
    2.999250989954525e+01, // 666
   -4.670662585166320e+01, // 667
    1.283598804828168e+01, // 668
   -2.097731938787311e+01, // 669
   -1.305017192360280e+01, // 670
   -2.618338071757587e+01, // 671
    6.338866293280963e-01, // 672
   -3.293945146067377e+00, // 673
    7.176551124650858e+00, // 674
   -2.705904180714172e+00, // 675
    2.853437554916721e+01, // 676
   -5.209425596290641e+01, // 677
    9.868005215759574e+00, // 678
    8.222326881074418e+00, // 679
   -1.770065043138868e+01, // 680
   -7.454795499162505e+00, // 681
    1.549336824068174e+01, // 682
    3.357443482682650e-01, // 683
    1.786960813809859e-02, // 684
   -2.522258687710855e+01, // 685
   -2.259041872121239e-02, // 686
   -2.023849271032065e+01, // 687
    2.697876709113564e+01, // 688
    2.580718971829845e+01, // 689
    1.280926751283717e+01, // 690
   -3.068878761304191e+01, // 691
    2.839353241491865e+01, // 692
   -1.473877479381236e+01, // 693
    7.601784915967899e+00, // 694
    1.105998354430700e+01, // 695
   -1.711385511447959e+00, // 696
    1.326581777038753e+01, // 697
    7.881808588418165e+00, // 698
    2.364418934127127e+01, // 699
    8.772586627706005e+00, // 700
    4.216020682033284e+00, // 701
   -9.642955953581097e+00, // 702
    7.454300553963146e+00, // 703
    2.454444724101596e+01, // 704
    1.138110243814495e+01, // 705
   -1.753648693689313e+01, // 706
   -6.154314088494924e-01, // 707
    6.525710711269431e+00, // 708
   -1.058538249344627e+01, // 709
    6.613423178964608e-01, // 710
   -1.918211886381336e+01, // 711
    3.511522390849895e+00, // 712
   -6.640949819129460e+01, // 713
    2.485822750992745e+01, // 714
    1.218225330061185e+01, // 715
    3.295032286861268e+00, // 716
   -2.673528051032207e+00, // 717
   -3.296199062311747e+01, // 718
   -9.667338326522634e+00, // 719
    5.196274621303554e+01, // 720
    1.183756424671268e+01, // 721
    9.838518043207142e+00, // 722
   -7.300857480576699e-01, // 723
   -2.530183662911503e-01, // 724
   -6.139262727784197e+00, // 725
   -3.968458578331877e+01, // 726
    2.312711443528702e+00, // 727
    1.246271063472934e+01, // 728
   -5.103658559968537e+00, // 729
   -4.244838266569591e+00, // 730
    1.034965921516559e+01, // 731
    7.219808749740175e-01, // 732
    1.232890568567566e+01, // 733
   -1.589855986894088e+01, // 734
    2.113261112086776e+01, // 735
   -4.925158517118491e-01, // 736
   -1.579150213632111e+01, // 737
   -2.687408321143343e+01, // 738
   -1.556641586467169e+01, // 739
   -2.667060179497246e+00, // 740
    3.382886164217465e+01, // 741
    3.411173244636857e+00, // 742
   -5.439716080340292e-01, // 743
    2.767486457719075e+01, // 744
    3.035318076100132e+00, // 745
   -3.420781906638324e+01, // 746
    1.773304831764169e+00, // 747
    2.338342495927278e+01, // 748
   -3.746888723987815e+01, // 749
    4.333451998434957e+01, // 750
    2.246186934003398e+01, // 751
    1.456338722462306e+01, // 752
   -1.890771176527590e+01, // 753
    9.758738998607894e+00, // 754
    3.551012020920145e+01, // 755
   -5.496321364596088e+01, // 756
   -1.095120700322344e+01, // 757
   -4.791485116850784e+01, // 758
   -3.861642191913630e+01, // 759
    3.981370962208231e+00, // 760
    1.337201465278353e+01, // 761
   -5.576044530562215e+00, // 762
   -5.081852316772756e+01, // 763
   -1.160186682195260e+01, // 764
   -8.448643304490639e+00, // 765
    3.318463306122253e+01, // 766
   -3.819084124491715e+01, // 767
   -2.573787478661958e+00, // 768
    1.652643061300742e+00, // 769
   -4.888769892575229e-02, // 770
   -2.684623082277863e+01, // 771
   -1.992345365787645e+01, // 772
    3.982644316157801e+01, // 773
   -1.738285134463503e+01, // 774
   -3.343011776886765e+01, // 775
    2.679462179149889e+01, // 776
   -1.022769195357060e+01, // 777
    6.989830279891451e-01, // 778
   -4.443755475463544e+00, // 779
   -1.007667551719504e+01, // 780
    6.427778006772479e-01, // 781
    4.087478736409093e+01, // 782
   -3.103360760838184e+00, // 783
   -6.679757173835820e+00, // 784
    1.046443198150877e+01, // 785
   -1.950499699941783e+01, // 786
   -7.456128674180914e+01, // 787
   -3.826264385128483e+01, // 788
    2.617854649881067e+01, // 789
   -2.804371233672729e+00, // 790
   -2.511320099402321e+00, // 791
    2.988117546187342e+00, // 792
   -4.944101615000710e+00, // 793
    1.562126154088425e+01, // 794
   -1.439287273799859e+01, // 795
   -5.793844471095270e+00, // 796
    2.159199574704135e-01, // 797
    3.091697875827274e+01, // 798
   -1.882645105789764e+01, // 799
    3.109606066458653e+01, // 800
   -6.893125490815573e+00, // 801
   -7.906954774427349e+00, // 802
   -2.369679234274631e+01, // 803
    1.858215843520652e+01, // 804
    6.896087104461023e+00, // 805
    2.430821087406261e+01, // 806
   -8.478237292688632e+00, // 807
   -4.126018155761915e+01, // 808
    1.012202218109145e+00, // 809
   -3.606281049314742e+01, // 810
   -8.977308751538331e+00, // 811
   -4.429940151012205e+00, // 812
   -5.179459568983552e+01, // 813
    1.884131906382908e+01, // 814
    1.554937853470307e+01, // 815
    9.911494996989771e-01, // 816
    8.542882758775185e+00, // 817
   -9.138546111441878e+00, // 818
    4.634188903892885e+01, // 819
   -8.567896497137443e+00, // 820
   -4.407265064512869e+01, // 821
    6.398204461299795e+00, // 822
    6.561613303620535e-01, // 823
    4.545131697524334e+01, // 824
    2.421259157206473e+01, // 825
    5.185636654822451e+01, // 826
   -2.407920409914365e+01, // 827
    3.541863232785194e-04, // 828
    1.358263574780177e+01, // 829
   -3.086617309553391e+01, // 830
    2.705963140555996e+01, // 831
   -2.293200671560229e-02, // 832
    8.711566093862631e+00, // 833
   -2.924237253225743e+01, // 834
    3.323724921277835e+00, // 835
    1.706620308858862e+01, // 836
    5.258860759112129e+00, // 837
   -3.160212566427300e+01, // 838
    7.968759628409443e+01, // 839
   -1.131003180049192e-01, // 840
    5.559632228662139e+00, // 841
   -3.070948662270069e-01, // 842
    2.450457148479472e+00, // 843
    2.396814440946970e-01, // 844
   -2.866515660838213e+01, // 845
    2.169886821005329e+01, // 846
    3.593615322621165e-01, // 847
   -6.603985435843772e+00, // 848
    5.714930034421773e+00, // 849
   -1.202641483223965e+01, // 850
    1.973991461252518e+00, // 851
   -4.515257714055590e+01, // 852
    1.733527774973852e+01, // 853
    1.290026512995860e+00, // 854
   -5.339021346566783e+00, // 855
    1.966741041155753e+01, // 856
   -8.816703096899202e+00, // 857
    3.814230993204658e+00, // 858
    4.824968193109969e+01, // 859
    3.505074151900872e+00, // 860
    2.126878735793439e+01, // 861
    1.796073443992751e+00, // 862
   -7.942282842740025e+00, // 863
    5.166906522933094e+00, // 864
    3.718863764159021e+00, // 865
   -1.264589916779545e+01, // 866
   -3.105602112886930e+01, // 867
    1.928221959207611e+01, // 868
    8.709759811276692e+00, // 869
    8.730618661710214e-01, // 870
   -2.301531560035734e+00, // 871
   -6.818150304351742e-01, // 872
   -4.684805436285210e-01  // 873
    };

    for (int i = 0; i< 874; i++)
      twobodyfit[i] = twobodyfit_cp[i];
  } else if (ion == "I") {
    polarizability =10.1184; //A^3 CCSD(T)/t-av5z from finite field method
   
    //xdm  
    C6XH  = 5.681559999999999e+02; // kcal/mol * A^(-6)
    C6XO  = 1.294680000000000e+03; // kcal/mol * A^(-6)
    
    //fit_ccsdtf12_avtqz_fit_5.5-7.5_mdp1p2000_pimdt298clusterst298_clusters_grid_nm9-14_xdm  fit 03/02/2016  (new polar grid) as submitted to JCTC 
    
    D6XH  = 8.394505117520159e+00; // A^(-1)
    D6XO  = 4.653256670263208e+00; // A^(-1)
    
    K_HH_INTRA =          6.840678735508587e-01; // A^(-1)
    K_OH_INTRA =          1.506391079020090e+00; // A^(-1)
    
    K_XH_COUL =           7.002155672714245e-01; // A^(-1)
    K_XO_COUL =           3.257023867189539e-01; // A^(-1)
    
    K_XLP_MAIN =          2.369994447759795e-01; // A^(-1)
    
    IN_PLANE_GAMMA =      1.999999948906768e+00; 
    OUT_OF_PLANE_GAMMA =  1.365632676396729e+00; 
    
    R2I =  6.000000000000000e+00; // A
    R2F =  7.000000000000000e+00; // A

    double twobodyfit_cp[] = {
   -9.898510765724636e+00, // 0
    5.373151308509444e+00, // 1
   -5.460388324256924e+00, // 2
    9.004627493855288e+00, // 3
   -1.784106603758942e+01, // 4
    1.370262944664008e+01, // 5
    1.655073146745184e+01, // 6
   -3.279050906918960e+01, // 7
    6.843822892358094e+00, // 8
   -7.672769748824333e-01, // 9
   -1.371443810954971e+01, // 10
   -7.956297438919831e+00, // 11
    1.965778418502972e+01, // 12
   -3.917999285545962e+01, // 13
   -1.527141529032672e+01, // 14
    1.431601589422009e+01, // 15
    2.646770827830446e+00, // 16
    1.266002108839401e+00, // 17
   -5.000374768312967e+01, // 18
   -1.485092457623636e+01, // 19
    2.656578167308535e+01, // 20
    1.634954881367844e+01, // 21
   -2.917056101068401e+01, // 22
   -3.411083867353284e+01, // 23
    4.588215138595357e+01, // 24
   -2.609857724840657e+01, // 25
   -2.910858053343690e+01, // 26
    4.818673429448151e+00, // 27
   -9.736750618892081e+00, // 28
    6.153583126415905e+00, // 29
   -1.477445115447082e+01, // 30
   -1.183007072680610e+01, // 31
    1.030685431934695e+00, // 32
    2.793407192070937e+00, // 33
    1.537800174059581e+01, // 34
   -3.327433630748247e+00, // 35
    4.117519700973450e+01, // 36
    2.841451800297363e+01, // 37
   -7.845297430653173e+00, // 38
   -1.393020456477753e+01, // 39
    8.601145657527434e+00, // 40
    1.656544707388122e+01, // 41
   -3.862958606759027e+01, // 42
   -8.607078885173204e+00, // 43
   -9.039110565665592e+00, // 44
    2.786550186768363e+01, // 45
   -1.547861968130183e+01, // 46
    9.336093526572260e+00, // 47
    3.548478716611374e+01, // 48
   -2.284773627511534e+01, // 49
    2.540351079060354e+01, // 50
    4.001066657165575e+01, // 51
   -5.405355644225933e+01, // 52
   -4.594860854403578e+00, // 53
    2.132903287624397e+01, // 54
   -8.647438148217702e+00, // 55
   -2.667298716087995e+01, // 56
   -1.276202514731431e+00, // 57
   -1.881238011492454e+01, // 58
    1.015183273012418e+01, // 59
    7.044093058776697e-01, // 60
   -2.919794347018999e+01, // 61
    9.067168544296608e+00, // 62
    3.671801726800376e+01, // 63
   -2.465690030917242e+01, // 64
   -1.469605355376362e+01, // 65
    6.654659151721227e+00, // 66
    6.061643756391540e+01, // 67
   -3.365365591186402e+00, // 68
    1.927213167083675e+00, // 69
   -2.904576552410954e+01, // 70
    2.304713337759794e+00, // 71
    3.303738321495293e+01, // 72
   -5.382043957218213e+00, // 73
   -5.176910968494620e+00, // 74
   -8.433499319380999e+00, // 75
   -4.728452510927782e+01, // 76
   -2.878527187136166e-01, // 77
   -3.011022174374627e+00, // 78
    1.425869315995443e+01, // 79
   -3.437120135522127e-01, // 80
   -3.451091529302848e+00, // 81
   -1.276957898414576e+01, // 82
   -7.531565981827206e+00, // 83
    4.581122585900863e+00, // 84
    1.004148199074964e+01, // 85
   -2.095100634963372e+01, // 86
   -4.605227388054819e+00, // 87
   -1.801933241408604e+01, // 88
    8.658937192734484e+00, // 89
    4.817821799507730e+01, // 90
   -2.051098069633020e+01, // 91
   -1.643550840928749e+01, // 92
    2.253290023794433e+01, // 93
    4.745698166608371e+01, // 94
    1.790635734262955e-01, // 95
   -1.666479492058324e+01, // 96
    8.225430243304048e+00, // 97
    1.403697225176330e+01, // 98
    1.825208988826371e+01, // 99
   -7.945943944789711e+00, // 100
    7.564837128958446e+00, // 101
   -6.278350617894205e+00, // 102
   -2.128917062792459e+01, // 103
    4.021387169417102e-01, // 104
    2.554569096111205e+01, // 105
    4.132958897015013e+01, // 106
    1.340147835103594e+01, // 107
   -1.384403292180432e+01, // 108
    2.751296382258087e+01, // 109
    1.232327564402871e+01, // 110
   -2.471015587943226e+01, // 111
   -1.817749798063765e+01, // 112
   -1.819026538826200e+01, // 113
   -5.926730823258073e+00, // 114
   -2.346981244266864e+01, // 115
    1.112094436853764e+01, // 116
    3.735051947236744e+01, // 117
   -3.659304883968483e+01, // 118
   -6.275358739460175e+01, // 119
   -1.423055748732835e+01, // 120
    8.720396383545618e+00, // 121
    3.598020813567256e+01, // 122
   -3.818389113487310e+00, // 123
    7.100894268833641e+00, // 124
    4.048186089115555e+00, // 125
    7.849901574939828e+00, // 126
   -4.846043564202242e+01, // 127
    1.830667714329012e+01, // 128
   -9.587513216881268e+00, // 129
    5.852436226721773e+01, // 130
   -3.866622839919309e+00, // 131
   -8.476940581263845e+00, // 132
   -1.433373141206306e+01, // 133
   -1.506713741116826e+01, // 134
   -1.048007774467270e+01, // 135
   -5.264991819690470e+00, // 136
    9.878250835727247e+00, // 137
   -5.315765722994828e+01, // 138
   -2.010062444010293e+00, // 139
   -2.116635916755818e+01, // 140
    1.179706969471305e+01, // 141
    7.476940803841219e+00, // 142
   -3.497571048032775e+00, // 143
   -1.051120468986030e+00, // 144
    2.733249951791103e+01, // 145
   -2.680388417775647e+01, // 146
    9.204630216568821e+00, // 147
    1.962918553726235e-01, // 148
   -1.138360235519591e+01, // 149
   -2.392700105577853e+01, // 150
    2.497785820364995e+01, // 151
   -7.783949138055066e+00, // 152
   -9.212491732928527e+00, // 153
    2.673516469545355e+01, // 154
    8.817424537300914e+00, // 155
   -3.265150141865095e+00, // 156
   -3.269154789621524e+01, // 157
    1.064767739685231e+01, // 158
   -6.794820413492396e+00, // 159
    1.893255173779331e+01, // 160
   -4.692315335615921e+00, // 161
    2.960313735872630e+01, // 162
    2.865839750304481e+00, // 163
   -3.122203705454081e+01, // 164
    1.402728937828825e+01, // 165
    1.126269950531759e+01, // 166
   -1.717558034876712e+01, // 167
    6.753995977699454e+01, // 168
    4.055685549928142e+00, // 169
    6.611724276288433e+01, // 170
    2.248656683217115e+00, // 171
    2.136798809195856e+01, // 172
   -2.894440937081600e+00, // 173
    2.431287221453158e+01, // 174
    8.482898527643099e+00, // 175
    2.002395831001030e+01, // 176
    1.592908481988906e+01, // 177
   -1.064838620733088e+02, // 178
   -8.961585643774690e+00, // 179
   -6.835620530458084e+01, // 180
   -1.886801548374324e+01, // 181
    2.559631873096642e+01, // 182
    9.281382588780328e+00, // 183
    2.113239869241458e+01, // 184
   -9.457193130807537e+00, // 185
    6.124269042968926e-02, // 186
   -1.206460187937657e+01, // 187
   -8.213806833538802e+00, // 188
    4.917393201974392e+00, // 189
   -3.002574338456037e+00, // 190
    1.656138280773297e+01, // 191
   -3.727860696240668e+01, // 192
   -4.284183766601138e+00, // 193
   -2.302905582037992e+01, // 194
   -4.561119350345568e+01, // 195
    7.260612233235503e+00, // 196
    1.016454545189731e+01, // 197
   -6.984213202526307e-01, // 198
   -1.430975835770842e+01, // 199
   -3.331809238527720e+01, // 200
   -4.436225680840518e+00, // 201
    9.162731955707017e+00, // 202
    2.887286341151076e+01, // 203
    1.486077125315160e+01, // 204
   -1.532655505676170e+01, // 205
    1.652469353147359e+01, // 206
   -1.740200874019679e+01, // 207
    1.156029960934791e+01, // 208
    3.256383841675515e+01, // 209
    3.294312958163146e+01, // 210
    1.996600190686064e+01, // 211
    4.576429478957737e+00, // 212
   -6.896113221622277e+00, // 213
    1.813791560167965e+01, // 214
    7.552842262606941e-01, // 215
   -3.428532409188618e+00, // 216
   -3.877936267684679e+00, // 217
   -1.717589189490360e+01, // 218
   -2.473087821206866e+01, // 219
   -1.621351925356577e+00, // 220
   -2.230384072195491e+01, // 221
   -3.190380651265756e+01, // 222
   -6.898472836157937e+01, // 223
   -1.340179041537033e+01, // 224
    1.527723115404407e+01, // 225
    1.368891429363104e+01, // 226
   -2.209873515045463e+00, // 227
    1.863256531561358e+01, // 228
    2.885574624446835e+00, // 229
   -9.301548307383074e-01, // 230
    1.159229454030782e+01, // 231
    5.257735131101306e+00, // 232
    1.844808953885006e+01, // 233
   -2.098323335256891e+01, // 234
   -2.028991150322386e+01, // 235
    1.143278419159578e+01, // 236
    1.332076329121937e+01, // 237
   -2.527102932490938e+01, // 238
   -3.650703418539209e+00, // 239
   -1.757967934645187e+00, // 240
   -3.728274844999678e+01, // 241
   -3.177151836631469e+01, // 242
    6.044167658857583e-01, // 243
    2.775987338979843e+00, // 244
    1.273485421626008e+01, // 245
   -1.496189496284462e+00, // 246
   -1.445529835478147e+01, // 247
   -1.458645442129651e+01, // 248
   -1.162230708520139e+01, // 249
   -1.603408700402193e+00, // 250
    7.842156515942639e+00, // 251
    1.301639614465020e+01, // 252
   -7.322022433830631e+00, // 253
    4.030227452589251e+01, // 254
    1.076706186070136e+01, // 255
    1.153218307616600e+00, // 256
   -1.432082179335523e+01, // 257
    1.934530693261733e+01, // 258
   -2.492395678359094e+00, // 259
   -1.185784313403080e+01, // 260
   -1.401472019761036e+01, // 261
   -1.301714581012652e+01, // 262
    1.325488608791228e+01, // 263
   -1.147111852621528e+01, // 264
   -6.464689606819548e+00, // 265
    3.310639164297496e+00, // 266
   -8.922324400900575e+00, // 267
    5.241744209977982e+01, // 268
    3.478101167279559e+01, // 269
    3.614528930368508e+01, // 270
   -1.239583805780753e+01, // 271
    8.887510116241069e+00, // 272
    5.912765159875825e+00, // 273
   -3.407156059640959e+01, // 274
   -3.605266257824443e+00, // 275
   -6.417534496785409e+00, // 276
    1.693025668104213e+01, // 277
   -1.779537765593023e+01, // 278
    6.258995352567248e+00, // 279
   -9.598706424619621e+00, // 280
   -9.109986738737788e+00, // 281
    9.332037130161369e+00, // 282
   -4.894714184312861e+01, // 283
   -3.151530597620687e+00, // 284
   -1.274025549645484e+01, // 285
    6.544125356650162e+00, // 286
   -1.185335326130675e+01, // 287
   -3.601056227293762e+01, // 288
    1.633360759972868e+01, // 289
    6.010947344434182e+00, // 290
    5.930885209915821e+00, // 291
   -6.277634400860089e+00, // 292
    5.522298817446216e-01, // 293
   -1.834044546951392e+01, // 294
   -1.513173782342905e+00, // 295
    4.046927976868709e+01, // 296
    1.608620034285070e+01, // 297
    4.329918470618295e+00, // 298
    2.832041302717806e+01, // 299
   -2.365493291567320e+01, // 300
    1.148471710386827e+00, // 301
    1.257430790342883e+01, // 302
   -3.043972187171821e+01, // 303
   -9.520566909083739e+00, // 304
   -6.829681323997774e-02, // 305
   -1.918238684676973e+01, // 306
    1.100814092475013e+01, // 307
    2.904527611223714e+00, // 308
    2.319566947039391e+01, // 309
   -8.897924668848065e-01, // 310
   -1.478296312628015e+01, // 311
   -1.533457651952888e+01, // 312
   -2.378004595750007e+00, // 313
    1.805827427081417e+00, // 314
    1.983745027373914e+01, // 315
    3.288603272705955e+00, // 316
   -2.017768257532580e+01, // 317
    4.048049350783163e-01, // 318
    2.054962072179029e+01, // 319
   -1.061738932552823e+01, // 320
    9.615064649783246e-01, // 321
   -1.201834660209769e+01, // 322
    9.081754604481985e+00, // 323
    5.070445285639225e+00, // 324
   -1.938841402592778e+01, // 325
    7.485965918979321e+00, // 326
    2.508580839740688e+00, // 327
   -2.163683105973638e+01, // 328
   -3.351716033821952e+00, // 329
    2.499847958602634e+01, // 330
   -3.557369726980055e+00, // 331
    8.134711073712301e+00, // 332
    6.800345275229647e+00, // 333
    2.393320641074222e+01, // 334
   -1.038505224829331e+01, // 335
    3.676285054213248e+00, // 336
   -1.109904702711449e+01, // 337
    4.383836955752306e+01, // 338
   -4.685378739736544e+01, // 339
    7.063686184955649e+00, // 340
   -2.043165315968438e+00, // 341
   -4.855760724661929e+00, // 342
    1.476435411624795e+01, // 343
   -2.591102314761631e+01, // 344
   -7.571440972983020e+00, // 345
   -1.222217111355663e+01, // 346
    2.525529872681226e+01, // 347
   -6.982795543693939e-01, // 348
   -1.016119519200317e+01, // 349
    2.634987405723654e+01, // 350
    2.181569737916139e+01, // 351
   -1.432573478884875e+01, // 352
   -5.532051627695973e+00, // 353
   -9.896089422196278e+00, // 354
   -2.938230848904997e+00, // 355
   -1.885300334226385e+01, // 356
   -1.333015395299271e+01, // 357
   -3.119472488340467e+00, // 358
    1.435556424019740e+01, // 359
   -4.140655688253353e+01, // 360
    3.704199606884847e+01, // 361
    1.299384614056580e+01, // 362
    6.546531196614563e+00, // 363
   -3.504673549602143e+01, // 364
   -9.898974343305479e+00, // 365
   -1.224750276037225e+01, // 366
   -2.404851118273948e+01, // 367
   -1.847000585080969e+00, // 368
   -9.376124277456226e+00, // 369
   -1.017880825146768e+01, // 370
    6.605547139895960e+00, // 371
    1.094807583913797e+00, // 372
   -1.085166910413717e+01, // 373
    1.319245973280722e+01, // 374
   -1.859313294749924e+01, // 375
    1.650183078466585e+01, // 376
   -1.048556800848356e+01, // 377
    2.336106717639614e+01, // 378
    1.276965824206678e+01, // 379
   -2.145346497832826e+00, // 380
    2.806550600416362e+01, // 381
    2.005610893531522e+01, // 382
   -2.330798737484723e+01, // 383
   -5.404557004957271e+00, // 384
    1.655643438550475e+01, // 385
   -1.745063847530991e+01, // 386
    9.295153340011092e+00, // 387
   -1.287640134523582e+01, // 388
   -2.816072182270729e+00, // 389
    9.341708133235036e+00, // 390
   -1.508917673415807e+01, // 391
    6.916344184430766e+01, // 392
   -1.818613209832436e+01, // 393
    5.446575171804256e+00, // 394
    1.874165894050153e+01, // 395
   -2.428308026696088e+01, // 396
   -6.096052559131159e-02, // 397
    1.326742854759356e+01, // 398
    2.187230924112326e+01, // 399
    1.287793267956189e+00, // 400
    3.688104855241506e+00, // 401
   -8.243511586096808e+00, // 402
    1.768896517979952e+01, // 403
   -3.232459013751587e+01, // 404
    1.403905835312331e+01, // 405
   -6.422622242440885e+01, // 406
    5.355522717389283e-01, // 407
   -2.555561566462170e+01, // 408
   -2.219905407321822e+01, // 409
   -8.112715675400928e-01, // 410
   -3.269856720115178e+01, // 411
   -1.350714284523086e+01, // 412
   -1.062422804958058e+01, // 413
    6.758711648375180e+00, // 414
    1.151399664314474e+01, // 415
    1.210164914991866e+01, // 416
   -8.515506315458722e+00, // 417
    6.408680399040787e+00, // 418
   -6.172009837728618e+00, // 419
    5.498304755229503e+00, // 420
    5.880062664397876e+00, // 421
    4.643481576678137e+01, // 422
   -3.684131432102552e+01, // 423
    1.972648045897013e+01, // 424
   -1.430710039709001e+01, // 425
    1.837590012483942e+00, // 426
    6.256640773782535e+00, // 427
   -2.923415522489385e+01, // 428
   -2.797466436274950e+01, // 429
   -1.769469757169744e+01, // 430
   -8.309611008846584e+00, // 431
    1.628459487037709e+01, // 432
   -1.961736076945868e+00, // 433
    3.734554650556085e+00, // 434
   -1.072257217216383e+01, // 435
   -1.744037287553233e+01, // 436
   -5.647452168982454e+00, // 437
   -3.781557835835984e+01, // 438
   -4.964002752995063e+00, // 439
    1.551698529094282e+01, // 440
   -9.943540235259375e+00, // 441
   -8.284023952852525e+00, // 442
   -5.344534751558042e-01, // 443
    1.468194105222377e+01, // 444
    1.881835725737722e+01, // 445
    6.375789055040167e+00, // 446
    2.306669846371164e+01, // 447
    1.006637803455005e+01, // 448
   -2.864458055471465e+00, // 449
    9.248526061624633e+00, // 450
    8.384292680561590e+00, // 451
    5.518691254073397e+01, // 452
    5.836494362667291e+00, // 453
    4.929909753684676e+00, // 454
   -3.379615610937128e+00, // 455
    5.806570345280406e+00, // 456
   -3.383279252728878e+01, // 457
    3.110343704601770e+01, // 458
   -1.372574733727252e+01, // 459
   -1.616675219629782e+01, // 460
   -7.884849400253620e+00, // 461
   -7.460124232607781e+00, // 462
   -1.695091875292529e+00, // 463
    3.334184868201673e+01, // 464
    1.826503701792367e+01, // 465
    3.878267855457928e+01, // 466
    1.220935007685070e+01, // 467
    1.531198715070468e+01, // 468
   -2.029750190450049e+00, // 469
   -1.318565997152837e+01, // 470
   -3.161586887290276e+01, // 471
    2.314675313385310e+01, // 472
    1.330182831532859e+01, // 473
    3.093244883985595e+01, // 474
    1.039069703422310e+01, // 475
    1.774917656431135e+01, // 476
   -9.591819192558569e+00, // 477
   -1.238001209181687e+01, // 478
    6.844456014272473e+00, // 479
   -1.758343363134270e+01, // 480
   -3.413235259067275e+01, // 481
   -7.551163455881564e+00, // 482
    5.527802188844781e+01, // 483
   -7.663533135005901e+00, // 484
   -8.241634733243966e+00, // 485
   -9.772909498361077e+00, // 486
   -1.298953727469901e+01, // 487
   -3.565488956385837e+00, // 488
   -1.528369890690235e+01, // 489
   -6.260746263838588e+00, // 490
    2.039481438674089e+01, // 491
    5.202631692646114e+00, // 492
    2.698881932677666e+01, // 493
   -4.995358828553466e+00, // 494
   -4.070801366190284e+00, // 495
   -2.594639852552249e+00, // 496
   -1.458285843808946e+01, // 497
    1.194896157954362e+01, // 498
    9.978545365913737e+00, // 499
   -5.078270652800887e+00, // 500
    2.954667511101455e+00, // 501
   -3.074441335202978e+00, // 502
   -6.783256797176199e+00, // 503
   -8.177452903086593e+00, // 504
    1.410986560064661e+01, // 505
   -3.993833383051786e+01, // 506
    1.052650748363313e+01, // 507
    2.959436254707630e+01, // 508
   -3.449280926851947e+01, // 509
    7.886496412589563e-01, // 510
   -1.469620987569453e+01, // 511
   -1.804369025688477e+01, // 512
    7.326041487532820e+00, // 513
    9.724922707885238e+00, // 514
    1.137843805315385e+01, // 515
    3.137157326948279e+00, // 516
    1.291127209994690e+01, // 517
    2.642011878323463e+01, // 518
   -3.787211117685354e+01, // 519
    5.783844682126988e+00, // 520
    2.089463886944267e-01, // 521
    8.638906159184597e+00, // 522
   -3.641831372175976e-01, // 523
    9.329507967156296e+00, // 524
    5.297216281811342e+00, // 525
    3.155227751638602e+01, // 526
    1.083887052491730e+01, // 527
    9.737940084666089e+00, // 528
   -6.439570019501545e+00, // 529
   -1.739641777644932e+01, // 530
   -7.839914771675471e+00, // 531
    1.942891003796814e+01, // 532
   -1.936289961573477e+00, // 533
   -7.829000009958945e+00, // 534
    2.257740607217154e+01, // 535
   -2.390025279579887e+01, // 536
   -3.501564032256903e+01, // 537
    8.337493091557315e-01, // 538
   -6.073476820102737e+00, // 539
   -3.341547834363513e+01, // 540
    6.508556513666490e+00, // 541
   -7.576879392730211e+00, // 542
    9.285084408322492e+00, // 543
    1.914972060416477e+01, // 544
    2.164175675832731e+01, // 545
    3.224556425266841e+00, // 546
    2.109584783393990e+01, // 547
   -1.468146710806314e+01, // 548
    4.849992602171382e+00, // 549
   -1.561870323901115e+01, // 550
   -1.225690214730253e+01, // 551
   -6.467038326388889e+01, // 552
    2.820537451937505e+00, // 553
   -2.864313149650900e+01, // 554
    7.460329689500061e+00, // 555
   -3.570763001130755e-01, // 556
   -3.265362518469826e+00, // 557
    7.946451805691005e-01, // 558
    7.653387491263851e+00, // 559
    3.013660960836350e+00, // 560
   -7.763837493473961e+00, // 561
    5.349404992915058e-01, // 562
   -3.508282173929404e+00, // 563
    1.389553772442678e+01, // 564
    9.994789639227703e+00, // 565
   -9.709586227071865e+00, // 566
    3.219723495764586e+01, // 567
    1.081099308005949e+01, // 568
    2.236529909029160e+00, // 569
    1.588577805373851e+01, // 570
    1.374277783970057e+01, // 571
   -9.300673401293013e+00, // 572
   -5.864149005142176e+01, // 573
   -2.673195301593346e+00, // 574
   -8.614452143719538e-01, // 575
   -4.168126219341613e+00, // 576
    2.442727407099147e+00, // 577
   -1.124479988983288e+01, // 578
    9.608765125312692e+00, // 579
   -3.124766587464802e-02, // 580
   -5.054407652284457e+00, // 581
    6.954716094891591e+00, // 582
    2.229414789909315e-01, // 583
   -8.099404384143337e+00, // 584
    3.460476994732368e+00, // 585
    3.546341812678258e+01, // 586
    5.189655654154436e+00, // 587
    1.906611882874634e+01, // 588
    1.492320381537230e+01, // 589
   -1.571817850387325e+01, // 590
   -3.159949455183223e+01, // 591
    9.360710876266261e-01, // 592
    2.160546453718416e+00, // 593
    1.264283013302046e+01, // 594
    1.093715238902706e+01, // 595
   -1.201940865950159e+01, // 596
   -1.901237240387409e+01, // 597
    1.728119662525323e+01, // 598
   -2.833399687459225e+01, // 599
   -3.203526341230445e+01, // 600
    2.554378991039675e+01, // 601
   -1.076801600600355e+01, // 602
   -2.570065104176204e+01, // 603
   -7.774432644490380e+00, // 604
   -1.349355183671681e+01, // 605
   -7.882241131391053e+00, // 606
    2.017203151915949e+01, // 607
    1.101170771808557e+01, // 608
    3.870111535801530e+00, // 609
   -5.228725413941804e+00, // 610
   -3.063242398559827e+01, // 611
    1.122835476367568e+01, // 612
    1.811590130343953e+01, // 613
   -1.646013447585158e+01, // 614
   -8.599406910678593e+01, // 615
    1.621906967185757e+01, // 616
   -1.301893117553418e+01, // 617
    2.208425401324994e+00, // 618
   -3.468663309869572e+00, // 619
    1.706956947401826e+01, // 620
   -1.405675194673227e+01, // 621
    6.108821478166965e+00, // 622
   -5.181970753422822e+01, // 623
   -2.505673904493357e+00, // 624
   -1.003260087596770e+01, // 625
    1.377894949326608e+01, // 626
    1.239505273499278e+01, // 627
    3.175370768258297e+01, // 628
   -6.842030600680054e+00, // 629
    1.387100063380829e+01, // 630
    2.893484302890763e+01, // 631
    9.070382202287064e+00, // 632
    2.960208469444908e+00, // 633
    1.675920162021208e+01, // 634
    3.314876295739157e+01, // 635
   -3.451059972660796e+01, // 636
   -1.926206311906063e+00, // 637
    6.089819408666740e+00, // 638
    3.923064060506495e+01, // 639
    9.158340302254963e+00, // 640
   -4.132910149172831e+01, // 641
   -5.671562312374419e+00, // 642
   -6.968237844839759e+00, // 643
    3.439382792765059e+00, // 644
    3.527194668112804e+01, // 645
   -3.958941624199935e-01, // 646
    8.849661105155533e+00, // 647
    3.904316485547374e+00, // 648
    1.330496850505373e+01, // 649
    2.501463926625660e+01, // 650
   -1.379178029687024e+01, // 651
    8.553568374703540e-01, // 652
   -3.603613183306722e+00, // 653
    2.358636943896810e-01, // 654
    4.816202939944026e+00, // 655
    6.469977555835078e+00, // 656
    2.511302389723030e+01, // 657
    5.336291211937795e+00, // 658
   -2.580720679845392e+01, // 659
   -1.425881721309795e+01, // 660
   -1.301984750850670e+01, // 661
   -1.516938478132934e+00, // 662
   -1.868620792665353e+01, // 663
   -5.090987000385280e+00, // 664
   -2.810295723092517e+00, // 665
    5.156491912552408e+00, // 666
   -5.843432078216529e+00, // 667
    1.602475884768624e+00, // 668
   -8.773299651010712e+00, // 669
   -1.672581273616770e+01, // 670
    2.947218357183485e+01, // 671
    1.611674457748779e+01, // 672
    8.493933910988357e-01, // 673
   -1.543191007387047e+01, // 674
   -5.469275544788675e+00, // 675
    7.055141711180863e+00, // 676
   -4.115470136498970e+01, // 677
   -1.269926233474056e+01, // 678
    1.020333406199375e+01, // 679
   -1.660876256225635e+01, // 680
   -9.189245387095790e+00, // 681
   -5.460391676646862e-01, // 682
    3.335236211154986e+00, // 683
    3.933072428924345e+00, // 684
    2.550153810570464e-01, // 685
   -1.367763759187985e+00, // 686
   -7.444277315350462e+00, // 687
   -1.133782879763869e+01, // 688
    3.124862138501865e+01, // 689
   -6.121547622032967e-01, // 690
   -9.392074236433832e+00, // 691
    2.864642263022512e+01, // 692
   -1.560749562443983e+01, // 693
   -2.384546127746137e+01, // 694
    1.302025323316917e+01, // 695
    4.455592239726145e+00, // 696
   -8.465944250867713e+00, // 697
    2.850138196368803e+01, // 698
    2.430072424300563e+01, // 699
    1.053467907649230e+01, // 700
   -2.058602625549607e+01, // 701
    1.486208415285118e+01, // 702
   -1.925830498163625e+01, // 703
    5.315325109255588e+01, // 704
   -8.973388860734794e-01, // 705
    1.935973422105226e+01, // 706
    5.313930173382007e+00, // 707
    2.748521900762190e+00, // 708
   -1.148983406221052e+01, // 709
   -1.603547230638917e+01, // 710
   -2.269060718297754e+01, // 711
    2.805045600006778e+01, // 712
    2.929463393650914e+01, // 713
   -9.811702314934731e+00, // 714
   -1.859627984602822e+00, // 715
   -5.129249143072927e+00, // 716
   -7.831016897640472e+00, // 717
    1.615935259302390e+01, // 718
   -7.203957691397203e+00, // 719
    7.431457242507410e+00, // 720
    4.022555722800425e+00, // 721
   -1.454979567635128e+00, // 722
    2.273747374385955e+01, // 723
    1.354913325037567e+01, // 724
   -1.228374866405145e+00, // 725
   -2.580127790142181e+01, // 726
    1.353696243759630e+00, // 727
   -1.706028820927396e+01, // 728
   -9.200544906870933e+00, // 729
   -1.634790287044170e+01, // 730
   -2.299761576978557e+00, // 731
   -7.173503520443234e+00, // 732
   -2.454318174255370e+01, // 733
   -1.750498272055032e+01, // 734
    1.739573328453208e+01, // 735
   -8.857760225118099e+00, // 736
   -2.375816035597742e+01, // 737
   -9.456798754312022e+00, // 738
    2.868033283837363e-02, // 739
    2.088980061088363e-01, // 740
    2.009346620619187e+01, // 741
   -1.185495972674595e+01, // 742
    4.980047618404342e+00, // 743
    4.927027875654355e+01, // 744
    5.467873461696787e-01, // 745
    3.660312305608871e+01, // 746
   -4.479874753671341e+01, // 747
   -5.975521687493094e+00, // 748
    4.836517519307775e-01, // 749
    3.779572100558168e+01, // 750
   -1.202178150407191e+01, // 751
    6.191471054351425e-03, // 752
   -1.675857404874872e+01, // 753
    9.695888192868219e-01, // 754
    1.242683909283949e+01, // 755
    6.297378913963186e+00, // 756
   -1.858817431900898e+01, // 757
   -1.338980308913153e+01, // 758
    1.437058904655166e+01, // 759
   -8.324942074723262e-01, // 760
    1.389879120226364e+01, // 761
    1.140729549016947e+01, // 762
   -6.489398684732191e+00, // 763
    2.892305407562262e+01, // 764
   -2.557453822461961e+01, // 765
    1.810618417105819e+01, // 766
   -4.468578196807150e+01, // 767
    1.954804624496585e+01, // 768
   -1.291334088223442e+01, // 769
   -8.944253390053282e+00, // 770
   -1.289085966722961e+01, // 771
   -2.512852680424959e+01, // 772
    3.477278495489863e+00, // 773
   -3.764864292671353e+01, // 774
   -2.411322086631439e+01, // 775
    5.185951192350591e+01, // 776
   -4.104831475822061e+00, // 777
   -1.407860965289238e+01, // 778
   -4.740716447590449e+00, // 779
    1.888788429146232e+01, // 780
    3.744100400037418e+00, // 781
   -2.021933583139916e+01, // 782
   -1.669585035555139e+00, // 783
   -8.182985696583865e+00, // 784
    1.095799409392642e+01, // 785
    5.863516688769769e+00, // 786
    4.501007906080602e+00, // 787
   -1.218428128380581e+01, // 788
    2.327899893977133e+01, // 789
   -1.129382921362626e+00, // 790
   -1.063750240786360e+01, // 791
    4.429802466467269e+00, // 792
    3.652055113224528e+00, // 793
   -9.911941293742627e+00, // 794
   -7.246585473497879e+00, // 795
    2.939974035162809e+00, // 796
    1.190600471330703e+01, // 797
    2.480133257461637e+00, // 798
    5.661167786796052e+00, // 799
    2.979851782638882e+01, // 800
   -9.956903066952281e+00, // 801
   -1.305321683339342e+01, // 802
   -4.586784122933862e+00, // 803
    2.108121810999587e+01, // 804
    1.738412818303572e+01, // 805
    1.100496378153456e+01, // 806
    5.102354727601238e+00, // 807
    3.073575661277569e+01, // 808
    2.380995130551926e+01, // 809
   -7.334501514646201e+00, // 810
   -2.648112215504564e+00, // 811
    1.276596228332904e-01, // 812
    1.569249044083394e+00, // 813
    6.385189665622086e+00, // 814
    1.121225961325794e+01, // 815
    1.885931385298791e+00, // 816
   -1.307577133998622e+00, // 817
   -2.094140760970979e+01, // 818
    2.361226909749039e+01, // 819
   -6.641193398771906e+00, // 820
    4.992635509113169e+00, // 821
   -7.093716953549684e+00, // 822
   -1.174922629079895e+01, // 823
   -8.594136647527449e+00, // 824
   -3.708405023689551e-01, // 825
    3.103731535007939e+00, // 826
    2.597862782743689e+01, // 827
    1.470447182104481e-01, // 828
   -2.589481040574819e+00, // 829
   -1.012225607625375e+01, // 830
   -1.718750261379405e+01, // 831
    2.823770629533865e+01, // 832
   -2.812694565939661e+01, // 833
   -1.685867442916406e+01, // 834
    2.397828000247029e+01, // 835
   -7.387750517186314e+00, // 836
   -2.598130763463168e+00, // 837
    1.476915813549688e+01, // 838
   -7.958949483789605e+00, // 839
   -3.235630775936987e+00, // 840
    3.092519780416355e+01, // 841
   -4.330719302775718e+00, // 842
   -2.903030254871970e+01, // 843
   -4.265324213831649e+01, // 844
    2.643605081974423e+01, // 845
    3.495335664539141e+00, // 846
   -7.780677471072820e-01, // 847
    1.173172374172179e+01, // 848
    1.047445581020611e+00, // 849
   -9.633818454758785e+00, // 850
   -8.195360190337475e+00, // 851
   -2.112838070133187e+01, // 852
    8.326087853022139e-02, // 853
   -1.415452690699046e+01, // 854
    1.092263978284420e+01, // 855
    8.096636801994894e+00, // 856
    2.764935886204531e+00, // 857
    8.958796496671242e-01, // 858
   -1.926511946114729e+01, // 859
    1.467107153899586e+01, // 860
    4.191412652644742e+00, // 861
   -9.825203394177933e+00, // 862
   -8.890973843871953e+00, // 863
    5.222560981886978e+00, // 864
   -1.519981220305011e+01, // 865
   -2.013437939661065e+01, // 866
   -7.613568028191409e+00, // 867
    1.753806630014288e+01, // 868
    1.504407737108122e+01, // 869
   -4.105553570569722e+00, // 870
   -4.194296938911758e+00, // 871
    1.062868491319910e+01, // 872
    1.032403720495974e+00  // 873
    };

    for (int i = 0; i< 874; i++)
      twobodyfit[i] = twobodyfit_cp[i];
  } else {
    std::cerr << "Ion " << ion << " not found in mb-nrg parameters." << std::endl;
    throw std::exception();
  }
}

void mbnrg_param_X_H2O_H2O::set_parameters(const std::string ion){
  if (ion == "F") {
    //fit-h4o2f_ccsdtf12_avtz_cp_ts_w_nm_scans   04/25/16
 
    R3I =       0.000000000000000e+00; // A
    R3F =       6.500000000000000e+00; // A
   
    KHH_INTRA = 2.755748327997387e-01; // A^(-1)
    KOH_INTRA = 2.315732022876699e-01; // A^(-1)
   
    KHH =       3.839217123331481e-01; // A^(-1)
    KOH =       4.905511724775750e-01; // A^(-1)
    KOO =       3.735309003786624e-02; // A^(-1)
   
    KXO =       -5.637402258336355e-01; // A^(-1)
    KXH =        8.124982097936495e-01; // A^(-1)
   
    DHH_INTRA = 8.566836352171249e+00; // A
    DOH_INTRA = 5.130533144222694e+00; // A
   
    DHH =       3.651904308189822e-01; // A
    DOH =       1.058733875505909e+01; // A
    DOO =       9.361783326467794e+00; // A
   
    DXO =       1.518380912416376e+00; // A
    DXH =       7.556013047179954e+00; // A

    
    double threebodyfit_cp[] = {
    1.348783038757758e-01, // 0
   -1.727834429154826e-01, // 1
   -1.261705932280166e-01, // 2
   -1.562590737582713e+00, // 3
   -2.017108379913202e+00, // 4
    1.270561191699174e-01, // 5
    2.296953029162184e+00, // 6
    3.756723401562410e-01, // 7
    4.086406732833154e-02, // 8
    1.243429677769461e-01, // 9
   -1.542639983860444e+00, // 10
    1.739020613771523e+00, // 11
   -2.567067980982450e+00, // 12
    3.157991216300979e-03, // 13
    4.036947014333781e+00, // 14
    1.546165122412566e-02, // 15
    4.351117373441885e-01, // 16
    8.482712530676396e-02, // 17
    5.815526446785189e-02, // 18
   -5.084477441381017e-01, // 19
   -2.592460340251661e+00, // 20
    7.123214264517409e-01, // 21
   -1.425927859201935e-02, // 22
   -5.631436975609036e-03, // 23
    2.214674471684346e-02, // 24
    6.673681938118071e-01, // 25
   -2.762676142090279e-01, // 26
   -2.111561685775190e-02, // 27
   -9.643967707906549e-01, // 28
    3.645498404327925e-01, // 29
   -8.897651655168973e-02, // 30
    1.199502153956949e-02, // 31
   -6.415918131836859e-01, // 32
   -4.119344637935028e-02, // 33
   -1.657474335022932e-02, // 34
   -1.613154530357476e-01, // 35
    2.301348284379697e-02, // 36
    1.009789827075964e-01, // 37
    7.036761766895185e-01, // 38
   -2.277064426626724e-03, // 39
   -2.354841644529963e-01, // 40
   -4.698810971220908e-03, // 41
    7.590746984531693e-01, // 42
    1.107606682792919e-03, // 43
    1.220057311384296e-03, // 44
    1.302604612317471e-01, // 45
    9.007891136173896e-02, // 46
   -6.614681758296065e-02, // 47
    3.366366562997532e-02, // 48
    2.313214669434594e+00, // 49
    4.154420752235164e-02, // 50
    3.683487537464047e-01, // 51
    1.427920361876311e+00, // 52
    3.932292307995044e-04, // 53
    3.793634217016160e+00, // 54
   -8.110058867892726e-03, // 55
    8.169502526911331e-03, // 56
   -3.816668123729129e-03, // 57
   -1.801147307132384e-01, // 58
   -2.127543641913584e-01, // 59
   -2.527014644396623e-01, // 60
   -3.058439426474428e-01, // 61
    2.077492896018811e+00, // 62
    6.974946289157401e-04, // 63
   -4.199529888730603e-03, // 64
    3.638306844099325e-01, // 65
    2.035760201424599e+00, // 66
   -2.252742692286062e-02, // 67
   -6.191068538813023e-02, // 68
    1.154792904419120e+00, // 69
    5.071844441082206e-03, // 70
    1.619105335005019e-01, // 71
   -6.816148470950550e-02, // 72
   -1.543325100892712e+00, // 73
   -6.723588135911056e-03, // 74
   -1.830324527202019e-01, // 75
    2.873739898705872e+00, // 76
    5.549470446702676e-03, // 77
    9.327875087235633e-02, // 78
    8.603843163973354e-01, // 79
   -1.857845393600082e-01, // 80
   -2.388049021022565e+00, // 81
   -3.747025155192382e-02, // 82
   -6.682562788579796e-03, // 83
   -4.913583257988038e-02, // 84
   -1.145211508172193e+00, // 85
    9.480217353106745e-04, // 86
   -6.162789148948740e-04, // 87
    1.850998189498348e+00, // 88
    1.602329802773372e-03, // 89
   -5.141463848828681e-02, // 90
   -1.341643848834741e-01, // 91
   -1.944507630227664e-01, // 92
    5.401074376212094e-03, // 93
   -1.008039498495894e+00, // 94
    5.672058066388268e-01, // 95
    2.754013121572970e-01, // 96
    2.185758629533460e-02, // 97
    1.003444351507666e-02, // 98
   -1.094633327519688e+00, // 99
   -1.059748659960563e+00, // 100
    1.724535322133156e-02, // 101
   -4.029274363741292e+00, // 102
    3.253221355166413e-02, // 103
    9.444114189007823e-04, // 104
   -3.509052279612594e-02, // 105
   -1.709919042431231e+00, // 106
   -1.028252157413311e+00, // 107
    1.750110081912372e-01, // 108
    4.745332540312293e-01, // 109
   -1.197188253927807e+00, // 110
   -6.972659676065973e-02, // 111
   -6.999334425821586e-01, // 112
    8.846285277792034e-01, // 113
    2.392009689495495e-03, // 114
    1.018952891686627e+00, // 115
    3.997820123933516e-02, // 116
    5.116697420180175e-02, // 117
   -8.367936876744147e-03, // 118
   -1.135959410881215e-01, // 119
    4.200081431010339e-01, // 120
    5.497989406527363e-02, // 121
    2.272329675057466e+00, // 122
   -3.867605316257267e-01, // 123
   -5.771249584845338e-03, // 124
    5.198408833814914e-01, // 125
   -2.113878516304189e+00, // 126
    2.115529029087962e+00, // 127
    1.599796244091545e-02, // 128
   -3.361591088467543e-05, // 129
    4.381677198020863e-02, // 130
    8.898804833723928e-02, // 131
   -2.183265788749359e-02, // 132
   -4.821722108512298e-01, // 133
   -3.962185430478492e-03, // 134
   -2.454119139399692e+00, // 135
    3.713531810532914e-01, // 136
    1.019583721268520e-01, // 137
   -3.537939206835495e+00, // 138
   -9.899036090720545e-02, // 139
    8.515544521100521e-02, // 140
   -3.269094919375287e-03, // 141
   -6.066127107976114e-01, // 142
   -1.083528785432554e-02, // 143
    2.345596078895553e+00, // 144
    2.539511894213964e-03, // 145
   -1.390886615294600e-02, // 146
   -1.329352259651054e+00, // 147
   -1.267790139327035e-01, // 148
    2.801184050069118e-01, // 149
    3.186468542340383e+00, // 150
   -3.139751818456998e-02, // 151
   -3.802178859027495e-01, // 152
   -9.100285769695714e-02, // 153
    3.538586302942422e-02, // 154
    8.450105925826309e-02, // 155
    1.309651685979332e+00, // 156
    5.168646014727310e-04, // 157
    4.011050482865192e-01, // 158
   -1.059713624411928e-01, // 159
    4.686072933882744e-02, // 160
    3.818480247046101e-02, // 161
    1.407596222470777e-02, // 162
   -7.621575554141751e-04, // 163
    3.768720342658553e-03, // 164
   -9.335531513036236e-05, // 165
   -4.676933238381333e-04, // 166
    3.639852911936846e-04, // 167
   -2.522256527634963e-03, // 168
   -3.062907189388503e-02, // 169
    1.193707475693426e-05, // 170
   -1.195220021915454e-06, // 171
    1.102474613894094e-05, // 172
   -3.896117259252502e-03, // 173
   -1.261672691333970e-03, // 174
   -4.569177131014731e-03, // 175
   -1.163598323738462e-04, // 176
    1.461587231673653e-01, // 177
   -3.319124902900986e-04, // 178
   -1.839717490538552e-02, // 179
   -3.589321469899387e-02, // 180
    1.697489914933397e-01, // 181
    4.347392394980230e-02, // 182
    1.003102969482816e+00, // 183
   -2.291490164432843e-04, // 184
    4.627847904543533e-02, // 185
    8.941549155600754e-05, // 186
    9.336085895053238e-06, // 187
    1.478207901098412e-04, // 188
    3.181109574904509e-02, // 189
    2.233072699812314e+00, // 190
   -5.643197032636755e-01, // 191
    5.015025282160589e-03, // 192
    3.002042468370950e-05, // 193
   -5.426519016818785e-03, // 194
    1.025904482198812e-03, // 195
   -9.279758656949229e-05, // 196
    8.568867847110457e-04, // 197
    4.488945961456551e-05, // 198
   -8.640693424122786e-05, // 199
    1.766919366523239e-02, // 200
   -3.527251876723974e+00, // 201
   -8.615902735953083e-03, // 202
   -8.864355520298706e-05, // 203
    3.765918373216439e-05, // 204
   -7.927838999273541e-04, // 205
   -2.811584482204048e-02, // 206
    1.159012535464600e-05, // 207
    4.119987218923617e-03, // 208
   -1.265065139706624e-01, // 209
   -2.731875320550921e-04, // 210
    8.660064728189225e-03, // 211
   -4.642514867680148e-03, // 212
    3.684095124097168e-03, // 213
    3.097040138769017e-01, // 214
    9.096880684955379e-03, // 215
   -2.084286494987914e+00, // 216
   -3.062873101879803e-03, // 217
    2.471055641479766e-04, // 218
    2.387452358702598e+00, // 219
   -1.575503737225422e+00, // 220
    4.316156422152302e-04, // 221
    4.880350533866615e-04, // 222
    5.829634752868392e-03, // 223
    1.173933406338929e-02, // 224
    2.599570961507807e-01, // 225
    3.008829554438030e-02, // 226
   -1.858139779942415e-03, // 227
    2.244527420392938e-01, // 228
    6.452412073427441e-04, // 229
   -6.634331569593845e-02, // 230
   -4.269501434523529e-03, // 231
   -4.205187026091222e-03, // 232
   -1.718271523669988e-03, // 233
    9.078849235959564e-03, // 234
   -1.003068356058572e-03, // 235
   -2.466027733435720e-04, // 236
    3.113971870692393e-04, // 237
    1.368811157601611e-06, // 238
    4.791078067887510e-04, // 239
    8.317095604246250e-05, // 240
   -4.480560055005949e-05, // 241
   -1.028011219234260e-05, // 242
    1.564899638814544e-02, // 243
    2.885253272892567e-02, // 244
    8.791656055556811e-04, // 245
    6.218384824631081e-02, // 246
    3.740430397038504e-02, // 247
   -9.631321965213014e-05, // 248
    5.840503942527379e-03, // 249
    4.150142744768719e-03, // 250
   -3.858850512977834e-02, // 251
    3.826922480687366e-05, // 252
   -1.993376961010447e-05, // 253
    1.552666802062649e-05, // 254
   -1.756428364498459e-03, // 255
   -8.990727104987632e-03, // 256
    1.425310644028362e-02, // 257
   -1.570448910649131e-05, // 258
   -2.308629523772964e-03, // 259
   -4.279174924626875e-04, // 260
    8.621850005033333e-06, // 261
    9.859781663851730e-05, // 262
   -6.342358292773312e-05, // 263
    8.661849831193214e-02, // 264
   -1.317377649477416e-06, // 265
   -2.049173414754846e-03, // 266
   -9.897822438629657e-03, // 267
   -9.168322743827749e-05, // 268
   -2.200823880067628e-02, // 269
    2.808189012927705e-03, // 270
   -7.619116063986431e-05, // 271
    1.164410972088357e-04, // 272
   -2.171059140584488e-05, // 273
   -1.282911749117232e-04, // 274
    4.319950555845473e-05, // 275
   -1.111040610271305e-03, // 276
   -2.076960440452190e-03, // 277
    4.520632687504106e-03, // 278
   -1.015332702282679e-02, // 279
    8.652282468913912e-06, // 280
   -2.718623626167673e-05, // 281
    1.817475243545105e-02, // 282
    8.000841561178333e-01, // 283
   -2.626991048673232e-03, // 284
   -9.419433129356727e-02, // 285
    1.655681292221971e-02, // 286
    3.181604370240704e-02, // 287
    7.828244666594790e-03, // 288
    7.528514900326044e-04, // 289
   -9.872867035209800e-04, // 290
    6.274074466272094e-05, // 291
   -1.596658065412983e-03, // 292
   -1.936312887786585e-02, // 293
   -1.453235669958825e+00, // 294
    3.112222471033711e-03, // 295
    1.650666349904379e-02, // 296
   -3.027264216333286e-06, // 297
   -6.057258405036767e-04, // 298
    1.249608503596237e-03, // 299
   -1.344985889359564e-05, // 300
    1.267522850316445e-03, // 301
   -6.461850259576002e-03, // 302
    2.077469356560600e+00, // 303
    1.035868526618240e-04, // 304
    7.096040577963966e-04, // 305
   -2.195731150175412e-03, // 306
   -3.192851563586596e-01, // 307
   -3.322088565858193e-04, // 308
    5.991567247154954e-04, // 309
    4.796596927829243e-03, // 310
   -4.757248440635690e-02, // 311
   -2.415632953991583e-04, // 312
    6.083519123454736e-05, // 313
   -5.679204858488184e-02, // 314
   -7.564759435519120e-04, // 315
    3.312884563893103e-03, // 316
   -9.344061241881389e-02, // 317
   -6.375042746327769e-06, // 318
   -4.751323376694140e-01, // 319
    9.637984056407226e-04, // 320
    4.867245380552750e-06, // 321
   -3.472550558171593e-05, // 322
    4.155056396710059e-02, // 323
   -1.305615168969845e-06, // 324
    5.403646198012105e-03, // 325
    1.242089583883781e-03, // 326
    3.539659650649991e-05, // 327
   -5.492934304964190e-04, // 328
    1.267381940977004e-04, // 329
    3.124281737293473e-02, // 330
    2.387423382323648e-06, // 331
    2.393804024003856e-01, // 332
    1.385521507974987e-04, // 333
    4.827349126297058e-03, // 334
   -1.474079423103592e-05, // 335
   -4.183895104524010e-04, // 336
    2.680567681768797e-04, // 337
   -1.797499417717993e-04, // 338
    1.071969138407238e-05, // 339
    1.578477392193812e+00, // 340
   -1.182946922589322e-04, // 341
    6.815801578061662e-04, // 342
    9.266449434021304e-04, // 343
   -4.718007595481102e-02, // 344
   -8.605834324363428e-03, // 345
   -2.237329177547378e-03, // 346
   -4.058866652324681e-05, // 347
    8.941181663618926e-06, // 348
    1.890506873740202e-03, // 349
   -1.922557752163121e+00, // 350
    1.311040577169067e-05, // 351
   -1.061561269960688e-05, // 352
   -1.791562669033952e-06, // 353
    4.127429199010751e-04, // 354
   -4.999751688028774e-03, // 355
   -7.401923663251902e-04, // 356
   -4.666887385847210e-05, // 357
    7.395609116739785e-04, // 358
    3.514563251416768e-04, // 359
   -1.087352251275619e-03, // 360
   -2.883020327837441e-01, // 361
    2.221911608079390e+00, // 362
    1.462848808162292e-05, // 363
    7.516224166631986e-03, // 364
    1.090909240260852e-01, // 365
    2.991130094622694e-03, // 366
    5.199806454662554e-03, // 367
   -8.966072049821508e-03, // 368
    1.351058344541936e-03, // 369
   -8.400777102984072e-02, // 370
    2.330855065778186e-05, // 371
   -1.567467219829188e-03, // 372
    7.765885976432726e-02, // 373
   -2.497777045166945e+00, // 374
    3.650216382435493e-02, // 375
    1.486133104173762e-02, // 376
    7.744602088468089e-02, // 377
    2.090122058583854e-02, // 378
   -3.202758113941277e-06, // 379
    8.864773246070221e-02, // 380
   -1.436436275270270e-03, // 381
   -2.426752943715040e-03, // 382
   -2.698008129846082e-03, // 383
   -2.701909479431922e-04, // 384
    4.401511328746279e-04, // 385
    2.052698664898467e-03, // 386
   -2.539402885508937e-02, // 387
    2.087003238936652e-03, // 388
    4.195019357534055e-04, // 389
   -1.493653754131069e-05, // 390
    6.551508630101155e-02, // 391
   -7.958742336391217e-05, // 392
    8.994318099541139e-04, // 393
   -1.107050528925509e-05, // 394
   -2.086701030713594e-02, // 395
   -1.426329192909371e-03, // 396
    1.160560169784921e-02, // 397
   -2.443137392180362e-04, // 398
    4.827489356490424e-05, // 399
    3.172881051733384e+00, // 400
   -4.876954636238316e-03, // 401
    2.290811594039771e-04, // 402
    2.069627349801178e-01, // 403
    3.574608543405132e-03, // 404
   -2.713772946594739e-05, // 405
    2.307218716513571e-04, // 406
    1.947182468398591e-05, // 407
    2.596739478973393e-02, // 408
    1.364835657549471e-03, // 409
    1.323604015010178e-02, // 410
    5.105367183078571e-04, // 411
    4.346264376227853e-01, // 412
    1.653536247409390e-03, // 413
   -2.674116234541388e+00, // 414
    2.928443421638527e-02, // 415
   -7.815875934117817e-04, // 416
   -4.029303943552272e-03, // 417
   -9.016004337939813e-02, // 418
   -1.121495948082008e-03, // 419
    9.552916420522633e-04, // 420
   -3.457346315000421e-06, // 421
   -2.078135194360150e+00, // 422
   -5.468197863587308e-03, // 423
    1.858754014505927e-03, // 424
    8.429918651444716e-05, // 425
    8.560957506297169e-04, // 426
   -4.019227928084926e-03, // 427
   -9.027605753490526e-04, // 428
   -1.705509042633394e-03, // 429
    6.864173264660983e-04, // 430
   -1.530837470616963e-04, // 431
    9.131831473631428e-05, // 432
   -1.097981081141334e-03, // 433
   -6.951320132816757e-02, // 434
    4.856107263745759e-01, // 435
   -2.229254669807877e-04, // 436
   -3.228831770502372e+00, // 437
   -4.317353667215898e-05, // 438
   -4.115551696075330e-03, // 439
    1.089330066844530e-04, // 440
    5.809438809830019e-02, // 441
   -9.997021385415014e-06, // 442
   -9.061636879646929e-04, // 443
   -5.333890017767094e-02, // 444
    1.514697031422370e-03, // 445
   -9.628414019240878e-03, // 446
   -1.466444093967240e-04, // 447
   -6.987061669598540e-04, // 448
   -1.014461371007039e-04, // 449
   -6.845564934607029e-04, // 450
   -1.890823523260498e-04, // 451
    2.882509492807627e-04, // 452
    2.056756897972788e+00, // 453
    6.720597382184551e-05, // 454
    2.489510798220515e-02, // 455
   -2.924672702326397e-05, // 456
   -2.384499417532354e-04, // 457
   -6.940818564424389e-02, // 458
    1.528098259759363e-02, // 459
    1.165986048703463e-02, // 460
   -2.652220038246466e-04, // 461
   -7.212483945117829e-03, // 462
   -5.465900644738643e-02, // 463
    5.388121029972521e-02, // 464
   -6.819851643602975e-04, // 465
    4.698785183336213e-05, // 466
   -3.065084573449445e-04, // 467
    3.428964198500309e-01, // 468
    8.712999046029471e-05, // 469
    9.470139614391622e-03, // 470
    1.402734098305402e-01, // 471
   -6.251570121280420e-06, // 472
   -2.414140060274046e-03, // 473
   -5.126397874492795e-04, // 474
    1.672098494305086e-01, // 475
    4.553076155794118e-02, // 476
    5.318007113635399e-02, // 477
    1.827189445948441e-04, // 478
   -1.001225774890628e-02, // 479
   -5.824676942341107e-02, // 480
    4.230146542533064e-04, // 481
    5.911699913346976e-03, // 482
   -9.246890993658428e-02, // 483
   -1.668226213056736e-06, // 484
    1.461267772827373e-04, // 485
    3.141380904029366e-02, // 486
    5.132207009373031e-01, // 487
   -4.400170828283463e-03, // 488
    3.062914536107488e-02, // 489
    3.637313382680799e-03, // 490
   -1.592158165461738e-01, // 491
   -2.204775801312554e-04, // 492
    3.647244463181439e-06, // 493
   -7.007257947047843e-03, // 494
    1.432640641104541e-01, // 495
   -1.330892987882850e-04, // 496
   -5.775102892752564e-03, // 497
    7.307023610729198e-06, // 498
   -1.381909316505716e-04, // 499
    1.890001084622417e-03, // 500
   -7.512699198764593e-05, // 501
   -5.631377292628037e-06, // 502
   -2.998733972865119e-01, // 503
    2.125331631306876e-01, // 504
   -5.019088936181867e-02, // 505
   -1.676930765042046e-04, // 506
    3.826640763982358e-03, // 507
    3.156542140050274e+00, // 508
   -1.478045267521004e-05, // 509
   -9.169414908443327e-05, // 510
    2.816884512241649e-05, // 511
   -2.741645627680921e-05, // 512
   -5.362241494477598e-06, // 513
   -5.741178441045244e-02, // 514
    1.134008248952228e-06, // 515
   -4.608147854459909e-04, // 516
    3.914259975579182e-05, // 517
   -6.812704682929658e-05, // 518
    9.086135988228258e-03, // 519
   -1.382478806811129e-02, // 520
   -1.787761860585304e-02, // 521
    9.966962604260388e-04, // 522
   -1.818097054515449e-01, // 523
   -5.029619747411682e-02, // 524
   -3.696169752314824e-04, // 525
    1.161193134824989e-03, // 526
   -6.498056103636331e-04, // 527
    3.424333348926766e-05, // 528
   -9.917206795273395e-05, // 529
    4.966358209239735e-02, // 530
   -5.731707968559601e-03, // 531
    2.965278126901096e-02, // 532
   -5.634254749540159e-02, // 533
    3.404589539340721e-03, // 534
   -4.105535781292257e-03, // 535
    2.971826363959811e-04, // 536
    7.881730683812911e-02, // 537
    5.913531314457050e-05, // 538
   -2.916244137382761e+00, // 539
   -2.648756638862122e-03, // 540
   -6.807128926748277e-03, // 541
   -3.310267272249415e-01, // 542
    1.587920616857342e-03, // 543
   -6.024292495353303e-05, // 544
    1.435588212378895e-02, // 545
    1.126381823766356e-01, // 546
    4.773657199359223e-06, // 547
    6.491451265487381e-01, // 548
   -8.766073116022830e-04, // 549
    2.389881353513177e-04, // 550
   -1.525441724325881e-04, // 551
   -2.028482835434888e-03, // 552
   -3.813686579314903e-02, // 553
    1.098573911433963e-04, // 554
   -2.378639074930982e-02, // 555
    2.307165031084759e-01, // 556
    1.314281047481014e-03, // 557
    7.124056293610614e-03, // 558
    5.406568588839585e-02, // 559
    6.804804848750873e-03, // 560
   -3.294752288735970e-01, // 561
    1.062649807351239e-02, // 562
    9.302191230377223e-05, // 563
    1.833700618908617e-04, // 564
   -1.362269470546950e-02, // 565
    6.009793386180001e-04, // 566
    2.931460807489294e-04, // 567
    6.802806134495221e-02, // 568
    3.113508075716993e-02, // 569
   -3.136570254289271e-03, // 570
   -9.498770547482301e-06, // 571
    5.835785586604497e-04, // 572
   -3.762736801727411e-01, // 573
   -2.459075489736231e-01, // 574
   -4.221966390309544e-03, // 575
   -2.416857139087138e-01, // 576
    2.796238418847162e-06, // 577
    3.202190211865823e-03, // 578
   -5.603315710914867e-04, // 579
   -1.594810524597681e-04, // 580
   -1.040075395582782e-02, // 581
    1.913815635091348e-02, // 582
   -4.385393276953013e-04, // 583
   -8.081259101725469e-02, // 584
   -4.272230314335337e-02, // 585
    7.477706896408559e-03, // 586
    1.978464911544897e-01, // 587
    1.164807693784776e-05, // 588
    6.481897019855233e-04, // 589
    6.266378951908107e-04, // 590
   -4.583678866720240e-03, // 591
    2.633846580775300e-06, // 592
    1.426584616896345e-03, // 593
   -1.135281472397988e-05, // 594
   -4.824984169569485e-01, // 595
    2.106440553320022e-03, // 596
   -1.633147139632022e-05, // 597
    2.832333804201102e-02, // 598
   -2.222764196496926e-04, // 599
   -1.545693569032574e-03, // 600
   -3.899340830574986e-05, // 601
   -2.961769822967454e-03, // 602
    6.912351111635354e-03, // 603
    9.724396465370934e-02, // 604
   -6.433319795939101e-01, // 605
   -2.341040537392214e-04, // 606
   -1.028944153251506e-03, // 607
    2.937843181526928e-03, // 608
   -3.475901181204234e-02, // 609
   -8.767350072063548e-04, // 610
    2.642533247383589e-03, // 611
   -6.809758656854711e-02, // 612
   -7.991329668862189e-06, // 613
    2.011090529905550e-02, // 614
    3.040060702702815e-01, // 615
   -3.687714701302355e-05, // 616
   -8.451101408481425e-05, // 617
    2.294584037349740e-03, // 618
    5.020708645606992e-04, // 619
   -9.671055330452942e-02, // 620
   -2.566431553450325e-02, // 621
   -3.764538317827801e-03, // 622
    1.021342113591308e-01, // 623
   -2.838429420027571e-04, // 624
   -2.273003857946847e-02, // 625
    1.597454717970391e-03, // 626
   -3.049139894566292e+00, // 627
    5.240697827154074e-03, // 628
   -1.280485375567687e-01, // 629
   -5.165743721138241e-02, // 630
    1.015302246766382e-02, // 631
    7.856481792251875e-03, // 632
   -1.149698190844471e-05, // 633
    2.108056757149737e-04, // 634
    5.359715505929616e-04, // 635
   -2.291677212037079e-05, // 636
   -7.716253389902132e-02, // 637
   -3.689006780312384e-03, // 638
   -1.063890597029637e-05, // 639
    1.887592705186036e-05, // 640
    2.111244380479438e-05, // 641
    1.875908196791848e-05, // 642
    8.122394061069659e-07, // 643
   -1.421624659975924e-04, // 644
    2.658471153779234e-01, // 645
    2.819923020369049e-05, // 646
   -4.580252010794206e-02, // 647
   -2.010705117052021e-02, // 648
    7.737491606593566e-02, // 649
    1.399571517721951e-01, // 650
    2.789315974922803e-02, // 651
    9.103015759293247e-03, // 652
   -1.411247878550598e-02, // 653
    4.040499763738428e-03, // 654
    3.736793825282650e-04, // 655
   -1.136119459879266e-05, // 656
   -3.348481331589093e-02, // 657
   -7.088302763487653e-04, // 658
   -1.032329283803956e-04, // 659
    1.194464563264107e-04, // 660
   -1.244044887636100e-02, // 661
    6.293223322918499e-04, // 662
    1.817921706370711e-01, // 663
    1.545201088185205e-04, // 664
   -3.026026933907693e-02, // 665
    7.901956255481904e-04, // 666
    8.009828007046675e-04, // 667
    2.271586615094132e-02, // 668
   -3.527208241768323e-04, // 669
    3.455840574089018e-03, // 670
   -1.708235470318829e-03, // 671
   -3.485450684157349e-05, // 672
    2.834459862153964e-01, // 673
    1.575709103845012e-04, // 674
    1.839367825187810e-03, // 675
    1.984337325282969e-05, // 676
   -3.767096610009348e-02, // 677
   -4.272993447198587e-04, // 678
    2.425558170838556e-06, // 679
   -1.206820256315689e-04, // 680
    1.606792301821596e-02, // 681
    3.255369910314140e-04, // 682
   -1.035345590449876e-02, // 683
   -1.185616084140001e-05, // 684
   -1.071367201701183e-02, // 685
    9.696753616818597e-03, // 686
   -1.694648210641535e-02, // 687
    2.772593625714858e-02, // 688
   -2.415900851519534e-06, // 689
    7.978819788281853e-03, // 690
   -2.524368613195813e-04, // 691
   -1.148507055308653e-03, // 692
   -2.439255400298820e-02, // 693
    5.262737306116532e-02, // 694
    9.800590470878470e-04, // 695
   -1.043574920177604e-04, // 696
    2.290216513246199e-05, // 697
    2.245018652376280e-03, // 698
   -1.287628169994012e-01, // 699
    9.633477594967835e-06, // 700
    1.457815253044703e-03, // 701
    1.114043515395446e-06, // 702
    7.711159104812376e-06, // 703
    2.388099140189224e+00, // 704
    4.074159040571359e-03, // 705
   -4.692980544441519e-04, // 706
   -6.497371514347020e-05, // 707
   -1.265649535770575e-01, // 708
   -8.299384060425024e-04, // 709
   -9.213542630774075e-03, // 710
   -7.892638178507100e-05, // 711
   -1.420473808307573e-01, // 712
    8.734360832509689e-06, // 713
   -7.244513415156657e-03, // 714
   -1.355445585431823e-03, // 715
    1.222459625759454e-04, // 716
    1.564161966916614e-04, // 717
   -6.385057872128289e-01, // 718
    3.909899280588919e+00, // 719
   -4.228062695038925e-04, // 720
   -7.404217800437613e-03, // 721
   -5.635290039730013e-05, // 722
   -1.275579425088724e-04, // 723
    4.235318930902227e-05, // 724
   -2.763429210117048e+00, // 725
   -5.200909418932818e-03, // 726
    4.596671161753958e-02, // 727
    3.557668220270883e-03, // 728
    3.168220391227272e-04, // 729
   -1.793200338901663e-06, // 730
    6.158046997516499e-04, // 731
    2.035763907821982e-05, // 732
    1.364709834959945e-05, // 733
   -1.479899764002185e-03, // 734
   -3.537678811145167e-05, // 735
   -1.496514850812827e-03, // 736
    5.923682598528664e-02, // 737
   -3.547699563082904e-04, // 738
   -7.293181529038537e-04, // 739
   -1.140400034088486e-06, // 740
   -4.666506553850578e-03, // 741
    3.181924020466318e-05, // 742
    1.241584762888619e-03, // 743
    5.776884887115706e-03, // 744
   -1.624622056536164e-02, // 745
    1.528754527798998e+00, // 746
    1.136441313572174e-04, // 747
    4.165723901093176e-05, // 748
   -1.887666856783412e-03, // 749
   -1.680191485756178e-01, // 750
    1.424725794738028e-02, // 751
    5.875471489799949e-03, // 752
   -2.971500825729565e-03, // 753
   -1.333858362938830e-05, // 754
    7.799405244726223e-07, // 755
   -1.471338733241598e-04, // 756
    6.169708016550303e-04, // 757
   -1.150945940697208e-02, // 758
    7.779107107332957e-02, // 759
    1.981980965657578e-02, // 760
    5.438777192550208e-03, // 761
   -4.324751534809845e-02, // 762
   -6.563718327538430e-02, // 763
    2.554610443616381e-05, // 764
    2.658239295487991e-03, // 765
   -2.788970421833109e-01, // 766
    9.272614378878924e-02, // 767
    6.688889802705529e-05, // 768
   -2.987612514652066e-06, // 769
    4.192447356782712e-02, // 770
   -9.845890086892503e-06, // 771
    8.098984935513512e-04, // 772
    1.091777153580770e-02, // 773
    3.692332437320780e+00, // 774
    1.947208053789196e-03, // 775
    3.916859605888956e-05, // 776
   -5.934465072081542e-04, // 777
    2.955906047564634e-02, // 778
    6.559188009317325e-06, // 779
    6.465833327037807e-05, // 780
   -2.762844357873794e-01, // 781
    1.404121123795685e-04, // 782
   -4.030669805641936e-03, // 783
    6.428287776050235e-05, // 784
   -2.108712067313861e-05, // 785
   -1.048257654367335e-05, // 786
   -1.195391511467939e-04, // 787
   -6.657850196952481e-05, // 788
   -1.077502208451160e-03, // 789
    1.456422608911639e-03, // 790
   -7.372817887051831e-06, // 791
    1.925740402835996e-03, // 792
   -3.506083088124934e-02, // 793
    5.741341047083483e-02, // 794
    2.144006627398162e-05, // 795
   -5.553038103562949e-03, // 796
    3.494398672304985e-02, // 797
   -3.627564819878433e-06, // 798
    3.370807363348277e-06, // 799
    3.291739633295689e-05, // 800
    5.679976142732513e-05, // 801
   -1.440263897170871e-04, // 802
   -2.142628947330999e-03, // 803
   -1.070478297570994e-03, // 804
    9.128006451743783e-05, // 805
    8.122038211435477e-03, // 806
    1.521661213885185e-04, // 807
   -5.101917071320696e-04, // 808
    3.593578978892203e-02, // 809
   -1.262637737544059e+00, // 810
   -9.856521688996855e-05, // 811
    8.284582370635591e-04, // 812
    3.080323329941204e-06, // 813
    2.229321213057480e-01, // 814
   -1.600141396601874e-03, // 815
   -7.445401498120620e-03, // 816
   -1.623291269382418e-02, // 817
   -1.321306315795044e-01, // 818
   -3.914701643743747e-02, // 819
    2.236328365571090e-01, // 820
    9.005631934986580e-04, // 821
    1.598692512410889e-03, // 822
   -6.385275339354654e-03, // 823
    5.624053719267427e-02, // 824
   -8.234479693377062e-04, // 825
   -8.627579042069506e-03, // 826
   -8.445106709302014e-03, // 827
    1.107193200273606e-03, // 828
    1.065704920878105e-01, // 829
   -4.143390288955793e-04, // 830
   -1.086146744796929e-03, // 831
   -2.399247763246899e-04, // 832
   -1.153421085727069e-03, // 833
   -1.463852230649261e-04, // 834
   -1.338937958941926e-05, // 835
    4.824349683381444e-01, // 836
   -4.922445668080346e-03, // 837
    2.294058804433233e-04, // 838
    2.282557968360359e-01, // 839
   -1.142703922503132e-05, // 840
   -5.035247097003243e-02, // 841
    1.071011280716560e-04, // 842
    1.783553517462357e-01, // 843
   -2.486148982167304e-03, // 844
   -3.974584232705978e-03, // 845
   -1.493810267938009e+00, // 846
    5.964207582764087e-02, // 847
    5.119880767413877e-01, // 848
   -3.658152750950285e-02, // 849
   -3.309319349107932e-03, // 850
    1.984016631437269e-05, // 851
    1.432431279638253e-03, // 852
   -3.573621003027439e-02, // 853
   -1.928884841968607e-03, // 854
   -4.797018429732296e-03, // 855
    1.223679419905484e-05, // 856
   -5.308453124392728e-04, // 857
    2.916107124790073e-03, // 858
    5.473598402757679e-04, // 859
   -4.223476008383326e-04, // 860
    1.376304430690881e-03, // 861
   -6.035464534160673e-07, // 862
    3.053325179678595e-04, // 863
   -6.111772804531452e-04, // 864
   -1.637860639171207e-03, // 865
    2.197688038406822e-03, // 866
   -1.483089245671545e-05, // 867
    7.778926759466457e-03, // 868
   -2.953606836084056e-02, // 869
    4.929261590820076e-02, // 870
    3.229557006805933e-02, // 871
   -1.889667752076195e-04, // 872
    1.582897659979626e-04, // 873
   -2.366930557058629e-03, // 874
   -1.311106128435399e-03, // 875
   -1.904797130312279e-04, // 876
   -8.924152672241793e-02, // 877
   -3.613281765327975e-04, // 878
    5.659133000774489e-05, // 879
   -3.469341825968845e-04, // 880
   -1.107281307287049e-04, // 881
   -3.078429816024422e-04, // 882
   -6.350399876892727e-04, // 883
    3.231200277566420e-04, // 884
   -9.344297893379881e-06, // 885
   -4.286335380432246e-04, // 886
   -4.450161103232519e-03, // 887
   -2.958459378287085e-06, // 888
   -2.803392265642136e-05, // 889
   -4.662544830540094e-04, // 890
    9.763565073591959e-04, // 891
    3.095489056210674e-03, // 892
   -3.390143764355931e-04, // 893
   -4.019719736846160e-02, // 894
    7.496891363793445e-06, // 895
    8.501733795240708e-04, // 896
   -8.644416593811062e-05, // 897
    4.934158785638010e-06, // 898
    2.907207966291812e-04, // 899
    5.447406193003994e-04, // 900
    5.946802919379039e-03, // 901
   -2.624170501447047e-04, // 902
   -2.630297315364625e-03, // 903
   -3.845664454442703e-04, // 904
    3.427494122750611e-04, // 905
   -3.309178970922015e-02, // 906
    1.828491343746277e-03, // 907
   -3.555273348682889e-06, // 908
   -3.893090128143842e-05, // 909
    1.046226464149776e-05, // 910
   -4.593591058943116e-03, // 911
   -8.235980187770853e-03, // 912
   -3.464035656102783e-03, // 913
   -1.128579295152355e-04, // 914
   -5.295205127220973e-04, // 915
    3.512903476963319e-03, // 916
   -4.035547100846168e-02, // 917
    5.505781663556414e-06, // 918
   -5.614779708015520e-04, // 919
    2.542537866846631e-04, // 920
    7.358653054833527e-06, // 921
    5.274437233730590e-04, // 922
    2.381140008957385e-05, // 923
    1.591389193527560e-06, // 924
   -1.670972187277457e-07, // 925
    2.473337731040602e-04, // 926
    1.400026565695706e-05, // 927
   -6.675078405031188e-05, // 928
    2.012421809018613e-04, // 929
    6.115719722227613e-07, // 930
    2.222059155116034e-05, // 931
   -2.098555407318130e-07, // 932
   -1.202061652428052e-08, // 933
    3.366804656267317e-05, // 934
   -2.738073303264622e-02, // 935
    6.129209272743532e-07, // 936
   -3.108328662236818e-09, // 937
   -1.164570615612987e-03, // 938
   -2.229249923833289e-01, // 939
   -8.233096515955954e-06, // 940
    7.456800557505224e-08, // 941
   -2.437440145023636e-06, // 942
    1.512270676431019e-05, // 943
   -3.194579143377138e-05, // 944
    4.288710934575108e-06, // 945
    9.250154512562955e-05, // 946
    1.735941657238957e-04, // 947
   -5.793716098065919e-04, // 948
    2.543930306137040e-07, // 949
   -6.119495565482513e-04, // 950
    2.043177070888583e-07, // 951
   -6.410177355140990e-05, // 952
   -6.515778560674559e-05, // 953
   -1.418162363846070e-08, // 954
   -3.280497577391259e-05, // 955
    5.176035191411399e-09, // 956
    1.145152149238095e-03, // 957
    1.126860187188416e-04, // 958
    8.575878934452096e-08, // 959
    1.188878510453472e-06, // 960
   -6.197094646732639e-06, // 961
   -9.105375646415805e-06, // 962
   -1.014848352305246e-04, // 963
    5.148662875344653e-04, // 964
   -1.660663900022338e-05, // 965
   -1.312683739510248e-06, // 966
   -2.440141994395279e-07, // 967
   -4.018398468201471e-02, // 968
   -1.362580350028620e-06, // 969
    9.163340936955661e-06, // 970
   -2.934757890129319e-09, // 971
   -1.574254525446946e-05, // 972
   -4.151850549915734e-05, // 973
   -3.494575778808628e-09, // 974
   -2.588685978492406e-05, // 975
    8.174388415962752e-05, // 976
   -2.573579798041476e-08, // 977
    2.746776198277158e-08, // 978
    7.393084003973617e-07, // 979
   -8.758639409465520e-02, // 980
   -1.139946079009790e-03, // 981
    7.599991433047414e-02, // 982
    2.676911583260183e-06, // 983
   -3.332891178952576e-05, // 984
   -1.069567210389497e-01, // 985
   -9.719306562462166e-07, // 986
   -6.530214132776039e-07, // 987
   -1.589752919043689e-03, // 988
    2.931875776190900e-02, // 989
   -7.459281767165592e-05, // 990
    5.228226450876235e-05, // 991
   -3.053760370808696e-09, // 992
   -1.566681826126891e-08, // 993
   -1.966702660045528e-03, // 994
    9.085879516160423e-07, // 995
   -8.712158348442924e-07, // 996
   -1.234648852651573e-02, // 997
    1.407626135360869e-08, // 998
   -4.029506005053149e-09, // 999
    2.097951744944564e-06, // 1000
    2.553193016462203e-09, // 1001
    2.857523454119806e-05, // 1002
   -2.661889362139976e-02, // 1003
    9.502245117517190e-05, // 1004
   -1.293011887798771e-03, // 1005
   -2.661084868839727e-05, // 1006
   -1.241296135051342e-06, // 1007
    5.615012985379542e-04, // 1008
    6.728850713841488e-08, // 1009
    4.269415749244651e-06, // 1010
   -6.783800502631562e-06, // 1011
   -9.472452638965129e-08, // 1012
    1.689236549259907e-07, // 1013
   -1.133204424154994e-04, // 1014
   -7.597214744218620e-04, // 1015
    9.736271604047163e-07, // 1016
    4.662531519478126e-06, // 1017
    3.571192816338317e-07, // 1018
   -3.083539106997655e-07, // 1019
    6.014247177129048e-07, // 1020
    1.101114494305751e-06, // 1021
    5.217051783268383e-07, // 1022
   -1.747651179941938e-02, // 1023
   -4.100676313470965e-08, // 1024
    6.819174350168667e-03, // 1025
    8.622908428454252e-06, // 1026
   -1.195841915777780e-07, // 1027
    4.582367789448306e-02, // 1028
   -1.983025693394732e-07, // 1029
    3.055512436671544e-02, // 1030
    8.085830674390175e-07, // 1031
    7.920866013394580e-06, // 1032
   -1.766560758219116e-04, // 1033
   -4.058450761604154e-09, // 1034
   -6.297964187143345e-06, // 1035
   -3.698832579334650e-05, // 1036
   -1.780315920887679e-06, // 1037
   -6.932523829832179e-05, // 1038
   -1.879214769519423e-08, // 1039
   -7.554868540480206e-09, // 1040
    5.266210004095125e-07, // 1041
    2.577920872772280e-07, // 1042
   -1.894608591462028e-03, // 1043
   -4.738442707978868e-07, // 1044
   -3.519706624808000e-08, // 1045
    1.341875055523865e-04, // 1046
    9.559934088736353e-05, // 1047
   -1.488035471166601e-06, // 1048
   -6.237176057907804e-03, // 1049
   -9.132271938954265e-04, // 1050
    5.579357669298823e-08, // 1051
    3.888024470970328e-05, // 1052
    7.959259740168264e-08, // 1053
    9.730070234441089e-08, // 1054
    3.968307394546800e-03, // 1055
    7.703555711230869e-06, // 1056
    3.692396375039883e-02, // 1057
   -1.860996248064732e-05, // 1058
   -3.846112016692944e-04, // 1059
    1.507014829697873e-07, // 1060
   -5.398834228034094e-03, // 1061
    1.079251247445338e-05, // 1062
   -2.779323013692631e-03, // 1063
    4.668525164027205e-07, // 1064
   -1.407419108673766e-05, // 1065
    2.494370397733509e-06, // 1066
   -1.809960041666531e-06, // 1067
   -2.084026455067145e-08, // 1068
    2.595427467812581e-05, // 1069
    1.883974705094639e-04, // 1070
    6.403827447405639e-09, // 1071
    2.029043627215638e-05, // 1072
   -1.963535708973851e-05, // 1073
    1.340997210967273e-06, // 1074
   -1.402761995101284e-08, // 1075
    1.144856057382913e-04, // 1076
    5.150613733379921e-07, // 1077
    7.681655375202082e-05, // 1078
    4.754897536987580e-06, // 1079
   -3.361720253281882e-06, // 1080
   -3.701322389809211e-05, // 1081
    4.485151765664123e-02, // 1082
    6.473826240237163e-07, // 1083
   -1.675737246745848e-07, // 1084
   -3.076221977302607e-03, // 1085
   -2.953901639509105e-04, // 1086
   -2.819143751233054e-02, // 1087
   -3.932511305346343e-06, // 1088
    8.085813638855201e-07, // 1089
    5.633684904193928e-05, // 1090
    2.184374945356600e-06, // 1091
   -9.721477818294135e-05, // 1092
    2.177480706627401e-05, // 1093
   -2.161997741652864e-06, // 1094
   -6.603078370857724e-06, // 1095
    1.103523170517189e-05, // 1096
   -1.177647970599511e-06, // 1097
   -7.458188568608877e-08, // 1098
   -5.038451033001147e-09, // 1099
   -8.194356397878829e-09, // 1100
    2.749819560546172e-05, // 1101
    3.343218292303784e-05, // 1102
    2.928443653355504e-06, // 1103
    4.062007398115532e-05, // 1104
    2.271289266134325e-07, // 1105
    9.743896670139851e-05, // 1106
   -6.335639012360397e-02, // 1107
    5.902423190927800e-05, // 1108
    3.955947819627391e-07, // 1109
    3.417690649565489e-10, // 1110
   -8.896810186385119e-06, // 1111
    2.159229977688597e-03, // 1112
    1.038858269666802e-04, // 1113
    3.317042178105725e-06, // 1114
    5.814503815693614e-06, // 1115
   -6.821413987089652e-09, // 1116
    1.908338368659845e-07, // 1117
    8.154000810516221e-05, // 1118
   -7.049651051453784e-08, // 1119
   -2.640192747603034e-02, // 1120
    4.979479540344973e-05, // 1121
   -2.030130214000783e-09, // 1122
    5.907832292059456e-06, // 1123
   -3.487449774621545e-05, // 1124
    1.994048652027782e-06, // 1125
   -4.616803117693043e-09, // 1126
   -1.317089812784404e-05, // 1127
   -6.100245020389540e-08, // 1128
    9.630025267237178e-04, // 1129
   -1.666479479738701e-04, // 1130
   -5.283883041150690e-05, // 1131
   -7.779158774568811e-07, // 1132
   -4.096867364138898e-06, // 1133
    3.892185967998724e-03, // 1134
   -8.172105145127963e-08, // 1135
   -9.503774960953960e-09, // 1136
   -5.022919264328310e-07, // 1137
    1.825829118491923e-04, // 1138
   -3.021684420223645e-06, // 1139
   -1.313724302479983e-07, // 1140
    1.447682069221086e-02, // 1141
   -6.927125592025546e-06, // 1142
   -6.653097471632919e-06, // 1143
   -1.020566248767762e-03, // 1144
    6.358124656674913e-08, // 1145
   -2.330270373430741e-05, // 1146
   -6.404929163908353e-08, // 1147
    5.097398748355821e-05, // 1148
   -1.763313425441631e-06, // 1149
   -6.711597420065555e-05, // 1150
    2.601551607819577e-03, // 1151
    2.381740345216822e-05, // 1152
    1.614255710593677e-07, // 1153
    6.909132958309242e-05, // 1154
   -8.247393307709201e-08, // 1155
    1.513733484657465e-04, // 1156
   -1.696806063693342e-01, // 1157
   -1.278014906358691e-07, // 1158
   -1.353157837847037e-05, // 1159
    9.734961880142622e-03, // 1160
    5.849638745112066e-05, // 1161
   -8.411225177901267e-07, // 1162
    8.135482430181273e-04, // 1163
   -5.640920031733721e-05, // 1164
    1.645608217972802e-04, // 1165
   -2.149386031496251e-08, // 1166
   -3.432517194213489e-06, // 1167
    1.567176538578141e-05, // 1168
    4.296497955279189e-06, // 1169
    1.258195809054150e-06, // 1170
   -1.625878583371367e-06, // 1171
    6.386410359308861e-05, // 1172
    5.344536917922364e-05, // 1173
    1.552155690252655e-05, // 1174
    6.501791090396260e-05, // 1175
    3.797466161589105e-04, // 1176
   -1.196382770037226e-07, // 1177
   -6.495029699884390e-05, // 1178
    2.243190560203903e-05, // 1179
    1.377837643426056e-06, // 1180
   -5.529864521275590e-06, // 1181
    2.774202301880291e-07, // 1182
   -1.058505300861635e-08, // 1183
   -1.137024227340842e-09, // 1184
   -5.049959193288535e-06, // 1185
   -6.600555507011521e-08, // 1186
    4.167642781852499e-07, // 1187
    1.160135779874393e-06, // 1188
    7.775084244996844e-09, // 1189
    1.115833703960813e-06, // 1190
    2.179993339265731e-07, // 1191
    8.157136194436784e-08, // 1192
    1.217396469226835e-03, // 1193
   -2.271432788471970e-06, // 1194
   -2.786444616319870e-04, // 1195
    4.691383997656959e-04, // 1196
   -2.817315067695666e-05, // 1197
   -8.247453362605828e-08, // 1198
   -8.010426402052731e-07, // 1199
    6.434870875368327e-05, // 1200
   -5.641270292894246e-11, // 1201
    6.405661021714947e-08, // 1202
   -3.641382894679156e-06, // 1203
    7.123020366812732e-06, // 1204
   -2.994720619169166e-07, // 1205
   -1.093788665070615e-03, // 1206
   -5.024259008301062e-07, // 1207
   -1.894820127931582e-06, // 1208
    8.297288015669238e-02, // 1209
   -3.364994586967423e-10, // 1210
    6.928120843469183e-07, // 1211
    5.422965070556900e-02, // 1212
   -3.262112265704690e-07, // 1213
   -1.587115491006607e-07, // 1214
    1.078060713268575e-06, // 1215
    3.175315483366561e-04, // 1216
   -4.413943113122425e-06, // 1217
    2.918909593044543e-03, // 1218
   -1.452186239930930e-04, // 1219
    7.650650409981075e-06, // 1220
   -1.215242010874831e-04, // 1221
   -1.385549445808536e-06, // 1222
    5.184048391330135e-07, // 1223
   -9.852745061455668e-07, // 1224
   -2.921207183894661e-04, // 1225
    8.114744321456812e-05, // 1226
    4.782216377345139e-04, // 1227
    1.882954714036003e-04, // 1228
    9.123753115491462e-10, // 1229
    1.460649597413506e-07, // 1230
    6.965032900115358e-05, // 1231
    4.062951995399724e-07, // 1232
    1.931829922582998e-07, // 1233
    7.747614207265191e-06, // 1234
    4.997228593960785e-04, // 1235
   -3.671647069858358e-06, // 1236
   -3.007667345555329e-03, // 1237
    6.172152438930724e-07, // 1238
   -2.970539098809084e-05, // 1239
    5.433797154602398e-06, // 1240
    1.566867616932778e-05, // 1241
    2.104537762693970e-07, // 1242
   -3.741510089963718e-04, // 1243
    2.181985834994815e-03, // 1244
    1.462694776982857e-06, // 1245
    7.771783221316398e-06, // 1246
    8.944130365686970e-07, // 1247
    1.850999109665009e-04, // 1248
   -5.242620800668445e-03, // 1249
    3.980651967636679e-10, // 1250
    4.897372152548275e-04, // 1251
    8.870928490512685e-06, // 1252
   -2.483043919305898e-04, // 1253
    6.919152264376902e-06, // 1254
    1.001300169785136e-05, // 1255
    4.331260517877268e-04, // 1256
   -1.339074085959981e-04, // 1257
   -2.456182134488531e-07, // 1258
   -1.156723946032573e-08, // 1259
   -2.460951336878331e-07, // 1260
   -4.236405719870979e-07, // 1261
   -1.593439600489235e-09, // 1262
   -3.809659390503653e-04, // 1263
   -1.904671102173969e-05, // 1264
   -1.838347982351769e-05, // 1265
    2.169673044166577e-03, // 1266
    1.833404166205878e-02, // 1267
    8.765919672391600e-04, // 1268
   -1.519179976749853e-01, // 1269
    3.580234016475086e-04, // 1270
   -1.245340953953265e-05, // 1271
   -3.032286576743201e-02, // 1272
   -1.316639988327525e-08, // 1273
    2.226900354554155e-07, // 1274
   -3.232062248169335e-05, // 1275
   -1.234669364367074e-03, // 1276
    3.370855085410248e-03, // 1277
    2.036998925295781e-06, // 1278
   -5.652787441369369e-07, // 1279
    1.389087788620310e-01, // 1280
    9.442283196639804e-08, // 1281
   -4.949923684569565e-07, // 1282
    5.611209116585173e-06, // 1283
   -2.124849158603509e-03, // 1284
   -1.087786987314990e-04, // 1285
    1.338464746367810e-05, // 1286
   -1.678282831873043e-06, // 1287
   -4.927907259809790e-03, // 1288
   -2.930969881178539e-03, // 1289
   -2.885885525108464e-06, // 1290
   -6.734820232850598e-05, // 1291
   -2.260671592556894e-04, // 1292
    3.302269154500847e-06, // 1293
   -4.382775844072150e-07, // 1294
    2.950192482254142e-05, // 1295
   -8.870197777463313e-06, // 1296
    1.877643129699604e-07, // 1297
   -3.169284276110876e-04, // 1298
   -1.100791114478087e-05, // 1299
   -5.139259375543223e-07, // 1300
    8.833139011095534e-06, // 1301
   -1.306998063855334e-05, // 1302
    3.038004331067425e-05, // 1303
   -4.624679534545237e-06, // 1304
    8.446616528831007e-05, // 1305
    1.697498128753539e-06, // 1306
    6.501994590957647e-07, // 1307
    7.467808097875512e-06, // 1308
    8.495925401443646e-07, // 1309
   -1.657022117539550e-07, // 1310
   -1.516670912180620e-05, // 1311
   -6.680836235809378e-09, // 1312
   -3.098806363976578e-05, // 1313
    8.217255705537308e-04, // 1314
    3.696219890955502e-07, // 1315
   -5.302238569756745e-06, // 1316
   -4.112857293236173e-05, // 1317
   -2.382057959208614e-08, // 1318
    2.051752697917090e-09, // 1319
    2.784323074523429e-04, // 1320
   -1.562745235941668e-01, // 1321
   -1.961668948112212e-05, // 1322
    2.371133606130616e-06, // 1323
    6.742432786791754e-06, // 1324
    8.713546647327488e-07, // 1325
    1.046860720156879e-07, // 1326
   -1.994242895390270e-06, // 1327
   -6.623299607572961e-05, // 1328
    5.979586316810334e-05, // 1329
   -6.117106521456468e-05, // 1330
   -3.645905829168144e-04, // 1331
    2.276338046800770e-05, // 1332
   -1.177039506872564e-06, // 1333
   -7.273324935589651e-02, // 1334
   -1.138171214322842e-06, // 1335
    8.570452738384575e-03, // 1336
    7.768269348668331e-05, // 1337
    2.651728833685655e-06, // 1338
    3.193182441875968e-08, // 1339
   -2.578781726415342e-04, // 1340
    7.822718977673715e-04, // 1341
    1.114551777005126e-06, // 1342
    9.549882265473396e-07, // 1343
    1.045161309651499e-05, // 1344
   -1.413115496648849e-06, // 1345
   -3.262318565361144e-06, // 1346
   -8.835925446439172e-04, // 1347
    2.082980595691390e-09, // 1348
   -2.823185047455480e-02, // 1349
    4.082159717648539e-06, // 1350
    5.309788577693026e-03, // 1351
   -2.374341382383380e-06, // 1352
   -2.770748150369672e-07, // 1353
    7.081141784874235e-04, // 1354
    5.120926843602972e-04, // 1355
   -8.815804542762455e-06, // 1356
    1.752596627371904e-06, // 1357
   -5.648048902743647e-09, // 1358
    5.684615540355572e-06, // 1359
   -3.322497065488516e-03, // 1360
   -8.672461629457762e-04, // 1361
   -3.820944825994633e-03, // 1362
    7.032392492883294e-05, // 1363
   -4.609208168814203e-01, // 1364
   -1.195079261997130e-06, // 1365
    8.021723185937596e-06, // 1366
    3.180411762101723e-05, // 1367
    6.202118301580506e-07, // 1368
    1.110213516220946e-06, // 1369
    1.457838514169460e-07, // 1370
    3.561308141634082e-06, // 1371
   -1.145166409386437e-04, // 1372
    2.416111413812879e-07, // 1373
   -5.038511946142657e-07, // 1374
    7.792866268628196e-05, // 1375
    2.204342691698788e-04, // 1376
   -5.427885176153342e-04, // 1377
   -4.160288354902360e-05, // 1378
   -3.968776447797291e-07, // 1379
    1.385795547643476e-04, // 1380
   -1.961989226784952e-03, // 1381
   -7.645923462985509e-06, // 1382
    3.395532983552510e-05, // 1383
    2.887293133089003e-06, // 1384
   -7.069170006463199e-05, // 1385
   -1.873830346951004e-06, // 1386
    2.411865006716484e-05, // 1387
   -9.460859421601115e-05, // 1388
   -4.173623261545834e-05, // 1389
   -1.286581109525061e-02, // 1390
    1.552833792726133e-08, // 1391
    1.820008124057574e-01, // 1392
   -2.205334204101761e-06, // 1393
    3.379197904062537e-06, // 1394
   -9.915477150579196e-05, // 1395
    1.278577735206402e-05, // 1396
    3.791921422506824e-03, // 1397
    5.001571920216849e-02, // 1398
    1.554099592608743e-06, // 1399
    1.159107096944593e-03, // 1400
   -2.426055511050047e-08, // 1401
   -3.723564548333477e-06, // 1402
   -4.527136163905959e-08, // 1403
    6.433593285664371e-04, // 1404
    1.875449961262596e-06, // 1405
    4.826354889575052e-04, // 1406
    3.279079708316649e-04, // 1407
    1.624506213977693e-07, // 1408
    2.131743718954134e-05, // 1409
    5.330794049774993e-09, // 1410
   -4.493579972429649e-05, // 1411
    4.792706642879973e-02, // 1412
   -4.014063704509821e-03, // 1413
   -1.305231283405851e-04, // 1414
    2.283341679303360e-04, // 1415
    1.080890209033579e-04, // 1416
   -6.160227770450289e-05, // 1417
    4.497261200522636e-02, // 1418
    2.527139585512134e-04, // 1419
   -3.184320391024962e-05, // 1420
    9.822000208324940e-06, // 1421
    1.698717217602127e-06, // 1422
   -1.174252067534641e-04, // 1423
    1.672186596549615e-06, // 1424
    2.106030675228079e-04, // 1425
    2.993597418181611e-07, // 1426
    7.650554754137613e-09, // 1427
    2.120543461474058e-07, // 1428
    4.211272214246246e-08, // 1429
    2.566790985089961e-07, // 1430
    1.597227636247761e-06, // 1431
   -3.098160793836354e-05, // 1432
    3.727863595073149e-03, // 1433
   -2.526422990420879e-05, // 1434
    1.116343968003066e-03, // 1435
    5.593612200335174e-08, // 1436
   -2.911051167842339e-08, // 1437
   -1.127278071324847e-07, // 1438
    9.101913908240694e-07, // 1439
    8.910128944142376e-05, // 1440
   -4.589813295557039e-02, // 1441
    7.890063280244086e-07, // 1442
   -4.347484010546926e-03, // 1443
   -1.816675216189803e-06, // 1444
   -9.150201934541349e-07, // 1445
   -8.121660586072766e-04, // 1446
   -7.966527952377957e-07, // 1447
    1.236256001177829e-05, // 1448
    2.831836140565278e-02, // 1449
    2.542795020998090e-08, // 1450
    1.631911673372432e-06, // 1451
   -6.045695644070684e-06, // 1452
   -2.535529763618001e-07, // 1453
   -5.104693673716619e-06, // 1454
    3.380251839822921e-10, // 1455
   -2.070144483655781e-06, // 1456
    1.892211267588388e-06, // 1457
   -3.989565019997250e-04, // 1458
    4.073172884577307e-09, // 1459
    1.558283481258131e-06, // 1460
    1.109964297026633e-07, // 1461
   -2.013341203857800e-07, // 1462
    2.278246634005530e-08, // 1463
    1.604691729080607e-03, // 1464
    8.808975946648458e-05, // 1465
   -5.421391432284287e-07, // 1466
   -6.714500145789249e-07, // 1467
   -1.397504633898588e-08, // 1468
    2.736710895267996e-06, // 1469
    1.890270861719331e-03, // 1470
    5.538406365155663e-05, // 1471
   -3.763921444428237e-06, // 1472
   -3.614301345065365e-06, // 1473
   -3.731876396590713e-07, // 1474
   -1.951057214171971e-07, // 1475
   -1.297608128242623e-06, // 1476
   -3.316944777293216e-07, // 1477
    3.107766850276483e-06, // 1478
    1.046687250011847e-06, // 1479
    3.577732398173959e-03, // 1480
    1.942401135874425e-04, // 1481
    9.751797537987716e-04, // 1482
    2.018561521469822e-07, // 1483
   -1.330710125802748e-04, // 1484
    1.876915883214591e-03, // 1485
   -7.062070979853636e-05, // 1486
   -5.916171606070909e-05, // 1487
   -4.063506664593678e-07, // 1488
   -3.635271367299263e-06, // 1489
    2.151088451705936e-05, // 1490
    8.552235908203542e-09, // 1491
    3.454728375156928e-06, // 1492
   -4.127692429883805e-06, // 1493
   -1.274122661514536e-06, // 1494
   -6.416115526353244e-04, // 1495
   -3.466622853301759e-06, // 1496
   -8.764728887182817e-09, // 1497
    8.807426124244013e-06, // 1498
   -9.702687466924079e-07, // 1499
    5.246022637548574e-08, // 1500
   -4.229867657060693e-05, // 1501
   -3.448093140056261e-04, // 1502
   -2.701934445036698e-04, // 1503
    9.626535406554006e-06, // 1504
    2.080857352674190e-07, // 1505
   -5.404572254305795e-08, // 1506
    5.807574972910400e-04, // 1507
    5.341051995203563e-10, // 1508
    1.678016453184151e-06, // 1509
    7.643543243602295e-09, // 1510
    8.296551179818904e-03, // 1511
   -6.672852213059151e-04, // 1512
   -1.176145757635530e-06, // 1513
   -1.464458285035083e-06, // 1514
   -3.521070030648085e-10, // 1515
    8.999255648551937e-06, // 1516
    1.244611018019262e-06, // 1517
   -6.647389695835747e-08, // 1518
   -1.435223564426078e-08, // 1519
   -2.465220457366484e-07, // 1520
   -1.319573759478153e-04, // 1521
   -8.763698618851094e-05, // 1522
    5.948133423384632e-08, // 1523
   -1.313803139285621e-05, // 1524
    1.249547629106186e-04, // 1525
    2.880771128189619e-04, // 1526
   -4.935537862152820e-04, // 1527
   -6.197008602257928e-08, // 1528
   -2.030900000748708e-08, // 1529
   -9.237431020223977e-02, // 1530
   -8.952970747030540e-05, // 1531
   -3.181292946953597e-07, // 1532
    1.085695527012844e-07, // 1533
   -2.686285686959280e-02, // 1534
    1.006973404865927e-05, // 1535
   -1.712349718423223e-05, // 1536
    2.477330346622755e-06, // 1537
   -1.899462746769063e-06, // 1538
    3.060020946327606e-08, // 1539
    2.694823373933540e-07, // 1540
    1.459262301575002e-04, // 1541
   -1.533469874180087e-06, // 1542
    2.669695179442668e-01, // 1543
    1.010214793866085e-09, // 1544
    4.877297757597670e-04, // 1545
    2.145569038315099e-05, // 1546
    1.664908564947391e-05, // 1547
    9.688008844124495e-07, // 1548
   -2.453989896127725e-10, // 1549
    1.636053796602562e-05, // 1550
    3.586679377540119e-05, // 1551
   -3.547824741439812e-04, // 1552
   -9.691304236423010e-04, // 1553
   -1.750976787902718e-05, // 1554
    3.059598625081454e-07, // 1555
    3.253041866441760e-07, // 1556
    1.186264488951358e-06, // 1557
   -1.478927203314423e-04, // 1558
   -3.961769416564253e-05, // 1559
   -5.189080877616160e-05, // 1560
    7.270537583560611e-03, // 1561
   -3.242746809721205e-06, // 1562
   -4.354025992435741e-08, // 1563
   -3.742764987034172e-06, // 1564
    2.867291988148543e-08, // 1565
    1.203414325018080e-04, // 1566
    7.680349319098092e-08, // 1567
   -8.920453838753560e-07, // 1568
    6.569851543832030e-03, // 1569
    3.268124202658250e-06, // 1570
    5.364698919485200e-08, // 1571
   -9.528516317440588e-07, // 1572
    1.135619581947606e-08, // 1573
    4.073587788409653e-09, // 1574
    2.596870477131760e-08, // 1575
    1.068717513794919e-04, // 1576
   -4.796448057076365e-07, // 1577
   -6.556500362729678e-04, // 1578
   -3.181304148800884e-07, // 1579
   -2.977587695765697e-05, // 1580
    8.324359432981530e-08, // 1581
    1.204088085346399e-04, // 1582
    3.969109026385673e-04, // 1583
    1.085657836080014e-04, // 1584
    1.272912933899567e-06, // 1585
    3.834085716646763e-03, // 1586
    5.760056938097539e-07, // 1587
    7.563538328311465e-08, // 1588
    2.773359595371738e-02, // 1589
   -2.435867327334755e-06, // 1590
   -3.702340438334153e-06, // 1591
   -2.363825838265525e-05, // 1592
    3.053826599257341e-08, // 1593
   -1.837374920403247e-05, // 1594
    6.404511296886260e-09, // 1595
    4.550562984734536e-08, // 1596
   -5.600455483572817e-07, // 1597
   -9.117260069937161e-06, // 1598
   -1.484527247391004e-05, // 1599
    2.288099502599249e-06, // 1600
    9.796105708935015e-08, // 1601
    1.696207094795586e-07, // 1602
   -1.197617974533255e-03, // 1603
    4.195983556577708e-06, // 1604
   -7.742287011884905e-04, // 1605
    4.174831562868233e-05, // 1606
    3.247148944640470e-09, // 1607
   -2.414297889648872e-07, // 1608
   -4.162315894437629e-05, // 1609
   -7.473270561825071e-06, // 1610
    3.856808219442165e-04, // 1611
    1.254790863034394e-04, // 1612
    2.102484673531370e-05, // 1613
   -6.256542575916793e-05, // 1614
   -6.843540255183870e-07, // 1615
   -3.790853026572007e-06, // 1616
   -4.947810511430145e-04, // 1617
   -4.361961479434225e-07, // 1618
   -1.225965730455986e-06, // 1619
   -5.786699124700691e-06, // 1620
   -3.000486369507167e-07, // 1621
   -2.690658591446831e-06, // 1622
    3.761970338785752e-07, // 1623
    5.343117351401683e-04, // 1624
   -2.069475671172327e-05, // 1625
    6.546610835656842e-06, // 1626
    6.366799661307784e-08, // 1627
   -1.557267686506512e-06, // 1628
    3.028059162199333e-05, // 1629
    3.555873160982620e-06, // 1630
   -1.460230813900928e-08, // 1631
    2.334907570165287e-07, // 1632
    9.852219371562433e-06, // 1633
    1.913024032291691e-03, // 1634
   -1.406984835527648e-07, // 1635
   -1.018340898140415e-06, // 1636
   -1.207845314066850e-05, // 1637
    1.407010749193130e-06, // 1638
   -2.589543384544949e-05, // 1639
   -2.386718290429583e-04, // 1640
    1.300215541946481e-03, // 1641
   -5.922538660950203e-10, // 1642
   -2.853773630849987e-07, // 1643
    6.714450224812725e-04, // 1644
   -3.372199503967303e-06, // 1645
   -2.042871904707839e-04, // 1646
    8.164990053655840e-07, // 1647
   -2.514435981397920e-02, // 1648
    2.963504612451672e-06, // 1649
   -5.562080069534774e-04, // 1650
    3.397823302172904e-03, // 1651
   -8.375195467396093e-06, // 1652
    5.395388609200035e-04, // 1653
   -1.441414085590445e-06, // 1654
   -5.029964796081629e-09, // 1655
    1.641753153471797e-03, // 1656
   -1.420582363356430e-04, // 1657
   -9.803179671254834e-06, // 1658
    6.850184017003606e-08, // 1659
   -1.784280016778209e-08, // 1660
    1.239576661498683e-03, // 1661
    3.375519169456467e-06, // 1662
    3.061229017062343e-06, // 1663
    3.319308794344470e-08, // 1664
   -8.537327845204847e-07, // 1665
    3.582429584108119e-07, // 1666
   -3.696111237431162e-07, // 1667
   -3.788602953312099e-07, // 1668
   -6.042955095178354e-05, // 1669
   -9.966387412785605e-07, // 1670
    5.198990912225224e-03, // 1671
   -1.932647580769034e-03, // 1672
   -7.347769698612068e-05, // 1673
   -3.045716662553576e-06, // 1674
    1.874231453714885e-06, // 1675
    5.831905794413785e-04, // 1676
    1.152815462376092e-04, // 1677
    2.457268152571569e-06, // 1678
   -1.166087548983010e-06, // 1679
   -1.078434476903947e-04, // 1680
    6.986533787222824e-08, // 1681
   -9.026592000452198e-06, // 1682
    1.563782292029578e-04, // 1683
    8.225537776188462e-07, // 1684
   -2.351580668697325e-03, // 1685
    8.040451746730896e-07, // 1686
   -4.628416162259408e-03, // 1687
    9.098989377789296e-07, // 1688
   -3.325761726460618e-09, // 1689
    3.805774584108571e-09, // 1690
    7.758124391338699e-04, // 1691
   -3.593605839816820e-08, // 1692
    5.261866836570727e-07, // 1693
   -1.530569466591763e-05, // 1694
    1.394140673015142e-06, // 1695
   -1.305244374944318e-05, // 1696
   -4.844904670318938e-06, // 1697
    5.131546857017192e-03, // 1698
   -2.973045480413030e-05, // 1699
   -1.281915719698283e-07, // 1700
   -8.712075361866325e-03, // 1701
   -2.502830767276972e-06, // 1702
    1.215208368769213e-06, // 1703
    3.231749524714995e-06, // 1704
   -3.327744841703557e-07, // 1705
    2.724847546218876e-05, // 1706
   -1.184598328712181e-08, // 1707
   -1.312422232195600e-06, // 1708
   -2.188654276029109e-09, // 1709
    3.932760166245546e-08, // 1710
   -7.772943708354754e-05, // 1711
    2.889328090375244e-06, // 1712
    3.000724167611391e-07, // 1713
   -5.198066813858977e-07, // 1714
    7.786973210911154e-02, // 1715
   -7.106259618940949e-08, // 1716
   -1.269290737137963e-05, // 1717
   -7.719483386072191e-07, // 1718
    3.786083737195265e-03, // 1719
   -8.096979807425912e-05, // 1720
   -2.041647891153797e-05, // 1721
    1.377634401935852e-08, // 1722
   -1.158825117625762e-03, // 1723
    2.895780493047103e-04, // 1724
    1.065991612531392e-06, // 1725
   -2.585691526876099e-09, // 1726
    7.086465556876362e-06, // 1727
   -1.870588857690427e-06, // 1728
   -9.682262917208302e-11, // 1729
    1.328414338374072e-06, // 1730
    3.496320264611928e-05, // 1731
    2.217890505646148e-03, // 1732
    9.553866358087714e-09, // 1733
    4.019034455319875e-04, // 1734
   -2.725338262909482e-07, // 1735
   -1.089244408453663e-05, // 1736
    1.169599432552823e-08, // 1737
   -7.684198967725697e-09, // 1738
   -2.377624168892930e-06, // 1739
   -2.810991298985157e-07, // 1740
   -2.196767393107959e-03, // 1741
   -1.017688983025095e-08, // 1742
    1.489104708855555e-04, // 1743
    1.263896063802141e-05, // 1744
    2.665040163081249e-09, // 1745
    7.647464336751798e-09, // 1746
   -1.968287249325993e-05, // 1747
   -6.994635402661342e-07, // 1748
   -1.274754709542114e-07, // 1749
   -1.192593092932654e-07, // 1750
    2.724121019494382e-05, // 1751
    4.193581051566598e-05, // 1752
    1.176560234180977e-07, // 1753
   -4.754352133331555e-04, // 1754
   -2.945284302036071e-08, // 1755
    3.302485170224582e-07, // 1756
    3.725591921666088e-03, // 1757
   -1.153157098047397e-06, // 1758
   -5.614841398084160e-09, // 1759
    1.307314506512284e-02, // 1760
    4.454638180786599e-03, // 1761
    3.867745721623372e-07, // 1762
    1.068848618099930e-04, // 1763
   -9.390461484658289e-07, // 1764
   -3.794059161337472e-07, // 1765
    1.215345496453722e-04, // 1766
   -3.234698017755911e-07, // 1767
   -1.369924448254638e-06, // 1768
   -1.270364807962222e-05, // 1769
    6.107760241869946e-08, // 1770
    3.014632009455680e-03, // 1771
    1.818266241623230e-07, // 1772
   -3.091604247764227e-05, // 1773
   -2.085905535913707e-05, // 1774
    2.021830277118204e-06, // 1775
   -3.088713652622418e-05, // 1776
    5.892434981782125e-07, // 1777
   -2.206676567367915e-05, // 1778
    1.389990899475978e-05, // 1779
    8.217587297542588e-05, // 1780
   -6.085259994458146e-06, // 1781
    1.519201537247616e-05, // 1782
    9.350627829143918e-06, // 1783
   -7.461691782951851e-06, // 1784
    2.537107820058438e-10, // 1785
    1.301057356760477e-06, // 1786
   -3.111647222726680e-04, // 1787
    1.562785644365840e-04, // 1788
    9.310211971450923e-07, // 1789
   -8.952555607282130e-04, // 1790
    1.859567995459654e-05, // 1791
    3.512203017827726e-09, // 1792
    1.058645251796841e-03, // 1793
    8.898116362826126e-09, // 1794
   -5.788491733830464e-08, // 1795
    1.251199442199936e-05, // 1796
    1.536252316825821e-05, // 1797
   -8.391123210964950e-05, // 1798
    7.229501761979374e-09, // 1799
   -2.108807107602940e-04, // 1800
    4.928161306743342e-07, // 1801
    3.637472293729442e-07, // 1802
   -1.677189197525034e-08, // 1803
    4.041861613626562e-04, // 1804
    8.434801135484150e-08, // 1805
   -6.271274424194654e-08, // 1806
   -8.337258755693152e-05, // 1807
    6.743305404406980e-08, // 1808
   -9.965319092074326e-08, // 1809
    3.067768473796455e-04, // 1810
    4.014443699823260e-06, // 1811
   -2.299521664981220e-05, // 1812
    4.208882304711851e-04, // 1813
   -2.162614476993514e-07, // 1814
   -4.393057886669742e-05, // 1815
    4.102555705493092e-09, // 1816
   -1.822566655880963e-04, // 1817
   -2.346482075140840e-04, // 1818
   -1.548671492451685e-06, // 1819
   -4.614227189001380e-06, // 1820
   -3.823962683195745e-06, // 1821
    5.331612725578472e-07, // 1822
   -1.103604545797218e-07, // 1823
    5.251046301815568e-07, // 1824
   -7.126332713863215e-07, // 1825
    6.203192478975132e-06, // 1826
   -2.630678362446671e-05, // 1827
   -9.281618640487778e-06, // 1828
    3.916278096834045e-05, // 1829
   -7.385982382690236e-04  // 1830
    };

    for (int i = 0; i< 1831; i++)
      threebodyfit[i] = threebodyfit_cp[i];

  } else if (ion == "Cl") {
    //fit-ccsdtf12-avtz-w-nm-highenergyconfgis2_scans       04/25/16 
    R3I =       0.000000000000000e+00; // A
    R3F =       7.000000000000000e+00; // A
   
    KHH_INTRA = 4.115838660781490e+00; // A^(-1)
    KOH_INTRA = 1.348512043588310e-01; // A^(-1)
   
    KHH =       1.064364756656435e-01; // A^(-1)
    KOH =       7.372402717800215e-01; // A^(-1)
    KOO =       9.593030189987210e-02; // A^(-1)
   
    KXO =       1.813006742617342e-01; // A^(-1)
    KXH =       5.530225041814487e-01; // A^(-1)
   
    DHH_INTRA = 5.762129671706188e-01; // A
    DOH_INTRA = 9.279934228572884e-01; // A
   
    DHH =       2.652526312906467e+00; // A
    DOH =       9.930233513486893e+00; // A
    DOO =       3.822041731828924e+00; // A
   
    DXO =       -2.045963524812788e+00; // A
    DXH =        7.311018390661705e+00; // A


    double threebodyfit_cp[] = {
    3.505984759874757e-01, // 0
    1.272027817240172e-01, // 1
    3.081286054201003e-03, // 2
   -2.056884773084618e+00, // 3
    6.911235043583309e-01, // 4
    1.271630433011577e+00, // 5
    9.656810082333613e-01, // 6
   -8.678768369308547e-03, // 7
    1.092945102303956e-02, // 8
   -6.368469642652848e+00, // 9
    1.373611067179471e-01, // 10
   -4.784538288549925e-01, // 11
   -1.391307798656138e+00, // 12
   -1.712988830988370e-03, // 13
    1.507354173506487e+00, // 14
   -1.344346950380170e-01, // 15
    3.425779059833803e+00, // 16
    5.910442274760725e-01, // 17
   -7.311684796400505e-01, // 18
    6.141239786385141e-02, // 19
   -5.540326366562910e-01, // 20
   -6.788886024390980e+00, // 21
   -1.387808305891278e-02, // 22
   -6.635273308607892e-03, // 23
   -3.143616625455178e-01, // 24
    2.404743889583593e-01, // 25
   -2.506641720747098e-01, // 26
    9.508606378740854e-02, // 27
   -4.024617881810253e-01, // 28
   -6.918753049602073e+00, // 29
   -2.045176288868771e-01, // 30
   -1.163553149437266e+00, // 31
    2.166359963345084e+00, // 32
    2.189683085260248e-01, // 33
    8.738511230914344e-01, // 34
   -7.801204871122758e-03, // 35
   -2.436769198433468e-02, // 36
    1.718072182148261e+00, // 37
    5.174433296449242e-01, // 38
   -3.773234263679078e-04, // 39
    1.991118177432569e-01, // 40
    1.090109965863725e+00, // 41
   -1.524320876132972e+00, // 42
   -3.583175694876219e-02, // 43
    3.124008046205966e-02, // 44
   -2.663283108346514e-01, // 45
   -1.353796755960685e-01, // 46
    3.145227223178534e-01, // 47
   -1.977945357261319e-01, // 48
    2.456525229913736e+00, // 49
   -1.023263204103882e+00, // 50
   -1.143366571104024e+00, // 51
    1.662082962157896e+00, // 52
    2.057524220044216e-02, // 53
    2.337282438591330e+00, // 54
    4.325736169420698e-03, // 55
    3.107605684116231e-03, // 56
    6.016009226740346e-04, // 57
    1.175521853603915e+00, // 58
    6.411391123099286e-01, // 59
   -3.470763626721946e-01, // 60
   -1.335018199471908e+00, // 61
   -7.360603374644286e+00, // 62
   -2.090349497818924e-01, // 63
   -1.104870704379999e-01, // 64
   -3.950515005753112e-01, // 65
   -6.510745676520034e-01, // 66
    1.364448664293777e+00, // 67
   -9.035343558531750e-02, // 68
   -3.237510228592240e+00, // 69
    1.948023425313629e-03, // 70
    1.095992077898117e-01, // 71
   -1.281483663237431e+00, // 72
   -7.290440319236533e+00, // 73
   -1.010015403590775e-01, // 74
   -1.580232597534736e-01, // 75
    1.714972443203534e+00, // 76
   -7.746260145312189e-03, // 77
    1.950656440993445e-01, // 78
    5.619039102612838e+00, // 79
   -2.518029794740765e-01, // 80
    1.553618904660239e+00, // 81
   -9.299684286278881e-02, // 82
   -2.653814670639822e+00, // 83
   -2.208829855671971e-02, // 84
   -4.173496678979525e-01, // 85
   -2.574918387531684e-01, // 86
    2.879782731679444e-01, // 87
   -9.355949378287520e-01, // 88
    2.001935649654514e-03, // 89
    2.140361422976169e+00, // 90
   -1.487300376901566e+00, // 91
   -3.105440572444345e-01, // 92
   -7.482251025741342e-02, // 93
   -5.554865562386496e-01, // 94
    5.068772506656419e-01, // 95
    2.803981875034525e+00, // 96
    1.165299012191819e+00, // 97
    8.121355973801268e-01, // 98
    2.561501391444625e+00, // 99
   -5.243494811806925e-01, // 100
    2.330247520466570e-01, // 101
    2.497632925979702e+00, // 102
   -2.255433847305734e+00, // 103
   -3.605275743316940e-01, // 104
    1.877099468838904e-01, // 105
    2.663513075838611e+00, // 106
   -2.100751995543007e+00, // 107
   -1.623139737490634e-01, // 108
    2.994915890272039e+00, // 109
    5.785686658783541e-01, // 110
   -1.199524284728668e+00, // 111
   -1.559977879515257e+00, // 112
    2.057458000232228e+00, // 113
   -4.142765225352230e-02, // 114
    1.775780177262474e+00, // 115
    1.550932838254460e+00, // 116
    9.203604212435780e-02, // 117
    3.504665504991207e+00, // 118
    1.743551434555566e+00, // 119
    3.016486900035853e+00, // 120
    1.641117016849529e-03, // 121
    2.672837719107422e+00, // 122
   -1.550201908454370e-01, // 123
    5.722512739386766e-01, // 124
   -1.915082756798211e+00, // 125
    3.303356200960815e-01, // 126
   -2.359860782014285e+00, // 127
   -3.664709660670712e-01, // 128
   -1.373938126598166e-02, // 129
   -1.013129191595465e+00, // 130
   -4.231685171453207e-01, // 131
   -2.159659458000367e-01, // 132
   -9.332287896127744e-01, // 133
    2.553212498701767e-02, // 134
    1.971859676777354e-01, // 135
    1.764637807660713e+00, // 136
    1.184184791859404e+00, // 137
    1.561797466508335e+00, // 138
   -1.722577223941426e+00, // 139
    1.645997881381054e-02, // 140
    5.185744967180577e-01, // 141
   -1.203260334709182e-01, // 142
   -7.675709037509222e-01, // 143
    4.939673235190537e+00, // 144
   -5.041705216655175e-02, // 145
    3.231970745171083e-01, // 146
   -1.771369968898833e+00, // 147
    1.793273061634444e+00, // 148
   -9.549569833696387e-01, // 149
    2.343975820280249e+00, // 150
   -3.791117711054046e-01, // 151
   -8.434113412564412e-02, // 152
   -2.320632833621389e-01, // 153
    4.981585853728595e-01, // 154
    5.487011552057811e-01, // 155
    5.973009613415713e-02, // 156
   -4.065286432466299e-01, // 157
    1.077066979363363e+00, // 158
   -8.517003981222779e-02, // 159
    1.517649028723354e+00, // 160
    6.242902950885942e-01, // 161
    1.044764786004160e+00, // 162
   -1.042659171289018e+01, // 163
   -7.243084499350729e-04, // 164
    1.524462654897098e-07, // 165
   -2.440658762343860e-04, // 166
    2.756494195183793e-02, // 167
    6.892792309181685e-02, // 168
   -2.565710394813518e-02, // 169
    1.212990351826585e-02, // 170
   -1.114725130556139e-03, // 171
    8.030203269202604e-05, // 172
    1.958284693173177e-02, // 173
    2.264074844952080e-03, // 174
    3.420483139733588e-02, // 175
   -6.243663885196744e-04, // 176
    7.597214331598393e-01, // 177
    6.136361547266166e-02, // 178
    2.514146458619428e+00, // 179
   -9.488760166851591e-02, // 180
    1.677165257294699e+00, // 181
   -8.930349761797612e-02, // 182
    9.852289710224137e-01, // 183
   -1.244137723504135e-05, // 184
    4.252541516039754e-01, // 185
    2.938744982224402e-01, // 186
    1.724129150757102e-03, // 187
   -1.422651456309909e-01, // 188
    1.253385125511222e-02, // 189
   -8.747496640071347e-01, // 190
   -1.658036874140358e-01, // 191
    1.687745800413555e+00, // 192
   -5.680355873919625e-07, // 193
    1.237398405946706e+00, // 194
   -3.578334913140664e-02, // 195
   -3.382342762139165e-03, // 196
    1.478462528182957e-01, // 197
    1.108550575693872e-05, // 198
   -6.039045827655519e-03, // 199
    8.707437817493290e-02, // 200
   -7.170050969219027e-01, // 201
    5.255328005904931e-01, // 202
   -6.107378316980687e-04, // 203
   -4.815784848241649e-07, // 204
   -1.373849452936334e+00, // 205
   -8.460020968127270e-01, // 206
    1.657448281303137e-03, // 207
    3.652164516324434e-03, // 208
   -2.250054386115108e-02, // 209
    1.484561073537031e-03, // 210
    6.168839696798900e-01, // 211
   -1.798167419753061e-02, // 212
   -1.726204436669286e+00, // 213
   -1.482340924297425e+00, // 214
    1.361617609446881e-01, // 215
   -2.955590608888422e+00, // 216
   -1.390702194398635e-02, // 217
   -9.129374609953328e-03, // 218
   -1.227489809570515e+00, // 219
   -1.227924651054111e+00, // 220
    1.016486756345829e+00, // 221
    7.316846485915546e-01, // 222
    1.207936336157484e-02, // 223
    1.346074646929180e-01, // 224
   -8.607349425113104e-01, // 225
    1.645858164555591e+00, // 226
   -1.398531534923648e-03, // 227
    9.379260780999076e-02, // 228
    3.946809399237551e-01, // 229
    2.268454220103834e+00, // 230
    1.488734112815892e+00, // 231
    1.999196534372916e+00, // 232
    1.511575056357095e-02, // 233
   -1.722521449061104e-02, // 234
    2.076352828902913e+00, // 235
   -2.612131010278196e-03, // 236
   -1.660552512705370e-01, // 237
   -6.296727003229996e-04, // 238
   -2.159695119440738e-01, // 239
   -2.801796638010474e-05, // 240
   -1.042381740035035e-04, // 241
   -8.487335550356697e-04, // 242
   -4.483374230429898e-02, // 243
   -1.133224950271913e-01, // 244
    8.259134452466976e-02, // 245
   -9.283209593009316e-01, // 246
   -4.582355477947644e-01, // 247
   -1.092511242837288e+00, // 248
    8.429971133780483e-02, // 249
   -9.745099488122890e-01, // 250
    1.093744682846582e+00, // 251
    2.776550864729833e-03, // 252
   -1.115523288512671e+00, // 253
    2.591250093713358e-05, // 254
    3.872419467053949e-01, // 255
   -1.557092159186214e-02, // 256
    2.023753917119574e-01, // 257
    2.489049467655135e-05, // 258
   -1.396544483923212e-02, // 259
   -4.397192939592742e-02, // 260
    7.007678118406847e-04, // 261
    4.510841333524808e-05, // 262
    4.445669579506435e-01, // 263
   -2.385771343618898e+00, // 264
    4.697849775018097e-05, // 265
    2.127838077428716e-01, // 266
    3.266506767021122e-01, // 267
    2.599569574788875e-03, // 268
   -1.839491424777318e+00, // 269
    2.031784449316125e-01, // 270
    9.399565533685955e-03, // 271
    1.427508646244964e-05, // 272
    5.121360261033597e-05, // 273
   -1.167509628861971e-02, // 274
   -4.001938712747330e-01, // 275
   -2.552624066714434e-02, // 276
    8.711971760894688e-02, // 277
    4.712724142208032e-03, // 278
    2.802159005618317e-03, // 279
   -3.135543370738462e-04, // 280
   -1.876970058846185e-02, // 281
    6.567815106691463e-02, // 282
    5.520957026882825e+00, // 283
    1.466238776238328e-03, // 284
   -1.548193825962642e-01, // 285
    1.479094589144273e-01, // 286
   -4.814839434012897e-01, // 287
   -3.026806499856911e-03, // 288
    2.271636463025599e-01, // 289
   -8.243765009316310e-05, // 290
    6.515083901147257e-01, // 291
   -4.835314103631067e-02, // 292
   -2.638049515140717e-02, // 293
   -1.298995240239059e+00, // 294
   -1.460247291626110e-02, // 295
   -1.125787171509855e+00, // 296
    1.771240773260611e-06, // 297
   -1.049863567863922e+00, // 298
    7.298755260395023e-02, // 299
   -5.318831919036843e-03, // 300
   -3.807420493566487e-01, // 301
   -4.873404823088619e-02, // 302
    9.284879919295852e-01, // 303
   -1.260841672947238e-01, // 304
   -6.949531639336883e-02, // 305
    2.273065561068986e+00, // 306
    9.312323015889034e-01, // 307
   -5.340397914944665e-02, // 308
    5.768638766320745e-02, // 309
    5.969269973360701e-01, // 310
    1.403154296314540e+00, // 311
   -1.119594112359708e-01, // 312
    1.876153762277893e-01, // 313
    5.707904584215434e-01, // 314
   -1.174932814063663e-02, // 315
   -4.079221218804773e-01, // 316
   -3.255797362931247e-01, // 317
    2.088707877409461e-07, // 318
    5.934470943445384e+00, // 319
    1.281760791537849e+00, // 320
   -6.480243018012070e-02, // 321
   -1.969592026330184e+00, // 322
    3.710642612715698e-03, // 323
   -9.958449700520114e-04, // 324
   -3.283231900051267e-01, // 325
   -1.784881748285186e-01, // 326
   -2.127831410257615e-04, // 327
    6.767914932330964e-06, // 328
   -2.519220968074969e-04, // 329
    8.661679701727853e-03, // 330
    2.907624479628878e-03, // 331
   -1.542553323932950e+00, // 332
   -3.129803983710937e+00, // 333
   -5.676440542601039e-04, // 334
   -2.199416894868598e-04, // 335
   -3.759848339775884e-01, // 336
   -1.323951666318339e-03, // 337
    5.366536774021226e-02, // 338
   -1.052671690595373e-04, // 339
   -5.447371640364430e-01, // 340
   -2.159373747512607e-05, // 341
    2.282812521800319e-01, // 342
   -1.736100959157371e+00, // 343
    5.125517902931924e-01, // 344
   -9.293017099771439e-02, // 345
   -2.411718870042234e-01, // 346
    1.857946641572144e-01, // 347
   -3.614507959713741e-02, // 348
    1.384844467997454e-03, // 349
   -4.240454958702212e-03, // 350
    1.570049924833017e-04, // 351
    3.073280222414828e-05, // 352
   -1.806274046874143e-04, // 353
    4.783096832322854e-04, // 354
   -2.374839395571088e-02, // 355
   -5.059420960108063e-01, // 356
    8.218655476527717e-06, // 357
    1.271972814891922e-01, // 358
    5.018903646529950e-01, // 359
   -7.732231815475728e-02, // 360
   -2.230756658400978e+00, // 361
   -6.807905997498575e-01, // 362
    3.850055112563199e-05, // 363
   -4.626722400439438e-02, // 364
   -7.892442947487326e-02, // 365
    8.288134590334270e-01, // 366
    8.795468455097388e-01, // 367
    1.029933314461573e-03, // 368
   -1.244287184340593e-01, // 369
    5.747371299404646e-01, // 370
    1.569740911713510e-03, // 371
    1.270832449204555e-01, // 372
   -8.619499326626103e-01, // 373
   -2.987716642755463e-01, // 374
   -5.213928689096533e-02, // 375
    4.489132845467195e-01, // 376
   -2.179554209384813e+00, // 377
   -4.296532382932190e+00, // 378
    1.319329208116352e-03, // 379
   -3.279833472719221e+00, // 380
    2.032662929007781e-01, // 381
    8.772951325383006e-02, // 382
    9.521116539068212e-03, // 383
    1.727643099238525e-01, // 384
   -4.312862944832083e-01, // 385
   -1.210522924568315e-01, // 386
   -6.680920874297075e-02, // 387
   -3.656856466316400e-01, // 388
    3.572928088862713e-02, // 389
   -8.488714668258997e-05, // 390
   -2.628430639992124e+00, // 391
    3.647214905639146e-06, // 392
    1.664807684045176e+00, // 393
   -3.329906842081026e-02, // 394
   -3.988666942973910e+00, // 395
   -2.690854993164525e-03, // 396
   -4.834987070199723e-02, // 397
    1.976053210014963e-01, // 398
    8.189753300445274e-01, // 399
   -9.672612491702991e-01, // 400
    1.894100331715090e-01, // 401
    1.143732270436788e-03, // 402
   -4.005037475478800e-01, // 403
   -4.147371048278027e-01, // 404
    1.228706815975162e+00, // 405
    6.014134383512814e-05, // 406
    2.925643670146306e-05, // 407
   -1.355245130612575e-01, // 408
   -6.802788273817566e-03, // 409
    1.562738862548047e-04, // 410
   -2.819797391618954e-02, // 411
   -3.210727136234278e+00, // 412
    2.819407208215176e+00, // 413
   -9.826945862777021e-01, // 414
   -7.954557370630758e-01, // 415
   -1.296149136465911e-01, // 416
   -1.724565413970966e+00, // 417
    6.989522577834235e-02, // 418
    7.302082683676653e-02, // 419
   -6.172851148270830e-02, // 420
   -1.666665568842713e+00, // 421
   -5.054446352871477e-01, // 422
   -4.201127414087808e-04, // 423
    5.263649538827507e-03, // 424
    2.362282613799061e-01, // 425
    2.009007525474920e-03, // 426
    4.940220468480392e-04, // 427
    3.842565602372223e-02, // 428
    6.125333708296717e-03, // 429
    7.674850868744301e-02, // 430
   -2.018795463165261e-05, // 431
    2.885358432829235e-02, // 432
   -8.766563432310682e-03, // 433
    4.848461660749020e-01, // 434
   -4.946075732549596e-01, // 435
   -3.148851000212850e+00, // 436
   -1.550420819451153e+00, // 437
    2.966314684582273e-02, // 438
    1.560944642796485e-01, // 439
   -4.295754609077086e-06, // 440
    1.200642472500313e-01, // 441
    6.638504008177844e-04, // 442
   -7.769653699058254e-04, // 443
   -1.634138229500250e+00, // 444
    7.059753654950351e-05, // 445
    1.153101060611876e-01, // 446
    1.023051261952285e-04, // 447
   -9.193975106477577e-02, // 448
    9.610893724740106e-02, // 449
    9.424960408759012e-02, // 450
    1.094027174924837e+00, // 451
    5.616235826987263e-02, // 452
    2.597928956281847e-01, // 453
   -3.267202236435213e-06, // 454
    1.216721502267366e-01, // 455
   -1.031527685375438e-06, // 456
    1.244980213208176e+00, // 457
    7.397684318476934e-01, // 458
   -4.057206874077558e-02, // 459
    1.367542186068576e-02, // 460
    4.977406905846903e-02, // 461
    3.112918117350998e-01, // 462
    2.477989066462701e+00, // 463
   -7.183532221909779e-01, // 464
    4.531306377822718e-03, // 465
    1.687140117452360e-04, // 466
   -1.105450887947783e-01, // 467
    1.381461445646859e-01, // 468
   -2.081269895632233e-06, // 469
   -2.003147094172140e+00, // 470
   -3.591162765316300e+00, // 471
    8.243242292972735e-04, // 472
   -1.294223290604573e-01, // 473
   -3.868686371909989e-02, // 474
    2.292845660651722e-01, // 475
    4.173086974649704e+00, // 476
    1.877741159669312e+00, // 477
   -1.675564352196124e-05, // 478
    5.101459565803064e-05, // 479
   -5.789402410593127e-02, // 480
   -3.515837798269486e-03, // 481
    6.758531804353161e-01, // 482
   -1.576642402214840e+00, // 483
    1.569363602046456e-02, // 484
   -7.583747790684600e-06, // 485
    2.059243915001716e+00, // 486
   -1.606677458193938e+00, // 487
    7.197436858205591e-01, // 488
   -9.978602797802195e-04, // 489
    2.067497940091855e-02, // 490
   -9.080769118098820e-01, // 491
   -7.299504109699167e-05, // 492
    3.027421848904069e-05, // 493
   -1.099606453292644e+00, // 494
    1.703827018455963e-01, // 495
    6.895198497620922e-03, // 496
   -8.986604652725235e-01, // 497
    9.647151364146683e-02, // 498
    9.936234803538160e-02, // 499
    9.395067675762198e-03, // 500
    2.529537642898584e-06, // 501
   -8.198280528964572e-04, // 502
    4.439791645339060e+00, // 503
    2.897066386798900e-01, // 504
   -1.712446358189749e-01, // 505
    6.094256236159960e-05, // 506
   -1.328111022006107e-02, // 507
   -8.055049141017205e-01, // 508
   -7.830482085712324e-05, // 509
    2.488028588067245e-03, // 510
    1.594217689091363e-01, // 511
    1.179123605015275e-04, // 512
   -2.386852147195017e-02, // 513
   -9.883449643224548e-01, // 514
   -1.884365879713668e-02, // 515
    5.878870966064897e-02, // 516
   -8.497058601838177e-04, // 517
   -2.757843917268179e-04, // 518
    2.617520345437625e+00, // 519
    1.725671286299374e+00, // 520
   -1.491438283597873e-02, // 521
    1.294847886856370e-02, // 522
   -1.605298285984673e-01, // 523
   -4.397586706202249e-02, // 524
   -7.792621757149345e-04, // 525
    1.811551391735880e-02, // 526
   -7.194435631145150e-01, // 527
   -1.441716482601607e-07, // 528
   -2.418338971666682e-02, // 529
    9.723269234561778e-03, // 530
   -7.543368550978294e-02, // 531
    1.650956752799791e-02, // 532
   -2.524367335924508e-03, // 533
   -9.391449087149170e-01, // 534
    1.778127447099513e-03, // 535
    3.448064291944166e+00, // 536
   -5.340707773271451e-02, // 537
   -5.107591881001401e-02, // 538
    1.070371374738794e+00, // 539
   -6.844340134233693e-04, // 540
    1.077122363027745e+00, // 541
    6.000475947711813e-01, // 542
   -5.075580548008017e-02, // 543
   -4.949481124467358e-03, // 544
    1.029498190077928e+00, // 545
    1.679826834127383e+00, // 546
    6.914914150988221e-03, // 547
    3.072864469322134e-01, // 548
    9.797377419883832e-02, // 549
   -9.881722683066947e-05, // 550
   -9.710502685468638e-01, // 551
   -1.819150723369382e-01, // 552
    1.930879253500442e+00, // 553
   -2.340425649375582e-05, // 554
   -3.621997687062776e-01, // 555
   -4.145659584413377e+00, // 556
   -4.362384559268483e-01, // 557
    4.984079477895779e-01, // 558
   -3.484567985954889e-01, // 559
    3.107978095861483e-03, // 560
   -2.463945205083820e+00, // 561
    3.733394112605763e-02, // 562
   -8.194410941110383e-03, // 563
   -1.833164475109550e-05, // 564
   -1.287944829102657e-02, // 565
    2.135398787992262e-02, // 566
    1.458282887085314e-01, // 567
   -1.059296949437513e+00, // 568
    3.001502969905462e-01, // 569
    2.714985561528607e-01, // 570
    9.595259593223179e-04, // 571
   -5.631141223911804e-02, // 572
   -2.639947794189641e+00, // 573
    5.745771941755935e+00, // 574
   -8.553587375048923e-01, // 575
   -2.290076395225736e+00, // 576
    1.494208968961689e-03, // 577
    9.452517677210401e-01, // 578
    5.322896648649903e-01, // 579
   -3.692306500192847e-05, // 580
   -6.870220472979708e-01, // 581
    1.168134343724507e-01, // 582
   -1.097383993933373e-03, // 583
   -1.026883905811468e-01, // 584
    1.827723045697369e+00, // 585
    1.454166301599400e-01, // 586
   -6.806766677549203e-01, // 587
   -8.913510651473276e-05, // 588
    6.334982974024683e-03, // 589
   -8.408882069229857e-01, // 590
   -2.572457362721376e+00, // 591
   -8.136818170267259e-03, // 592
    1.530334437307517e-03, // 593
   -1.429006627853850e-02, // 594
   -5.605858775029597e-01, // 595
    2.832596665121788e-04, // 596
    5.994300325961387e-02, // 597
   -1.734049419216473e-01, // 598
   -1.791122661440781e-02, // 599
   -1.523163697895537e-01, // 600
   -3.941788842525078e-01, // 601
    5.346327139259438e-03, // 602
    9.712633824915032e-02, // 603
   -1.767304363643412e+00, // 604
    4.908659238601987e-02, // 605
    2.194766987376814e-01, // 606
    3.955161876887152e+00, // 607
   -3.641411543106643e-01, // 608
   -1.955387470010863e-02, // 609
   -2.501831390971315e-04, // 610
   -6.541798983127202e-01, // 611
    6.198504000622151e-01, // 612
   -1.450559587638036e-03, // 613
    1.390438647137225e+00, // 614
    1.287650769889567e+00, // 615
   -2.065317094261663e-04, // 616
   -1.757983932896048e-03, // 617
    3.613963321986070e-02, // 618
   -1.085764788267912e+00, // 619
    1.570296645576010e+00, // 620
    8.903052119643819e-02, // 621
   -1.183666651527798e-03, // 622
    1.442560094332728e+00, // 623
   -2.957595663075398e-02, // 624
   -1.267799706217737e+00, // 625
   -1.493623309327246e-01, // 626
    7.317804547690728e-01, // 627
   -1.781481371636310e-03, // 628
    3.695300254831801e-01, // 629
    6.583470931482831e-01, // 630
   -1.413006172076885e-01, // 631
   -2.927017633915903e-01, // 632
    3.354508331987135e-05, // 633
   -5.705264139596947e-02, // 634
    2.512377703601313e-04, // 635
    9.152997506051698e-05, // 636
    2.411470531648090e+00, // 637
   -2.200569563970357e-01, // 638
   -1.613495512785707e-03, // 639
   -1.658976881620898e-04, // 640
    7.214127808876329e-06, // 641
   -4.980153687648437e-01, // 642
    7.370409019586170e-03, // 643
    8.433382352972574e-02, // 644
    6.126143062451422e+00, // 645
   -1.008851286907602e-01, // 646
    9.137650242236464e-01, // 647
    2.092398378494342e-01, // 648
    1.874619758615963e+00, // 649
    5.596978881129449e-01, // 650
   -4.446867817236713e+00, // 651
    1.075240563656426e-01, // 652
    4.532128132115170e-01, // 653
    6.364165439711873e-01, // 654
   -1.413903674754142e+00, // 655
    6.014232464388453e-03, // 656
    1.654760579166137e-01, // 657
   -7.781974772545079e-02, // 658
    1.652588546038009e-04, // 659
    6.996163009276295e-04, // 660
   -6.848471889979803e-02, // 661
    3.287406794406545e-03, // 662
   -7.678759876570452e-01, // 663
    4.555770706053027e-01, // 664
   -6.408441824510176e-01, // 665
   -1.402104827114135e-01, // 666
   -1.972430601520592e-01, // 667
   -2.634475859884499e-01, // 668
   -2.350616347800500e-03, // 669
   -2.005097292600072e-02, // 670
    8.516221622342838e-03, // 671
    8.480417358724623e-05, // 672
   -1.156701573673941e+00, // 673
    8.691798914451510e-03, // 674
    7.534812914229846e-02, // 675
   -1.035462702180387e-04, // 676
   -4.412957177887784e-01, // 677
    6.982786602746067e-02, // 678
   -5.302403137004074e-05, // 679
    7.754987819872972e-01, // 680
   -1.026494205784370e-01, // 681
    9.523278638792139e-01, // 682
    3.516410725131137e-01, // 683
    1.991122014173096e-03, // 684
    3.833096550134753e-02, // 685
   -3.624831144053181e-01, // 686
    4.233983688806144e-01, // 687
   -5.613266589182628e-02, // 688
    1.512287245908679e-04, // 689
    1.438719116150277e+00, // 690
   -6.020175535906788e-03, // 691
   -8.515701368190151e-01, // 692
   -1.526343871229218e-01, // 693
   -2.626637674928957e+00, // 694
   -5.984418893290822e-01, // 695
    2.267981030824406e-04, // 696
   -3.387721014484610e-05, // 697
   -2.976318795472616e+00, // 698
    2.253471003946390e+00, // 699
   -9.975199005149596e-05, // 700
   -2.420391268160499e-01, // 701
    1.030143767435178e-03, // 702
   -1.148203243104329e-04, // 703
   -1.499080315648819e+00, // 704
    7.048237626542588e-02, // 705
    1.047426077695852e-01, // 706
    3.535152801692241e-01, // 707
    2.692208370117966e+00, // 708
    8.900297567103891e-03, // 709
    1.621593794917615e-04, // 710
   -1.033487559420595e-04, // 711
    4.480187190912999e-01, // 712
   -1.466322688928480e-03, // 713
    2.919808154174306e-03, // 714
    1.175191842053469e-01, // 715
    5.558730677487292e-03, // 716
   -1.264831152832635e+00, // 717
   -4.365122335309392e-01, // 718
   -7.508251775568963e-01, // 719
    1.069839482082105e-01, // 720
   -6.424047907287747e-01, // 721
   -6.997447969678770e-02, // 722
   -9.584404215328540e-01, // 723
    4.192039945599387e-05, // 724
    5.438837888117455e+00, // 725
   -8.408113424829068e-02, // 726
   -6.860614891614318e-01, // 727
    5.992224101502602e-03, // 728
   -8.446185378641972e-03, // 729
   -1.581656204451342e-03, // 730
   -5.639423655696796e-04, // 731
   -3.055641041993342e-01, // 732
   -3.832329465618029e-04, // 733
   -3.311608901094809e-02, // 734
    2.563244501783957e-03, // 735
    1.102155790602023e+00, // 736
    1.146630248234064e+00, // 737
   -6.820874459212436e-01, // 738
    3.003839869173482e-04, // 739
   -2.199109994129134e-05, // 740
    8.923558027731700e-04, // 741
    2.403590816697455e-02, // 742
   -7.589001449499308e-03, // 743
    3.586865404235599e-02, // 744
    1.028151811067442e-02, // 745
   -3.725690293986706e+00, // 746
   -2.154829842493072e-04, // 747
    3.200834617144375e-05, // 748
   -3.674693712260665e-01, // 749
    3.209480388927065e-01, // 750
    9.029720079430871e-01, // 751
    4.970134005052996e-01, // 752
    6.892000474084644e-03, // 753
   -1.364216425304147e-03, // 754
   -6.153159057922466e-03, // 755
    4.112530844320123e-05, // 756
    4.538091139458868e-02, // 757
   -1.514516284639165e+00, // 758
    7.129868357219478e-03, // 759
   -3.036046042713461e-01, // 760
   -1.111527754445432e+00, // 761
   -5.374845024758272e-01, // 762
    1.215753417081701e+00, // 763
    4.031149703273239e-01, // 764
   -5.715503944449666e-01, // 765
   -1.946747275055312e-01, // 766
    1.282786454965537e-01, // 767
   -1.218868740283157e-01, // 768
   -6.780880222071570e-05, // 769
    1.613261297840551e-01, // 770
   -3.536226551091798e-04, // 771
   -2.853876686261152e-03, // 772
    1.040306209102137e-01, // 773
    6.553573994025827e-02, // 774
    3.639838349563612e-02, // 775
   -3.555250309922995e-03, // 776
   -4.404055149063481e-03, // 777
   -2.760199865350009e+00, // 778
    2.102954887957522e+00, // 779
    7.293469193565213e-05, // 780
    3.065749683350958e-01, // 781
   -1.733489136345897e-01, // 782
    1.566053664268774e+00, // 783
   -6.673322312430596e-01, // 784
   -1.474779168474867e-03, // 785
    6.745569378241975e-05, // 786
    3.524073527771355e-03, // 787
   -6.820780902688238e-01, // 788
   -2.112677493027175e+00, // 789
    1.091991918034362e-02, // 790
   -2.094335544023333e-05, // 791
    1.662489132159121e-01, // 792
    1.639317838806049e+00, // 793
    7.365183866255021e-02, // 794
    3.624360772052154e-02, // 795
   -5.436501560203293e-02, // 796
   -1.672248526021967e+00, // 797
    1.850413080338683e-06, // 798
   -5.775443002986968e-04, // 799
    5.669569318492415e-02, // 800
   -1.750059292203669e+00, // 801
    1.431712916299218e-02, // 802
    8.984980914236672e-01, // 803
    2.953304081719195e-01, // 804
   -1.130117218820789e-04, // 805
    7.401019375526592e-01, // 806
   -5.554511398601449e-01, // 807
    2.820569943578651e-03, // 808
   -1.730261343577673e-01, // 809
   -1.799408618744328e+00, // 810
   -3.918767406529601e-04, // 811
    3.686903822356299e-01, // 812
    2.272875637157606e-03, // 813
    2.053570194439945e+00, // 814
    7.876639220521704e-01, // 815
   -2.520919977156404e-03, // 816
   -5.755415866101081e-01, // 817
    1.014778289697120e+00, // 818
    2.460524377891871e+00, // 819
    3.632510973117653e+00, // 820
   -3.494136671889112e-01, // 821
   -2.196978346492904e+00, // 822
    8.109858820915113e-01, // 823
   -8.204901863159034e-02, // 824
   -7.370793339662818e-02, // 825
   -1.861914466993348e-01, // 826
    1.461675488013455e+00, // 827
   -9.426664668590748e-02, // 828
    1.476540469169649e-01, // 829
   -9.974247682813807e-01, // 830
   -2.160571091688383e+00, // 831
   -2.667882884912364e-01, // 832
   -1.466963488754844e+00, // 833
    5.030385876324003e-01, // 834
    1.336970447243505e-03, // 835
   -1.912591033689501e+00, // 836
    5.617530233421394e-01, // 837
    2.727987841966044e-02, // 838
    1.568939683469150e+00, // 839
    1.073853534058074e-03, // 840
    9.806902185390132e-02, // 841
    6.523764780109373e-07, // 842
    1.556470924775451e+00, // 843
    5.980687359957351e-01, // 844
   -2.852175385917973e-03, // 845
    1.492100826956730e-02, // 846
    2.030483575973628e+00, // 847
    3.194251689910876e-01, // 848
   -1.570283033034023e-01, // 849
    1.671539297052435e+00, // 850
   -6.613605986383549e-07, // 851
   -8.652321005547565e-03, // 852
    8.669672106179097e-01, // 853
    8.236329887620224e-02, // 854
   -5.761057010685160e-01, // 855
    9.860241512220850e-06, // 856
    3.028794580895721e-01, // 857
   -3.892248839500873e-01, // 858
   -8.627523427841050e-01, // 859
    1.099015802209533e-01, // 860
    7.119412294796207e-02, // 861
   -4.419639928055320e-03, // 862
   -1.706457601700602e-03, // 863
    1.787086462273588e-01, // 864
    3.395690681578153e-02, // 865
    8.118834876937598e-04, // 866
    7.273200174304471e-05, // 867
   -9.673635089872380e-01, // 868
    4.809648586106172e-01, // 869
   -4.020124847222951e-01, // 870
    2.640179604236901e+00, // 871
   -3.684621479768198e-02, // 872
   -3.627035163579278e-01, // 873
    2.488720325174566e-02, // 874
    3.839627103619449e-02, // 875
    1.144494321341684e+00, // 876
   -1.357056756718425e+00, // 877
   -1.112952508446752e-02, // 878
   -5.169116419871591e-01, // 879
    2.057639276640218e-02, // 880
    5.381760558304107e-02, // 881
   -6.356982461390734e-01, // 882
   -9.857233066605103e+00, // 883
    4.629841214549531e+00, // 884
    5.279322412569822e-04, // 885
    8.219964416988251e-02, // 886
    5.542819830158187e-01, // 887
   -4.079309894478273e-03, // 888
    2.372751301947394e-04, // 889
   -1.254008758305162e-01, // 890
    1.968310468633906e+00, // 891
   -7.226666518849529e-01, // 892
   -1.004584718782300e-03, // 893
    1.751004275037681e-01, // 894
   -2.209068061032515e-04, // 895
    3.617011374801946e-02, // 896
    1.414796028929768e-03, // 897
    3.177207786914233e-05, // 898
    2.712191996536616e-01, // 899
    1.431814178576874e-02, // 900
   -3.149286605238471e-03, // 901
    3.263230232773284e-02, // 902
    1.333208317103960e+00, // 903
    1.402474928904500e-01, // 904
   -1.931105067785436e-04, // 905
    1.476187706860769e+00, // 906
    1.602936183122075e+00, // 907
    2.419427832281475e+00, // 908
   -4.049267143826650e-05, // 909
    5.190829226218560e-04, // 910
   -1.182952885580259e+00, // 911
    3.067535582375637e-01, // 912
    7.336721602748014e-02, // 913
   -2.599315854363931e-04, // 914
   -2.666759158445351e-02, // 915
    4.596806829848568e-02, // 916
   -8.336065075110591e-01, // 917
    6.312921663747696e-04, // 918
   -5.262257692728178e-01, // 919
   -1.214748412371474e-02, // 920
    7.281410983857249e-04, // 921
   -2.506992559121824e-02, // 922
    2.494001342568744e+00, // 923
    4.508804467400932e-04, // 924
   -2.822946168765821e-08, // 925
   -3.584028634483649e-01, // 926
   -4.803692604432485e+00, // 927
   -6.011001906204479e-02, // 928
   -3.675734848210208e-04, // 929
    4.370309283131809e-05, // 930
    1.643001173660797e-02, // 931
    4.925598581396402e-10, // 932
   -2.052299305919921e-07, // 933
    2.042044011560878e-05, // 934
    4.758780576019556e-02, // 935
    1.056332183727235e-04, // 936
    9.133193903796462e-09, // 937
   -3.123008829498908e-01, // 938
    1.836577578646656e-01, // 939
   -1.352078974845329e-03, // 940
    3.619625745986849e-04, // 941
    2.538651810025946e-03, // 942
   -3.695440147174666e-04, // 943
   -4.225421539741549e-04, // 944
    4.806453106338067e-07, // 945
    6.235392738039731e-01, // 946
    5.863358957895155e-01, // 947
   -2.128894764742120e-03, // 948
   -3.413380515126525e-04, // 949
   -1.056801377171079e-01, // 950
    7.044572239216203e-04, // 951
    3.106926280708701e-01, // 952
   -2.452036946598616e-01, // 953
   -2.959803246689752e-07, // 954
   -8.108769327302100e-02, // 955
   -4.496521360564334e-08, // 956
    2.583270579364803e-03, // 957
   -4.959892973011194e-05, // 958
    2.410361626863613e-05, // 959
   -1.724103601178413e-07, // 960
    1.816785782228763e+00, // 961
   -1.412261870217518e-01, // 962
    3.689093237874200e-02, // 963
   -6.005645726956284e-04, // 964
    3.004936195456596e-06, // 965
    1.522660599493005e-05, // 966
   -5.946374313344659e-07, // 967
    4.091269458384880e-02, // 968
   -3.728438411780845e-05, // 969
   -4.540801590578277e-07, // 970
    1.015458845671609e-06, // 971
   -2.116030517827755e-03, // 972
    2.775169203377877e-02, // 973
   -2.035559426732073e-07, // 974
   -5.265498243596660e-07, // 975
    1.091600215069555e-01, // 976
    1.366614758306150e-09, // 977
   -2.255641968523679e-10, // 978
    5.647586014628723e-07, // 979
   -9.663623751274375e-01, // 980
   -5.115752939306981e-02, // 981
    3.747368802195834e-01, // 982
   -2.001072690250013e+00, // 983
    1.722566904273995e+00, // 984
   -2.691208019953313e-01, // 985
   -1.218869766866685e-05, // 986
    3.067220639891311e-07, // 987
   -5.546989764074355e-03, // 988
    3.079111427028620e-02, // 989
   -1.378774744992518e-05, // 990
    3.229115377347150e-03, // 991
   -6.005498216876226e-07, // 992
    7.158650095459206e-07, // 993
   -6.519959630627036e-03, // 994
    2.484001237368693e-04, // 995
    1.118913453706541e-03, // 996
   -3.464627193645473e-04, // 997
   -1.274779195796047e-04, // 998
   -1.285427090275196e-06, // 999
    8.972019465231502e-05, // 1000
    4.072640718757482e-07, // 1001
    2.649582698799889e-02, // 1002
    2.549349810520614e+00, // 1003
   -4.097790100022971e-01, // 1004
   -9.693992572080989e-04, // 1005
    5.602523185997653e-03, // 1006
   -2.579292672223539e-05, // 1007
    1.696342598676547e-01, // 1008
    2.843511833023716e-09, // 1009
   -3.405363691291822e-06, // 1010
    1.319940397562482e-03, // 1011
    4.046502754479816e-06, // 1012
    3.408041696551528e-05, // 1013
   -1.017191019089096e+00, // 1014
   -3.518825934291714e-03, // 1015
    8.374402231331072e-06, // 1016
   -6.049409772953869e-07, // 1017
    5.301129548003718e-08, // 1018
    1.905825459521567e-04, // 1019
   -3.668773540044530e-05, // 1020
   -3.615540038222992e-04, // 1021
   -6.764331675495010e-05, // 1022
   -4.811901146307542e-01, // 1023
    6.382970480711008e-04, // 1024
   -9.906530837885935e-01, // 1025
    3.996685204705802e-04, // 1026
    1.834315884628939e-04, // 1027
    6.809668310423996e-02, // 1028
    1.466723639975130e-04, // 1029
   -3.800535815585273e-02, // 1030
   -1.798096389996134e-04, // 1031
   -4.319478833014364e-05, // 1032
    4.238101693624391e-03, // 1033
   -2.314542376321185e-07, // 1034
    4.649111501720450e-07, // 1035
   -2.422443341399925e-05, // 1036
    1.124354326759488e-04, // 1037
    3.133740028282733e-02, // 1038
   -4.758121023019279e-07, // 1039
   -2.656267941732604e-10, // 1040
    1.521449750119380e-03, // 1041
   -1.919769324408966e-06, // 1042
    4.992584246526725e-01, // 1043
    1.110357248368597e-03, // 1044
   -2.937211467167469e-08, // 1045
   -3.520315192931838e-02, // 1046
   -8.568803547263791e-03, // 1047
    1.158971481891037e-04, // 1048
    2.409745248869294e+00, // 1049
    6.807735430275574e-01, // 1050
    4.793143809661745e-10, // 1051
    1.472755082394949e-06, // 1052
    1.848681654514072e-03, // 1053
   -1.393695235797885e-08, // 1054
    2.329104052204724e-02, // 1055
   -2.080195530478642e-01, // 1056
   -2.438169727192338e+00, // 1057
   -3.082681655078117e-05, // 1058
    2.377521010677348e+00, // 1059
    2.894061157709835e-05, // 1060
   -1.453628855087097e-02, // 1061
   -3.345136543165086e-05, // 1062
   -8.689172100713462e-03, // 1063
   -7.872940343239273e-06, // 1064
    5.709077244070669e-04, // 1065
   -1.175923632465116e-07, // 1066
   -1.537338889816026e-07, // 1067
    4.629790868600616e-10, // 1068
    6.430515157627967e-02, // 1069
    4.017817831564480e-03, // 1070
   -3.262238752650717e-10, // 1071
   -1.470785720384345e-02, // 1072
   -1.517180749766029e-03, // 1073
   -4.277637190657044e-04, // 1074
    3.760124714118673e-06, // 1075
   -8.151229288305253e-04, // 1076
    2.418290368239662e-05, // 1077
    4.165038981806391e-02, // 1078
    6.765540850896700e-03, // 1079
   -1.942866673859235e-04, // 1080
    2.499666697274287e-01, // 1081
   -6.348356852969302e-02, // 1082
   -6.226367381059913e-04, // 1083
   -2.777117487215694e-04, // 1084
   -3.710125489718097e-02, // 1085
   -6.676494158622948e-01, // 1086
   -5.071702726974108e-01, // 1087
   -4.962410237477823e-05, // 1088
   -5.229069119997767e-04, // 1089
   -2.941823872140204e-02, // 1090
   -2.065603797202060e-05, // 1091
    5.518853361306388e-04, // 1092
   -9.069211176786799e-03, // 1093
   -2.276152855611938e-05, // 1094
   -1.592504627602861e-05, // 1095
    2.333629753665179e-07, // 1096
    3.116502007025304e-07, // 1097
    9.420522539903707e-10, // 1098
    4.303891206306733e-07, // 1099
    1.576211885050681e-10, // 1100
    5.025841599589720e-06, // 1101
    2.819351278817544e-02, // 1102
   -2.661248899876644e-04, // 1103
   -3.480574744711752e-01, // 1104
   -2.768543324218767e-04, // 1105
   -1.341967992049426e-02, // 1106
    3.988184544238376e-01, // 1107
   -8.753991437553506e-03, // 1108
   -2.277512750867913e-04, // 1109
    3.536091493261981e-05, // 1110
   -2.451939535039637e-05, // 1111
   -1.385923593243191e-02, // 1112
    2.638665661163025e-04, // 1113
   -1.226537975722575e-03, // 1114
   -3.338167640476108e-02, // 1115
   -2.327962543932310e-04, // 1116
   -3.544170814931270e-04, // 1117
   -9.350047236006522e-06, // 1118
   -7.055613770287072e-06, // 1119
    1.483272881748938e-03, // 1120
   -1.612823894351140e+00, // 1121
   -1.155472246251249e-07, // 1122
   -3.511105399973645e-07, // 1123
   -3.010276236138160e-03, // 1124
   -9.441562688889766e-10, // 1125
    1.222033259371629e-05, // 1126
   -4.342733177167767e-08, // 1127
    1.579746798658271e-08, // 1128
    5.220282087816918e-03, // 1129
    2.003314203845142e+00, // 1130
    2.258535065234679e-02, // 1131
   -5.750429354269474e-01, // 1132
   -1.594132415804475e-02, // 1133
   -3.421279469581750e-02, // 1134
   -1.147950789902594e-05, // 1135
   -5.453843490516966e-08, // 1136
    2.002931335373132e-03, // 1137
   -1.139676010974981e-03, // 1138
    1.658574980683444e-03, // 1139
   -1.362418640634682e-09, // 1140
   -9.868149104472466e-01, // 1141
    9.588764437544513e-06, // 1142
   -3.286900271606703e-02, // 1143
    1.800775504138237e+00, // 1144
    1.400105478690321e-08, // 1145
    7.954663596039110e-07, // 1146
    2.989757970204798e-03, // 1147
   -1.235858169421505e-01, // 1148
    2.105979802402971e-04, // 1149
   -1.942772629700765e-01, // 1150
    1.882496346693836e-02, // 1151
   -1.091021603790425e-01, // 1152
    3.872841309140912e-07, // 1153
    3.741131765206792e-05, // 1154
    2.286012217224304e-09, // 1155
    4.494389361664940e-03, // 1156
    1.866161727244313e+00, // 1157
   -1.487923454065174e-05, // 1158
    9.562792593279418e-07, // 1159
   -3.274534330254359e-03, // 1160
   -2.940624574741358e-01, // 1161
   -1.356758280023140e-03, // 1162
    2.929773034369051e-04, // 1163
    2.025073566225063e-02, // 1164
   -5.596973547977497e-01, // 1165
   -4.747705024669460e-03, // 1166
    1.853941771453945e-05, // 1167
   -1.774694985139933e-05, // 1168
    3.769941648495506e-04, // 1169
    3.141915281908207e-06, // 1170
    4.973049324880509e-05, // 1171
   -1.795337036901476e-04, // 1172
   -1.104779013756622e-02, // 1173
   -5.186670382907245e-02, // 1174
    7.260109128962815e-06, // 1175
   -3.382025831593161e-01, // 1176
    6.020625746664137e-03, // 1177
   -6.225689982313726e-02, // 1178
    8.747134060279365e-04, // 1179
    4.721774390230294e-08, // 1180
    3.925587424211045e-05, // 1181
   -2.427541403224014e-07, // 1182
   -1.241627565973362e-05, // 1183
   -1.406801938974328e-05, // 1184
    2.469477404083087e-02, // 1185
    9.232657034794797e-03, // 1186
    1.084810634270343e-05, // 1187
   -2.804441875977315e-04, // 1188
    1.520007737847021e-06, // 1189
    5.325383747219143e-05, // 1190
    4.530667432342379e-07, // 1191
   -9.467553096311647e-10, // 1192
    5.376702382189298e-01, // 1193
    4.691057593355744e-07, // 1194
   -1.406885305409208e+00, // 1195
    3.897646687700640e-03, // 1196
   -1.468170994755627e-01, // 1197
    2.665515601185386e-08, // 1198
   -2.770039385904603e-05, // 1199
    1.496375844154153e-05, // 1200
    7.045568669346408e-05, // 1201
    3.557911002109072e-08, // 1202
    8.951865901263603e-01, // 1203
    5.383099611235235e-07, // 1204
   -1.203407506792164e-06, // 1205
   -1.015324577661838e-03, // 1206
    5.854233858430814e-02, // 1207
    6.065809632422961e-06, // 1208
    1.786821668706982e-01, // 1209
   -8.804167036823397e-07, // 1210
   -3.162189465828143e-03, // 1211
   -4.665442363488362e-01, // 1212
   -4.488097596954908e-04, // 1213
   -4.213466360229386e-01, // 1214
   -1.068635563129491e-02, // 1215
    3.689207443319747e-02, // 1216
   -4.749774392934398e-05, // 1217
   -2.207002576726014e+00, // 1218
   -1.610088853130000e+00, // 1219
   -2.376268890921698e-01, // 1220
   -9.803484246312749e-01, // 1221
   -5.474820238334116e-08, // 1222
   -6.930076675171602e-02, // 1223
   -1.392477750114692e-02, // 1224
    2.497457145673979e-02, // 1225
   -1.825023080818104e-06, // 1226
   -9.676428821294891e-01, // 1227
    2.411236891365109e-02, // 1228
    8.350740063812097e-08, // 1229
    1.255109164533585e-06, // 1230
    1.919239403351453e-03, // 1231
    4.538247731693507e-07, // 1232
   -2.263318299476091e-06, // 1233
   -1.800682794438939e-01, // 1234
    1.743108027269142e-01, // 1235
   -1.320487069282232e-07, // 1236
    6.517488730908138e-03, // 1237
    1.261799265260798e-03, // 1238
    2.052893037286076e-01, // 1239
    8.169014264211737e-08, // 1240
   -4.065943068862063e-08, // 1241
   -2.805223114971856e-04, // 1242
   -1.282055952798102e+00, // 1243
   -3.930557536730457e-01, // 1244
    1.293201891619785e-03, // 1245
   -1.040198981144355e-03, // 1246
    2.884480876714727e-07, // 1247
   -4.653552882343884e-02, // 1248
   -2.759682756849623e-03, // 1249
   -1.086902192704586e-05, // 1250
    3.436095157846600e-02, // 1251
   -1.859560887852559e-03, // 1252
    1.803996018991777e+00, // 1253
   -1.002576726292572e-06, // 1254
   -1.697568796503292e-01, // 1255
    1.905120613477966e-04, // 1256
    6.420936684241820e-06, // 1257
   -7.273769275161617e-07, // 1258
   -2.944610338692302e-11, // 1259
   -3.891349634241714e-04, // 1260
    4.096016552409659e-07, // 1261
   -4.204928811401917e-07, // 1262
    2.133662085094102e+00, // 1263
   -3.929604691932973e-01, // 1264
   -4.399000483729544e-05, // 1265
    3.094782950867098e-01, // 1266
   -2.398367080913673e+00, // 1267
    1.241614309945110e+00, // 1268
    1.623997011818103e+00, // 1269
   -1.771407471113624e-01, // 1270
   -2.570941785572449e-02, // 1271
    1.226837642526394e-01, // 1272
    5.712947403786434e-07, // 1273
    1.153823910710040e-02, // 1274
    1.034305715063490e-05, // 1275
    9.617842871480939e-04, // 1276
    1.764905886589016e-03, // 1277
   -1.764190364505530e-05, // 1278
   -8.074490875963366e-05, // 1279
   -7.395091841117034e-01, // 1280
   -1.637536541882405e-05, // 1281
   -3.927135287518621e-06, // 1282
   -1.648580821400922e-05, // 1283
   -1.550457085759167e-01, // 1284
    8.102601057066151e-03, // 1285
    1.271043341670797e-06, // 1286
   -1.430521688612692e-05, // 1287
   -4.873953026227149e-01, // 1288
    7.654525086822327e-03, // 1289
    1.155974565258662e-07, // 1290
   -1.121394854518929e-05, // 1291
    7.355761625447141e-02, // 1292
    2.577348372408893e-01, // 1293
   -1.535176642894702e-04, // 1294
    1.980284983418446e-01, // 1295
   -1.690500961509127e-03, // 1296
   -1.822428003716820e-07, // 1297
    3.255713691213252e-01, // 1298
    2.715480590838026e-03, // 1299
   -6.335354668690255e-06, // 1300
   -8.641706258446682e-01, // 1301
   -2.690286881666514e-07, // 1302
   -1.071519436040821e-02, // 1303
   -1.016992492213905e-02, // 1304
    7.784597081723418e-05, // 1305
    1.664926509525402e-04, // 1306
   -3.317201336823689e-04, // 1307
    9.976540643542330e-03, // 1308
   -1.740713425584459e-03, // 1309
    2.796166891779115e-03, // 1310
    8.623226724350244e-03, // 1311
   -5.725291169323168e-07, // 1312
    2.462930770375450e-04, // 1313
    9.211473909369246e-02, // 1314
    2.256401139853752e-04, // 1315
   -2.959000724844163e-05, // 1316
    3.936236898768710e-04, // 1317
   -1.046070133672268e-06, // 1318
   -1.499696996026450e-06, // 1319
    1.232121439879133e-01, // 1320
    6.467650747159335e-01, // 1321
    5.923641442228103e-05, // 1322
   -2.356216625037546e-03, // 1323
   -1.269949096113969e-02, // 1324
   -2.254686495917352e-04, // 1325
   -6.725737061494542e-07, // 1326
   -1.024336169874263e-03, // 1327
   -3.790897850433578e-05, // 1328
   -1.805764682368359e-03, // 1329
   -4.374970462916862e-04, // 1330
   -4.986603908905026e-04, // 1331
    7.650630925992442e-05, // 1332
   -2.381139465540841e-04, // 1333
   -3.586611239826313e+00, // 1334
    5.012253478741911e-05, // 1335
    5.806801881298792e-03, // 1336
    1.061548291762702e+00, // 1337
    1.325926972298648e-05, // 1338
   -4.399450731759303e-09, // 1339
   -3.796972621699378e-03, // 1340
   -1.762253109065035e+00, // 1341
    1.446022460785800e-07, // 1342
    1.441920163584259e-01, // 1343
   -2.481520275504007e-07, // 1344
    5.320503655803750e-09, // 1345
    3.102910625183299e-07, // 1346
   -2.287524186939792e+00, // 1347
    6.100667284769166e-07, // 1348
   -1.078900028892829e-02, // 1349
    2.452589669986505e-04, // 1350
   -2.996633439627502e+00, // 1351
   -1.719863315788766e-06, // 1352
   -4.288441143403000e-05, // 1353
    6.514479834794867e-01, // 1354
   -4.797868922891423e-02, // 1355
   -6.784771867748191e-04, // 1356
   -3.870598338290888e-07, // 1357
   -1.301181786539757e-06, // 1358
   -1.006797408702767e-03, // 1359
   -1.075076578423131e+00, // 1360
    4.439064255207979e-02, // 1361
    1.868906303612707e+00, // 1362
   -3.426774639387401e-06, // 1363
   -3.573606760520294e+00, // 1364
    3.500435351841306e-05, // 1365
   -2.749350876564922e-05, // 1366
    5.755489286155934e+00, // 1367
   -1.799300071135455e-04, // 1368
    9.841464135590184e-04, // 1369
    3.307029426315107e-03, // 1370
    2.864776468902562e-02, // 1371
    2.664960531617710e-04, // 1372
   -1.021404139774994e-06, // 1373
   -2.844154191338790e-04, // 1374
   -3.074742931051401e-01, // 1375
   -5.898547800193739e-02, // 1376
   -1.321517238107895e+00, // 1377
   -1.712498195211914e-02, // 1378
    1.195620769441610e-04, // 1379
   -1.171491444141481e+00, // 1380
    4.848992122531825e-02, // 1381
   -3.419402531419012e-04, // 1382
    1.414276083891514e-03, // 1383
    7.467164142140305e-03, // 1384
    2.302496470456551e-06, // 1385
    9.671389207615852e-04, // 1386
    1.440380741519125e-04, // 1387
   -1.701194778088796e-05, // 1388
    2.415000239211017e-01, // 1389
   -1.458885871425188e-01, // 1390
   -4.639345267338333e-02, // 1391
   -6.820127513234638e-01, // 1392
   -3.842736109835357e-04, // 1393
    9.889627468728131e-06, // 1394
    2.594083638582413e-03, // 1395
    5.653436053401351e-05, // 1396
    1.069218559144817e+00, // 1397
    8.271933822512987e-03, // 1398
    1.958249937118753e-05, // 1399
    3.311308394736286e+00, // 1400
    1.267493905061928e-04, // 1401
    2.144026328119058e-05, // 1402
   -3.822027803920576e-08, // 1403
    1.216594932876425e+00, // 1404
   -8.067980750540040e-06, // 1405
    1.094649866694575e-01, // 1406
    1.739895382949358e-04, // 1407
   -1.155325444524232e-09, // 1408
   -3.154964775090615e-07, // 1409
   -7.137752141841762e-06, // 1410
   -2.028444010211143e-03, // 1411
    1.954058254753838e+00, // 1412
    4.729192045446428e-04, // 1413
    5.597756825541414e-02, // 1414
    4.356424438595501e-02, // 1415
    5.642062988025096e-06, // 1416
    7.253300546068899e-04, // 1417
   -2.427275017605819e+00, // 1418
    3.520384343627241e-02, // 1419
    6.379439508960065e-04, // 1420
   -8.850872293771081e-04, // 1421
    9.536937055003654e-06, // 1422
    1.169910002422583e-01, // 1423
    4.867377757021301e-01, // 1424
   -3.587652164220401e-01, // 1425
    2.744503575155647e-04, // 1426
    3.623970512447203e-06, // 1427
    2.723816352119443e-04, // 1428
    1.622727906266817e-03, // 1429
    7.822981384060661e-03, // 1430
    1.601937763831218e-04, // 1431
   -4.894996470564802e-05, // 1432
    1.139325702842102e-01, // 1433
   -2.049851385686532e-05, // 1434
   -5.579181362874297e-01, // 1435
   -1.897405284283813e-05, // 1436
   -4.188625403043712e-08, // 1437
    3.407854959467673e-08, // 1438
   -4.697234335700841e-04, // 1439
   -4.104880537258690e-01, // 1440
    4.172387207831836e-01, // 1441
    6.521449800328483e-03, // 1442
    3.182371219374548e-01, // 1443
   -2.325163331755630e-07, // 1444
    6.917572217749169e-03, // 1445
   -8.123809020361830e-02, // 1446
    5.791602598305672e-07, // 1447
   -7.339968177548965e-04, // 1448
    1.518211461210150e+00, // 1449
   -1.976587827274409e-07, // 1450
   -8.670107780411338e-05, // 1451
    2.131072678792638e-01, // 1452
   -1.277272419825320e-03, // 1453
   -2.452812415496905e-07, // 1454
   -7.876644829290262e-05, // 1455
    4.709818266355563e-05, // 1456
    2.031502273072009e-07, // 1457
    1.781652834696346e-03, // 1458
    1.305455828338528e-06, // 1459
    3.938170007028436e-05, // 1460
    4.874012572684768e-04, // 1461
    5.479818045402341e-04, // 1462
   -4.831240995097575e-07, // 1463
   -7.203287545105652e-01, // 1464
    3.282046064581701e-01, // 1465
   -1.776593532927855e-06, // 1466
   -3.729726060353320e-04, // 1467
    8.431462826900253e-07, // 1468
    5.907343511286554e-07, // 1469
    1.085750675344977e-03, // 1470
   -2.200612666979521e-06, // 1471
   -1.391051664614009e+00, // 1472
   -2.707834075234017e-02, // 1473
   -2.927551188590118e-08, // 1474
   -7.282311781937618e-04, // 1475
    9.908256628756029e-05, // 1476
    1.426079455706159e-02, // 1477
   -2.811015828002660e-02, // 1478
    3.742331483479812e-04, // 1479
   -4.864842503009996e-01, // 1480
    7.469222219042655e-01, // 1481
    6.735801621753458e-01, // 1482
    9.342500523341082e-04, // 1483
   -5.918612926157767e-04, // 1484
   -2.619295024657327e+00, // 1485
   -1.098368004144598e-02, // 1486
   -2.380355294302801e-05, // 1487
    2.123735955414004e-09, // 1488
    1.195962774183602e-02, // 1489
   -1.090034539349260e+00, // 1490
    2.320294173091762e-07, // 1491
    5.052987953731422e-02, // 1492
   -7.457067608878115e-04, // 1493
   -1.941811184045946e-06, // 1494
   -3.860617881819844e-02, // 1495
    3.073461022644765e-05, // 1496
   -8.392614857650558e-06, // 1497
   -2.267779441957986e-07, // 1498
   -1.844517243417292e-05, // 1499
   -1.207672172307544e-04, // 1500
   -2.977847273500137e-01, // 1501
    1.416957428364425e-03, // 1502
   -8.809920551849865e-02, // 1503
    1.951517999550202e-01, // 1504
    9.954867996441164e-04, // 1505
   -6.173980170428097e-02, // 1506
   -1.380326413470397e+00, // 1507
   -1.042574558235425e-08, // 1508
    9.841694984579666e-03, // 1509
    1.194601672486430e-10, // 1510
    5.170519778449881e-06, // 1511
   -2.152257331655391e-03, // 1512
    2.906572036224753e-06, // 1513
   -5.511946818785667e-08, // 1514
    4.192236162204334e-03, // 1515
   -8.096413122486872e-02, // 1516
   -7.868138530999580e-01, // 1517
   -3.703313803914246e-04, // 1518
    6.772635869202161e-09, // 1519
    2.383208332006990e-05, // 1520
    1.039539470660615e+00, // 1521
    7.201051297554507e-02, // 1522
    5.419811345458303e-05, // 1523
    4.096217578059846e-02, // 1524
   -1.151863879058401e-03, // 1525
   -1.002642420987798e-02, // 1526
    7.700908345525371e-01, // 1527
   -2.683839171044810e-10, // 1528
    1.224976704382621e-08, // 1529
   -1.732975813174649e-01, // 1530
   -5.949083149731410e-01, // 1531
    9.942245180619338e-06, // 1532
    4.508896741966291e-05, // 1533
   -1.906743021766640e-02, // 1534
    1.060114038032088e-09, // 1535
   -2.642163348561124e-03, // 1536
   -1.728697123270470e-06, // 1537
    1.991451069415141e-05, // 1538
   -6.552501507632413e-10, // 1539
    6.479481896157996e-03, // 1540
    3.248950602927954e-02, // 1541
    6.359111339531656e-03, // 1542
    3.862210290908913e+00, // 1543
    7.529416243052342e-06, // 1544
   -4.678261902376278e-06, // 1545
    1.249116272193138e-03, // 1546
   -6.241567433553264e-04, // 1547
    2.167016010025492e-07, // 1548
    9.882555662824327e-08, // 1549
   -1.998560200049982e-04, // 1550
   -3.492309579781332e-02, // 1551
   -2.815616693786905e-02, // 1552
    2.342033487859676e-01, // 1553
    1.145500122947318e-06, // 1554
   -3.748833243367484e-05, // 1555
   -1.689627082795220e-05, // 1556
    2.321766256621040e-02, // 1557
    8.029718620640556e-01, // 1558
   -2.705600206130775e-02, // 1559
    2.150620123265653e-03, // 1560
   -1.594711636455038e-04, // 1561
    1.890271823555901e-06, // 1562
    1.892239392343741e-09, // 1563
   -3.075621280814776e-07, // 1564
    4.080271825903125e-08, // 1565
   -6.658017754029344e-05, // 1566
   -3.624648120650025e-03, // 1567
    1.604029910344576e-03, // 1568
   -5.837588612731651e-01, // 1569
   -3.829706947143841e-05, // 1570
    1.298403155267304e-09, // 1571
    4.608670481664499e-06, // 1572
   -1.800772530672543e-03, // 1573
    1.314472207283895e-07, // 1574
    4.347306564387026e-09, // 1575
   -1.069848378647749e-04, // 1576
    2.178094285996951e-09, // 1577
    1.492879557764722e-02, // 1578
    2.186118504913764e-04, // 1579
    9.565539801312733e-03, // 1580
   -2.902644840381338e-10, // 1581
    1.031493163285069e-02, // 1582
    1.502063917616423e-02, // 1583
    5.717317086738603e-01, // 1584
    7.872121433633103e-02, // 1585
   -9.174121130054772e-04, // 1586
    5.109775020872133e-06, // 1587
   -9.265296594062169e-03, // 1588
   -2.436166908539570e+00, // 1589
    2.429872722123583e-07, // 1590
   -1.728854748435947e-01, // 1591
   -1.240792895305660e-05, // 1592
   -2.122359954786880e-10, // 1593
    1.829224227618071e-02, // 1594
   -4.185234919410971e-06, // 1595
    6.349476237403607e-09, // 1596
    1.689187016475920e+00, // 1597
   -4.819363874439860e-04, // 1598
   -2.605401680108956e-02, // 1599
   -1.210801921076876e-06, // 1600
   -6.950845485879713e-08, // 1601
   -4.088004538136713e-05, // 1602
   -4.215059564899814e-04, // 1603
    2.844955042583189e-07, // 1604
   -2.489810861095425e-01, // 1605
    1.085338959962194e-05, // 1606
    3.260603682205517e-06, // 1607
   -1.316802320751973e-04, // 1608
   -1.984648241202073e-02, // 1609
   -1.394490287048011e-03, // 1610
   -1.034321804263411e+00, // 1611
   -7.381201768774599e-04, // 1612
    4.239040736996922e-02, // 1613
   -8.199095003708324e-01, // 1614
   -8.711511424676068e-06, // 1615
    4.205848071910118e-05, // 1616
   -2.706663280260330e-04, // 1617
    6.964703420852778e-05, // 1618
    2.866897318098620e-05, // 1619
   -1.290268166722026e-06, // 1620
    3.794936840843779e-02, // 1621
    6.461571865287229e-04, // 1622
    1.194703406918508e-06, // 1623
    2.632577319098833e-03, // 1624
   -3.427437260369675e-05, // 1625
   -1.141663314434046e-02, // 1626
    3.007812782821297e-04, // 1627
    2.367468566429132e-06, // 1628
    1.229748041779795e-04, // 1629
   -4.625034940677523e-02, // 1630
   -1.183207636569763e-09, // 1631
    2.102375192479460e-08, // 1632
   -3.273003821337823e-05, // 1633
    5.374879247200318e-04, // 1634
    1.242292615549167e-08, // 1635
    9.972744635826343e-03, // 1636
   -8.599603568469663e-01, // 1637
    5.882243964209298e-05, // 1638
   -7.872089847895212e-06, // 1639
   -2.039644962604369e-02, // 1640
   -1.789520849596363e-02, // 1641
    3.320319874090479e-07, // 1642
    5.193665110212721e-06, // 1643
   -1.213843290690781e+00, // 1644
   -9.713030032641588e-05, // 1645
   -1.995581986223016e-02, // 1646
   -2.723217006699254e-05, // 1647
   -1.051552315695262e-01, // 1648
   -2.421567873366899e+00, // 1649
   -1.393632125535981e-01, // 1650
    4.913547087820713e-04, // 1651
   -1.624462660257759e-02, // 1652
    2.226764802477426e+00, // 1653
    6.647110296520179e-08, // 1654
    2.497380123396095e-06, // 1655
    1.943325582444782e+00, // 1656
    1.170412730118414e-01, // 1657
    2.332682625454333e+00, // 1658
    1.143095947924296e-09, // 1659
    5.252699409042931e-07, // 1660
    2.376416346908039e-03, // 1661
    4.537016043045368e-06, // 1662
    1.814490493200365e-07, // 1663
   -1.085512037165969e-03, // 1664
   -1.629393557503008e-05, // 1665
    8.514729750268150e-04, // 1666
   -2.041130524469102e-04, // 1667
   -1.876296177942788e-08, // 1668
    7.741295144331912e-01, // 1669
    2.262279103880176e-02, // 1670
    3.701192350767317e-04, // 1671
   -7.354287900262745e-04, // 1672
   -8.735494994640705e-06, // 1673
   -3.645523493397482e-05, // 1674
    2.525487915273493e-05, // 1675
   -1.545933140374055e-02, // 1676
    9.288063802277619e-03, // 1677
    4.920319618722216e-08, // 1678
    1.065660315664085e-04, // 1679
   -1.489460855716172e-06, // 1680
   -5.829600460226174e-10, // 1681
    2.671499756954584e-05, // 1682
   -2.962395372783326e-02, // 1683
   -2.638979598780550e-06, // 1684
    4.266617465583983e+00, // 1685
    8.086175030531134e-07, // 1686
    1.471949398165780e-03, // 1687
    4.405344674984371e-05, // 1688
   -2.936077241042644e-06, // 1689
    2.968098085634813e-02, // 1690
    7.050655788564870e-04, // 1691
   -1.226979446151133e-06, // 1692
   -2.496098090034641e-01, // 1693
    2.924977429298872e-02, // 1694
   -4.908536201087553e-07, // 1695
   -6.542887988364180e-01, // 1696
    7.156293581127307e-04, // 1697
   -2.836420167660835e-03, // 1698
   -3.890043081347643e-04, // 1699
   -3.145099223735770e-07, // 1700
   -9.886364383992007e-01, // 1701
    4.804145216989856e-08, // 1702
   -3.507080471180096e-03, // 1703
    1.422065332096139e-02, // 1704
   -6.466096593634495e-03, // 1705
   -9.898081123747782e-01, // 1706
   -1.460626079374053e-07, // 1707
   -2.268195595152255e-07, // 1708
   -1.056243790814441e-04, // 1709
   -3.107317631838024e-02, // 1710
    2.182417430428626e-06, // 1711
    2.303147282869899e+00, // 1712
    1.513983905684768e-05, // 1713
   -1.166538660651637e-03, // 1714
   -5.976249492212776e-02, // 1715
   -5.513596099257557e-08, // 1716
    5.093390845235585e-01, // 1717
    3.577577474841129e-04, // 1718
    8.825503041104670e-01, // 1719
    5.237310639042021e-01, // 1720
    1.514534212444472e+00, // 1721
   -3.814730793443279e-07, // 1722
   -4.008631810040458e-02, // 1723
    9.802075122372320e-02, // 1724
    3.903001509692295e-07, // 1725
   -6.707027981841691e-09, // 1726
   -2.436585128629641e-01, // 1727
   -7.787448900654916e-06, // 1728
    7.115061341780704e-06, // 1729
   -2.357496409246606e-04, // 1730
   -2.078417848660740e-02, // 1731
    1.129927113306047e-03, // 1732
    1.230376983769784e-09, // 1733
    6.815571617847237e-02, // 1734
    1.337663370931813e-04, // 1735
   -3.103960161083926e-01, // 1736
    9.010250868830296e-09, // 1737
    2.423675199324475e-06, // 1738
   -4.480836257067920e-06, // 1739
    1.157233533471363e-06, // 1740
   -6.976448233155327e-01, // 1741
    8.454729725873986e-05, // 1742
    1.948523658636492e-03, // 1743
   -4.251150860647927e-03, // 1744
   -3.762770245574431e-08, // 1745
    1.263462267905332e-06, // 1746
    8.805462018072524e-01, // 1747
    1.332098960167935e-02, // 1748
    9.090798242190338e-05, // 1749
    3.602025138893490e+00, // 1750
    4.587452728561730e-01, // 1751
    3.095052317410095e-02, // 1752
    2.859450430718346e-04, // 1753
   -4.579628072250448e-02, // 1754
   -3.970463854591577e-09, // 1755
   -2.596127657090720e-01, // 1756
   -1.614047301710331e-03, // 1757
   -8.046411828275898e-02, // 1758
    6.141571358888712e-05, // 1759
   -1.152871026491459e-01, // 1760
   -7.593717482929805e-01, // 1761
    1.062441585694441e-06, // 1762
    7.236728440575309e-04, // 1763
   -7.817787174423393e-04, // 1764
    2.626896287863225e-04, // 1765
    1.342556098426714e-02, // 1766
    2.411746475927123e-04, // 1767
    2.251886387004770e-05, // 1768
   -2.765795005870929e-04, // 1769
   -1.051060002005444e-08, // 1770
   -7.311993834076996e-01, // 1771
    1.011063705783955e-05, // 1772
   -2.921362155042846e-03, // 1773
    6.262494203481991e-07, // 1774
   -3.992082594990334e-05, // 1775
    8.191702086590520e-06, // 1776
   -1.797544474758187e-07, // 1777
   -2.725718363382107e-03, // 1778
   -2.096558746578165e-01, // 1779
   -3.525714401645554e-01, // 1780
   -6.290043297333722e-02, // 1781
    1.431361517057873e-04, // 1782
   -1.515738919773198e-04, // 1783
    2.406113985906117e-04, // 1784
    1.229979225280536e-07, // 1785
   -1.486834875621362e-05, // 1786
    1.906965471011837e-04, // 1787
   -9.770572296232201e-02, // 1788
    3.875717968701841e-01, // 1789
   -5.267505232684652e-02, // 1790
    9.951107730525600e-02, // 1791
    4.661714844818986e-07, // 1792
    1.919674889099165e+00, // 1793
    2.159691887424593e-06, // 1794
    7.072614835028429e-03, // 1795
    5.567747734381424e-02, // 1796
    1.108788708752360e-03, // 1797
    3.178192337792440e-02, // 1798
   -3.877501753543959e-07, // 1799
   -2.882325311833093e-03, // 1800
   -7.118171407616270e-08, // 1801
    9.838090042380668e-01, // 1802
   -3.074414476345974e-08, // 1803
    9.385401536550251e-01, // 1804
    3.183311488047281e-05, // 1805
    3.019822050280350e-04, // 1806
    9.585924637186287e-01, // 1807
    6.729083877619838e-07, // 1808
    5.304688662507382e-04, // 1809
   -4.223573245587330e-02, // 1810
    2.555447503807474e-02, // 1811
    2.435881643279679e+00, // 1812
    4.094716776863910e+00, // 1813
   -7.247931432750918e-06, // 1814
    9.027596462037531e-04, // 1815
   -1.607985249896117e-06, // 1816
   -9.929373411917794e-05, // 1817
   -1.212810670919664e-01, // 1818
    6.928792523353325e-02, // 1819
    1.472787534190053e-04, // 1820
   -3.628360609684837e-05, // 1821
   -6.647692730959778e-03, // 1822
    3.994670460516083e-10, // 1823
    2.511369921413526e-08, // 1824
    2.993976216815472e-05, // 1825
   -7.635210359023059e-05, // 1826
    5.453119831319176e-02, // 1827
   -1.054030563562104e-05, // 1828
    8.485781406292831e-02, // 1829
    1.823255818385418e-01  // 1830
    };

    for (int i = 0; i< 1831; i++)
      threebodyfit[i] = threebodyfit_cp[i];

  } else if (ion == "Br") {

    //fit-h4o2br_ccsdtf12_avtz_cp_ts_w_nm_highenergyconfigs_scans     04/25/16
     
    R3I =       0.000000000000000e+00; // A
    R3F =       7.000000000000000e+00; // A
    
    KHH_INTRA = -1.678381203838004e+00; // A^(-1)
    KOH_INTRA =  1.579410940607007e+00; // A^(-1)
    
    KHH =       3.233275920432773e-02; // A^(-1)
    KOH =       5.382597769657202e-01; // A^(-1)
    KOO =       8.250164801742468e-02; // A^(-1)
    
    KXO =       1.253723917610167e-01; // A^(-1)
    KXH =       4.439795081951433e-01; // A^(-1)
    
    DHH_INTRA = 1.526427928788355e+00; // A
    DOH_INTRA = 3.431762235778779e+00; // A
    
    DHH =       1.223975182221622e+01; // A
    DOH =       1.115003763285723e+01; // A
    DOO =       9.146822362117812e+00; // A
    
    DXO =       2.624878079566018e+00; // A
    DXH =       1.402640536052922e+01; // A    

    double threebodyfit_cp[] = {
   -5.616956032697001e-02, // 0
    2.600414960744533e-01, // 1
    4.632017325597402e-01, // 2
   -1.831871696905046e+00, // 3
    2.324534944472428e+00, // 4
    2.321259972825422e+00, // 5
   -1.322348043165233e+00, // 6
   -7.695344061085135e-01, // 7
    1.778721982171829e+00, // 8
   -1.157001662253039e+01, // 9
   -2.669548685612225e+00, // 10
    4.480268509394407e-01, // 11
   -5.078095702982170e+00, // 12
    2.047742031720532e-03, // 13
    1.430051943073742e+00, // 14
   -7.954616245462023e-03, // 15
    7.179020822064057e+00, // 16
    2.155902930174001e-01, // 17
    2.402531838957384e-01, // 18
    2.675444718973473e-01, // 19
    2.130411293904872e-01, // 20
    4.433943843166382e-01, // 21
   -1.694498924099349e-01, // 22
    2.457184065448924e-03, // 23
   -8.306396223837548e-01, // 24
    1.549618120706676e-01, // 25
    2.709734457437810e-01, // 26
    3.440513403168428e-04, // 27
   -5.396150869681977e-02, // 28
   -2.724539226938961e+00, // 29
   -9.193926672809235e-01, // 30
   -2.023875010015196e-01, // 31
   -9.805756975831488e-01, // 32
   -5.925612328154212e-04, // 33
    5.446798126404429e-02, // 34
   -7.141204693438705e-01, // 35
    1.172704756132724e-04, // 36
   -3.940740524693024e+00, // 37
    4.304423720649974e-02, // 38
    1.603635661332401e-03, // 39
   -2.091850257406176e-01, // 40
    3.099093535014918e+00, // 41
   -6.968309007925727e-02, // 42
   -1.038973910845513e-03, // 43
    3.944989416833235e-04, // 44
    5.114539306793296e-01, // 45
   -3.585555153498012e-02, // 46
   -1.961512179348585e+00, // 47
    7.875088953307704e-01, // 48
    9.467240997315722e-01, // 49
    4.303830420450783e-01, // 50
   -3.493954836965100e-02, // 51
    1.149350695374558e+00, // 52
    7.776543768021756e-03, // 53
   -1.150074586552519e-02, // 54
   -4.454144375026114e-03, // 55
   -6.952195231585335e-04, // 56
   -2.294517641378161e-04, // 57
    5.303280442983618e+00, // 58
   -3.554852692919995e+00, // 59
   -9.855280135634729e-01, // 60
   -7.223928059167606e-02, // 61
   -2.534375805946286e+00, // 62
   -1.590033475142575e-04, // 63
   -1.783160696358343e-04, // 64
    3.022225200957179e-01, // 65
    5.094075326520104e+00, // 66
    3.621495613192859e-03, // 67
   -2.569161684793635e-04, // 68
   -1.736125086174126e-01, // 69
    5.900087502828705e-04, // 70
    1.248706753723726e+00, // 71
   -9.435664514522360e-03, // 72
   -2.078381519320501e+00, // 73
    4.835630298182226e-05, // 74
   -1.241168841745682e+00, // 75
   -1.963661640320641e+00, // 76
   -7.106191250909577e-04, // 77
   -4.120904362501503e+00, // 78
   -3.175621706349086e+00, // 79
    1.007138467509767e-01, // 80
    7.903149014774236e-01, // 81
    3.664176885296121e-04, // 82
   -3.770478755548750e+00, // 83
    9.916553744976612e-05, // 84
    3.690934617886268e+00, // 85
    1.785809300348859e-03, // 86
    7.925759021072892e-04, // 87
   -1.566925066767045e-01, // 88
   -4.044163874302042e-03, // 89
   -1.817439786764512e-01, // 90
   -3.953673615235090e-02, // 91
   -2.948716049102837e-01, // 92
   -6.714603901796504e-01, // 93
    2.759330439398516e-01, // 94
   -5.952595399762242e-01, // 95
    4.712691937244008e-02, // 96
   -3.874118632789450e-02, // 97
    1.055533045066603e-02, // 98
    1.423262408784363e+01, // 99
    2.805443506045460e+00, // 100
    2.409391817548803e-04, // 101
    3.355419020985113e+00, // 102
   -1.547049692478915e-01, // 103
    7.479204999992385e-03, // 104
   -1.305456574404799e+00, // 105
    6.689425953642160e+00, // 106
   -1.929070191526047e-01, // 107
    1.144343160044593e+00, // 108
    1.475471393954795e+00, // 109
   -4.093439704823049e+00, // 110
    3.728787578079851e-01, // 111
    1.103709325962084e-02, // 112
   -4.260127642704563e+00, // 113
   -2.471690950818779e-03, // 114
    2.774418352787423e+00, // 115
   -1.315466311636441e+00, // 116
   -1.669772591522403e-04, // 117
    1.429973697364382e+00, // 118
    2.362665217310327e-01, // 119
    6.870263156335456e-02, // 120
   -5.453370396053324e-04, // 121
    3.837080702407507e+00, // 122
    1.551138303811221e-01, // 123
   -1.022693534148698e-03, // 124
    9.518258407523510e-02, // 125
   -2.229954083477601e+00, // 126
   -3.750551418281607e-01, // 127
    1.028265346545424e-02, // 128
   -6.131602742740246e-04, // 129
    8.738314188412624e-01, // 130
    8.041275814344315e-02, // 131
   -7.183432151828691e-05, // 132
   -1.052554974953253e-01, // 133
    1.902586031941264e-03, // 134
    9.037031854862124e-02, // 135
    5.380996628984044e+00, // 136
   -3.308178775791878e-02, // 137
   -1.381787249651480e-01, // 138
   -3.854271488172192e-02, // 139
   -2.886451395581286e-01, // 140
   -3.770339600039460e-02, // 141
   -8.986746462684290e-01, // 142
    1.629173093914391e+00, // 143
    3.362377845347766e+00, // 144
   -8.505916710654813e-01, // 145
    5.437386626068900e-03, // 146
    2.662570884662352e-02, // 147
   -3.268731350460097e+00, // 148
    2.162363261378259e-01, // 149
   -7.674425085555762e-02, // 150
    7.975279461578621e-05, // 151
   -6.541218915725622e-01, // 152
    4.069438375610036e+00, // 153
   -3.286275748316878e+00, // 154
   -4.183199754700229e-01, // 155
   -1.384000405073348e-01, // 156
    4.225858889283666e+00, // 157
    4.523556835584833e+00, // 158
   -3.334347069650689e+00, // 159
   -2.368853764746107e+00, // 160
   -3.434341616189376e-01, // 161
   -5.053286679353227e-03, // 162
    9.399809754858343e-01, // 163
   -2.511148386773940e-04, // 164
    9.572790073176086e-06, // 165
   -2.012368121435728e-03, // 166
    8.312752960480655e-05, // 167
    3.151348537271893e-02, // 168
    2.534577454941173e-03, // 169
    6.019137286324835e-08, // 170
    2.690922175292820e-07, // 171
    1.819302015936291e-07, // 172
   -4.231886629760631e-05, // 173
    2.415513734146943e-04, // 174
    4.225435106228982e-04, // 175
   -1.294892513503671e-04, // 176
   -1.116362984567238e-01, // 177
    3.511419908729652e-04, // 178
   -6.180678219236840e-02, // 179
   -2.115962002406317e-02, // 180
    2.349839853194656e-02, // 181
    5.504251652380218e-01, // 182
   -4.099316244771662e+00, // 183
    3.659006041229334e-08, // 184
   -2.180975631356832e-03, // 185
    1.170899133034195e-01, // 186
    6.661505760850248e-07, // 187
    1.392501610495057e-03, // 188
    3.673265443070076e-01, // 189
    1.792267878620101e+00, // 190
   -3.057186803404158e-01, // 191
   -1.674944212646647e+00, // 192
    5.294914884481157e-06, // 193
   -4.585071986050037e+00, // 194
    5.098949394771848e-04, // 195
   -3.785171466008518e-09, // 196
   -1.129757055882745e-03, // 197
   -2.877124900846033e-06, // 198
   -2.188502870757272e-03, // 199
    6.877611276873900e-04, // 200
   -3.520612071681953e-02, // 201
   -4.625798829017649e+00, // 202
   -3.143161420858717e-03, // 203
    1.368145794376822e-05, // 204
   -2.911785572919633e-04, // 205
    1.118596124813761e+00, // 206
   -1.717190060089068e-07, // 207
   -3.103392356367171e-06, // 208
    2.689492012160826e-01, // 209
    7.123170441394758e-05, // 210
   -1.997174662027377e-05, // 211
   -2.767523369627252e-05, // 212
   -1.906983841272576e-02, // 213
   -3.564252083518756e+00, // 214
    1.020487675016194e-04, // 215
   -4.613612228122615e+00, // 216
   -1.930601365999438e-03, // 217
    6.161930617795707e-03, // 218
    5.021055513945844e-02, // 219
    5.923638224630274e-01, // 220
    4.888348612148787e-01, // 221
   -4.890342660911867e-04, // 222
    1.902257023070490e-03, // 223
   -1.740937492521143e+00, // 224
   -4.690715117675374e-02, // 225
   -2.832881416358992e+00, // 226
   -2.170261866459562e-03, // 227
    3.229066703038044e-01, // 228
   -7.521146543316731e-02, // 229
    3.887164568516766e+00, // 230
   -7.239231280619942e-01, // 231
    5.339095534050017e-02, // 232
   -1.948183147176035e-04, // 233
   -9.115800966628790e-05, // 234
    1.082003507184773e+00, // 235
    1.056622025895840e-03, // 236
   -2.365076101919048e-04, // 237
    7.160948168984925e-07, // 238
   -1.196888881740896e-03, // 239
   -1.382591479005182e-07, // 240
    1.869347910996447e-08, // 241
    4.139999342134819e-08, // 242
   -3.765013166107371e-05, // 243
    1.270408096845930e-02, // 244
    3.310981228567110e-04, // 245
    1.546465304053740e-02, // 246
    4.583992941372906e-01, // 247
   -7.770735871679815e-01, // 248
   -5.015409021377223e-05, // 249
    1.092954396062632e-01, // 250
    7.593441850271518e-02, // 251
   -6.470062094376375e-03, // 252
    8.075302924818371e-07, // 253
   -7.546219714815199e-06, // 254
    2.173200395287534e-04, // 255
   -2.667312113804102e-03, // 256
    4.920737022729993e-01, // 257
    2.854742686004942e-06, // 258
   -2.401351901973410e-03, // 259
    9.719160347998395e-04, // 260
   -3.375485439453355e-06, // 261
   -8.145996118711619e-06, // 262
   -1.170216697098516e-05, // 263
   -7.666760482881909e-01, // 264
   -1.009528332327949e-06, // 265
   -3.219872432838055e-05, // 266
   -1.293176352759920e+00, // 267
    6.334775689283545e-06, // 268
    2.142489862901880e-02, // 269
   -5.883658466469584e-03, // 270
    9.793743347829458e-07, // 271
    1.541465389478057e-05, // 272
   -7.835801887986008e-06, // 273
   -2.362882528243179e-05, // 274
    1.581372298856508e-05, // 275
   -8.555816834438088e-04, // 276
   -9.569683266679155e-06, // 277
   -1.126969828079866e-04, // 278
    8.145535953717855e-04, // 279
   -2.229486552287431e-03, // 280
   -4.514257273796906e-08, // 281
   -4.375265882557313e-05, // 282
    2.433627133633804e-01, // 283
   -8.907885026313892e-04, // 284
   -7.124880849234545e-01, // 285
    1.367784443687758e-05, // 286
   -1.401453425802576e-02, // 287
   -2.553653546544473e-05, // 288
   -1.245477955999206e-03, // 289
    8.581237944727465e-04, // 290
   -1.385900576720293e-04, // 291
   -3.695429395119102e-05, // 292
   -4.783983692219575e-05, // 293
    9.258610509605251e-03, // 294
   -5.382083830927697e-04, // 295
    1.329219225570587e+00, // 296
   -6.472083874114481e-06, // 297
    2.713846155477930e+00, // 298
   -1.042592736133632e-03, // 299
    1.437204411622941e-08, // 300
    9.343404350908577e-05, // 301
    1.661984452114956e-05, // 302
   -1.547248161125892e+00, // 303
   -8.219005492204123e-04, // 304
   -6.269963590191953e-05, // 305
    2.093321938427200e-01, // 306
   -4.416153104913561e-05, // 307
   -4.926681527946127e-04, // 308
   -1.172843098822745e-03, // 309
    1.339552486771701e+00, // 310
    1.000105460401973e-01, // 311
   -7.792858009240584e-05, // 312
    1.017508207172090e-04, // 313
    2.409195489052787e-02, // 314
    1.010941637750387e-03, // 315
    1.903158584495774e-04, // 316
    3.502271634925697e-01, // 317
   -1.798272925389280e-06, // 318
   -7.708570166087252e-01, // 319
    3.697413033058063e-04, // 320
   -8.585634990246738e-04, // 321
   -3.655458189400500e+00, // 322
   -7.340682652661469e-01, // 323
    2.410904748864601e-07, // 324
    4.303629240285405e-01, // 325
   -1.700001274090877e-05, // 326
    3.205771556014127e-07, // 327
   -4.191426429819074e-05, // 328
   -3.910054407208214e-07, // 329
    1.236208321013161e-02, // 330
    3.475721748000649e-07, // 331
   -9.966320680145000e-04, // 332
   -3.223228123424965e-01, // 333
    6.821772145239094e-04, // 334
   -1.933997141473392e-08, // 335
   -1.841652432136865e-01, // 336
    9.910740055550493e-03, // 337
   -2.242551770718312e-03, // 338
   -5.614282079569888e-06, // 339
   -1.927372133484933e+00, // 340
    2.898244462558058e-08, // 341
   -7.290703328866002e-03, // 342
    7.212043263310573e-03, // 343
    3.011881601184601e+00, // 344
   -7.225162900633222e-05, // 345
    3.071680268459142e-05, // 346
   -3.787109092179689e-04, // 347
   -1.117898218122523e-03, // 348
    1.583501331044158e-03, // 349
    1.196295406783695e-02, // 350
    3.634158844914002e-06, // 351
    1.675296200973496e-06, // 352
   -8.314992996580556e-07, // 353
    5.699234648345320e-03, // 354
   -6.620645075712628e-04, // 355
   -4.539351886355604e-05, // 356
   -4.216217339269348e-06, // 357
    4.852839333897258e-04, // 358
    1.466057944696211e-03, // 359
    1.468838923407636e-06, // 360
    2.220862293560708e-02, // 361
    5.837137384674145e-01, // 362
    6.876760736129651e-06, // 363
   -3.118445575904939e-04, // 364
    1.727405776669151e-01, // 365
   -4.826022809895069e-05, // 366
    8.628766362994061e-03, // 367
    1.525779590837733e-03, // 368
    1.253564328564123e-05, // 369
   -6.457455483167078e-01, // 370
   -2.726629059341605e-08, // 371
   -2.314592153887976e-04, // 372
   -9.742061044251925e-02, // 373
   -5.842429945557380e-02, // 374
    1.703234527505917e-04, // 375
   -1.757878458226158e-01, // 376
    1.295954716969177e+00, // 377
   -2.420870325628284e-01, // 378
    2.932964261418689e-08, // 379
   -6.490976085150832e+00, // 380
    4.782119994928187e-04, // 381
    8.545841156928105e-04, // 382
   -7.339299787749243e-04, // 383
   -1.673112607574116e-01, // 384
   -7.142492515314516e-01, // 385
    1.189550202377089e-06, // 386
    4.436648277950489e-05, // 387
    1.110104944409910e-04, // 388
    6.398371659222233e-04, // 389
    9.854090122015883e-09, // 390
    2.808889104691344e-01, // 391
   -9.478987268067059e-06, // 392
   -2.088848593227082e-03, // 393
   -2.441422382920548e-03, // 394
    5.989757486522720e-02, // 395
    4.190661420535372e-03, // 396
    9.392449445879199e-05, // 397
   -1.957456267571743e-05, // 398
    5.728565201661651e-04, // 399
    2.026968824022165e-03, // 400
    4.883470227944523e-05, // 401
   -8.667976824784406e-05, // 402
   -4.336965791123956e-01, // 403
   -1.091063817626032e-04, // 404
   -2.336478677698858e+00, // 405
    9.123863678273958e-04, // 406
   -1.310139846211760e-05, // 407
   -3.199665783352689e-05, // 408
   -4.537146615807638e-05, // 409
    4.055869305451716e-03, // 410
    2.252415021864650e-05, // 411
    1.542849972666429e-01, // 412
    5.486419174835766e-01, // 413
   -5.316550041541774e-01, // 414
   -1.412705502289797e-01, // 415
    2.960787505801706e-04, // 416
   -1.814469683769726e-01, // 417
    4.755594390605760e-01, // 418
    5.371445713886587e-06, // 419
   -1.366067816695600e-03, // 420
    1.463155265823760e-05, // 421
   -4.610037911619528e-03, // 422
   -2.856412609494936e-03, // 423
    1.944930943103550e-03, // 424
    3.617082268178028e-05, // 425
   -8.001768938074810e-03, // 426
   -2.404619706247728e-03, // 427
   -1.742363478034698e-04, // 428
    8.964480610081462e-05, // 429
    6.626232650693007e-06, // 430
   -7.152977173839415e-08, // 431
   -5.084290717741566e-04, // 432
    1.214002689976927e-02, // 433
   -1.340066102916177e+00, // 434
    2.716939897059005e-02, // 435
    1.291764488567276e-02, // 436
    2.197405462674750e-02, // 437
    9.308465486273438e-04, // 438
    9.460039434887710e-04, // 439
   -2.219722495164063e-07, // 440
   -2.629769125710984e-01, // 441
    1.107350223851813e-05, // 442
    7.213916085697512e-03, // 443
   -8.861002418093623e-01, // 444
   -6.439729087773056e-04, // 445
    5.806869983886825e-05, // 446
   -1.054448015142827e-05, // 447
    2.965942908584443e-04, // 448
   -1.111002034936123e-03, // 449
    1.401485694119843e-04, // 450
   -2.067699225776777e-04, // 451
   -2.749734559831493e-04, // 452
    1.316159285995651e+00, // 453
    3.828234470812958e-06, // 454
   -3.223451652860034e-02, // 455
    1.169004679263785e-05, // 456
    1.603801797438132e-06, // 457
   -3.325721222057002e-02, // 458
    3.416605120235290e-05, // 459
    1.718472794585781e-01, // 460
    1.062992038366766e+00, // 461
   -1.705691222878483e+00, // 462
   -3.456896376133193e-04, // 463
    1.831466909224350e-03, // 464
   -3.340782455984162e-04, // 465
    9.526479491192200e-08, // 466
    1.326717197604830e-04, // 467
   -9.106104687317701e-02, // 468
    2.020050104796440e-06, // 469
   -3.244979000631150e-01, // 470
   -8.732181969297557e-02, // 471
    4.398015863542312e-08, // 472
   -7.100237722786817e-06, // 473
   -1.405720990095037e-02, // 474
   -7.200831629174267e-02, // 475
    2.233926381027592e+00, // 476
   -3.797503615316623e-01, // 477
    5.797385274356820e-08, // 478
   -1.639304617166771e-04, // 479
    1.171387278000945e+00, // 480
    2.390077175396091e-05, // 481
    1.037978997692898e-02, // 482
    4.746926454845115e+00, // 483
    4.166635283695362e-06, // 484
   -1.064351676577964e-06, // 485
    4.632203785964430e-01, // 486
   -3.307878004411002e-02, // 487
   -3.018386478862378e-01, // 488
    1.340671352421429e-03, // 489
   -8.991562989161636e-05, // 490
    9.208889922111120e-04, // 491
    1.488686205640418e-07, // 492
   -8.200004852330603e-08, // 493
   -1.738930226825097e+00, // 494
    2.136165536573014e-01, // 495
    8.123203511203920e-03, // 496
    2.121732634230719e-03, // 497
   -9.351676361060528e-06, // 498
   -5.330871709517958e-06, // 499
   -7.875507770377253e-04, // 500
    1.603524848198991e-05, // 501
    7.832001200279218e-08, // 502
    3.658263098486783e+00, // 503
    3.346774265389054e-01, // 504
    5.484516852810671e-02, // 505
   -2.867198966094771e-08, // 506
   -1.970515326446107e-03, // 507
   -1.169948470941943e-02, // 508
   -4.121668213347638e-06, // 509
   -8.544851308574242e-07, // 510
    2.556024971436555e-04, // 511
    1.042484890429334e-07, // 512
    1.276206450534376e-06, // 513
   -2.989472414257836e-03, // 514
   -3.539837298493410e-06, // 515
    2.243370532073496e-03, // 516
    6.182647055042120e-09, // 517
   -3.192962851060424e-07, // 518
   -4.329957378034536e+00, // 519
    1.032221775916996e-01, // 520
   -3.471409146105569e-06, // 521
    1.845482185708376e-04, // 522
    1.096140398435693e+00, // 523
   -1.094560985939044e+00, // 524
   -9.682236312859664e-03, // 525
   -6.757749955947992e-06, // 526
    3.779996092026229e+00, // 527
   -5.057100919198680e-06, // 528
    2.916365438623960e-06, // 529
   -4.824192869896398e-05, // 530
    3.809212526853461e-05, // 531
   -3.506130303202104e-04, // 532
   -2.624236711499011e-01, // 533
    1.465810852738361e-01, // 534
   -1.144331510902805e-03, // 535
    2.051134490373102e-02, // 536
   -1.450644891850593e-03, // 537
    2.018110544316308e-04, // 538
   -5.945900662675602e-03, // 539
   -3.537682102820927e-03, // 540
    1.424862199018495e+00, // 541
    1.533554109232760e-01, // 542
    3.018868849418073e-03, // 543
   -1.517273208933608e-03, // 544
    1.627673148383088e-02, // 545
    7.536799707428661e-01, // 546
    1.541556817393658e-03, // 547
   -1.106884724850690e-02, // 548
   -1.650191144740185e-04, // 549
    4.281879258888754e-07, // 550
   -4.700967812621715e-06, // 551
    4.622697719267369e-03, // 552
   -5.945288000610709e-02, // 553
   -1.435989514526934e-07, // 554
    7.789900730426317e-01, // 555
   -7.969003989277202e+00, // 556
    1.155045348314782e-01, // 557
    1.583237685218337e-03, // 558
    7.568669083853953e-02, // 559
    1.688948616971737e-03, // 560
   -2.368055219746203e+00, // 561
   -8.583949766598967e-05, // 562
    6.497459432804236e-03, // 563
   -5.148568515718800e-04, // 564
   -1.936463327238954e-04, // 565
   -2.971285923239385e-04, // 566
    1.521949030687720e-04, // 567
    2.721782641703802e-02, // 568
    4.060339404642750e-02, // 569
   -1.107324102179613e-05, // 570
    2.459477866380150e-06, // 571
   -5.666204977973346e-04, // 572
   -2.474951502622359e-02, // 573
    2.646368258401322e-02, // 574
   -9.760753913554978e-01, // 575
    3.380306032556170e-02, // 576
   -2.739920083090625e-06, // 577
   -9.017756879616832e-01, // 578
    2.697714235567691e-01, // 579
   -1.701952285994910e-07, // 580
    1.452932188958088e-02, // 581
    6.924940802452775e-04, // 582
    2.769945858287856e-05, // 583
    5.986607380506844e-05, // 584
   -5.189499203225572e-02, // 585
    7.699761175169824e-05, // 586
    2.067589176767226e-02, // 587
    2.809869227834312e-06, // 588
    1.580256276879859e-03, // 589
   -4.216640261567798e-02, // 590
    1.403181719951904e-01, // 591
   -3.696534559650879e-07, // 592
   -3.811804770974008e-03, // 593
    1.783123851786442e-06, // 594
    7.394349608967840e-02, // 595
   -1.369198004502690e-03, // 596
   -6.846571678333830e-04, // 597
   -2.291114882999418e-03, // 598
   -1.188804332349124e-03, // 599
    1.249248756242437e-03, // 600
   -9.198215703850761e-02, // 601
    5.361779603969540e-05, // 602
    1.811390115883764e-01, // 603
   -6.100524511543670e+00, // 604
    2.395306980215728e-01, // 605
   -1.147310922697214e-03, // 606
    3.650943580520522e-03, // 607
    5.167689682281304e-05, // 608
   -2.264763369617467e-01, // 609
    8.543910203170608e-04, // 610
    2.055884853295615e-05, // 611
    7.027556161867239e-02, // 612
   -6.369380043427164e-08, // 613
    4.258090644194535e-01, // 614
   -1.510865934666405e-02, // 615
    1.496658463044454e-05, // 616
    4.704030167183706e-08, // 617
    9.886574968890321e-05, // 618
    2.509234041013935e-02, // 619
    7.850498037354460e-02, // 620
    5.452755467771930e-05, // 621
    5.163096031166376e-04, // 622
    1.247947008571629e+00, // 623
    6.570370425395179e-05, // 624
    7.406949922985642e-01, // 625
   -1.309732480204883e-03, // 626
    1.162259775420976e-02, // 627
   -8.483133193812610e-05, // 628
   -4.800997321383601e-01, // 629
    1.900069909569473e-02, // 630
    1.737852888940347e-04, // 631
    5.135752944684877e-05, // 632
    2.012181919497445e-07, // 633
    3.484546466739402e-05, // 634
   -8.147385203030738e-04, // 635
    1.751563195628216e-05, // 636
   -2.796947375279826e-01, // 637
   -3.993454663296420e-06, // 638
    6.361929828118400e-08, // 639
   -8.605911199063509e-07, // 640
    2.669716715312264e-06, // 641
    1.681038140918297e-04, // 642
    5.401857301132220e-07, // 643
    9.517223343120417e-05, // 644
   -5.961846281220091e-02, // 645
   -4.791953771993377e-04, // 646
    4.514156265364916e-01, // 647
   -1.616321774558197e-03, // 648
   -4.292178159560361e-02, // 649
    5.754619221493719e-01, // 650
   -1.604384648540179e+00, // 651
   -1.407102175839773e-05, // 652
    1.525680225484200e+00, // 653
    3.509817120560832e-06, // 654
   -3.989714311268507e+00, // 655
   -3.032985961682796e-08, // 656
   -7.956507296928930e-02, // 657
    1.548972050741439e-03, // 658
   -5.028214215565010e-06, // 659
    5.791360133471760e-06, // 660
    2.135863688223489e-01, // 661
    5.094408933728937e-03, // 662
    2.917624093390403e-02, // 663
    2.044274263763739e-04, // 664
   -2.527359079004537e-03, // 665
    2.520230775270137e-04, // 666
   -9.682505649184944e-04, // 667
    8.724943922506450e-06, // 668
    1.627961685281070e-03, // 669
   -1.277196124186704e-03, // 670
    1.972714110877787e-03, // 671
    1.670860392518456e-06, // 672
   -7.507969161690382e-04, // 673
   -1.770162458083705e-03, // 674
   -2.124588743847731e-06, // 675
    1.766039435338694e-06, // 676
   -5.343741577264430e-01, // 677
   -3.007059779394894e-05, // 678
    1.173458100856034e-06, // 679
   -2.044025581807136e-04, // 680
   -6.041992117796287e-04, // 681
   -1.778151595188768e-06, // 682
    4.730288773210341e-05, // 683
   -2.405634788283355e-07, // 684
   -1.459773493767122e-04, // 685
   -3.311048529102045e-01, // 686
    2.510700508040751e-01, // 687
    5.580900350397556e-01, // 688
   -8.708658194215756e-07, // 689
    2.308274895889847e-02, // 690
    6.773747036278299e-03, // 691
   -4.610267313669634e+00, // 692
    1.389878656948956e-05, // 693
    2.711568279107358e-03, // 694
    2.274271573552156e-02, // 695
    3.839258658256780e-05, // 696
    3.497890085807540e-06, // 697
   -1.633411340439347e+00, // 698
   -5.367377862739302e+00, // 699
    2.352679778203559e-03, // 700
    3.962683591425300e+00, // 701
   -1.791891686561014e-06, // 702
    3.906905654918809e-07, // 703
   -2.311890943366751e-01, // 704
   -1.919033826570469e-03, // 705
    9.732142275602650e-05, // 706
   -5.703339571212298e-05, // 707
   -3.926093813302196e-01, // 708
   -1.229145084950187e-04, // 709
    3.106619470675438e-04, // 710
   -4.475923302846045e-08, // 711
    6.873179644460631e-01, // 712
    1.033260639983981e-06, // 713
   -8.719661736631584e-05, // 714
    5.101676744128316e-05, // 715
   -1.659129495440488e-04, // 716
    2.480461074397311e-03, // 717
   -9.340256339720381e-02, // 718
    2.367369380856075e+00, // 719
    7.113683200789553e-05, // 720
   -1.236489922158911e-04, // 721
    4.496070071132543e-04, // 722
   -1.643029366048424e-05, // 723
   -4.208743231156216e-06, // 724
    3.213324633218170e-01, // 725
   -1.521058922741698e-03, // 726
    3.706686470375948e-02, // 727
   -6.887339292573046e-03, // 728
    1.005243212820707e-04, // 729
    8.115291485301667e-07, // 730
   -5.857780285732671e-03, // 731
   -8.038469097498777e-07, // 732
    4.884576617105884e-07, // 733
   -6.724146697060068e-06, // 734
   -1.916036774608676e-05, // 735
   -7.933910349929350e-04, // 736
    4.648918518128564e-01, // 737
   -5.342460199338867e-05, // 738
    2.194190212525763e-03, // 739
   -4.166416265678631e-06, // 740
    6.585885472979150e-04, // 741
   -1.870656383552280e-05, // 742
   -6.804505262901547e-05, // 743
   -1.436645220770996e-04, // 744
   -2.806098629985238e-03, // 745
   -9.220298235066643e+00, // 746
    4.416549425402143e-07, // 747
   -7.194005574283905e-08, // 748
   -1.922293178067888e+00, // 749
   -6.999724359372358e-02, // 750
    3.092330559855105e-05, // 751
   -4.288696251208884e-05, // 752
   -1.388484232835551e-03, // 753
   -3.898950501980827e-04, // 754
    6.671212950480762e-08, // 755
   -4.406286836975746e-07, // 756
    7.940116327078382e-06, // 757
   -3.403985349620879e+00, // 758
    1.116433765991624e-03, // 759
   -4.358674882391562e-03, // 760
    6.019675607718710e+00, // 761
    1.860557748232453e-01, // 762
   -8.325965722200861e-03, // 763
    4.730525758797773e-02, // 764
    1.762921803122868e+00, // 765
   -1.781625253634411e-03, // 766
    1.216213760872869e-05, // 767
    3.199289469711156e-04, // 768
   -1.388616607606470e-06, // 769
    4.550455580442104e+00, // 770
   -6.046173211056741e-07, // 771
    2.995998145371100e-06, // 772
    1.263522601408184e-04, // 773
    2.779999769562322e-01, // 774
    2.806979261448914e-04, // 775
    1.477378049266280e-07, // 776
    2.691905738946575e-03, // 777
   -2.153084010008046e+00, // 778
   -7.230355824194820e-04, // 779
   -1.352149376910313e-08, // 780
   -1.576099035290518e-03, // 781
    7.211993787597991e-05, // 782
   -5.779738330281013e+00, // 783
    2.671878636390376e-04, // 784
   -8.599804919692680e-06, // 785
    2.666423496485957e-06, // 786
   -2.066389083497599e-07, // 787
    7.169105740821193e-01, // 788
    1.912728073247622e-02, // 789
    3.322108355579437e-01, // 790
    2.349898100328655e-06, // 791
   -2.767796942220854e-05, // 792
   -6.558724236129003e+00, // 793
    3.215688581342620e-05, // 794
   -9.442043111545015e-08, // 795
    5.427608571403629e-05, // 796
   -3.781620898737771e-02, // 797
   -2.362160081036112e-06, // 798
   -1.599403670411638e-06, // 799
    3.602061324664288e-04, // 800
    4.634375485636728e-03, // 801
    7.076591822172931e-04, // 802
   -2.472389370558761e-02, // 803
   -4.862861850910448e-05, // 804
   -5.912500718820321e-08, // 805
   -4.500612914601168e-01, // 806
    1.130455270451078e-01, // 807
    1.090808631730267e-03, // 808
    3.429671618996356e-01, // 809
   -1.358474952162999e+00, // 810
   -2.935007296369410e-08, // 811
   -2.694539868737189e+00, // 812
    5.092320902141086e-07, // 813
    1.057355998184677e-03, // 814
    2.222227400508375e+00, // 815
   -1.451176441106693e-03, // 816
    1.685429092363745e-02, // 817
   -4.359365102298806e-01, // 818
   -4.597351894603807e-01, // 819
    1.230451045077473e+00, // 820
    2.522514076234912e-01, // 821
    5.689344320241337e-01, // 822
    3.198902353608352e-02, // 823
    1.848224613674567e+00, // 824
   -4.320298308168106e-05, // 825
   -1.499296830288364e-04, // 826
   -9.177175220443730e-01, // 827
    2.343849796734043e-03, // 828
    1.096617003029245e+00, // 829
    1.845489553809645e-04, // 830
   -3.081958411208684e-01, // 831
   -3.593885780383235e-04, // 832
   -3.954259806399742e-02, // 833
    4.004668904842217e-01, // 834
   -2.600466888515315e-07, // 835
    3.350608962599392e-01, // 836
   -8.786325700461634e-02, // 837
   -1.603923871481558e-02, // 838
    2.488782105635463e-03, // 839
    2.263813026115473e-07, // 840
   -7.680191125056608e-01, // 841
    3.192221048549234e-07, // 842
    6.329959387660621e-01, // 843
    5.087288125350506e-02, // 844
   -4.936783708250102e-04, // 845
    2.935780334992623e+00, // 846
   -9.688489641444742e-02, // 847
   -3.730314968498524e-01, // 848
    1.776104084032733e-03, // 849
   -1.067396819856645e-01, // 850
    1.181092731177108e-06, // 851
    1.049794059075847e-04, // 852
    3.076582968443204e+00, // 853
    2.445102444824511e-05, // 854
   -1.059085715729203e-04, // 855
   -6.729563636760341e-06, // 856
    1.467985736668917e+00, // 857
    2.499876486122939e-01, // 858
    1.366834325121140e-01, // 859
   -4.199940616871964e-05, // 860
   -2.981047193274971e-04, // 861
    1.166488212858865e-06, // 862
    1.451526477852561e-04, // 863
   -2.561394325999263e-05, // 864
    1.490143464358418e-03, // 865
   -3.162170345586699e-03, // 866
   -1.248674239809707e-05, // 867
    1.198936687529587e+00, // 868
    3.309753456985660e-03, // 869
    3.733852961408523e-04, // 870
   -7.937322918035879e-02, // 871
   -5.805127476586668e-03, // 872
   -1.296190406323402e+00, // 873
    7.739182045769221e-04, // 874
    4.296117298362282e-03, // 875
    1.327758523663600e-05, // 876
   -3.286093345055311e-01, // 877
    6.715397512431577e-07, // 878
    3.402157586439027e-04, // 879
    7.517463506784659e-07, // 880
    2.046180340742333e-04, // 881
   -1.239913035516501e-05, // 882
   -2.341394297689301e-01, // 883
   -6.574920240661840e-01, // 884
    5.060699996375796e-06, // 885
    1.332069109678592e-05, // 886
    2.389277189372073e-02, // 887
    1.306719028934486e-07, // 888
   -5.271394724823051e-08, // 889
    3.639691051245567e-02, // 890
    3.617806163733612e-01, // 891
    9.422473889718074e+00, // 892
    3.313030354876649e-03, // 893
   -7.235513983309422e-02, // 894
    6.406832338340081e-07, // 895
   -8.043209645910775e-01, // 896
   -2.213791525131580e-07, // 897
   -1.393000333033768e-06, // 898
   -4.018696231824273e-04, // 899
   -1.520663966090149e-03, // 900
    3.824472424039951e-03, // 901
    1.425737966847505e-03, // 902
    3.157244333474400e-03, // 903
    5.867595728865915e-04, // 904
    2.450311141683001e-05, // 905
   -1.447345345696032e-03, // 906
   -9.739834179358439e-03, // 907
   -3.611496287969674e-04, // 908
   -2.181499781725860e-04, // 909
    9.534463071086858e-07, // 910
    4.823087229389008e+00, // 911
    7.658716207294385e-01, // 912
    2.816221059523073e-04, // 913
   -1.796699377428870e-06, // 914
    1.714550717220374e-03, // 915
   -2.417503291907617e+00, // 916
    7.765349627839916e+00, // 917
   -2.254315940307457e-08, // 918
   -2.751986059365899e-05, // 919
   -7.104116296616702e-03, // 920
   -1.132878822237729e-05, // 921
   -5.604760562328083e+00, // 922
   -1.744645598704373e+00, // 923
    9.255123835907593e-04, // 924
   -8.602685733662491e-09, // 925
    1.630600157831724e+00, // 926
   -7.026933614136246e-01, // 927
    6.441709565187225e-04, // 928
   -1.421109341660461e-03, // 929
    4.274964189171927e-04, // 930
    2.678400096779854e-01, // 931
   -8.365828495144921e-09, // 932
    3.455337317361236e-09, // 933
   -1.767436425423530e-04, // 934
   -8.629432722259630e-01, // 935
    5.112470535633503e-07, // 936
    7.585745251407127e-10, // 937
   -1.772257560858786e+00, // 938
   -1.364751131536037e+00, // 939
   -1.102371418563445e-06, // 940
   -6.780766157746361e-07, // 941
    1.217951950532376e-03, // 942
    2.519512742920581e-03, // 943
    1.016409737677402e-03, // 944
   -4.355382896578192e-07, // 945
    4.245391963795210e-01, // 946
    4.004726418272974e-01, // 947
   -1.487172855269697e-03, // 948
   -1.528615115417224e-06, // 949
    7.381166293172059e-02, // 950
    1.911684563888077e-07, // 951
    2.299558961058811e+00, // 952
    2.085284679765048e-01, // 953
    2.763240808623559e-09, // 954
   -5.124943643187425e-02, // 955
   -1.586711983078298e-09, // 956
   -5.762232313322752e-04, // 957
   -1.178421692769858e-03, // 958
   -7.508834304517859e-07, // 959
    1.479798457557213e-07, // 960
    6.357434201733904e-01, // 961
    1.402217215512005e-03, // 962
   -5.975344252435223e-03, // 963
   -9.245793560805484e-04, // 964
    2.095832496999831e-04, // 965
    2.196949450208942e-06, // 966
   -2.155382268215997e-06, // 967
   -5.978698638563243e-02, // 968
   -4.300076001646124e-06, // 969
    1.497567450879604e-07, // 970
    1.080177995940834e-10, // 971
   -8.593992702054081e-04, // 972
   -1.469522783977684e-03, // 973
    8.427840820637207e-10, // 974
   -3.591603081400148e-06, // 975
   -8.604846055358688e-01, // 976
   -6.236310909695774e-09, // 977
    1.095622935749702e-09, // 978
    2.558844023196098e-07, // 979
    2.713657540103960e-01, // 980
    6.599817805908952e-01, // 981
   -4.284130046364176e-01, // 982
   -1.267148787213255e-01, // 983
    1.571677675688369e+00, // 984
    3.245790455017089e+00, // 985
    2.065895052666626e-06, // 986
    2.556447550002685e-06, // 987
    8.480753600688451e-04, // 988
    4.931788575248947e-02, // 989
   -6.347179351448176e-04, // 990
    2.440942166648201e-03, // 991
    2.846310040738889e-09, // 992
    2.501040084342024e-09, // 993
   -7.844953566398944e-05, // 994
   -1.041599325830870e-06, // 995
    1.312996928448810e-06, // 996
   -2.703875177797740e-03, // 997
    6.944638930707321e-07, // 998
    1.507876948409822e-09, // 999
    7.212533976524460e-07, // 1000
   -7.355099533434363e-10, // 1001
   -1.572406634931023e-03, // 1002
    4.925164350220242e-01, // 1003
   -1.477774332396321e-04, // 1004
   -4.791928530502864e-03, // 1005
    8.872867509928343e-04, // 1006
   -1.994796431957665e-07, // 1007
   -1.067817225600881e+00, // 1008
   -1.057153911332401e-09, // 1009
    3.414556783224100e-06, // 1010
    1.788328145455713e-06, // 1011
   -9.179582143833261e-07, // 1012
    2.237367836192462e-06, // 1013
    2.516670968887835e-01, // 1014
    4.641036303684095e-04, // 1015
    1.646794950958877e-06, // 1016
    1.247555500515899e-06, // 1017
    4.538304545255660e-08, // 1018
    1.581623278509399e-06, // 1019
   -5.651498214534765e-06, // 1020
    1.107754654682138e-06, // 1021
   -4.327530901468508e-06, // 1022
    2.930501779865781e-01, // 1023
    1.144097995784394e-06, // 1024
    1.379481778004947e+00, // 1025
   -7.910936096754253e-07, // 1026
   -1.583154243064409e-07, // 1027
   -1.871584378327737e-01, // 1028
    3.781549876299573e-07, // 1029
    6.482094397034034e-01, // 1030
   -4.342086066548170e-04, // 1031
    4.195055478352455e-06, // 1032
   -1.518213741621822e-03, // 1033
    1.447394678899758e-09, // 1034
   -3.211136926513831e-06, // 1035
   -2.059562684202478e-06, // 1036
   -4.064485910424526e-07, // 1037
    3.866863697149769e-03, // 1038
   -1.673349909236696e-09, // 1039
   -8.903556120384613e-10, // 1040
    3.257265519134752e-07, // 1041
    2.019214655500893e-06, // 1042
    1.061013856354648e-01, // 1043
   -9.797531201948891e-07, // 1044
    1.044593786640000e-08, // 1045
    1.373570410827682e-04, // 1046
    1.790921047900365e-04, // 1047
   -1.099281889043039e-03, // 1048
    5.478232917424400e-02, // 1049
    2.777931295273061e+00, // 1050
    1.862994325502191e-09, // 1051
    1.328343074644082e-06, // 1052
    1.897721449892290e-06, // 1053
   -1.378661815469540e-08, // 1054
   -2.948696652216979e-04, // 1055
   -2.117298249568323e-03, // 1056
    1.154140037678319e-01, // 1057
    2.803325986175875e-06, // 1058
   -1.378392824047092e-01, // 1059
   -1.577878512203120e-06, // 1060
   -4.751888161669133e-04, // 1061
    6.555363087710178e-08, // 1062
    7.316624102710704e-05, // 1063
   -1.793606428241860e-06, // 1064
   -1.204327983200899e-03, // 1065
    4.408509490474500e-06, // 1066
   -2.757426977334681e-06, // 1067
    2.404397096266655e-09, // 1068
    1.386759854998856e-03, // 1069
   -1.533906821733448e-03, // 1070
    6.612302130286970e-10, // 1071
   -9.071045988826436e-04, // 1072
    1.349952748186115e-05, // 1073
   -2.659808478966327e-06, // 1074
    2.724223976290783e-06, // 1075
   -1.153741348186605e-03, // 1076
    5.517390219113239e-06, // 1077
    3.826139999672372e-03, // 1078
   -9.019901820281639e-04, // 1079
    3.418921058357790e-05, // 1080
    6.857794846375232e-04, // 1081
    2.634072035350245e-01, // 1082
    1.300681445206777e-06, // 1083
    3.154884760594132e-07, // 1084
    7.309363825075126e-01, // 1085
    3.026339716360493e+00, // 1086
   -5.373809683880243e-02, // 1087
   -3.773173333523376e-06, // 1088
    1.482888877289056e-06, // 1089
   -1.936931793708032e-04, // 1090
    4.328520373160485e-04, // 1091
   -1.127455181612152e-03, // 1092
   -8.114753209214172e-04, // 1093
   -2.849376238673824e-06, // 1094
    2.889324051410607e-06, // 1095
    1.305366487992745e-07, // 1096
   -3.124840313796780e-06, // 1097
   -8.744386062886136e-09, // 1098
    3.776618057054368e-09, // 1099
    7.162269787611567e-11, // 1100
   -3.282371127618079e-06, // 1101
   -4.148904391870559e-04, // 1102
    1.897479824869602e-03, // 1103
   -5.907320259752133e-02, // 1104
   -1.251452424353449e-06, // 1105
   -2.752401244525213e-01, // 1106
   -2.531042918897512e-01, // 1107
   -1.689658858941597e-03, // 1108
   -1.361994628728615e-06, // 1109
   -5.603454326808281e-10, // 1110
    1.363011732885440e-07, // 1111
   -8.313372511791341e-04, // 1112
    2.269712386505752e-06, // 1113
   -1.013964771594865e-03, // 1114
   -1.040027607296277e-03, // 1115
    2.034316891545588e-06, // 1116
   -3.483155565015690e-06, // 1117
   -1.052400401613084e-03, // 1118
   -3.888905301508308e-08, // 1119
    4.564374341979128e-05, // 1120
   -1.498426990839747e-01, // 1121
   -1.720403102888767e-10, // 1122
    1.641682349411378e-06, // 1123
   -1.688756880728674e-03, // 1124
    1.793184952442540e-06, // 1125
   -2.344733312934616e-10, // 1126
   -2.531060507449161e-06, // 1127
    1.170606128555747e-09, // 1128
   -2.571873516036616e-03, // 1129
    6.781732805498430e-02, // 1130
    2.460676165492029e-03, // 1131
    1.097425589516866e-04, // 1132
   -1.201076172032059e-04, // 1133
    3.531977782075646e-04, // 1134
   -3.002503840112931e-07, // 1135
   -1.688518951050054e-09, // 1136
    7.495228469726722e-07, // 1137
   -1.651356477530090e-03, // 1138
    6.035674447752195e-04, // 1139
   -9.834141514384798e-09, // 1140
   -3.757585061633891e+00, // 1141
   -4.258033020265921e-06, // 1142
   -2.027758296042603e-03, // 1143
    4.090771970584579e-01, // 1144
    1.978417971449354e-10, // 1145
   -1.787629544160351e-06, // 1146
   -7.300777386993566e-07, // 1147
   -1.467548546421889e-01, // 1148
   -8.538827596664966e-04, // 1149
   -3.321466309900872e-01, // 1150
   -1.871459303373465e-04, // 1151
    2.469048865918262e-02, // 1152
   -2.012878025774142e-06, // 1153
    1.787080990771973e-03, // 1154
    2.221878893968537e-09, // 1155
    6.908806552208078e-04, // 1156
    6.446088397808380e+00, // 1157
    1.599155552990004e-07, // 1158
    4.737100568675239e-06, // 1159
    8.925064270564695e-05, // 1160
    6.291873780354161e-06, // 1161
   -1.703544971431542e-07, // 1162
   -2.178566024143238e-04, // 1163
    5.779060551379886e-04, // 1164
   -3.659986164010579e-01, // 1165
   -7.103529210371434e-08, // 1166
   -1.325530308023986e-06, // 1167
    8.891709333514186e-04, // 1168
    2.612418980748518e-06, // 1169
   -1.054612786227469e-06, // 1170
   -1.874106422090657e-06, // 1171
   -2.537492604496801e-04, // 1172
    1.598548891276078e-03, // 1173
   -1.389046055916619e-04, // 1174
   -1.362316766567498e-04, // 1175
   -9.238358582023481e-02, // 1176
   -3.598675762059418e-07, // 1177
    2.915434194471720e-04, // 1178
    2.747380800186609e-06, // 1179
   -2.171730557719911e-06, // 1180
    7.999362819260172e-04, // 1181
    9.801801763667210e-07, // 1182
    7.372810099192296e-07, // 1183
   -3.322947682603453e-09, // 1184
    6.177870314029415e-05, // 1185
   -4.650943111963238e-05, // 1186
    1.571533522238098e-07, // 1187
   -1.464261037301218e-06, // 1188
    1.481652373123792e-09, // 1189
   -1.404800692049445e-06, // 1190
    1.269913930981347e-06, // 1191
   -7.438219876943523e-09, // 1192
    4.320929071238028e+00, // 1193
   -8.252373113259694e-07, // 1194
   -5.912288473218408e-01, // 1195
    1.685890488124860e-03, // 1196
    4.949848749564628e-04, // 1197
   -6.016983196542495e-09, // 1198
    1.440483712575822e-06, // 1199
   -9.570141711810016e-04, // 1200
   -1.122484053437528e-10, // 1201
   -7.431937188060039e-09, // 1202
   -1.032940065648101e-02, // 1203
    3.032120213400388e-06, // 1204
   -6.857366630283829e-07, // 1205
   -1.331173556316495e-03, // 1206
    2.438967625365847e-04, // 1207
   -4.303930511142198e-06, // 1208
    2.634564386062194e-01, // 1209
   -9.703239043153632e-10, // 1210
   -4.731664940050726e-07, // 1211
    5.947266257716342e-01, // 1212
   -3.579955816069572e-04, // 1213
    4.493918756099061e-02, // 1214
   -6.870674746254266e-07, // 1215
   -4.122648647049961e-04, // 1216
   -1.348666936299212e-03, // 1217
    2.255673311790433e+00, // 1218
   -5.298601821018472e+00, // 1219
   -3.588597930536103e+00, // 1220
    1.916521188541426e+00, // 1221
    2.252836661067175e-06, // 1222
    6.726620773034545e-04, // 1223
   -7.226702397665492e-05, // 1224
    1.502663874205046e-03, // 1225
   -1.056982569271403e-06, // 1226
    1.917022120096999e+00, // 1227
    3.975293691761670e-04, // 1228
   -2.658232046085613e-09, // 1229
    1.545831637040727e-06, // 1230
    1.878385415297399e-04, // 1231
   -1.558670963846101e-06, // 1232
    4.803119218243851e-06, // 1233
   -1.400028330482748e-04, // 1234
    1.323372038790029e+00, // 1235
    1.251737228274332e-06, // 1236
   -2.203117617819283e-04, // 1237
    1.109694264210714e-03, // 1238
   -7.700264107165803e+00, // 1239
   -8.587250910301499e-09, // 1240
   -1.961351588892795e-06, // 1241
   -6.253451375735840e-07, // 1242
   -3.959170493007744e-02, // 1243
    7.108892652712631e+00, // 1244
    4.532289763225053e-04, // 1245
    7.675574411643863e-04, // 1246
    9.399561335727848e-06, // 1247
    2.303962495926700e-01, // 1248
   -5.801340415414992e-04, // 1249
    5.890612575212339e-10, // 1250
    3.029351531650782e-03, // 1251
   -1.235297565133839e-04, // 1252
    1.254309823004755e-01, // 1253
    4.557879097297252e-06, // 1254
   -8.277597582537335e-04, // 1255
    5.282247771990397e-04, // 1256
    2.510998035005807e-07, // 1257
    1.311374312932675e-06, // 1258
   -5.045721835703511e-09, // 1259
    1.118031254396157e-06, // 1260
   -2.253252594771433e-06, // 1261
   -2.478408035183061e-09, // 1262
   -6.551723412581125e-01, // 1263
    4.148983384076876e-02, // 1264
    1.084839246859967e-03, // 1265
    1.461965568134499e+00, // 1266
    2.907755860694158e+00, // 1267
    1.420237999761763e-01, // 1268
   -2.574374692213102e+00, // 1269
   -8.633416750352404e-01, // 1270
    1.976145719839538e-04, // 1271
    1.008345122877702e-01, // 1272
   -4.172215385192293e-09, // 1273
   -3.820981920832023e-04, // 1274
    8.587004029350043e-04, // 1275
    1.935735669666108e-03, // 1276
    6.926824555929499e-04, // 1277
   -3.095785814523015e-06, // 1278
   -2.877428098343743e-06, // 1279
    2.928976212597181e+00, // 1280
    9.378145668578483e-07, // 1281
    5.211236581134594e-07, // 1282
    2.424127813824025e-06, // 1283
   -7.145525891925913e-01, // 1284
   -7.194058744283313e-04, // 1285
   -2.223661490876848e-06, // 1286
   -2.105556929233732e-06, // 1287
   -4.133587778793708e-01, // 1288
    7.260906294414961e-04, // 1289
   -1.047324970512692e-06, // 1290
    1.190568627954489e-04, // 1291
   -4.056589256128177e-01, // 1292
   -1.517289981924333e-04, // 1293
   -2.195429708500847e-07, // 1294
   -2.762099304997785e-04, // 1295
    1.073719407329850e-03, // 1296
   -3.535403185939279e-06, // 1297
    6.001562407067836e-01, // 1298
    1.148368840773754e-03, // 1299
    2.534017090668472e-06, // 1300
    3.322875181590333e-01, // 1301
   -1.940383844429538e-07, // 1302
    2.076715644629695e-04, // 1303
   -1.156827195921253e-04, // 1304
   -1.204630823812877e-03, // 1305
    5.021900019912959e-08, // 1306
   -4.747340101812395e-07, // 1307
    2.655767748990318e-04, // 1308
    5.354838217178678e-07, // 1309
    1.015683445614595e-06, // 1310
    6.540745081301598e-05, // 1311
   -2.693710857343603e-09, // 1312
    1.329235240127503e-03, // 1313
    3.129167308838147e+00, // 1314
    9.945099290718683e-07, // 1315
   -9.200207121503201e-07, // 1316
   -1.970086884465218e-03, // 1317
   -2.198996601765205e-09, // 1318
    3.989874043772355e-10, // 1319
    7.281156768245224e-01, // 1320
    5.217068141950031e+00, // 1321
    2.689921688170153e-07, // 1322
    1.509209479212284e-03, // 1323
   -9.190762289636395e-04, // 1324
    2.259212597159728e-06, // 1325
   -1.214994979168664e-06, // 1326
    5.695817512374092e-04, // 1327
   -1.535252909690554e-03, // 1328
    1.089712204720362e-04, // 1329
    1.218375173785956e-03, // 1330
   -3.024287825068516e-04, // 1331
    1.955100370448285e-04, // 1332
   -5.160158734449430e-07, // 1333
    4.190343187636532e+00, // 1334
    1.200191120092537e-07, // 1335
    9.629481525010656e-04, // 1336
    5.647058832229760e-02, // 1337
   -2.425405921846044e-06, // 1338
   -1.027350205410832e-09, // 1339
    4.314588557476073e-03, // 1340
   -5.529377734687925e-02, // 1341
    4.183118674773602e-07, // 1342
    1.423484901089916e-04, // 1343
    3.676938541430049e-06, // 1344
    3.045371953353152e-06, // 1345
   -1.371285151421633e-06, // 1346
   -4.472848470224490e+00, // 1347
   -3.990366326130639e-10, // 1348
    1.342709517406366e-01, // 1349
   -6.658576349900959e-07, // 1350
    3.680873991569002e-02, // 1351
    7.390936781498669e-06, // 1352
   -7.454227675479322e-07, // 1353
   -1.352351372724917e+00, // 1354
    4.131914132423149e-04, // 1355
    1.108095879358494e-03, // 1356
   -3.045746217660231e-06, // 1357
    1.111528758915480e-09, // 1358
    3.470507832345582e-04, // 1359
   -4.042764681012260e-01, // 1360
    1.098001546137882e-03, // 1361
   -9.827291415345919e-02, // 1362
    3.311106565489666e-06, // 1363
   -1.457921788417432e+00, // 1364
    5.558442001756245e-07, // 1365
   -1.431119359285933e-06, // 1366
   -5.183218549236183e-02, // 1367
    1.636289100963946e-07, // 1368
   -7.698045089380702e-04, // 1369
   -2.324162776863329e-06, // 1370
   -1.740804247906315e-04, // 1371
   -3.234367987036542e-03, // 1372
    3.905231471387780e-06, // 1373
   -2.979282290227556e-06, // 1374
   -6.471524049359737e-01, // 1375
   -3.796778716879463e-01, // 1376
    1.901935162585697e+00, // 1377
   -5.693140791199364e-01, // 1378
    3.809836046468646e-06, // 1379
   -1.373900209639331e+00, // 1380
   -1.114972765459736e-03, // 1381
    2.074517040732015e-07, // 1382
   -8.012792318728806e-05, // 1383
    6.590498145163544e-02, // 1384
    2.554448274382467e-07, // 1385
    2.131891041077503e-04, // 1386
    2.560397125670537e-03, // 1387
   -1.572675292596113e-06, // 1388
   -2.782715027726452e-04, // 1389
   -2.514577702808580e-02, // 1390
   -1.325401155055879e-03, // 1391
   -2.457794706218819e+00, // 1392
   -1.090287953387675e-06, // 1393
    1.258227677863370e-07, // 1394
   -1.393948243164711e-03, // 1395
   -1.604438026829179e-03, // 1396
    2.394319741731625e-01, // 1397
    8.695042096382144e-02, // 1398
   -2.516411065449120e-04, // 1399
    1.711203915833500e+00, // 1400
    5.232158841867595e-08, // 1401
   -8.042331039046877e-07, // 1402
   -2.206379233548775e-09, // 1403
   -2.522284013286558e-02, // 1404
    2.668749046295557e-07, // 1405
    2.612040886696839e-05, // 1406
    2.593122243733296e-03, // 1407
    4.319675869757443e-09, // 1408
    1.924283398937947e-06, // 1409
    1.320222076927724e-09, // 1410
   -1.961919321539512e-03, // 1411
    3.330748619620662e-01, // 1412
   -8.135941807967592e-04, // 1413
    1.627261097186285e-01, // 1414
    4.350529869795955e-01, // 1415
   -1.207842562510808e-03, // 1416
    2.025666057083835e-03, // 1417
    7.593103857286288e-03, // 1418
    8.315120112559850e-01, // 1419
    9.784934208124318e-04, // 1420
   -2.189382326096192e-06, // 1421
    2.348352057036749e-06, // 1422
   -6.470842806784710e-01, // 1423
   -6.710645523238647e-02, // 1424
   -2.249410717041408e-02, // 1425
   -1.420922799632876e-06, // 1426
    1.046707921503372e-09, // 1427
    1.463057767317323e-06, // 1428
    9.200603025636986e-07, // 1429
    1.642192898567016e-06, // 1430
   -2.522382964455700e-07, // 1431
    1.214530275754549e-07, // 1432
    8.096782681405261e-02, // 1433
   -2.257734481403382e-05, // 1434
   -2.439797275576941e+00, // 1435
   -5.424303849974063e-07, // 1436
    2.888156832249029e-09, // 1437
    8.494640723904792e-07, // 1438
    1.121246044913852e-06, // 1439
    3.259496448061684e-04, // 1440
    4.451395468060799e-02, // 1441
    2.798656943686504e-07, // 1442
   -3.567481710034814e+00, // 1443
   -1.685806543977913e-06, // 1444
    8.632621669511550e-08, // 1445
   -1.448064562541619e-05, // 1446
    1.154207604242633e-06, // 1447
    1.305285820198134e-03, // 1448
    3.922512839258294e-01, // 1449
    7.677962729472166e-09, // 1450
    5.060886283203676e-06, // 1451
   -3.046896014594347e-02, // 1452
    6.321198377560141e-07, // 1453
   -1.062438695177989e-06, // 1454
   -7.344693149126252e-10, // 1455
   -4.405405590156100e-05, // 1456
   -4.403928127322883e-07, // 1457
   -8.360798424360720e-01, // 1458
    6.835362455229924e-10, // 1459
    1.347476142613088e-06, // 1460
    4.198090560938029e-07, // 1461
    5.263659236141789e-08, // 1462
   -2.954045025374301e-09, // 1463
   -5.691385829955332e-02, // 1464
    2.321412222054953e-01, // 1465
    2.195573546905828e-06, // 1466
    2.247642230454132e-06, // 1467
    3.026529514850575e-09, // 1468
   -9.804153448414304e-07, // 1469
    2.863102180009900e-03, // 1470
   -5.748682558503192e-06, // 1471
   -1.397226054172177e-01, // 1472
   -1.386326506661533e-04, // 1473
   -9.464183139764676e-07, // 1474
   -9.075664437693085e-09, // 1475
   -1.915483247022088e-06, // 1476
    2.173586115280340e-04, // 1477
   -8.156053212195394e-02, // 1478
   -2.080976066559231e-07, // 1479
    7.362823058358381e-02, // 1480
   -2.736284545712630e+00, // 1481
   -1.263658684348005e-01, // 1482
   -2.239442086385511e-07, // 1483
   -2.734428363234088e-04, // 1484
   -3.581338277585536e-02, // 1485
   -4.932597058561946e-03, // 1486
    4.178238246997582e-04, // 1487
   -9.425517929661121e-09, // 1488
    1.566552095845491e-04, // 1489
   -1.332116046590852e+00, // 1490
   -6.079007119912187e-10, // 1491
    9.703741646566246e-04, // 1492
    2.761159061153656e-04, // 1493
   -8.458444021750957e-07, // 1494
    2.592404958229574e-04, // 1495
   -2.529302895923886e-06, // 1496
   -4.101544923355291e-10, // 1497
   -5.884512793440521e-06, // 1498
   -1.535712011049395e-06, // 1499
    1.522552393246724e-07, // 1500
   -3.222064471845856e-04, // 1501
   -1.600842841989210e-03, // 1502
   -1.197676982523942e-04, // 1503
    2.796854609494895e-04, // 1504
    1.776955859224581e-03, // 1505
    3.131149137205799e-04, // 1506
   -1.134622989958367e+00, // 1507
    7.982726665949191e-09, // 1508
   -5.411427368354486e+00, // 1509
    1.236493924444593e-11, // 1510
    1.399703126255008e-03, // 1511
    1.698045355617142e-03, // 1512
   -7.837715866905718e-06, // 1513
    1.907386708277796e-06, // 1514
    3.667036503922316e-07, // 1515
   -1.802315206685401e-01, // 1516
    2.133857154601774e-03, // 1517
   -8.621127906859120e-07, // 1518
    1.098613185117759e-09, // 1519
   -3.930239218710012e-06, // 1520
   -1.164957020936493e-01, // 1521
   -5.942042717854901e-02, // 1522
   -5.301237988003858e-07, // 1523
   -8.756225946600385e-04, // 1524
    5.323466004201160e-04, // 1525
   -7.888832524293819e-04, // 1526
   -2.380061825262134e-01, // 1527
    9.144966049405438e-09, // 1528
   -3.815868164181146e-09, // 1529
   -6.120188955810322e-01, // 1530
    1.018038801768296e+00, // 1531
   -3.831350513130565e-06, // 1532
   -2.486241991807549e-07, // 1533
   -1.506109750720934e-01, // 1534
   -8.120301495407334e-07, // 1535
    1.022383789718913e-03, // 1536
    6.843551507582203e-06, // 1537
    2.098894527897224e-06, // 1538
   -3.232957444997506e-09, // 1539
   -1.129863431619733e-07, // 1540
   -1.325189197319761e-03, // 1541
   -1.128430113099371e-04, // 1542
    3.371141177279115e+00, // 1543
    1.149479266125243e-09, // 1544
    1.318635461332521e-05, // 1545
   -5.337024377781996e-04, // 1546
   -2.756222825176573e-03, // 1547
    3.153894750166752e-07, // 1548
    6.315470575051345e-10, // 1549
   -5.038811512676489e-04, // 1550
    5.624373354464158e-01, // 1551
   -5.661442694290819e-04, // 1552
   -9.418637545372911e-01, // 1553
   -1.855383808655797e-06, // 1554
   -2.019206328514999e-06, // 1555
   -2.431181687464620e-04, // 1556
    8.506486989325359e-04, // 1557
    4.168417362124071e-04, // 1558
    1.322223781498138e-03, // 1559
    1.589979867150377e-03, // 1560
    2.609590370917949e-04, // 1561
    1.429812682313282e-06, // 1562
    1.084762734570664e-09, // 1563
    2.309272597065250e-07, // 1564
   -2.108290723648657e-10, // 1565
    2.180102721067997e-06, // 1566
   -1.920011405128849e-06, // 1567
   -1.735039011963781e-07, // 1568
    2.454152256423719e-01, // 1569
    6.614985368722932e-07, // 1570
    1.414361384358894e-09, // 1571
    2.573485974975784e-06, // 1572
   -8.652598483626403e-07, // 1573
   -1.366840332403769e-09, // 1574
    1.194392730130342e-09, // 1575
    2.591945617597684e-06, // 1576
   -3.487398048291135e-07, // 1577
    1.767851258337678e-04, // 1578
    2.043052732457086e-06, // 1579
   -6.096925281703796e-05, // 1580
    9.138749774900610e-09, // 1581
   -1.813688043807276e-03, // 1582
    5.533055155590550e-04, // 1583
    4.958028116901851e-01, // 1584
    5.415655491521362e+00, // 1585
   -1.227851160923656e-03, // 1586
   -3.937107100002444e-06, // 1587
   -2.117566371323622e-06, // 1588
    3.258703525292752e-01, // 1589
    2.341431050872699e-06, // 1590
   -7.460053325697267e-04, // 1591
   -3.680332168205796e-05, // 1592
   -7.362837923069478e-09, // 1593
    3.331761555922114e-05, // 1594
   -1.935977188797248e-09, // 1595
    1.533718489129090e-09, // 1596
   -1.645868937568619e-01, // 1597
    1.377566104733870e-03, // 1598
    8.135751489609153e-02, // 1599
    7.098402854590842e-07, // 1600
    9.561977948167820e-10, // 1601
   -4.530582736395322e-07, // 1602
    3.259644801947819e-04, // 1603
    2.810941570343128e-06, // 1604
    5.642191021024368e-01, // 1605
    5.769426703757376e-04, // 1606
   -1.445761389315531e-10, // 1607
    1.917375481225201e-06, // 1608
   -6.725886704660126e-01, // 1609
   -4.233450189477714e-04, // 1610
    2.446169289143953e+00, // 1611
   -2.631236324886771e-03, // 1612
    3.718962528506163e-04, // 1613
    1.073527620245016e+00, // 1614
   -3.465292631583037e-07, // 1615
   -3.653869221261290e-06, // 1616
   -8.783205846757968e-05, // 1617
    2.293898231347100e-06, // 1618
   -1.944090327938964e-06, // 1619
    2.520291254372711e-06, // 1620
   -9.893935030352114e-04, // 1621
   -5.487332272229763e-07, // 1622
   -7.166222519155375e-06, // 1623
   -6.167479989262189e-04, // 1624
   -4.522610462536034e-06, // 1625
   -2.353235399085696e-04, // 1626
    1.868470821297527e-06, // 1627
   -8.916017728698887e-07, // 1628
   -2.509657334794947e-06, // 1629
   -5.176979029598090e-04, // 1630
    3.927695599284997e-09, // 1631
    1.449505849013899e-08, // 1632
   -7.050683560332195e-07, // 1633
   -6.274143128686590e-05, // 1634
    8.152728907007729e-10, // 1635
    4.833906453277112e-07, // 1636
    1.161575775234562e-01, // 1637
   -3.762737198444172e-07, // 1638
   -8.056631117458701e-06, // 1639
    2.198974462138411e-03, // 1640
   -1.282641861104120e-03, // 1641
    6.014190316388305e-09, // 1642
    2.197988612557441e-06, // 1643
    3.961083881188819e-01, // 1644
    2.481744380815012e-03, // 1645
   -6.246239007656874e-04, // 1646
    5.442714260625632e-07, // 1647
   -5.558063772256239e-02, // 1648
    1.892422408795644e-01, // 1649
   -5.259025010425349e-01, // 1650
    1.245666367850933e-03, // 1651
    5.871929210113734e-05, // 1652
    6.580493926983084e-02, // 1653
    4.175767506928903e-06, // 1654
   -3.636138434311973e-09, // 1655
   -3.338606776659440e-01, // 1656
    3.981607748849852e-04, // 1657
    1.110643061149238e+00, // 1658
    9.509105888492627e-09, // 1659
   -1.319164753171544e-10, // 1660
   -9.916553063060002e-04, // 1661
   -1.194451692135440e-06, // 1662
    1.205384998085974e-06, // 1663
    1.713521437575658e-06, // 1664
    2.326198402458718e-06, // 1665
   -5.358602023207615e-06, // 1666
   -1.468664156033377e-06, // 1667
   -1.718690203583763e-07, // 1668
    7.107872897697426e+00, // 1669
    7.180621703717268e-04, // 1670
    1.702654718751177e-03, // 1671
   -6.930799529593006e-04, // 1672
    3.080359976015620e-06, // 1673
   -2.198198301362725e-06, // 1674
   -3.637165735116963e-04, // 1675
   -2.555444221014433e-04, // 1676
    1.269251066224407e-03, // 1677
    1.674725739098867e-06, // 1678
    2.648071040353595e-06, // 1679
    1.381324035226661e-03, // 1680
    2.261367479153848e-09, // 1681
   -3.482955614776939e-06, // 1682
   -5.488311207361841e-05, // 1683
   -3.643849860455026e-07, // 1684
   -1.539145235579060e+00, // 1685
    7.690244516746231e-06, // 1686
    5.402368036321614e-04, // 1687
   -3.775216803094786e-03, // 1688
   -1.715141054141349e-10, // 1689
    3.561705235429640e-05, // 1690
    1.692057136654915e-04, // 1691
   -1.380375872592812e-06, // 1692
   -1.864174338391867e-03, // 1693
   -6.382333654241690e-04, // 1694
    1.270782395160861e-06, // 1695
   -1.873758479938218e-01, // 1696
   -2.541705971774228e-07, // 1697
    4.869916837645621e-01, // 1698
   -1.143434431999277e-03, // 1699
   -1.294590976401774e-06, // 1700
   -2.736549549311266e-02, // 1701
   -3.930734701025814e-06, // 1702
    1.939706403746561e-07, // 1703
    6.945621524756837e-04, // 1704
    6.348781856708545e-06, // 1705
   -2.160262318427021e-01, // 1706
   -4.996997831899520e-10, // 1707
    2.918281886680814e-07, // 1708
   -2.759892901458512e-10, // 1709
    5.802379425720915e-07, // 1710
    5.073612629421561e-08, // 1711
    1.190331545525561e-01, // 1712
   -8.301585788443038e-07, // 1713
    5.125106502002186e-07, // 1714
    4.630692116752415e+00, // 1715
   -7.999313209601421e-08, // 1716
    6.056437346146766e-04, // 1717
   -1.719422121334382e-06, // 1718
   -4.920484867580486e-01, // 1719
    1.505848754279792e+00, // 1720
   -3.896215463139895e-01, // 1721
    6.920642136281969e-09, // 1722
   -6.778793858876955e-05, // 1723
    8.937819217205579e-05, // 1724
   -6.885240623231936e-07, // 1725
    6.446989382541809e-09, // 1726
    2.515173879106229e+00, // 1727
   -7.010692965214384e-08, // 1728
    2.072275082529227e-09, // 1729
    1.096345005112244e-06, // 1730
   -1.576820397432177e-03, // 1731
    2.347787906684741e-03, // 1732
   -1.392657058245056e-08, // 1733
   -6.450907065641320e-04, // 1734
   -2.664754217532378e-06, // 1735
   -3.833587087616143e-04, // 1736
   -1.440754793507208e-09, // 1737
    9.672418626753981e-10, // 1738
    6.528779726194245e-06, // 1739
    3.219108842189785e-06, // 1740
   -1.585660793947305e+00, // 1741
   -1.236537353971972e-03, // 1742
   -1.083306136502249e-03, // 1743
   -7.398942174765490e-04, // 1744
    5.171255641548432e-09, // 1745
    1.063771638362502e-08, // 1746
   -4.549178635733666e+00, // 1747
    1.968441997458917e-02, // 1748
   -4.229828015451178e-07, // 1749
    4.488396971527560e-01, // 1750
   -3.027466136661325e-02, // 1751
    1.542383423668647e-03, // 1752
   -4.146745502894666e-06, // 1753
    3.179541893800181e-04, // 1754
   -1.465575854641076e-09, // 1755
    2.830379883471458e-01, // 1756
    1.178043072692247e-03, // 1757
   -1.134305962930794e-03, // 1758
    6.407704119389177e-07, // 1759
   -8.089887357302143e-01, // 1760
   -5.136379407016675e-01, // 1761
   -4.881235666365080e-06, // 1762
   -3.313058523534384e-03, // 1763
    1.307867808504696e-03, // 1764
   -4.710249071036963e-07, // 1765
   -2.939150051493310e-03, // 1766
    2.452752966407502e-06, // 1767
   -1.615280899226778e-04, // 1768
    1.429800494530956e-06, // 1769
   -2.127599981318979e-09, // 1770
   -7.394730808338438e-01, // 1771
   -2.807400004922842e-07, // 1772
   -3.108453933739626e-04, // 1773
    1.681400944552889e-06, // 1774
    1.327217184025099e-03, // 1775
   -2.973999407817203e-06, // 1776
    3.521010359917604e-06, // 1777
   -4.264233899419095e-04, // 1778
    7.531506718534850e-02, // 1779
    6.578129198859102e-01, // 1780
   -6.449685913614429e-04, // 1781
   -4.315298016038908e-06, // 1782
    3.917566278144787e-07, // 1783
   -1.595570982847294e-04, // 1784
   -2.167737085444259e-09, // 1785
    1.808359972047884e-06, // 1786
   -5.362871601627677e-06, // 1787
   -7.993126954320402e-04, // 1788
    1.515757543900716e-03, // 1789
    2.622788330938023e-01, // 1790
    1.638494061000463e-01, // 1791
   -1.392675798859754e-09, // 1792
   -1.592969000791413e+00, // 1793
   -2.095271230862032e-09, // 1794
    2.803621953945040e-07, // 1795
    1.154217336334725e-01, // 1796
    2.252374085569495e-03, // 1797
    4.213733150326600e-03, // 1798
   -2.474118263973213e-09, // 1799
    4.271763332636984e-03, // 1800
   -2.771157422440081e-06, // 1801
    1.157873686790901e+00, // 1802
   -1.310096339213505e-09, // 1803
   -8.193693192972031e-02, // 1804
    7.213655658695939e-07, // 1805
    5.134093256860974e-08, // 1806
    1.283956564817718e-01, // 1807
   -4.831879018371161e-09, // 1808
    4.917771843400818e-04, // 1809
    3.599649522005985e-04, // 1810
    3.012945682924430e-04, // 1811
   -4.820694585352653e-02, // 1812
   -1.979082690639561e-01, // 1813
    1.746357063371293e-06, // 1814
    1.354203015569164e-03, // 1815
    3.949207666994235e-10, // 1816
   -2.119136841287295e-04, // 1817
    2.168237630565096e-01, // 1818
    5.177514906253755e-02, // 1819
    1.854874842205719e-04, // 1820
   -3.211601687869429e-06, // 1821
    5.603898860325906e-07, // 1822
    1.870474509906975e-09, // 1823
    2.386978140330642e-07, // 1824
    1.192578697328972e-06, // 1825
    1.619585071642260e-06, // 1826
   -1.178464620600306e-01, // 1827
    1.387560224340110e-06, // 1828
   -1.310850002826055e-01, // 1829
    2.140057442728104e-01  // 1830
    };

    for (int i = 0; i< 1831; i++)
      threebodyfit[i] = threebodyfit_cp[i];

  } else if (ion == "I") {

    //fit-h4o2i_ccsdtf12_avtz_cp_ts_w_nm_highenergyconfigs_scans   04/25/16
     
    R3I =       0.000000000000000e+00; // A
    R3F =       8.000000000000000e+00; // A
    
    KHH_INTRA = 4.894474582719232e-01; // A^(-1)
    KOH_INTRA = 4.327453626570707e+00; // A^(-1)
    
    KHH =       5.547025984469160e-02; // A^(-1)
    KOH =       4.556437879454365e-01; // A^(-1)
    KOO =       2.665727975587118e-02; // A^(-1)
    
    KXO =       -5.489127303764888e-01; // A^(-1)
    KXH =        9.394988842459783e-01; // A^(-1)
    
    DHH_INTRA = 2.735755155974525e+00; // A
    DOH_INTRA = 3.538187234483583e+00; // A
    
    DHH =       4.062579132859071e-03; // A
    DOH =       6.902380422981034e+00; // A
    DOO =       1.118010804286718e+00; // A
    
    DXO =       -1.567355464209935e+00; // A
    DXH =        6.475551175954035e+00; // A

    double threebodyfit_cp[] = {
    1.132128441182371e+00, // 0
   -1.948159439663807e+00, // 1
   -6.518222738281623e+00, // 2
   -3.112105983320666e+00, // 3
   -4.588683282526138e+00, // 4
    7.524733308502854e-02, // 5
    1.090121243709725e+00, // 6
   -1.508037578600479e+00, // 7
   -1.137814138436817e+00, // 8
    3.580191081697762e-01, // 9
   -1.552703941123466e+00, // 10
   -2.213262370028378e+00, // 11
   -1.195087024011385e-01, // 12
   -1.239934882666165e-01, // 13
    4.182519836778118e+00, // 14
   -7.328875304306198e-02, // 15
   -2.085628834924106e-03, // 16
    6.351971002239239e-02, // 17
    5.114232270861970e-01, // 18
    1.621576138489441e+00, // 19
    4.170302483209274e-01, // 20
   -1.208330607033605e-05, // 21
   -3.413245391164211e-01, // 22
    1.059866826922048e+00, // 23
    7.519228356697293e-02, // 24
    2.962798380882248e+00, // 25
    3.956274133483637e-01, // 26
    4.474560069005845e-08, // 27
   -1.806758658977087e-05, // 28
    1.147214873634181e-05, // 29
    2.907084277511683e+00, // 30
    4.161539881059822e-02, // 31
   -6.842308454872901e-01, // 32
   -7.546528026992081e-06, // 33
    1.672593062639555e-01, // 34
    1.385627663362581e+00, // 35
    1.388159699343187e-06, // 36
    1.325156286186750e-01, // 37
    7.390480452228599e-01, // 38
   -1.701341766003912e+00, // 39
   -3.385230397653374e-01, // 40
    8.259981053841139e-02, // 41
   -7.921621041153328e-05, // 42
   -1.444976718415524e-01, // 43
    4.617268498468634e-02, // 44
    2.200325109741051e+00, // 45
    8.588675386935904e-08, // 46
    2.032047325391504e-02, // 47
    6.108537085540776e-01, // 48
    5.447289145555740e+00, // 49
   -1.308298205782411e-01, // 50
    2.219508233719334e-06, // 51
   -1.022710846046808e+00, // 52
   -1.343011340630355e-01, // 53
   -7.212980036884011e-05, // 54
   -3.478669008606687e-01, // 55
    2.960941507702703e+00, // 56
    1.159491337664827e+00, // 57
   -7.375987963117983e-02, // 58
   -1.554387844927412e-04, // 59
    2.141232378152360e-01, // 60
   -1.121417588949248e-06, // 61
    8.471260507171697e-06, // 62
    5.537478888364994e-03, // 63
   -4.322389490800577e-02, // 64
    3.451554206431296e+00, // 65
    8.602440121822063e-01, // 66
   -1.209520703800557e-08, // 67
   -9.518967976662574e-06, // 68
   -1.331044274465924e+00, // 69
   -2.393564135368440e+00, // 70
    2.674943389076637e+00, // 71
    7.834367868758806e-06, // 72
   -7.927939825539858e-06, // 73
    8.757226377686997e-08, // 74
   -1.739070976942358e+00, // 75
    1.601339141110112e-01, // 76
    4.063791076417902e-02, // 77
    7.611016070320324e-02, // 78
    1.207196743773338e+00, // 79
   -2.458000145849669e-01, // 80
   -1.569367198431883e+00, // 81
    1.699143626090400e-06, // 82
   -1.978798059748619e-01, // 83
   -2.746705584957165e-07, // 84
    5.069200106187290e-07, // 85
    2.317517966544600e-03, // 86
   -3.242402609419815e-02, // 87
    3.699889944074107e-01, // 88
    2.110176038457457e-01, // 89
   -3.030431068354204e-01, // 90
   -1.319333429141158e+00, // 91
    1.403291408797823e+00, // 92
    4.908804759420463e-04, // 93
   -5.158719202769988e-01, // 94
   -1.946347544331727e+00, // 95
    3.408611361675636e-07, // 96
    9.084443898919926e-04, // 97
   -8.748243887673530e-08, // 98
    1.814103427283789e-02, // 99
    2.617813616263942e+00, // 100
    1.056262315078815e-06, // 101
    7.146198336182579e-01, // 102
    9.108894160721197e-07, // 103
    2.299842233699043e-01, // 104
    8.764657874548766e-02, // 105
    4.071748480377820e-01, // 106
   -1.012213634064615e+00, // 107
    2.243150655207806e-01, // 108
   -4.236407994443972e-01, // 109
    1.196669151411602e-01, // 110
   -1.708324262207374e-01, // 111
   -1.824785646516357e-06, // 112
   -1.874187012674621e+00, // 113
   -1.511670814759327e-01, // 114
   -4.650079402475414e-01, // 115
   -1.011819562528100e-02, // 116
    5.993057536588787e-06, // 117
    1.737500785015806e-03, // 118
    5.883850615820878e-01, // 119
    1.214042478277457e-05, // 120
   -8.433084137714821e-07, // 121
   -1.373656712237735e+00, // 122
    4.724666458095542e-01, // 123
    4.217476953720741e-01, // 124
    1.059672645656722e-05, // 125
    1.168660284882296e-01, // 126
    4.886385989127948e+00, // 127
   -4.725931290788242e-01, // 128
    1.158934153843015e-01, // 129
    1.970063746285801e-01, // 130
    1.597020190403512e-03, // 131
   -3.409454664995115e-07, // 132
   -8.963684176394116e-01, // 133
    4.213555505752680e-01, // 134
    9.899089660316597e-05, // 135
   -2.097787913465957e-06, // 136
    2.192796855928625e-06, // 137
   -6.403062928647705e-01, // 138
    1.466929241470302e-05, // 139
    5.849567475853099e+00, // 140
   -1.745186287523663e-03, // 141
   -5.731531367578400e+00, // 142
   -7.509398861521093e-05, // 143
   -4.146781309199860e-01, // 144
   -2.496199591023730e-04, // 145
    4.469614960504184e-01, // 146
    5.212153637965491e-05, // 147
    6.597224320195395e-02, // 148
    1.703034970839527e-07, // 149
   -1.474848238598099e-05, // 150
    4.885326967026949e-06, // 151
    1.774065911368613e+00, // 152
   -8.511115227051216e-04, // 153
   -1.451575344076138e-01, // 154
   -1.145898866592683e-02, // 155
   -4.566218633748616e-01, // 156
    4.002376255396674e-01, // 157
   -9.592990231842673e-10, // 158
    2.442914979323886e-02, // 159
    3.647042369427643e-03, // 160
   -1.389313900807535e+00, // 161
   -2.218573341046943e-01, // 162
   -3.562475120243517e-05, // 163
   -1.226254413989671e+00, // 164
   -8.474992104488883e-02, // 165
    8.777238400159115e-02, // 166
    7.618593509464152e-04, // 167
   -1.088630153867634e-10, // 168
    7.650392217371556e-02, // 169
    2.698884646957740e-10, // 170
   -1.485885772397018e-05, // 171
   -2.682405102984410e-04, // 172
    5.791281546363681e-07, // 173
   -2.297880216679544e-01, // 174
   -7.536482084779749e-01, // 175
    1.492410630651600e-08, // 176
    6.224109713196230e-07, // 177
   -1.658994891425528e-01, // 178
    1.619541321502738e-08, // 179
    1.353671869981949e-07, // 180
   -1.034085703109892e-06, // 181
   -4.258465208094442e-02, // 182
   -2.922889228828449e+00, // 183
    3.199739383300220e-08, // 184
    2.321825695697075e-08, // 185
   -2.926360918452969e-07, // 186
   -5.251965459423831e-04, // 187
   -2.090948810248015e-04, // 188
   -7.431527609055275e-01, // 189
   -1.813432530903859e-01, // 190
   -2.237297834217203e+00, // 191
   -8.148600363234114e-02, // 192
   -2.398276563521898e-02, // 193
   -5.444695069451695e-12, // 194
    1.378106172251886e-01, // 195
   -7.110289013829861e-09, // 196
   -2.430937126749604e-02, // 197
    9.991786264273871e-03, // 198
   -1.345317228835987e-02, // 199
   -6.740221230442145e-06, // 200
   -3.194163601367208e-07, // 201
    3.346043721919047e-03, // 202
   -1.435526048970240e+00, // 203
    7.371225150167839e-03, // 204
    2.312618552626288e-02, // 205
    2.409781149369736e-01, // 206
    8.578733149720690e-10, // 207
   -1.130973219188350e-07, // 208
   -5.926866909551030e-04, // 209
    3.451276194345991e-09, // 210
    7.743805669408310e-08, // 211
    1.054522767164918e-06, // 212
    1.545493274739480e-11, // 213
   -2.560866265567528e-03, // 214
    2.142671711740601e-06, // 215
    1.865669183118092e+00, // 216
    4.552404725509804e-02, // 217
   -1.183314417620121e-03, // 218
    3.090034230669131e-06, // 219
    2.300266007942902e-02, // 220
    2.700535693872689e-05, // 221
   -1.487248778855002e-02, // 222
    4.520832722219692e-01, // 223
    9.666311007227479e-02, // 224
   -4.758229260469199e-08, // 225
    2.778370447010095e-11, // 226
    6.890184529045254e-02, // 227
   -2.305067985334956e+00, // 228
    3.053803301979536e-02, // 229
    1.330747262022181e-09, // 230
   -8.423315913366281e-04, // 231
   -1.974170252794926e-10, // 232
   -1.251448469663278e-06, // 233
    3.836476715252406e-07, // 234
   -7.298565039538114e-05, // 235
   -1.604642009077356e+00, // 236
   -4.789499662032071e-02, // 237
   -1.132492881166677e-05, // 238
    4.220679079020664e-02, // 239
    2.222681632021523e-09, // 240
   -2.290144601957430e-09, // 241
   -4.189609970875971e-10, // 242
   -5.704902457439987e-07, // 243
   -1.234298703540103e-07, // 244
    9.375566253442027e-04, // 245
    4.501449219792138e-09, // 246
   -2.878673840788513e-09, // 247
    3.046071921158463e-05, // 248
    9.760743843896182e-09, // 249
   -5.146970790114040e-04, // 250
    3.738972889789106e-02, // 251
    1.073765641916604e-03, // 252
    6.673851207150705e-09, // 253
   -1.578600110410272e-04, // 254
   -1.051689744153020e-03, // 255
   -2.180721253506362e-01, // 256
    1.053528569412706e-01, // 257
    9.038919596546556e-03, // 258
    1.209415645567036e-01, // 259
   -1.942210811445881e-05, // 260
    3.659387832930819e-04, // 261
   -9.155347593803490e-03, // 262
   -6.944046198923020e-11, // 263
   -2.976794906673890e-02, // 264
   -1.064276385425114e-04, // 265
   -4.230540307924374e-09, // 266
   -1.574263914825884e-01, // 267
    1.938535737844804e-07, // 268
   -7.120577514529325e-07, // 269
    1.246943515272979e-01, // 270
   -6.051588244632795e-10, // 271
    9.039233019641662e-03, // 272
    5.058873978858494e-03, // 273
   -9.149264188902307e-10, // 274
    3.345320231210124e-10, // 275
   -2.236532704839062e-02, // 276
    1.721975302119445e-07, // 277
   -1.034504213098007e+00, // 278
    3.326891138527034e+00, // 279
    1.633006208987937e-04, // 280
   -1.687335751613760e-10, // 281
   -9.646623393244613e-08, // 282
    9.809907843993337e-06, // 283
    2.426439417752596e-01, // 284
    1.726202404045409e+00, // 285
   -4.264723938546621e-06, // 286
   -3.623457336827539e-08, // 287
   -3.538092093879565e-08, // 288
   -2.740357066514475e-09, // 289
    1.821662269617610e+00, // 290
    8.466539419101295e-05, // 291
   -1.107312853009354e-07, // 292
   -1.870319740432872e-06, // 293
   -1.193080607441124e-04, // 294
    6.955545503213550e-02, // 295
    1.159514150107655e-01, // 296
   -1.619140459004339e-02, // 297
   -8.151638718657385e-06, // 298
   -3.959089662511733e-09, // 299
   -1.856219961150348e-10, // 300
   -2.652442219989074e-08, // 301
   -1.165228062477644e-07, // 302
   -3.467679282998936e-01, // 303
    1.109691619988415e-04, // 304
   -2.205629736357289e-09, // 305
   -1.218994798198045e-04, // 306
   -1.773426580979575e-06, // 307
   -1.058438856066069e-03, // 308
   -7.329968920350934e-01, // 309
   -1.352844532724051e-03, // 310
   -4.042109235960371e-07, // 311
    7.304950691695711e-10, // 312
   -1.703076246593470e-04, // 313
   -5.665049447224771e-08, // 314
    2.002163178011611e-02, // 315
    9.039668896956492e-08, // 316
   -3.425203718441296e-01, // 317
    4.922041796516507e-02, // 318
   -9.786944634318566e-06, // 319
   -1.653012517394020e-02, // 320
   -1.604172409647929e-04, // 321
    2.323084130756506e-06, // 322
    4.894383807746665e-02, // 323
    1.006593261803952e-09, // 324
   -3.034246085304083e-03, // 325
   -7.122279884565397e-03, // 326
    3.434018777299163e-09, // 327
   -1.510961048475876e-01, // 328
    1.251613099363716e-08, // 329
   -2.425518500117011e-01, // 330
    2.196482411133613e-09, // 331
   -4.973392821790991e-06, // 332
   -5.260859599365347e-07, // 333
    1.395069045471770e+00, // 334
   -1.453516821710417e-09, // 335
   -5.903951721490886e-05, // 336
    5.891582068087900e-03, // 337
   -9.913353011977887e-05, // 338
    3.331908550429930e-02, // 339
   -2.000902438528866e-02, // 340
   -9.611025648214751e-09, // 341
    4.734356160295138e-11, // 342
    1.094629832741426e-03, // 343
    3.313809670171536e-04, // 344
    9.316324410975146e-07, // 345
    1.486311890429978e-08, // 346
    3.154670027447406e-03, // 347
    3.919567915632588e-06, // 348
    4.427335771415379e-01, // 349
   -1.447206788512088e-06, // 350
   -1.940162650914187e-03, // 351
   -3.725639917785131e-03, // 352
    7.820510770607538e-05, // 353
    1.049639943338893e+00, // 354
   -2.002240170486094e-01, // 355
   -1.066630878148255e-02, // 356
   -3.061888768871868e-03, // 357
   -2.050220393737278e-01, // 358
   -2.082998904017357e-09, // 359
   -4.625732071195237e-08, // 360
   -2.079387748294502e-07, // 361
   -8.446775150512029e-07, // 362
    8.708872782795885e-04, // 363
   -3.973392263311839e-06, // 364
   -2.886223683203925e+00, // 365
    1.333235267886338e-07, // 366
   -4.543825481530863e-06, // 367
    1.329605731924767e-01, // 368
   -3.658563486425296e-08, // 369
    7.060221446647272e-02, // 370
   -2.885402589170213e-10, // 371
    4.528811335959450e-09, // 372
    4.764096234908338e-07, // 373
   -2.375763712281607e-06, // 374
    2.898209094372024e-06, // 375
    2.673838148857566e-03, // 376
   -8.831459255173290e-03, // 377
    2.385527531559092e-01, // 378
   -1.877117056774085e-11, // 379
   -3.030181739660148e-03, // 380
   -7.118905989607226e-02, // 381
   -8.945324140670111e-02, // 382
   -3.785593389562727e-01, // 383
   -1.163860702976344e-05, // 384
   -5.530935254770842e-01, // 385
   -1.100682313383771e-07, // 386
    1.370971668125960e-07, // 387
    1.851389450110315e-07, // 388
   -2.836595455330649e-05, // 389
    9.722444052098909e-09, // 390
    6.773295896374992e-03, // 391
    8.699349111272500e-03, // 392
    1.555291709366782e-08, // 393
   -2.129887625616243e-05, // 394
   -8.772791464339296e-08, // 395
   -4.029034898041291e-03, // 396
    1.235819894648934e-06, // 397
   -3.669091141096780e-08, // 398
    3.376167700899725e-02, // 399
    8.025238960708365e-06, // 400
    1.797862191864266e-07, // 401
   -5.031548837746635e-09, // 402
    3.585939887211311e-01, // 403
    1.851149211979477e-08, // 404
   -1.324233475482609e-04, // 405
   -6.884794880636742e-02, // 406
   -8.175711911301921e-04, // 407
   -8.742317890329123e-07, // 408
    1.547875522967701e-01, // 409
    1.275566435523741e+00, // 410
    9.003277200043582e-10, // 411
    3.986121016038476e-03, // 412
    2.209302710493390e-01, // 413
    5.327264988583386e-07, // 414
    2.581000353786415e-03, // 415
   -1.292899583819082e-08, // 416
   -6.701104191488048e-04, // 417
    3.988157000339501e-07, // 418
   -1.481242635950331e-07, // 419
    2.364127453379843e-02, // 420
    1.464267057024250e-05, // 421
   -2.497634991398578e-05, // 422
   -3.063542898021135e-01, // 423
    8.037027732488011e-02, // 424
    9.463890206334048e-08, // 425
    7.606927093700422e-03, // 426
   -9.278980769424007e-01, // 427
   -2.746992415481862e-09, // 428
   -1.665831443815646e-09, // 429
   -8.936846754508192e-08, // 430
   -5.793388086657706e-08, // 431
    3.515451506307132e-04, // 432
   -3.882454929883380e-02, // 433
    1.428664311409460e-02, // 434
    1.241574252429641e+00, // 435
    8.796007542602577e-12, // 436
    9.155434856899261e-05, // 437
    6.672126099373636e-05, // 438
    3.157729620270277e-06, // 439
    5.775864721399002e-09, // 440
    9.015686787122459e-03, // 441
   -3.861554813874691e-04, // 442
    3.442729919756591e-02, // 443
   -9.114947201485743e-02, // 444
    8.730126329707250e-02, // 445
    1.335116073503465e-06, // 446
   -1.019762554491840e-02, // 447
   -1.471594363219859e-09, // 448
    8.167815591408966e-04, // 449
   -1.488377005977279e-01, // 450
    1.559264078998259e-07, // 451
    2.432731069866615e-09, // 452
   -9.025472220645823e-01, // 453
   -1.017024048776260e-01, // 454
   -1.341347833775153e+00, // 455
   -5.231510893217842e-03, // 456
   -2.432853708002042e-09, // 457
    4.279848868440261e-07, // 458
   -1.667561270831052e-07, // 459
    4.089125866525269e-01, // 460
    3.203865971188670e-04, // 461
   -3.940106244860769e-01, // 462
   -2.156213136891018e-07, // 463
    3.036349736743667e-06, // 464
   -8.779739507812351e-02, // 465
   -4.446522093478870e-09, // 466
   -6.279987542029011e-07, // 467
   -1.177573826247592e+00, // 468
   -1.847688617567481e-02, // 469
   -8.979056002272202e-02, // 470
    1.693461391405903e-07, // 471
   -8.718513835021085e-10, // 472
    4.236593057324611e-08, // 473
    1.658935736028312e-03, // 474
    2.475529419650289e-01, // 475
   -5.653704251370024e-11, // 476
    2.090262711377242e-04, // 477
    1.034365714288654e-08, // 478
   -2.459523241570980e+00, // 479
    4.059183153048605e-02, // 480
   -3.575386039390344e-09, // 481
    2.931626750226046e-08, // 482
   -1.810544341498461e-02, // 483
   -1.669593395546769e-04, // 484
    3.181522495524138e-02, // 485
   -3.025411550955867e-04, // 486
    1.477663704649760e-06, // 487
   -9.711501797761072e-04, // 488
   -1.440888395314504e+00, // 489
    7.591197643779950e-08, // 490
   -2.637133944870132e-06, // 491
    1.897873835865782e-08, // 492
   -3.617945294775661e-08, // 493
    3.159388165908771e-03, // 494
   -9.851679453565869e-07, // 495
    8.010426570919172e-03, // 496
   -8.515181727574574e-09, // 497
   -1.249245010730288e-10, // 498
   -6.339257323659566e-10, // 499
   -8.634535231999054e-03, // 500
    1.255122943156920e-01, // 501
   -1.964692498037667e-04, // 502
   -2.836236453262668e-09, // 503
    4.029323914866629e-01, // 504
   -3.244041197688733e-08, // 505
   -1.359659683558498e-08, // 506
    1.945848280703748e-01, // 507
    9.114629372799226e-05, // 508
   -1.666437352240909e-05, // 509
   -5.778866591018918e-10, // 510
   -1.335742664450093e-05, // 511
   -6.784595483307057e-09, // 512
    7.953905804457516e-06, // 513
   -5.750333431887033e-08, // 514
    2.411531314270617e-05, // 515
   -1.902643172747424e-02, // 516
    6.580491360906718e-11, // 517
   -3.854384117013771e-09, // 518
   -1.652445938017690e-08, // 519
    2.572941475233602e-03, // 520
   -9.573054878105894e-07, // 521
    2.364482872375723e-02, // 522
   -1.533238832889845e-05, // 523
    2.531916752731889e-02, // 524
   -4.383478250579672e-03, // 525
    2.490447422866560e-07, // 526
    2.124952420333468e-04, // 527
   -7.948475713386097e-02, // 528
    9.626626471471185e-09, // 529
    9.416772944350760e-08, // 530
   -8.400164457281060e-07, // 531
   -3.460980837430716e-06, // 532
    6.390189717659114e-01, // 533
   -9.221611554718833e-05, // 534
    2.572517949196650e-01, // 535
    1.949612091015991e-08, // 536
    4.376799843860463e-06, // 537
   -1.991053192577776e-04, // 538
   -6.253371860527697e-06, // 539
    1.929389887792340e-01, // 540
    1.491630373132495e-01, // 541
   -1.030868601866220e+00, // 542
    3.400015465362858e-02, // 543
   -3.367687072410469e-03, // 544
    1.757916602624241e-08, // 545
    5.139290625915281e-09, // 546
    4.445944045572670e-03, // 547
   -6.775590721016873e-05, // 548
   -3.419993921420497e-03, // 549
   -6.681362332500193e-09, // 550
    4.913900603819694e-09, // 551
    4.139827939413434e-03, // 552
   -4.058902089750341e-08, // 553
   -2.825888163200317e-08, // 554
   -3.154001849716619e-02, // 555
   -7.225288042075778e-03, // 556
    3.537096092703963e-03, // 557
   -1.150568196292502e-08, // 558
    2.195329057910628e-08, // 559
    1.022324255917501e-02, // 560
    1.547331287682188e-02, // 561
   -9.897748013004610e-07, // 562
    4.206842807548119e-03, // 563
    8.085820213069156e-04, // 564
   -5.500728461909835e-07, // 565
   -2.341323725399256e-01, // 566
   -2.150038147012892e-02, // 567
   -4.132259855301096e-07, // 568
    5.898659850594716e-08, // 569
   -1.578024059565162e-07, // 570
   -1.137706137181219e-04, // 571
    7.299659959624345e-01, // 572
    5.351624796475616e-08, // 573
   -1.877074915357493e-06, // 574
    4.611045004558856e-05, // 575
    1.200656665770576e-07, // 576
    4.180185001868769e-04, // 577
    2.188376436610630e-04, // 578
    3.040894461817036e-05, // 579
    4.598857457137940e-09, // 580
   -6.269399938733417e-11, // 581
   -1.602801320159867e-06, // 582
   -1.125844128113675e-08, // 583
   -5.717272732657391e-06, // 584
    6.017355798314582e-08, // 585
    2.171070295037031e-07, // 586
   -1.156696036193221e-07, // 587
    6.403195128934307e-04, // 588
    9.098087613703226e-04, // 589
   -2.744100539885500e-10, // 590
    9.055666459103101e-03, // 591
   -6.795543658273189e-06, // 592
    3.222771021360841e-02, // 593
    4.415793812169259e-08, // 594
   -1.084685888422282e+00, // 595
    1.672042513701664e+00, // 596
   -2.187911615730419e-06, // 597
   -8.633818115382040e-09, // 598
    1.395569352986029e-01, // 599
    8.185106427835012e-02, // 600
   -1.240239429789597e-06, // 601
    9.004485962219528e-08, // 602
   -4.890726468959270e-03, // 603
   -6.297855389667483e-05, // 604
   -5.313823139079036e-01, // 605
   -2.607542151838961e-04, // 606
    1.603100573295592e-10, // 607
    5.981734816919084e-08, // 608
    9.944010345754755e-01, // 609
    5.208310035012833e-02, // 610
    2.362545529145976e-07, // 611
   -3.596544120235642e-07, // 612
    8.366976353824884e-10, // 613
    8.382425812892221e-03, // 614
    9.085297114539156e-07, // 615
   -6.566532943986529e-03, // 616
   -2.212328727570185e-10, // 617
   -9.970145722373712e-02, // 618
    4.253523035481944e-11, // 619
    4.133413482592834e-08, // 620
    1.286648804996197e-07, // 621
    2.573939138976883e+00, // 622
    4.160075611116489e-02, // 623
    1.147019162377507e-03, // 624
   -3.613243529937020e-02, // 625
    3.652160256608246e-01, // 626
    1.894712289529580e-05, // 627
   -2.269740576296146e+00, // 628
    1.846142015607304e-06, // 629
   -5.102146880796311e-01, // 630
    2.260962247316574e-07, // 631
    7.718197508352508e-08, // 632
    1.434671396560768e-08, // 633
    2.037692180519191e-10, // 634
   -8.287845246820686e-03, // 635
   -1.551405829672124e-04, // 636
    5.364152224557316e-07, // 637
    5.419895009233341e-08, // 638
   -1.698829972124444e-09, // 639
    1.887007749264721e-04, // 640
    8.673712070797632e-02, // 641
   -2.674999624040064e-06, // 642
    3.458944325472879e-05, // 643
   -1.681192542437735e-09, // 644
   -6.524333075542582e-06, // 645
   -3.296670874796792e-03, // 646
   -3.791995205522749e-03, // 647
    3.866474028048027e-06, // 648
    1.780809736909799e-07, // 649
    1.446723167855931e+00, // 650
    5.153404169297716e-03, // 651
   -4.095692555517941e-07, // 652
    1.699304574686887e-01, // 653
    3.842718950081118e-08, // 654
    3.361655316144266e-08, // 655
   -6.689535598396089e-10, // 656
   -6.281757762145088e-01, // 657
   -2.831416126354961e-04, // 658
   -5.507054567822175e-02, // 659
   -4.861004666936743e-09, // 660
   -5.769968156495870e-03, // 661
    5.156685205199355e-03, // 662
    3.117532634571977e-07, // 663
   -1.503414580769881e-03, // 664
   -3.953317321529808e-06, // 665
   -5.225881181599620e-09, // 666
    4.000944478760945e-02, // 667
    2.253299972174331e-07, // 668
   -5.038782275314010e-02, // 669
   -5.087149463713095e-01, // 670
    4.378483520171779e-01, // 671
    4.836975246581322e-03, // 672
   -4.761872429641511e-06, // 673
    2.917777269452073e-04, // 674
   -3.680570076839135e-09, // 675
    6.563954200500268e-03, // 676
    7.622489633573919e-10, // 677
   -1.074844552095222e-07, // 678
    5.721765261888527e-03, // 679
   -2.946776223041958e-04, // 680
    9.902925962017306e-02, // 681
   -5.938596966787479e-09, // 682
   -1.619551158349616e-07, // 683
   -3.519662971707098e-10, // 684
   -1.204480687993545e-06, // 685
   -1.159362953740959e-02, // 686
   -7.857608032971518e-02, // 687
   -9.393044319187509e-02, // 688
    3.865507311945149e-04, // 689
   -2.654720981467668e-07, // 690
    5.654830295947195e-03, // 691
   -4.001215350609728e-03, // 692
   -2.730321451701535e-07, // 693
    1.163658534743448e-07, // 694
    6.765269519332882e-12, // 695
   -6.936504718439765e-02, // 696
   -2.889958690179582e-04, // 697
   -4.201947426774446e-05, // 698
    1.299396441664685e-08, // 699
    7.263058935861095e-04, // 700
    5.416499960491809e-04, // 701
   -1.812415258565651e-04, // 702
   -4.233234323135350e-03, // 703
    1.006054855276200e-07, // 704
   -2.875549461780013e-01, // 705
   -4.247852632075169e-03, // 706
   -2.905428007948965e-08, // 707
    9.311349697842713e-09, // 708
    5.158231050260753e-08, // 709
    7.214509783443209e-01, // 710
    2.084867812506773e-08, // 711
    1.494297355715975e-03, // 712
    1.104098846316553e-03, // 713
   -1.202827944049549e-06, // 714
   -2.506217495773636e-07, // 715
   -7.690868095927400e-10, // 716
    3.227199392878302e-04, // 717
   -1.908905209725550e+00, // 718
    7.453957273319554e-01, // 719
   -9.772397270322514e-10, // 720
   -2.313063672171997e-07, // 721
    2.247268104001036e-04, // 722
   -4.360657623559771e-11, // 723
    1.000297090635402e-03, // 724
    7.298783042607792e-06, // 725
    4.705507382023854e-06, // 726
   -8.496196771201148e-08, // 727
    2.247949691218714e-02, // 728
   -1.088522416145275e-09, // 729
    7.336088756354506e-05, // 730
   -1.441545587127975e+00, // 731
   -2.716488008067090e-08, // 732
    1.680021321143220e-04, // 733
   -1.168206197819606e-06, // 734
    7.404797623323481e-09, // 735
    6.816693917311451e-09, // 736
    4.193098139118847e-02, // 737
    5.347215616473397e-03, // 738
   -7.970822681757649e-02, // 739
   -4.262380418142414e-03, // 740
    1.431288835429783e+00, // 741
   -8.373963711498183e-05, // 742
   -1.858674942375484e-09, // 743
   -8.995446166510596e-07, // 744
    1.344922615589457e-01, // 745
   -4.917414651086607e-01, // 746
    3.195610294373149e-08, // 747
    1.607176612497831e-08, // 748
    2.050169864120324e-05, // 749
   -2.722079712428465e-07, // 750
    3.163743327629397e-07, // 751
   -4.986575187355847e-08, // 752
    6.178021994066633e-02, // 753
    8.123328346162986e-04, // 754
    2.110467165821378e-05, // 755
   -4.619346630262626e-08, // 756
   -1.020222590235688e-07, // 757
   -5.475209636391234e-06, // 758
   -1.664129655757799e-06, // 759
    1.688272935205264e-08, // 760
   -1.110287964012118e-03, // 761
   -1.402243243984501e-01, // 762
    2.197192344910757e-07, // 763
    1.212086996027154e-06, // 764
   -6.455439124660983e-04, // 765
    8.118299867801039e-06, // 766
    7.730975837416338e-06, // 767
   -5.055038342287059e-06, // 768
    3.465758305057439e-04, // 769
   -7.164202886751184e-04, // 770
   -6.466208286437635e-04, // 771
    1.429254872579665e-07, // 772
    6.401854171386777e-07, // 773
    2.915460190337654e-07, // 774
   -5.197367290638272e-02, // 775
    2.489646777614683e-09, // 776
   -1.172264483221257e-02, // 777
    2.702906770223122e-01, // 778
   -1.017113615747871e-05, // 779
    1.940988132947000e-08, // 780
    6.141023545269164e-06, // 781
   -1.147941863749899e-07, // 782
   -1.220242830219970e-11, // 783
   -3.349381323612159e-03, // 784
   -1.376816827011843e-03, // 785
   -5.087026046149107e-03, // 786
   -3.282957621949546e-09, // 787
    5.377678969430842e-06, // 788
   -2.539482306947313e-10, // 789
   -2.904776256215368e-03, // 790
   -2.399775584443021e-03, // 791
   -1.004589847771594e-09, // 792
    9.829492530154912e-03, // 793
    8.519643782743548e-06, // 794
    2.987432375261722e-10, // 795
   -7.174594219577720e-07, // 796
   -3.561971987285832e-08, // 797
   -8.648996425124681e-05, // 798
   -3.086678044642570e-04, // 799
   -2.808113208139541e-04, // 800
    8.393706219937594e-13, // 801
    8.471972346278598e-04, // 802
    3.162492614169833e-03, // 803
   -1.928711486815487e-09, // 804
    5.450705081149583e-09, // 805
   -1.611259748729550e-02, // 806
    4.323745627398709e-03, // 807
   -1.793192957843236e-03, // 808
   -1.319787577892002e-01, // 809
    5.449667204353565e-01, // 810
   -4.235239375050390e-09, // 811
   -3.149366445272652e-04, // 812
    2.277292391521844e-04, // 813
   -2.014853186897211e-06, // 814
    2.129682904213683e-03, // 815
   -3.076187246173807e+00, // 816
   -3.354501254141585e-01, // 817
    3.390460052818913e-01, // 818
    8.318651515372441e-02, // 819
   -4.910025978702309e-09, // 820
    1.596243163887863e-05, // 821
   -1.484050304680029e-01, // 822
    3.961250132331254e-02, // 823
    8.146446085139328e-06, // 824
    5.056350062455977e-07, // 825
   -1.209767809077977e-06, // 826
    8.671715005431456e-03, // 827
   -1.739978415699065e-04, // 828
   -1.699688482869701e+00, // 829
    1.920855312062648e-09, // 830
   -4.409466270912434e-06, // 831
   -3.247132435363561e-10, // 832
    4.314359091600046e-10, // 833
    2.387473053489369e-05, // 834
   -5.570089721221688e-09, // 835
    1.952108167289193e-01, // 836
   -2.248165964067204e-03, // 837
   -3.490077298562158e-05, // 838
    6.735987083282681e-06, // 839
    1.774161606971504e-09, // 840
   -1.815645256733890e-01, // 841
   -1.274099718987163e-08, // 842
    5.957575952247497e-03, // 843
   -4.915983414455351e-04, // 844
   -1.300407766729350e-01, // 845
   -1.026201119352742e+00, // 846
    2.511462773467682e-08, // 847
    2.075058242079468e-01, // 848
   -6.269254864562505e-06, // 849
   -4.540410632227410e-04, // 850
    1.985123443884790e-02, // 851
   -2.253960148650438e-08, // 852
    1.543617500266468e-02, // 853
    1.315946286957361e-08, // 854
   -1.448320786121756e-07, // 855
    5.510948722247183e-03, // 856
    1.083970143803772e-06, // 857
   -9.298240233062267e-03, // 858
    3.764249473504828e-06, // 859
   -1.435598416139217e-10, // 860
   -2.423653121123970e-03, // 861
   -5.779529364538546e-06, // 862
   -1.683366279617350e-08, // 863
    4.064547386135370e-11, // 864
    1.865479983511891e-01, // 865
   -6.867556365581268e-02, // 866
    7.311186251999074e-03, // 867
    8.233904301397550e-05, // 868
   -1.704106022734689e-08, // 869
    1.113034818035543e-07, // 870
    4.764465674062824e-07, // 871
    1.788320347846990e-04, // 872
   -3.143256156393377e-05, // 873
   -4.027944782403810e-09, // 874
    9.191540233168280e-02, // 875
   -6.289802621332560e-11, // 876
   -5.473085482460020e-03, // 877
   -4.804840303943178e-09, // 878
    7.153648777990744e-03, // 879
   -1.553578152130423e-07, // 880
    1.682001549680576e-04, // 881
   -4.869506386436965e-10, // 882
   -6.136792570808813e-04, // 883
   -3.240610591327289e-05, // 884
   -7.205696693775667e-05, // 885
   -3.403694421093266e-04, // 886
    3.680910938916244e-11, // 887
    1.273326112130937e-09, // 888
   -9.619539304392642e-10, // 889
    6.223750494272056e-01, // 890
   -1.322873804900012e-02, // 891
   -3.725612086892824e-06, // 892
   -2.507749192697602e-04, // 893
   -2.222175474948273e-01, // 894
   -3.676116579460886e-03, // 895
    9.006985313029426e-04, // 896
   -3.305824422496850e-09, // 897
   -2.825877778263318e-04, // 898
   -3.582872405923966e-03, // 899
   -1.030620634218135e-01, // 900
    4.617152683170551e-01, // 901
    2.223339898415101e-04, // 902
    4.766902379935506e-09, // 903
    2.315324609790953e-02, // 904
    1.876019757653153e-02, // 905
    6.028915791357718e-08, // 906
   -4.399920462221596e-10, // 907
   -9.738201457280121e-07, // 908
    5.217654513822446e-02, // 909
   -8.850572992586502e-05, // 910
    2.428344730596446e-04, // 911
    3.462678823356583e-04, // 912
    6.078772500463180e-09, // 913
   -3.664155922675230e-02, // 914
   -2.079125403227934e-03, // 915
   -3.350104669205068e-03, // 916
   -1.716987399756855e-03, // 917
    1.314302765087847e-09, // 918
   -1.718981970280350e-07, // 919
   -1.564326638654393e-02, // 920
    7.998387956512218e-04, // 921
    2.574972245255451e-05, // 922
   -1.599410463101830e-05, // 923
    1.853464056335789e-07, // 924
   -2.744880748002868e-05, // 925
    5.910231759416150e-07, // 926
    1.245384154560519e-08, // 927
    8.469083286959136e-04, // 928
   -1.726495032393096e-01, // 929
    7.016277980496396e-06, // 930
   -7.332892514383047e-05, // 931
   -5.589422197030461e-04, // 932
    4.322854278132167e-07, // 933
   -1.597728335622302e-03, // 934
    1.132533481128609e-01, // 935
    1.725771347757393e-05, // 936
   -3.345044616252562e-05, // 937
   -1.442290022694293e-05, // 938
    3.780315051693926e-03, // 939
    3.830112450954492e-04, // 940
   -1.255634941164165e-06, // 941
   -1.233785428182182e-03, // 942
    1.912283752903486e-04, // 943
   -1.444888524046966e-03, // 944
   -6.159478847805614e-04, // 945
    2.173955104818040e-05, // 946
   -6.647634971923186e-06, // 947
   -4.441998303670151e-03, // 948
    9.195017148825347e-05, // 949
   -5.312028835385875e-05, // 950
   -6.627875365355190e-06, // 951
   -5.473444197599224e-10, // 952
   -4.497592979453806e-05, // 953
   -3.430613900540389e-06, // 954
    1.729549562586389e-04, // 955
   -2.449262529160778e-06, // 956
    1.991530665663877e+00, // 957
    6.498545134363289e-03, // 958
   -3.481545110603172e-06, // 959
    3.714678860524752e-03, // 960
    6.505049053513224e-10, // 961
    8.548167260134976e-05, // 962
    5.752595713244856e-05, // 963
   -2.299499141072010e+00, // 964
    9.307109650433241e-03, // 965
   -3.127832148429804e-03, // 966
    4.051569759828943e-03, // 967
    1.174338806586130e-01, // 968
    3.695654858745416e-05, // 969
   -4.682354450729677e-02, // 970
   -4.164806077769140e-07, // 971
   -5.589079188247459e-06, // 972
    2.686160869729786e-04, // 973
    2.453001912591477e-06, // 974
   -1.810177230347738e-02, // 975
   -2.287128831003961e-04, // 976
   -1.214099371162883e-04, // 977
   -7.302989597632335e-05, // 978
    1.461645356194083e-03, // 979
   -1.912934851292852e-02, // 980
    1.323665941337991e-03, // 981
    3.791953138705052e-01, // 982
    3.000382658318680e-08, // 983
    5.436438718119494e-04, // 984
    3.041182767815956e-04, // 985
   -3.897842137624172e-03, // 986
    7.191175765355572e-03, // 987
   -1.436810584057460e-01, // 988
   -1.134744349591569e+00, // 989
   -2.595005006185437e-03, // 990
   -5.785436490762968e-03, // 991
   -6.062531233882805e-06, // 992
    1.359219411213628e-05, // 993
   -8.808462922669501e-03, // 994
    1.065748103262695e-04, // 995
   -2.891176870264531e-06, // 996
   -1.599059936389483e+00, // 997
   -1.073586269082434e-04, // 998
    4.925802854330019e-07, // 999
   -8.765282742379588e-05, // 1000
    1.426380821746120e-06, // 1001
    5.213010444975625e-04, // 1002
   -1.943621828220344e-02, // 1003
    1.454383237865526e-04, // 1004
   -1.426833382614130e+00, // 1005
   -5.072800257601845e-04, // 1006
   -1.042961772592774e-05, // 1007
   -2.830516507200991e-04, // 1008
    1.764927420802839e-04, // 1009
    5.158513670115157e-04, // 1010
   -6.145247964248711e-04, // 1011
    4.868004288150044e-07, // 1012
    1.766845894426929e-06, // 1013
    2.413122369133390e-06, // 1014
   -2.491047665863056e-02, // 1015
    6.796854595891133e-04, // 1016
    4.358259360899871e-03, // 1017
    1.745483247056032e-04, // 1018
    8.801014248925835e-05, // 1019
   -1.334370466903579e-07, // 1020
    8.722434900745833e-04, // 1021
   -4.061662650281355e-04, // 1022
   -1.221085119014416e-01, // 1023
   -4.129432005841392e-07, // 1024
    6.447357196594463e-06, // 1025
    3.755314968754917e-04, // 1026
    1.253111064187035e-04, // 1027
   -3.899477238334127e-02, // 1028
   -3.616913694703353e-04, // 1029
   -1.039903636020446e-01, // 1030
   -8.328395362275859e-07, // 1031
    2.916923024034796e-03, // 1032
    1.069003600476861e-03, // 1033
    7.035593939559737e-07, // 1034
    9.513360397688977e-03, // 1035
   -1.098488871283946e-02, // 1036
   -6.662302495053307e-05, // 1037
   -4.921475770490837e-04, // 1038
   -1.139642005512380e-05, // 1039
   -5.866644918025247e-04, // 1040
   -1.056750374184988e-05, // 1041
    8.900598931522273e-05, // 1042
   -1.123014708827377e-04, // 1043
   -4.376794362590845e-05, // 1044
    1.140399702812820e-04, // 1045
    5.966687053877047e-05, // 1046
    1.006826103671411e-01, // 1047
   -1.031047145297010e-06, // 1048
   -4.082008300122804e-04, // 1049
    6.622285628326128e-06, // 1050
    3.988677548178291e-04, // 1051
    4.389796233408097e-03, // 1052
    4.196318795648544e-05, // 1053
   -2.609676555803179e-05, // 1054
    2.407183776888656e-01, // 1055
    1.274014591173253e-04, // 1056
   -4.571621660695425e-02, // 1057
   -1.169121306585317e-03, // 1058
   -1.821843251568033e-05, // 1059
   -3.109797629863086e-06, // 1060
   -5.188405539177683e-01, // 1061
   -7.653511568136120e-03, // 1062
   -2.076787001903397e-02, // 1063
    6.274531871763256e-04, // 1064
    1.330572808751276e-03, // 1065
   -1.300461650805005e-02, // 1066
   -5.235558390631806e-03, // 1067
   -1.624213176137257e-04, // 1068
   -1.116435926262376e-04, // 1069
   -3.977774549764639e-03, // 1070
    5.531193161144630e-05, // 1071
    6.563586087980946e-04, // 1072
    3.715067357593577e-07, // 1073
   -1.112778068721960e-04, // 1074
   -1.240727872852429e-05, // 1075
    1.760060396400376e-04, // 1076
   -6.861213605306911e-05, // 1077
   -7.654071382275176e-05, // 1078
    2.936767381925621e-07, // 1079
    2.471042829915321e-07, // 1080
    9.174946464138008e-05, // 1081
    1.856807410010483e-01, // 1082
   -4.300310808129843e-04, // 1083
    1.030904629666141e-06, // 1084
    2.745733708435545e-03, // 1085
   -3.422708431558939e-07, // 1086
    1.710053161019476e-03, // 1087
    5.878253459668869e-04, // 1088
    4.078382114823931e-06, // 1089
    2.392407896611430e-04, // 1090
   -7.495352553057871e-06, // 1091
   -1.038465917154240e-03, // 1092
   -1.403497291224109e-05, // 1093
    1.163015286092242e-03, // 1094
    2.731795062681962e-03, // 1095
   -1.494931547510567e-03, // 1096
   -1.370822832373601e-05, // 1097
    4.330852118606635e-04, // 1098
   -2.319104801260888e-06, // 1099
    2.342787353990174e-04, // 1100
    6.086287638658166e-03, // 1101
   -1.547612851054826e-04, // 1102
   -4.063222100815867e-04, // 1103
   -1.315992255596638e-04, // 1104
   -4.282525347288658e-05, // 1105
   -2.263052027273630e-04, // 1106
    2.035671814863714e-02, // 1107
   -1.561399391395046e-04, // 1108
   -3.889781748228116e-07, // 1109
    1.387389001664304e-07, // 1110
   -7.757188066107695e-04, // 1111
   -5.536370324106518e-02, // 1112
    3.780872977728757e-02, // 1113
   -7.504344332992558e-06, // 1114
    1.437933671995491e-04, // 1115
   -1.148183490049648e-04, // 1116
    3.602905893326255e-06, // 1117
    1.347232617455383e-03, // 1118
    6.814253996579667e-06, // 1119
    2.038743148911966e+00, // 1120
    2.462277214445324e-04, // 1121
   -2.417998227465899e-06, // 1122
   -1.653281421480886e-02, // 1123
    4.174539379242984e-04, // 1124
   -4.997450046058027e-03, // 1125
   -1.760272527590083e-06, // 1126
    1.515827752291246e-03, // 1127
   -1.421885793983951e-05, // 1128
    3.547257355222431e-02, // 1129
    9.027990308872726e-06, // 1130
   -8.003696406675209e-05, // 1131
   -1.093314206454218e-06, // 1132
   -6.407829340530413e-04, // 1133
    8.609024617379044e-01, // 1134
   -1.866479670352555e-06, // 1135
    3.040584000307381e-06, // 1136
    1.136891766840527e-05, // 1137
    2.036311141625589e-03, // 1138
   -7.893467140869649e-06, // 1139
    1.148784836044100e-03, // 1140
   -1.033906052611921e-02, // 1141
   -6.035775555300987e-03, // 1142
   -5.262851233135591e-04, // 1143
    1.172794068703803e-04, // 1144
   -2.225996357487652e-05, // 1145
    3.136621866306043e-02, // 1146
    1.146645025100874e-05, // 1147
   -2.391786513018969e-08, // 1148
    5.010092418216311e-07, // 1149
    2.909919552867108e-05, // 1150
   -1.590386171913280e-01, // 1151
    2.830650605664726e-04, // 1152
    2.321799144212250e-06, // 1153
   -1.243296381519920e-02, // 1154
    2.174530697636183e-05, // 1155
    9.020740679681083e-03, // 1156
    1.106412401470326e-02, // 1157
    3.080808678343917e-06, // 1158
   -3.605764425648625e-03, // 1159
   -3.734349261709371e+00, // 1160
    3.981671174765270e-05, // 1161
    3.871004262847295e-06, // 1162
   -5.418349923553850e-02, // 1163
    3.897457837615962e-05, // 1164
    2.893708260890149e-05, // 1165
   -1.934406611238765e-08, // 1166
   -1.564020983529824e-03, // 1167
   -6.196521732287067e-03, // 1168
   -8.268645888521175e-04, // 1169
    1.124103274482361e-03, // 1170
   -7.765071838842478e-06, // 1171
    6.951036551329526e-02, // 1172
    3.305825062699650e-04, // 1173
   -2.509096130717366e-05, // 1174
   -4.501155488128063e-03, // 1175
    2.145451584554279e-05, // 1176
   -5.737294401106694e-07, // 1177
    4.158329243876232e-05, // 1178
    2.132787046962006e-03, // 1179
    1.210212362151018e-04, // 1180
    2.367797617443743e-05, // 1181
   -8.208822138258529e-03, // 1182
   -2.880118193195143e-04, // 1183
   -1.841937885714538e-07, // 1184
   -1.774233581720291e-06, // 1185
    1.400470638370830e-08, // 1186
    1.831501820015359e-04, // 1187
    3.833905228664455e-04, // 1188
   -3.577832980036939e-05, // 1189
   -1.736272956619517e-04, // 1190
    9.846532263827331e-06, // 1191
    5.285115759918034e-06, // 1192
    3.768985559515997e-06, // 1193
   -7.240847931314244e-03, // 1194
   -2.590797202215239e-04, // 1195
    2.142664094481689e-03, // 1196
    5.551316020807012e-05, // 1197
   -9.417410502290210e-05, // 1198
   -1.338891745838038e-05, // 1199
    3.776552315177299e-03, // 1200
    3.013335887259113e-08, // 1201
   -1.345390948285073e-04, // 1202
   -3.006302929587717e-08, // 1203
    9.085997818265979e-03, // 1204
   -1.326620432354482e-04, // 1205
   -4.210078363694510e-01, // 1206
    1.721517268894133e-04, // 1207
   -2.247450250215847e-03, // 1208
   -2.049773715193174e+00, // 1209
   -1.335691830860220e-07, // 1210
    2.374961909495506e-05, // 1211
   -8.280641300203703e-02, // 1212
    4.484224087363489e-08, // 1213
   -1.094920320742664e-07, // 1214
    1.904682670817891e-04, // 1215
    5.061872774958559e-05, // 1216
   -3.461227225387711e-05, // 1217
   -3.958172266908259e-03, // 1218
    1.998285192180340e-07, // 1219
    3.137435315833179e-06, // 1220
    3.519664382748530e-07, // 1221
   -1.511407601523670e-04, // 1222
    6.896340660918145e-08, // 1223
   -2.443496955434332e-08, // 1224
   -5.770616361021062e-04, // 1225
    9.556236984562808e-02, // 1226
   -7.843383080137432e-06, // 1227
    2.100197491416081e-04, // 1228
    2.234687044184057e-06, // 1229
    3.581111949061519e-04, // 1230
    6.164872088045325e-02, // 1231
    1.274721733632663e-02, // 1232
   -1.271089610637406e-04, // 1233
    2.344519876012125e-06, // 1234
    1.401047867734017e-04, // 1235
    9.284061518097471e-03, // 1236
   -2.057693380588978e-01, // 1237
    7.384485349229254e-06, // 1238
   -1.136747920796334e-10, // 1239
   -2.354209514505283e-02, // 1240
   -5.066656950500904e-03, // 1241
    3.233664495486822e-06, // 1242
   -7.777788341537300e-05, // 1243
    2.780451700181482e-07, // 1244
   -4.931869401497723e-07, // 1245
    1.053166784929268e-05, // 1246
    3.647978681519832e-05, // 1247
    5.354368930814221e-05, // 1248
   -2.531993593224927e-02, // 1249
    2.921812009690022e-07, // 1250
   -3.453926993130292e-04, // 1251
    7.205644136384606e-06, // 1252
   -1.039431799669131e-05, // 1253
    2.244794213701710e-02, // 1254
    1.052234227426733e-05, // 1255
   -9.258721533333752e-02, // 1256
   -2.607266907255498e-02, // 1257
   -2.529713654340045e-05, // 1258
   -1.635406514251520e-04, // 1259
   -4.403347855518806e-07, // 1260
    1.960223630372067e-02, // 1261
   -9.085081937911051e-07, // 1262
   -6.553988297881414e-06, // 1263
   -8.318586083528809e-07, // 1264
   -9.294829764306406e-03, // 1265
   -1.907090497267290e-05, // 1266
    1.169518949679869e-03, // 1267
   -4.418733720100717e-05, // 1268
   -6.121129145895834e-03, // 1269
   -3.785074914349225e-05, // 1270
   -9.936781437173126e-06, // 1271
   -2.704047654699266e-02, // 1272
    4.148481531356754e-07, // 1273
    8.701154659198276e-08, // 1274
   -7.633500488476215e-03, // 1275
   -3.079517829596440e-02, // 1276
    1.267635464839193e-01, // 1277
   -3.037508087784520e-03, // 1278
    9.155006702970271e-06, // 1279
    1.302615200822902e-05, // 1280
   -4.004588004263363e-06, // 1281
   -9.452268064239714e-04, // 1282
   -5.369574550567320e-06, // 1283
    5.194204126176016e-01, // 1284
   -3.524346717889577e-03, // 1285
    6.132526903616811e-03, // 1286
    3.708088591543643e-04, // 1287
    1.540166909674910e-02, // 1288
   -7.155683981223576e-02, // 1289
    1.888798799718113e-02, // 1290
    4.912169368585782e-03, // 1291
   -8.845265024044160e-05, // 1292
    5.313827294396542e-07, // 1293
   -3.297488569293010e-06, // 1294
   -5.534253494658425e-05, // 1295
    1.462148950077438e-04, // 1296
    1.902435813550066e-05, // 1297
   -1.840722918989961e-04, // 1298
    4.304317036430379e-03, // 1299
   -2.238349949073815e-06, // 1300
    1.628439645553474e-07, // 1301
   -7.056153990577497e-03, // 1302
   -2.731489570005994e-05, // 1303
   -9.628652608102451e-06, // 1304
   -3.780397397948508e-03, // 1305
   -1.583443453970997e-04, // 1306
    2.443932981531090e-05, // 1307
   -9.745070985274942e-06, // 1308
   -2.836483591049192e-05, // 1309
   -8.506613164954098e-08, // 1310
   -2.523785084066002e-04, // 1311
    4.105876955916315e-06, // 1312
    9.310096564936346e-04, // 1313
    7.815044204527787e-07, // 1314
    8.220661584948517e-05, // 1315
    2.919421267459108e-04, // 1316
    6.937344824926210e-04, // 1317
   -1.543304700939290e-05, // 1318
    2.526117228954177e-07, // 1319
    5.614452948638273e-04, // 1320
    1.219456857633045e-03, // 1321
   -3.389955328132432e-02, // 1322
   -1.441463926565813e-03, // 1323
    1.209748619631547e-06, // 1324
    2.785306496414011e-05, // 1325
   -3.063567115856657e-05, // 1326
    4.650475086290850e-07, // 1327
    1.515442958835542e-02, // 1328
    3.266591925539274e-04, // 1329
   -7.440672306931849e-03, // 1330
    3.791308004675716e-02, // 1331
   -5.211778481360772e-02, // 1332
    1.250896801394098e-04, // 1333
    3.824918756311056e-03, // 1334
    1.419827504227157e-06, // 1335
    2.787494547327466e-01, // 1336
   -3.310586073819287e-06, // 1337
    2.959744710011514e-03, // 1338
   -3.387917365571809e-05, // 1339
   -8.079316135620103e-03, // 1340
    2.092741398216027e-04, // 1341
   -6.380867139125451e-06, // 1342
    6.272342064024624e-06, // 1343
   -1.124738347845727e-03, // 1344
    7.792659927027920e-03, // 1345
    1.488512666163358e-03, // 1346
    1.600369201071461e-06, // 1347
    3.355369172628522e-07, // 1348
    3.196214974528483e-01, // 1349
   -4.364977109624306e-04, // 1350
    1.219719389236254e-03, // 1351
   -3.158259513877739e-04, // 1352
   -7.427750181302692e-06, // 1353
   -3.956836563807744e-06, // 1354
    8.350030114625773e-01, // 1355
   -5.256198536709389e-04, // 1356
    1.791285670270408e-04, // 1357
   -2.618471184510089e-06, // 1358
    5.549797275790150e-06, // 1359
   -1.596353765613505e-06, // 1360
   -1.542457913692218e-01, // 1361
   -3.311499592344901e-04, // 1362
   -3.562179733459376e-02, // 1363
   -5.604095093939908e-03, // 1364
   -1.064755498978028e-03, // 1365
   -3.814657765658358e-04, // 1366
    3.592803494566721e-04, // 1367
    5.539201776149550e-05, // 1368
   -2.614162834700023e-03, // 1369
    3.396308723258086e-07, // 1370
   -1.037155406650955e-05, // 1371
    1.236244091979372e-04, // 1372
    1.208182036736311e-02, // 1373
   -5.318155256164276e-05, // 1374
   -2.102440557242139e-05, // 1375
   -3.164695948594408e-04, // 1376
   -1.230966107118042e-05, // 1377
   -3.842264644066173e-04, // 1378
    1.936100665273565e-04, // 1379
   -1.488890735490310e-04, // 1380
   -8.065740255748635e-01, // 1381
   -1.557185421801935e-04, // 1382
   -1.308940939131069e-03, // 1383
    4.429176767423200e-08, // 1384
    9.060777099052279e-02, // 1385
   -4.436340087001221e-06, // 1386
   -4.450964257176646e-05, // 1387
   -8.828531464781018e-03, // 1388
   -1.143237211339233e-04, // 1389
   -1.244690885440643e-01, // 1390
   -5.954032038636740e-06, // 1391
    7.458750805391377e-04, // 1392
    4.193246053018767e-04, // 1393
    1.022760011909821e-03, // 1394
    1.763142803477071e-03, // 1395
    3.609103823709109e-03, // 1396
   -3.364856716374422e-04, // 1397
   -7.662143818575908e-01, // 1398
   -3.639866713072469e-06, // 1399
    4.475558034890408e-04, // 1400
    9.623695080247837e-08, // 1401
   -3.807514876631705e-04, // 1402
    3.515260598361783e-06, // 1403
    1.370441951330491e-05, // 1404
   -3.583748226147697e-04, // 1405
   -1.387862121707645e-03, // 1406
    4.740416109308538e-03, // 1407
   -2.665769447465521e-04, // 1408
   -2.599871913710096e-02, // 1409
   -2.475235252240953e-08, // 1410
    1.771481368836012e-03, // 1411
    1.055950611366323e-01, // 1412
   -1.557826505474026e+00, // 1413
    5.086568454279975e-05, // 1414
    1.357262212137798e-04, // 1415
    4.230061308510811e-03, // 1416
    1.739792442204111e+00, // 1417
    9.113185678796269e-04, // 1418
   -9.762364818247350e-05, // 1419
    5.164581240725195e-04, // 1420
    4.907426131208092e-04, // 1421
   -3.919097164763595e-03, // 1422
    5.103316156261074e-07, // 1423
    8.601841724755864e-08, // 1424
   -9.095881733512918e-06, // 1425
   -1.000002334810994e-04, // 1426
   -1.596200049027304e-06, // 1427
    1.764330094270447e-05, // 1428
    2.395070947875182e-05, // 1429
    8.477224466641097e-07, // 1430
   -3.412797129711794e-04, // 1431
   -6.109049017189511e-03, // 1432
   -6.781767314505418e-01, // 1433
    4.121284341791189e-04, // 1434
    1.232248991594644e-05, // 1435
    1.026924441760899e-08, // 1436
   -1.117470383620909e-04, // 1437
   -9.953280965368842e-05, // 1438
   -2.535910762881761e-04, // 1439
    3.108121341716396e-04, // 1440
   -4.587540035145975e-03, // 1441
   -2.764035896450396e-05, // 1442
    1.263329531786412e-05, // 1443
   -8.674439131801926e-03, // 1444
    2.086720180665483e-05, // 1445
    6.422324885673253e-04, // 1446
    2.074925502036093e-02, // 1447
   -3.281354627047787e-06, // 1448
   -2.463138881475982e-01, // 1449
    1.188598973968033e-06, // 1450
    7.548204081912007e-06, // 1451
   -4.656863160407865e-08, // 1452
   -4.016764232445722e-06, // 1453
   -1.921382473026084e-02, // 1454
   -4.064448967865800e-08, // 1455
    2.916854482828196e-06, // 1456
   -5.893661200880760e-04, // 1457
    4.361024988190926e-06, // 1458
    4.128172069693950e-07, // 1459
   -3.964807284727741e-06, // 1460
   -7.490769583523725e-06, // 1461
   -2.557327448754395e-07, // 1462
    6.303728331641847e-06, // 1463
   -6.987086249517517e-05, // 1464
    1.688146144215104e-04, // 1465
    2.644191791118994e-03, // 1466
    1.315166398664319e-04, // 1467
   -2.964405819743771e-08, // 1468
    2.304002698802406e-03, // 1469
    1.721121850513220e+00, // 1470
   -1.280921248687447e-01, // 1471
   -4.419448191788935e-08, // 1472
   -1.961125053264960e-06, // 1473
    1.367687021196737e-04, // 1474
   -1.401657203699166e-06, // 1475
    2.579786952760251e-04, // 1476
    6.970286487914541e-07, // 1477
   -3.805002279558178e-08, // 1478
    1.226466768757365e-04, // 1479
    6.497104865910038e-04, // 1480
   -2.961986015600847e-06, // 1481
   -9.922972654742362e-04, // 1482
    1.353334520583636e-05, // 1483
   -2.543072676308796e-03, // 1484
    1.214085149528921e-04, // 1485
    7.880969009888881e-04, // 1486
    7.929562469686591e-03, // 1487
    1.111368999127473e-04, // 1488
    1.071145494457302e-04, // 1489
   -2.971856875456856e-04, // 1490
    1.989900014703771e-08, // 1491
    4.742731529134572e-06, // 1492
    1.494373268432094e-05, // 1493
    9.288837623366679e-07, // 1494
    2.557685080371024e-02, // 1495
    4.380815401582729e-04, // 1496
    7.164594730928011e-07, // 1497
    7.892594521339133e-03, // 1498
   -1.440396669166467e-03, // 1499
   -2.134600808217537e-07, // 1500
   -5.055653099689573e-05, // 1501
   -7.929126313529596e-03, // 1502
    6.649567603028560e-04, // 1503
   -1.001566631443536e-06, // 1504
    2.349193439526177e-06, // 1505
    2.545759615557765e-08, // 1506
   -1.779721342016495e-05, // 1507
    9.648311210311232e-05, // 1508
    3.104442009438362e-10, // 1509
    6.245105976635188e-05, // 1510
    2.863773484840606e+00, // 1511
   -7.477846546463490e-03, // 1512
    3.449860293628671e-05, // 1513
   -5.436636981228528e-05, // 1514
   -8.682937108999814e-08, // 1515
   -3.810821132207303e-08, // 1516
   -4.508984517687909e-09, // 1517
    9.051947352132598e-07, // 1518
   -4.661247042703112e-05, // 1519
   -3.129681077839478e-04, // 1520
    2.494502290780465e-04, // 1521
   -8.603078947475444e-06, // 1522
    1.294738736270731e-07, // 1523
   -2.957058745505627e-06, // 1524
    9.479283099475710e-03, // 1525
   -8.677193373175797e-05, // 1526
    1.559443185883368e-05, // 1527
   -2.699400039826110e-04, // 1528
    2.018735772503828e-05, // 1529
    1.976236216025992e+00, // 1530
   -1.058777711548630e-07, // 1531
    7.926082460103128e-07, // 1532
   -1.602899783492276e-06, // 1533
    8.327234735052076e-01, // 1534
    1.174501344747949e-02, // 1535
    2.126603957387344e-04, // 1536
    7.055852863523672e-05, // 1537
    1.418403783574318e-03, // 1538
   -3.064755095204171e-04, // 1539
    2.086040752220132e-05, // 1540
    3.432531454546064e-04, // 1541
    9.544789157265749e-05, // 1542
   -2.123911915675378e-02, // 1543
    2.242253268785844e-09, // 1544
    1.696747303578836e-01, // 1545
   -1.895919021471037e-03, // 1546
    1.464381285318805e-03, // 1547
    1.720518856666715e-03, // 1548
   -1.718681456543113e-06, // 1549
   -1.356981821352457e-03, // 1550
    6.251445452514717e-05, // 1551
    6.077765494803591e-04, // 1552
   -1.458980062519349e-04, // 1553
   -3.321971375814303e-02, // 1554
   -1.998601192823493e-06, // 1555
    7.735195999635895e-06, // 1556
   -4.229759767611664e-08, // 1557
   -2.115237594668268e-04, // 1558
    1.163913089851838e-04, // 1559
    3.102196671552307e-03, // 1560
   -1.098671999216475e+00, // 1561
   -1.071522738880194e-04, // 1562
    3.123467463424177e-05, // 1563
    9.283695635121981e-03, // 1564
    7.177444395236475e-05, // 1565
    1.321064729828036e-02, // 1566
   -5.369177617857112e-09, // 1567
    1.108708884832991e-05, // 1568
   -3.803589562387039e-03, // 1569
   -2.981836967359933e-05, // 1570
   -6.590367541168322e-06, // 1571
    4.593422799132907e-04, // 1572
    8.808737798182246e-09, // 1573
   -1.328773843638251e-07, // 1574
   -2.518916330748581e-05, // 1575
    6.163915257632913e-02, // 1576
    4.927173258884122e-05, // 1577
   -4.694245849577386e-02, // 1578
   -2.413602340552459e-06, // 1579
    9.196299577799675e-05, // 1580
    2.429948371473389e-04, // 1581
   -1.201797881441749e-03, // 1582
    7.921183610174174e-05, // 1583
   -1.112778474422322e-05, // 1584
   -2.046880315261327e-08, // 1585
   -1.621972144956380e+00, // 1586
    2.762836594076516e-05, // 1587
   -3.653021099894746e-05, // 1588
   -9.397866723430594e-02, // 1589
    2.820282028857020e-03, // 1590
   -1.088519326354585e-07, // 1591
    4.551055691504725e-03, // 1592
   -2.693790476994767e-04, // 1593
    1.844278552862601e-05, // 1594
    3.850130504460168e-06, // 1595
    8.874935720704174e-05, // 1596
   -1.150008111180868e-09, // 1597
    4.717283328358744e-05, // 1598
   -2.434417018246986e-07, // 1599
   -1.190631415361755e-03, // 1600
   -3.700584170019803e-08, // 1601
    4.913343979491039e-07, // 1602
   -3.519398407417428e-02, // 1603
    4.251325612760835e-03, // 1604
    1.759979503863279e-04, // 1605
   -5.712354215455823e-03, // 1606
   -2.399507349880972e-08, // 1607
   -1.069510243401433e-06, // 1608
    4.863068907799732e-05, // 1609
   -2.325984332035728e-03, // 1610
    4.381929671885532e-08, // 1611
    3.406373349320142e-03, // 1612
   -2.086733750679886e-04, // 1613
   -2.548999574589308e-08, // 1614
   -1.611058129274374e-06, // 1615
   -1.313946247579261e-05, // 1616
    1.093359931314441e-02, // 1617
    5.680824845494322e-07, // 1618
    1.342858222065122e-03, // 1619
    1.958643054625396e-03, // 1620
   -2.507081052250117e-07, // 1621
   -2.956177705589441e-05, // 1622
    2.855968943901784e-05, // 1623
    1.069107234066510e-02, // 1624
   -5.307581536654372e-03, // 1625
    5.090138033497887e-05, // 1626
   -7.222111122103685e-07, // 1627
   -5.033096011681277e-04, // 1628
    4.206447317743688e-03, // 1629
    3.625048956476950e-07, // 1630
   -5.093602904468684e-05, // 1631
    3.213038640171394e-04, // 1632
    4.269847168725185e-03, // 1633
    4.301882780989264e-01, // 1634
   -2.031405652802472e-04, // 1635
   -6.569131607655594e-05, // 1636
   -1.522963920429649e-08, // 1637
   -3.930092658336749e-06, // 1638
   -1.051127407128870e-01, // 1639
    2.040628945289320e-03, // 1640
   -5.227289146047583e-01, // 1641
   -1.734588975684819e-06, // 1642
   -7.116928232546249e-06, // 1643
   -3.088316910513007e-05, // 1644
   -6.988036991712988e-06, // 1645
    7.444139580884467e-05, // 1646
    1.316523566435808e-06, // 1647
    1.483178922449995e+00, // 1648
   -7.097873277965294e-08, // 1649
    1.377763219692040e-04, // 1650
    9.266374496909685e-01, // 1651
    2.168830103029026e-07, // 1652
    1.465260713424841e-05, // 1653
   -2.121589735332629e-05, // 1654
   -1.457604544402892e-06, // 1655
    1.688771089904578e-01, // 1656
    3.142392727970341e-04, // 1657
   -4.478496904766152e-09, // 1658
    1.368397047431848e-04, // 1659
   -4.692861374172550e-07, // 1660
    3.030224041386907e-03, // 1661
    3.356295703973500e-03, // 1662
    8.843686628587224e-03, // 1663
    2.369693782602176e-06, // 1664
    1.980585210969252e-03, // 1665
    2.954747919441213e-06, // 1666
    7.410720415042097e-05, // 1667
    1.680461981879161e-04, // 1668
   -4.466390677713587e-09, // 1669
   -4.574167804442354e-07, // 1670
    3.686039111726350e-01, // 1671
    8.007154656231753e-02, // 1672
    1.012800591229562e-02, // 1673
   -5.451262404569356e-04, // 1674
   -1.098883773182080e-05, // 1675
   -2.673382818975029e-02, // 1676
   -5.025699660416105e-04, // 1677
   -4.882580809057260e-04, // 1678
    2.287886254529465e-04, // 1679
   -2.988000245285180e-03, // 1680
    7.372565002560047e-05, // 1681
   -8.031778346780135e-04, // 1682
   -1.775068645296142e-03, // 1683
    1.299644221035099e-03, // 1684
   -5.002728687340173e-05, // 1685
   -4.486108652810746e-05, // 1686
    2.674320109784011e+00, // 1687
   -2.892637981043469e-05, // 1688
   -3.541503985832000e-07, // 1689
    6.002880614899190e-09, // 1690
   -4.025906235101852e-02, // 1691
    2.401938001476603e-05, // 1692
    8.207611174720483e-08, // 1693
    9.884044339170947e-07, // 1694
   -5.638080521190995e-05, // 1695
    1.412594504140801e-07, // 1696
   -9.292402964664188e-04, // 1697
    3.932061997657395e-07, // 1698
    1.573185072264552e-03, // 1699
   -5.351112622528026e-05, // 1700
   -2.711348383496326e-03, // 1701
    2.107629038370797e-03, // 1702
   -1.580532764003819e-05, // 1703
   -4.751807956709376e-07, // 1704
   -2.364683814530649e-07, // 1705
   -1.288195084308375e-06, // 1706
   -1.275243039768954e-05, // 1707
    6.384439129446281e-04, // 1708
   -4.464520820653365e-08, // 1709
   -3.319386277686064e-11, // 1710
    1.126160209486385e-02, // 1711
    3.365689981795805e-08, // 1712
    1.157178934309745e-03, // 1713
   -2.593005912435737e-05, // 1714
    2.162396645830371e-02, // 1715
   -1.034441560801370e-04, // 1716
   -1.173384118409186e-04, // 1717
   -6.248448587684766e-06, // 1718
    4.778429801008219e-04, // 1719
    4.129673353074808e-06, // 1720
   -1.364395930342601e-07, // 1721
    2.837410562164585e-06, // 1722
    3.879075066687090e-03, // 1723
   -4.063589216954856e-04, // 1724
    6.132024178734572e-05, // 1725
    5.995018378491848e-05, // 1726
    2.274702948495888e-09, // 1727
   -3.658098400494433e-03, // 1728
    2.631297126268846e-08, // 1729
   -5.415861703868444e-06, // 1730
   -8.051244299520499e-05, // 1731
   -1.914526140560718e-01, // 1732
   -3.079318710985104e-05, // 1733
    2.268079038776021e-02, // 1734
   -8.608709363058902e-05, // 1735
    2.452456665729048e-05, // 1736
    5.291551912686148e-05, // 1737
   -1.764762672060138e-07, // 1738
   -2.983918416080787e-03, // 1739
    1.807726111219324e-04, // 1740
    3.491440242964919e-06, // 1741
   -5.523046977252629e-06, // 1742
    8.955612544286881e-04, // 1743
   -5.898711086043231e-05, // 1744
    1.800480589061419e-04, // 1745
    1.312699904942439e-06, // 1746
   -1.492954738653437e-07, // 1747
    1.600907706279986e-07, // 1748
   -2.695868925345406e-07, // 1749
   -1.679760402047166e-09, // 1750
    3.112681832312086e-08, // 1751
   -3.304758985547574e-04, // 1752
   -1.712783976959194e-06, // 1753
    2.227199447939308e-02, // 1754
   -1.359356252636815e-05, // 1755
   -2.060174064888479e-09, // 1756
   -2.950016901352241e-01, // 1757
    4.074929190174608e-07, // 1758
    1.980354536374333e-04, // 1759
    5.202480509722807e-06, // 1760
   -5.035187780342876e-02, // 1761
    4.260642022440749e-05, // 1762
    6.649369133191425e-03, // 1763
   -6.594604755008116e-09, // 1764
   -2.883729244625297e-04, // 1765
   -2.850015523568597e-04, // 1766
   -1.364906889287079e-06, // 1767
   -5.127127207206604e-03, // 1768
    8.251483211853737e-04, // 1769
    1.013328831434306e-04, // 1770
    6.982074712404346e-04, // 1771
    6.449744957548208e-05, // 1772
   -4.646292036411117e-05, // 1773
    9.431262494640687e-02, // 1774
   -2.462405964514070e-06, // 1775
   -1.094185112664235e-02, // 1776
   -5.569381982750561e-03, // 1777
    3.377932349983107e-04, // 1778
    1.302385938885512e-06, // 1779
    2.105418722899038e-04, // 1780
   -2.665152476797489e-06, // 1781
   -8.171898776410800e-04, // 1782
    1.023559905563353e-04, // 1783
   -1.180203138515415e-06, // 1784
    3.377021662122456e-07, // 1785
   -6.439287567903705e-06, // 1786
   -1.956942056195865e-02, // 1787
   -4.375761252701631e-04, // 1788
    4.434168405300344e-08, // 1789
   -9.532417221117451e-04, // 1790
    2.028184743895502e-06, // 1791
    8.201379882054946e-06, // 1792
   -4.052728167698649e-04, // 1793
   -6.543964265117785e-07, // 1794
    9.056877845379398e-09, // 1795
    3.640966517094336e-07, // 1796
    2.074006295153846e-06, // 1797
   -8.219220878217508e-04, // 1798
    4.548527003770430e-07, // 1799
   -2.032274993376275e-03, // 1800
    4.489783217682035e-04, // 1801
   -5.061046723680742e-10, // 1802
   -7.364827252314383e-05, // 1803
    3.070595848166710e-05, // 1804
    1.353311289687014e-05, // 1805
    1.157865998158139e-05, // 1806
   -6.017113468556121e-07, // 1807
    7.696966307265311e-06, // 1808
   -1.235478097772192e-06, // 1809
    4.851193758417603e-04, // 1810
   -4.988213561229268e-07, // 1811
    1.287148651374100e-05, // 1812
   -7.200435502972832e-06, // 1813
    3.492519760062581e-06, // 1814
    1.003566821898428e-04, // 1815
    2.096632615315737e-07, // 1816
    7.317184200478789e-02, // 1817
    1.360071023215991e-04, // 1818
   -5.738358696564833e-08, // 1819
   -4.978077211038457e-06, // 1820
    2.923484372533472e-03, // 1821
   -3.320649905046732e-05, // 1822
   -3.839078879774470e-04, // 1823
   -2.293045617147391e-04, // 1824
   -6.587339541938020e-06, // 1825
    1.266020302831416e-06, // 1826
   -1.788735283987889e-07, // 1827
   -5.046878616095085e-03, // 1828
    1.258544868355404e-06, // 1829
    2.696620339878467e-03  // 1830
    };

    for (int i = 0; i< 1831; i++)
      threebodyfit[i] = threebodyfit_cp[i];

  } else {
    std::cerr << "Ion " << ion << " not found in mb-nrg parameters." << std::endl;
    throw std::exception();
  }
}
